--******************************************************************************************************
-- Created: 		12-06-2011
-- Last Updated:	25-07-2011
--
-- Author :  Kostadin Kotev / miau_u@yahoo.com /
-- Version:  3ds max 2009 and up
--
-- Discription: 
--	RTTAssist Install file
--******************************************************************************************************
-- MODIFY THIS AT YOUR OWN RISK

(
	global RTTAssist_Instalation
	try ( destroyDialog RTTAssist_Instalation ) catch ()
	try ( destroyDialog miauuRTTassist ) catch ()
	rollout RTTAssist_Instalation "RTTAssist 1.6 Setup"
	(
		local tempRTTAssistFolder = pathConfig.GetDir #temp+"\\tempRTTAssistFolder"
		local usRTTAui = pathConfig.GetDir #userscripts+"\\RTTAssistUI"
		local usRTTAuiIco = pathConfig.GetDir #userscripts+"\\RTTAssistUI\\RTTAssistIcons"
		local usRTTAuiPrst01 = pathConfig.GetDir #userscripts + "\\RTTAssist"
		local usRTTAuiPrst02 = pathConfig.GetDir #userscripts + "\\RTTAssist\\Presets"
		
		ImgTag ImgTag_BG bitmap:(bitmap 2 2 color:gray) pos:[0,0]  \
			width:309 height:194 opacity:1 transparent:(color 0 255 255) enabled:off

		hyperLink httpOficialSite "Oficial Site" pos:[213,138] color:(color 176 208 231) hoverColor:(color 82 129 181) visitedColor:(color 65 81 100) address:"http://vertexbee.com/rttassist.htm"
		hyperLink httpVideos "Videos" pos:[213,152] color:(color 176 208 231) hoverColor:(color 82 129 181) visitedColor:(color 65 81 100) address:"http://www.youtube.com/user/RTTassist?feature=mexp"
		ImgTag it_License bitmap:(bitmap 2 2 color:white) pos:[213,166]  \
			width:36 height:9 opacity:1 transparent:(color 0 255 255)
		
		button btn_Install "Install" width:138 height:30 pos:[30,103]
		button btn_Uninstall "Uninstall" width:138 height:30 pos:[30,145]

		
		function DeleteDirAndSubDir rootDir =
		(
			try ( DOSCommand ("rmDir \"" + rootDir + "\" /s /q") ) catch (messagebox "Can't delete RTTAssist folders!" title:"RTTAssist Install Error!!!")
		)
		function DeleteFiles curDir file =
		(
			filesToDelete = getFiles (curDir + file)
			for f in filesToDelete do	deleteFile f
		)
		
		function ValidateDirectory _dirNameIn  =
		(
			local _dirName = copy _dirNameIn
			local c
			for i = _dirName.count to 1 by -1 while (c=_dirName[i]; c=="\\" or c== "/") do
				_dirName = subString _dirName 1 (i-1)
			
			if doesFileExist _dirName then
				dirExists = true
			else
				dirExists = false
			
			return dirExists
		)
		function InstalRTTAssist =
		(
			if tempRTTAssistFolder != "" then
			(
				--	create main, icons and preset folders
				local rttAssistMainFolder = (makeDir usRTTAui)
				local iconFolder = (makeDir usRTTAuiIco)
				local presetFolder01 = (makeDir usRTTAuiPrst01)
				local presetFolder02 = (makeDir usRTTAuiPrst02)
				
				if presetFolder02 != true then
				(
					messagebox "Unable to create \"Preset\" folder" title:"RTTAssist Installation Error!!!"
				)
				else
				(
					--	copy icons and UI files
					if iconFolder == true then
					(
						allPreinstPNGfiles = (getFiles (tempRTTAssistFolder+"\\RTTAssistUI\\RTTAssistIcons\\*.png"))
						for pngFile in allPreinstPNGfiles do
						(		
							copyFile pngFile (usRTTAui+"\\RTTAssistIcons\\"+filenameFromPath pngFile)
						)
						allInstalledPNGfiles = (getFiles (usRTTAui+"\\RTTAssistIcons\\*.png"))						
						if allInstalledPNGfiles.count != allPreinstPNGfiles.count do messagebox "Installation Error!!!" title:"RTTAsssist"
					)
					else
						messagebox "Unable to create \"RTTAssist Icons\" folder" title:"RTTAssist Installation Error!!!"
					--	copy htm, ini, license and ms files
					if rttAssistMainFolder == true then
					(		
						allPreinstMCIfiles = (getFiles (tempRTTAssistFolder+"\\RTTAssistUI\\*.*"))
						for mciFile in allPreinstMCIfiles do
						(	
							copyFile mciFile (usRTTAui+"\\"+filenameFromPath mciFile)						
						)
						allInstalledMCIfiles = (getFiles (usRTTAui+"\\*.*"))						
						if allInstalledMCIfiles.count != allPreinstMCIfiles.count do messagebox "Installation Error!!!" title:"RTTAsssist"
					)
					else
						messagebox "Unable to create main \"RTTAssist\" folder" title:"RTTAssist Installation Error!!!"
					--	copy toolbar Icons
					for tBarIcoFiles in (getFiles (tempRTTAssistFolder+"\\icons\\*.*")) do
					(	
						copyFile tBarIcoFiles (pathConfig.GetDir #userIcons+"\\"+filenameFromPath tBarIcoFiles)
					)
					--	copy RTTAssist macro
					if (copyFile (tempRTTAssistFolder+"\\Macro_RTTAssist.mcr") (usRTTAui+"\\Macro_RTTAssist.mcr")) then
					(	--	load macro
						fileIn (usRTTAui+"\\Macro_RTTAssist.mcr")
 						--	start RTTAssist
						try(fileIn (usRTTAui+"\\RTTAssist.ms"))
						catch(messagebox "Please, start RTTAssist manualy!" title:"RTTAssist")
					)
					else
						messagebox "Can't copy the macro file of RTTAssist!" title:"RTTAssist Installation Error!!!"
				)
			)
			else
				messagebox "Insallation Error!!!" title:"RTTAsssist"
		)
		
		on RTTAssist_Instalation open do
		(
			if tempRTTAssistFolder != "" then 
			(
				ImgTag_BG.bitmap = (openBitmap (tempRTTAssistFolder+"\\RTTAssistInstallBG.png"))
				it_License.bitmap = (openBitmap (tempRTTAssistFolder+"\\miauuITlicense.png"))
			)
			
			if onlineUpdate == true do
			(
				if (doesFileExist ((getDir #userscripts) + "\RTTAssistUI\RTTAssist.ms")) do
				(					
					DeleteFiles ((getDir #userscripts) + "\RTTAssistUI") "*.*"	--	delete the ms, ini and help file
					DeleteFiles ((getDir #userscripts) + "RTTAssistIcons") "*.*"	--	delete the icons
					DeleteDirAndSubDir ((getDir #userscripts) + "\RTTAssistUI")	--	delete folders					
					DeleteFiles (getDir #userMacros) "*RTTAssist*.*"	--	delete macro
					DeleteFiles ("$max\\ui\\macroscripts\\") "Macro_RTTAssist.mcr"
				)
				InstalRTTAssist()
				destroydialog RTTAssist_Instalation
			)
		)
		on it_License lbuttondown do
		(
			licFile = tempRTTAssistFolder+"\license.html"
			shelllaunch licFile ""
		)
		on it_License mouseover do
		(
			it_License.bitmap = (openBitmap (tempRTTAssistFolder+"\\miauuITlicenseHover.png"))
		)
		on it_License mouseout do
		(
			it_License.bitmap = (openBitmap (tempRTTAssistFolder+"\\miauuITlicense.png"))
		)		
		on RTTAssist_Instalation close do
		(
			if tempRTTAssistFolder != "" then
				DeleteDirAndSubDir tempRTTAssistFolder
		)
		
		on btn_Install pressed do
		(
			if tempRTTAssistFolder != "" then
			(
				--	create RTTAssistUI directory
				if (ValidateDirectory usRTTAui) == false then
				(--	if RTTAssistUI folder does not exist start new installation
					InstalRTTAssist()
					destroydialog RTTAssist_Instalation
				)
				else
				(--	if RTTAssistUI folder exist show upgrade dialog
					try(destroyDialog ReinstallUpgrade)catch()
					rollout ReinstallUpgrade "RTTAssist 1.6"
					(
						label lb1 "RTTassist has already been installed!" pos:[20,20]
						label lb2 "To reinstall or update RTTAssist press \"Continue\"." pos:[20,40]
						label lb "To cancel the operation press \"Cancel\"."	pos:[20,60]
						
						button btn_Continue "Continue" pos:[150,90] width:50
						button btn_Cancel "Cancel" pos:[210,90] width:50
						
						on btn_Continue pressed do
						(
							if (doesFileExist ((getDir #userscripts) + "\RTTAssistUI\RTTAssist.ms")) or \
								(doesFileExist ((getDir #userscripts) + "\RTTAssistUI\RTTAssist.mse")) do
							(								
								DeleteFiles ((getDir #userscripts) + "\RTTAssistUI") "*.*"	--	delete the ms, ini and help file
								DeleteFiles ((getDir #userscripts) + "\RTTAssistIcons") "*.*"	--	delete the icons
								DeleteDirAndSubDir ((getDir #userscripts) + "\RTTAssistUI")	--	delete folders								
								DeleteFiles ((getDir #userMacros) + "\\") "*RTTAssist*.*"	--	delete macro 								
								DeleteFiles ("$max\\ui\\macroscripts\\") "Macro_RTTAssist.mcr"
							)
							InstalRTTAssist()
							destroydialog ReinstallUpgrade
							destroydialog RTTAssist_Instalation	
						)
						
						on btn_Cancel pressed do
						(
							destroydialog ReinstallUpgrade
						)
					)
					createdialog ReinstallUpgrade height:120 width:275 bgcolor:white fgcolor:red modal:true						
				)
			)
			else
				messagebox "Insallation Error!!!" title:"RTTAsssist"
		)
		
		on btn_Uninstall pressed do
		(
			if (doesFileExist ((getDir #userscripts) + "\RTTAssistUI\RTTAssist.ms")) or \
				(doesFileExist ((getDir #userscripts) + "\RTTAssistUI\RTTAssist.mse")) do
			(				
				DeleteFiles ((getDir #userscripts) + "\RTTAssistUI") "*.*"	--	delete the ms, ini and help file
				DeleteFiles ((getDir #userscripts) + "\RTTAssistIcons") "*.*"	--	delete the icons
				DeleteDirAndSubDir ((getDir #userscripts) + "\RTTAssistUI")	--	delete folders				
				DeleteFiles ((getDir #userscripts) + "\RTTAssist\Presets") "*.*"	--	delete the rpf and rps file
				DeleteDirAndSubDir ((getDir #userscripts) + "\RTTAssist")	--	delete folders
				DeleteFiles ((getDir #userMacros) + "\\") "*RTTAssist*.*"	--	delete macro 				
				DeleteFiles ("$max\\ui\\macroscripts\\") "Macro_RTTAssist.mcr"
				--	delete tempRTTAssistfolder
				if (tempRTTAssistFolder != "") then
					DeleteDirAndSubDir tempRTTAssistFolder
				
				destroydialog RTTAssist_Instalation
				
				rollout UninstallComplete "RTTAssist 1.6 Setup"
				(
					label lb1 "     Uninstallation complete." pos:[20,20]
					label lb2 "Thank you for using RTTAssist." pos:[20,40]
				)
				createdialog UninstallComplete height:70 width:185 bgcolor:white fgcolor:black
			)
		)
	)
	createDialog RTTAssist_Instalation height:194 width:309 bgcolor:gray
)