--******************************************************************************************************
--	LICENSE
-- RTTassist script is freeware and can be used in production environments. The source code is available and
-- can be modified for your own needs. However the script can not be sold, repackaged, 
-- included or distributed within any type of retail sales product. If you improve the script in
-- some aspect, please contact the authors, your contribution can be included in the official
-- version and your name will be included in the credits. For any further question, please contact the authors.

-- Disclaimer of Warranty

-- THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. 
-- THE PROGRAM IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER 
-- EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
-- OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS
-- TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE 
-- PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, 
-- REPAIR OR CORRECTION.

-- Limitation of Liability

-- IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL THE 
-- COPYRIGHT HOLDER BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, 
-- SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
-- INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA 
-- OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
-- PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
-- EVEN IF SUCH HOLDER HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

-- Copyright 2011 vertexbee.com. All rights reserved.

--******************************************************************************************************
/*	Version History
	1.6: added
		-	Export/Import of low-poly objects cages - idea by Joshua Stubbles
		-	The command pannel will no more flickering - thanks to @DenisT
	1.5: added:
		-	Baking System from ToTex. Special thanks to Sven Fraeys - http://www.sven.fraeys.be
		-	Hide all faces of low poly objects when MentalRay is used for texture baking
	-------------
	1.4: added:
		-	render the selectionSets of objects - idea by @Noors
	-------------
	1.3: changed:
		-	The Installer is changed and now the Presets folder is located in #userscripts directory and all preset are savetd there. Thanks to @Norman3D and @renderhjs
		added:
		-	spinner to set the Cage push amount value of all objects in the scene that have projection modifier - idea Nick  Quackenbush
		-	when use "save the scene" the objects will implode and then will explode again - to prevent saving scene with exploded objects
		-	The combined maps are with proper alpha channel - Special thanks to Dave Wortley
	-------------
	1.2: bug fix:
		Confirm File overwriten dialog will no more collapse by width
	-------------
	1.1: bug fix:
		-	"confirm file overwriten" groupbox now expand properly
		added:
		-	titlebar to show UV area calculation progres
		-	check for update
		-	MMB+Projection = show rollout with all LP objects and their HPs in Projection Reference List
		-	show preview of selected maps in Combine Maps dialog
	--------------
	1.0: first release
*/
--******************************************************************************************************
-- Created: 		22-02-2011
-- Last Updated:	18-06-2011
-- Version:			1.5
--
-- Authors :
-- 			Kostadin Kotev - code and development.
-- 			Martin Punchev - idea and development
--	
--	Special thanks to:
--			Sven Fraeys - Baking System - http://www.sven.fraeys.be/portfolio/
--			Dave Worty - swap alpha code - http://davewortley.cgsociety.org/about/
--
-- Version:  3ds max 2009 and up
--
--******************************************************************************************************
(	
	global gTextureBakeDialog
	
	global miauuRTTassist	
	global miauuCompairNames
	global miauuRenameMenager
	global miauuZeroPoint	
	global editTextSaveP
	global MainPresetRO
	global smartPresetUnimpRO
	global smartPresetImpRO
	global miauuTGAimageControl	
	global roBMP
	global roJPG
	global roPNG
	global roTIF
	global ObjByUVArea	
	global currentRenderedFile
	global rol_showUVcalculProgres
	global showLPandHPgroupsWithProj
	global CombineSingled
	global rol_MapPreview
	global ImplodeOnSave	
	global rol_SelectionSets
	global rol_ExportedCageFound
	try(destroydialog miauuRTTassist)catch()
	try(destroydialog miauuCompairNames)catch()
	try(destroydialog miauuRenameMenager)catch()
	try(destroydialog editTextSaveP)catch() 	
	try(DestroyDialog smartPresetUnimpRO)catch()
	try(DestroyDialog smartPresetImpRO)catch()
	try(destroydialog miauuTGAimageControl)catch()
	try(destroydialog roBMP)catch()
	try(destroydialog roJPG)catch()
	try(destroyDialog roPNG)catch()
	try(destroyDialog roTIF)catch()	
	try(destroyDialog ObjByUVArea)catch()
	try(destroyDialog showLPandHPgroupsWithProj)catch()
	try(destroydialog CombineSingled)catch()
	try(destroydialog rol_MapPreview)catch()
	try(destroyDialog rol_SelectionSets)catch()
	try(destroyDialog rol_ExportedCageFound)catch()
	try(delete miauuZeroPoint)catch()	
	local me = getSourceFileName()
	local dir = getFilenamePath me 
	local miauuIniFile = dir + "miauu.ini"

	local dialogWidth = 237
	local dialogHeight = 177
	
	rollout miauuRTTassist "miauu v1.3" 
	(
		local helpFile = GetDir #userscripts + "\\RTTassistUI\\help.chm"
		--	RCmenu
		local rcMapSize
		local rcSaveAs
		local rcRTTassistHelp
		--	imgtags for UI
		local url= ((pathConfig.GetDir #userscripts)+"\\RTTAssistUI\\RTTAssistIcons\\")
		ImgTag ImgTag_BG bitmap:(openBitmap (url+"miauuRTTAssist_main.png")) pos:[0,0]  \
			width:237 height:177 opacity:1 transparent:(color 0 255 255) enabled:off
		--	background for Preset Manger and Settings part of UI	
		ImgTag lb_renderBG  bitmap:(openBitmap (url+"miauuITrenderBG.png")) pos:[0, 176] \
			width:237 height:586 opacity:1 transparent:(color 0 255 255) enabled:off
			
	--	move borderless rollout
		local lbmDown = false
		local roPos = [0,0]

		on miauuRTTassist lbuttonup pos do lbmDown = false 
		on miauuRTTassist lbuttondown pos do
		(
			lbmDown = true
			roPos = pos
			try(destroyDialog smartPresetUnimpRO)catch()
			try(destroyDialog smartPresetImpRO)catch()
		)
		on miauuRTTassist mousemove pos do
		(
			if lbmDown do
				SetDialogPos miauuRTTassist  (mouse.screenpos - roPos)
		)
		
		local FindObjWithProjMod	--	predefine the find objects with added Projection modifier

		local settingsButtonState =1
		local renderButtonState = 1
		local mapButtonState = 1	
		local smartState = 1
		local batchState = 1
		
		local allObjITState = 1
		local visibleObj = 0
		local isSelectObj = 0
		
		local hideUnhideLPImgTagState = 1
		local hideUnhideHPImgTagState = 1
		local hideUnhideLPImgTagStateRB = 1
		local hideUnhideLPImgTagStateMB = 1
		local hideUnhideHPImgTagStateRB	=	1
		local hideUnhideHPImgTagStateMB	=	1
		local freezeState = 0
		local freezeStateH = 0
		local PresetDLLstate = 1	--	state of preset arrow
		local presetSmartUnim	=	1	--	state of smart preset for Unimportant object
		local presetSmartIm	=	1	--	state of smart preset for Important object
		local LoadPresetState = 1		--	state of load preset button-under Render button
		local smartIsRuning = false
		local smartStateMat = 1	--	state of Showing or Hiding Smart materials/original materials
		local startBatchRender = false	--	to use or not Batch rendering
		local chkBatchState = 1	--	to check or uncheck all files in batch listview
		local addBatchProj = false		--	 to process all objects when the LPs does not have a Projection modifier
		
		local explodeImplodeImgTagState = 1
		
		local lockSizeState = 1
		local sizeLockState = 0
		
		local pinRolloutErrMssg = 1

		global prefixNameLPAdd = undefined
		global prefixNameHPAdd = undefined
		global selObj = #()	--	store selection of objects	
		global dNetTBasSpn = undefined	--	value of explode spinner
		local isVisibleHideLP = #()
		local isVisibleHideLPAdd = #()
		local isVisibleHideHP = #()
		local isVisibleHideHPAdd = #()
		local allObjInScene = #()
		local startingObjPos = #()
		local newobjects = #()
		local smartArr = #()
		local onlyUVarea = #()
		local smartArrMinor = #()
		local smartArrMajor = #()
		local dataSelMinorLP = #()
		local start = 0	--	use by timer
		local objToBeStatic = undefined
		local noAnimExplByCntrl = 0 	--	to explode without Animation when pressing Explode button with Ctrl+LMB
		local noAutoCOByShift = 0 	--	to explode withoutAutoCO when pressing Explode button with Shift+LMB
		local skipInstances = 0		--	to skip or not instances when adding projection modifier
		local activeRender = undefined		--	wich renderer is active - scanline or MentalRay
		local vrayIsActiveRenderer = undefined		--	if the VRay is the currently active render
		local overwriteAllFile = false
		local fileNameForOverwrite = ""
		local objNameForCombineMap  = ""
		local dupsFound = false
		local objWithNoMat = #()
		local curRend = undefined
		local batchMAX2011ActRender = undefined	--	store the active renderer when using batch.
		local mRayAO = false
		local dN_sysDrawFont = dotNetObject "System.Drawing.Font" "Arial" 8
		local disableForeColor = (dotNetClass "System.Drawing.Color").Gray
		local dNetBorderStyle = (dotNetClass "System.Windows.Forms.BorderStyle").None
		local mssgHiddenHPfound = false
		local combinedSmartSeparateMapsName = #()	--	holds separate Smart CombMaps names
		local combinedSmartSeparateMapsPath = #()	--	holds separate Smart CombMaps paths
		local continueWithDifferentFileTypes = false		--	used by Smart system
		local continueWithDifferentOutputPath = true		--	used by Smart system
		local errMssg = undefined
		local maxFiles = #()		--	hold selected max files for batch rendering
		local maxFilesToBatch = #()	--	hold all max files for batch rendering
		local allIndexes = #()	--	determin wich max files are checked
		local isImplodeOnSaveActive = 0	--	used by implode before save
		local explodeMultiplier = undefined
		local useSelectionSets = false	--	to use or not the selectionSets objects
		local selectionSetsName = undefined	--	store currently rendered selection set name
		local exportImportCage = 0	--	the cages are not exported
		local selObjWithProjMod = undefined
		local objAndCageArr = #()
		local isCanceled = false	--	to cancel or not the importDelete cage loop
		local defaultMRPreset = false
		--	all objects with Projection modifier addet from script
		local allLPwithProjFromScript = #()
		local allLPwithProjFromScriptInst = #()
		local allLPwithProjFromScriptAdd = #()
		local allLPwithProjFromScriptInstAdd = #()
		--	variables for rendering system
		local bakedMapName
		local bakedObject		
		local selectedMap
		--	where to save baked maps
		local pathToSaveDiffuseMap =#()
		local pathToSaveSpecularMap =#()
		local pathToSaveCompleteMap =#()
		local pathToSaveShadowsMap =#()
		local pathToSaveLightingMap =#()
		local pathToSaveNormalsMap =#()
		local pathToSaveBlendMap =#()
		local pathToSaveAlphaMap =#()
		local pathToSaveHeightMap =#()
		local pathToSaveAmbOccMap =#()
		local pathToSaveUVMap =#()
		--	wich maps is added for baking
		local addDiffuseMap = false
		local addSpecularMap = false
		local addCompleteMap = false
		local addShadowsMap = false
		local addLightningMap = false
		local addNormalsMap = false
		local addBlendMap = false
		local addAlphaMap = false
		local addHeightMap =false
		local addAmbOccMap =false
		--	path to selected map
		local addDiffuseMapPath = ""
		local addSpecularMapPath = ""
		local addCompleteMapPath = ""
		local addShadowsMapPath = ""
		local addLightningMapPath = ""
		local addNormalsMapPath = ""
		local addBlendMapPath = ""
		local addAlphaMapPath = ""
		local addHeightMapPath =""
		local addAmbOccMapPath =""

		local CancelRenderProcess = false
		
		local useUVWChannel = 1
		local texture_Padding = 1
		
		local rendererChange -- renderer 'when' callback
		
		local mapTextureWidth = 256
		local mapTextureHeight = 256
		
		local UIstartZ = 0
		local UIstartY = 0
		
		--	uncomment to see how "Show Vray maps" work
-- 		checkbutton btn_vray "VRay " pos:[50,0]
--------------------------------------
	--	MAIN WINDOW
--------------------------------------
 		ImgTag btn_CloseX bitmap:(openBitmap (url+"miauuITClose.png")) pos:[219, 4]  width:14 height:16  opacity:1 transparent:(color 0 255 255)
 		ImgTag btn_help bitmap:(bitmap 2 2 color:white) pos:[191, 4]  width:26 height:15  opacity:0.0 transparent:(color 255 255 255)
		ImgTag btn_about bitmap:(bitmap 2 2 color:white) pos:[150, 4]  width:35 height:13  opacity:0.0 transparent:(color 255 255 255)
 		ImgTag chkbtn_IsSelect bitmap:(openBitmap (url+"miauuITisSelobj.png")) pos:[3,66] width:53 height:20  opacity:1 transparent:(color 0 255 255)	tooltip:"Work only with selected objects."			
 		ImgTag chkbtn_IsVisible bitmap:(openBitmap (url+"miauuITvisible.png")) pos:[3,46] width:53 height:20  opacity:1 transparent:(color 0 255 255)	tooltip:"Work only with visible objects."			
 		ImgTag chkbtn_All bitmap:(openBitmap (url+"miauuITAllobj.png")) pos:[3,26] width:53 height:20  opacity:1 transparent:(color 0 255 255) tooltip:"Work with all objects including hidden."
		
 		dotNetControl dNet_Label_selLP "System.Windows.Forms.Label" pos:[61,32] width:49 height:13
		dotNetControl dNet_TextBox_LP "System.Windows.Forms.TextBox" pos:[-202,-58] width:49 height:18
 		ImgTag ImgTag_chkbtn_low_hide bitmap:(openBitmap (url+"miauuIThideIA.png")) pos:[112,29]  width:20 height:20 \
			tooltip:"LMB to hide all Low-Poly objects!\nRMB to hide all main Low-Poly objects!\nMMB to hide all imported Low-Poly  objects!\nLMB to unhide all Low-Poly objects!\nRMB to unhide all main Low-Poly objects!\nMMB to unhide all secondary Low-Poly objects!"\
			opacity:1 transparent:(color 0 255 255)
		ImgTag ImgTag_btn_FreezeSelectedLP bitmap:(openBitmap (url+"miauuITunfreeze.png")) pos:[135,29] width:20 height:20 tooltip:"Freeze selected Low-Poly objects!\nRMB to unfreeze all Low-Poly objects!" opacity:1 transparent:(color 0 255 255)
		ImgTag ImgTag_button_low_export bitmap:(openBitmap (url+"miauuITexportIA.png")) pos:[158,29] width:20 height:20 tooltip:"Export all Low-Poly objects!" opacity:1 transparent:(color 0 255 255)
		
		dotNetControl dNet_Label_selHP "System.Windows.Forms.Label" pos:[61,51] width:49 height:13
		dotNetControl dNet_TextBox_HP "System.Windows.Forms.TextBox" pos:[-142,-74] width:49 height:18
 		ImgTag ImgTag_chkbtn_high_hide bitmap:(openBitmap (url+"miauuIThideIA.png")) pos:[112,48]  width:20 height:20 \
			tooltip:"LMB to hide all High-Poly objects!\nRMB to hide only main High-Poly objects!\nMMB to hide only secondary High-Poly objects!\nLMB to unhide all High-Poly objects!\nRMB to unhide only main High-Poly objects!\nMMB to unhide only secondary High-Poly objects!" \
			opacity:1 transparent:(color 0 255 255)
		ImgTag ImgTag_btn_FreezeSelectedHP bitmap:(openBitmap (url+"miauuITunfreeze.png")) pos:[135,48] width:20 height:20 tooltip:"Freeze selected High-Poly objects!\nRMB to unfreeze all High-Poly objects!" opacity:1 transparent:(color 0 255 255)
		ImgTag ImgTag_button_high_export bitmap:(openBitmap (url+"miauuITexportIA.png")) pos:[158,48] width:20 height:20 tooltip:"Export all High-Poly objects!" opacity:1 transparent:(color 0 255 255)
		
 		dotNetControl edittxt_SecondNameDivider "System.Windows.Forms.TextBox" pos:[61,69] width:49 height:12

 		ImgTag btn_CompareName bitmap:(openBitmap (url+"miauuITnames.png")) pos:[182,27]  width:51 height:18  opacity:1 transparent:(color 0 255 255) tooltip:"Compare pair names and correct mistakes."			
 		ImgTag btn_renameObj bitmap:(openBitmap (url+"miauuITrename.png")) pos:[182,47]  width:51 height:18  opacity:1 transparent:(color 0 255 255) \
			tooltip:"LMB to open the \"Rename\" dialog.\nRMB to replace automatically the prefixes of all\nsecondary Low-Poly and High-Poly objects with the main ones."		
 		ImgTag btn_buildPair bitmap:(openBitmap (url+"miauuITbuildPair.png")) pos:[182,67]  width:51 height:18  opacity:1 transparent:(color 0 255 255) \
			tooltip:" LMB to assign generated names to the current object selection.\n RMB to assign entered names to the current object selection."		
 		dotNetControl et_buildParisName "System.Windows.Forms.TextBox" pos:[114,69] width:62 height:12
			
		ImgTag ImgTag_ExplodeImplode bitmap:(openBitmap (url+"miauuITexplode.png")) pos:[3,94]  width:53 height:40 \
			tooltip:"LMB to explode the scene using default settings!\nAlt + LMB to turn on \"EXPLODE\"mode!\nCtrl+LMB to explode without animation!\nShift+LMB to explode without automaticaly checks\nfor overpalled objects!"\
			opacity:1 transparent:(color 0 255 255)
-----## Explode spinner
		dotNetControl dNet_TxtBoxAsSpinner "System.Windows.Forms.TextBox" pos:[5,136] width:33 height:12	
		ImgTag btn_Explode bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[UIstartZ+41,UIstartY+136]  width:13 height:7  opacity:1 transparent:(color 0 255 255)
		ImgTag btn_Implode bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[UIstartZ+41,UIstartY+144]  width:13 height:6 opacity:1 transparent:(color 0 255 255)
-----##
 		ImgTag btn_AddProjMod bitmap:(openBitmap (url+"miauITProj.png")) pos:[56,94]  width:39 height:40  opacity:1 transparent:(color 0 255 255) \
			tooltip:"LMB to add a \"Projection\" modifier to all Low-Poly objects..\nRMB to remove the \"Projection\" modifier  from all Low-Poly objects.\nAlt+LMB to add a  \"Projection\" modifier to all Low-Poly objects except instances.\nMMB to open the \"Projections list/Cage list\" dialog."		
-----##	Cage Push Amount Spinner
		dotNetControl dNet_cagePushSpinner "System.Windows.Forms.TextBox" pos:[58,136] width:21 height:14	
		ImgTag btn_cagePushSpinnerUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[UIstartZ+80,UIstartY+136]  width:13 height:7  opacity:1 transparent:(color 0 255 255) \
			tooltip: "Increase the Cage Push amount"
		ImgTag btn_cagePushSpinnerDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[UIstartZ+80,UIstartY+144]  width:13 height:6 opacity:1 transparent:(color 0 255 255) \
			tooltip: "Derease the Cage Push amount. \n RMB - reset the cage of all objects. \n MMB - Cage Auto-Wrap."
-----##		
		ImgTag btn_BatchRender bitmap:(openBitmap (url+"miauuITBatch.png")) pos:[103,94]  width:39 height:40  opacity:1 transparent:(color 0 255 255) tooltip:"Open batch render settings."						
		Imgtag btn_smartRender bitmap:(openBitmap (url+"miauuITsmart.png")) pos:[142,94] width:39 height:40  opacity:1 transparent:(color 0 255 255) \
			tooltip:"LMB to turn on \"Smart\" mode!\nLMB to show or hide the \"Smart Options\".\nMMB to show or hide the viewport materials indication.\nRMB - close Smart dialog"

 -----## Smart spinner
		dotNetControl dNet_smartSpinner "System.Windows.Forms.TextBox" pos:[144,136] width:21 height:14	
		ImgTag btn_smartSpinnerUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[UIstartZ+166,UIstartY+136]  width:13 height:7  opacity:1 transparent:(color 0 255 255)
		ImgTag btn_smartSpinnerDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[UIstartZ+166,UIstartY+144]  width:13 height:6 opacity:1 transparent:(color 0 255 255)
-----##		
		ImgTag btn_RenderToTexture bitmap:(openBitmap (url+"miauuITrender.png")) pos:[181,94] width:53 height:40  opacity:1 transparent:(color 0 255 255) \
			tooltip:"LMB to bake all Low-Poly objects with projection modifier applied by RTTAssist!!\nRMB to bake all Low-Poly objects with projection modifier!\nCtrl+RMB to bake only LP objects with correct prefix labels!\nMMB to bake all selected objects!\nCTRL+LMB = Will select all objects that have received their projection modifier\nby using the \"Project\" button from the current session of the script.\nALT + LMB = Will select all objects that have received their projection modifier from\nprevious session or that were applied manually by the user."
 		ImgTag btn_loadPreset bitmap:(openBitmap (url+"miauuITloadPreset.png")) pos:[181,134]  width:53 height:20  opacity:1 transparent:(color 0 255 255) tooltip:"Load preset"		
			
 		ImgTag btn_Settings bitmap:(openBitmap (url+"miauuITsettings.png")) pos:[1,154]  width:99 height:23  opacity:1 transparent:(color 0 255 255)
 		ImgTag btn_renderDialog bitmap:(openBitmap (url+"miauuITrendersettings.png")) pos:[99,154]  width:138 height:23  opacity:1 transparent:(color 0 255 255) 
--------------------------------------
	--	SETTINGS
--------------------------------------
		local sPSettY = 178
		local sPSettZ = 0
		ImgTag lb_faces_threshold bitmap:(openBitmap (url+"miauuITmaxLPfaces.png")) pos:[-500,-500] width:66 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
		ImgTag spn_faces_thresholdBG bitmap:(openBitmap (url+"miauuITmaxLPspn.png")) pos:[-500,-500] width:60 height:18 opacity:1 transparent:(color 0 255 255) enabled:off
		ImgTag btn_faces_thresholdUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500]   width:13 height:7  opacity:1 transparent:(color 0 255 255)
		ImgTag btn_faces_thresholdDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]  width:13 height:6 opacity:1 transparent:(color 0 255 255)
		dotNetControl spn_faces_threshold "System.Windows.Forms.TextBox" pos:[-500,-500]   width:44 height:12	
		--
		ImgTag lb_chkbox_AutoCheckOverlap bitmap:(openBitmap (url+"miauuITautoCO.png")) pos:[-500,-500] width:41 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
		checkbox chkbox_AutoCheckOverlap "Auto CO" pos:[-500,-500] height:14 width:13  tooltip:"Automatically check for overlapping\nobjects prior entering explode mode!"
		ImgTag lb_chkbox_isNodeFrozen bitmap:(openBitmap (url+"miauuITworkWithFrozen.png")) pos:[-500,-500] width:73 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
		checkbox chkbox_isNodeFrozen "" pos:[-500,-500] height:14 width:13 tooltip:"Work with frozen objects"
		ImgTag lb_chkbox_noCageReset bitmap:(openBitmap (url+"miauuITcageReset.png")) pos:[-500,-500] width:57 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
		checkbox chkbox_noCageReset "" pos:[-500,-500] height:14 width:13 tooltip:"If on, \"AddProjection\" button will add\n \"Projection\" modifiers with their cage reset"
		groupbox grpbox_animation "Animation" pos:[-500,-500] width:74 height:66 	
			ImgTag lb_animSpnBG bitmap:(openBitmap (url+"miauuITanimSpns.png")) pos:[-500,-500] width:70 height:35 opacity:1 transparent:(color 0 255 255) enabled:off
			dotNetControl spn_sTime "System.Windows.Forms.TextBox" pos:[-500,-500]  width:21 height:11	
			ImgTag btn_sTimeUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500] width:13 height:7  opacity:1 transparent:(color 0 255 255)
			ImgTag btn_sTimeDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]  width:13 height:6 opacity:1 transparent:(color 0 255 255)
			dotNetControl spn_animDistance "System.Windows.Forms.TextBox" pos:[-500,-500]  width:21 height:11	
			ImgTag btn_animDistanceUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500]  width:13 height:7  opacity:1 transparent:(color 0 255 255)
			ImgTag btn_animDistanceDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]   width:13 height:6 opacity:1 transparent:(color 0 255 255)
			ImgTag lb_chkbox_OnOffAnimation bitmap:(openBitmap (url+"miauuIToff.png")) pos:[-500,-500] width:15 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_OnOffAnimation pos:[-500,-500] height:14 width:13 tooltip:"Turn animation OFF!"
		groupbox grpbox_errMsg "LiveLog" pos:[-500,-500] width:65 height:66 
			ImgTag lb_chkbox_errInViewport bitmap:(openBitmap (url+"miauuITscreen.png")) pos:[-500,-500] width:33 height:8 opacity:1 transparent:(color 0 255 255) enabled:off
			ImgTag lb_chkbox_errInRollOut bitmap:(openBitmap (url+"miauuITrollout.png")) pos:[-500,-500] width:29 height:12 opacity:1 transparent:(color 0 255 255) enabled:off
			ImgTag btn_errInRollOutPin bitmap:(openBitmap (url+"miauuITunpin.png")) pos:[-500,-500] width:12 height:13 opacity:1 transparent:(color 0 255 255) tooltip: ""		
			ImgTag lb_chkbox_errInMsgBox bitmap:(openBitmap (url+"miauuITmsgBox.png")) pos:[-500,-500] width:40 height:11 opacity:1 transparent:(color 0 255 255) enabled:off

			checkbox chkbox_errInViewport "" pos:[-500,-500] height:14 width:13 tooltip:"Show error messages in the active viewport!"
			checkbox chkbox_errInRollOut "" pos:[-500,-500] height:14 width:13 tooltip:"Show error messages in RTTassist's interface window!"
			checkbox chkbox_errInMsgBox "" pos:[-500,-500] height:14 width:13 tooltip:"Show error messages in standart message box!"
		groupbox grpbox_explodeFrom "Point of explosion" pos:[-500,-500] width:97 height:66
			ImgTag lb_chkbox_explodeFromTop bitmap:(openBitmap (url+"miauuITtop.png")) pos:[-500,-500] width:20 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_explodeFromTop	"" pos:[-500,-500] height:14 width:13 ooltip:"Use objects highest point\nto place the origin of explosion."
			ImgTag lb_chkbox_explodeFromCenter bitmap:(openBitmap (url+"miauuITcenter.png")) pos:[-500,-500] width:32 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_explodeFromCenter	"" pos:[-500,-500] height:14 width:13 tooltip:"Use the center of all objects\nto place the origin of explosion."
			ImgTag lb_chkbox_explodeFromBottom bitmap:(openBitmap (url+"miauuITbottom.png")) pos:[-500,-500] width:34 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_explodeFromBottom	"" pos:[-500,-500] height:14 width:13 tooltip:"Use objects lowest point\nto place the origin of explosion."
			ImgTag lb_chkbox_ZeroPoint bitmap:(openBitmap (url+"miauuITshow.png")) pos:[-500,-500] width:28 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_ZeroPoint	"" pos:[-500,-500] height:14 width:13 tooltip:"Viewport indication showing\nwhere is the origin of explosion."
			ImgTag lb_chkbox_moveZeroPointObj bitmap:(openBitmap (url+"miauuITmoveClosestObj.png")) pos:[-500,-500] width:26 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_moveZeroPointObj "" pos:[-500,-500] height:14 width:13 tooltip:"If off, the object closest to\nthe origin of explosion stays in place"
			ImgTag btn_cancelSettings bitmap:(openBitmap (url+"miauuITresetSettings.png")) pos:[-500,-500] width:51 height:19 opacity:1 transparent:(color 0 255 255) tooltip:"Revert to default settings!"
			ImgTag btn_saveSettings bitmap:(openBitmap (url+"miauuITsavePreset.png")) pos:[-500,-500] width:51 height:19 opacity:1 transparent:(color 0 255 255) tooltip:"Save current settings as default!"
			ImgTag lb_chkbox_checkUpdateOnStatUp bitmap:(openBitmap (url+"miauuITautoUpdateCheck.png")) pos:[-500,-500] width:122 height:11 opacity:1 transparent:(color 0 255 255) enabled:off
			checkBox chkbox_checkUpdateOnStatUp "auto check for updates" height:14 width:13 pos:[-500,-500]
----------------------------
	--	PRESET MANAGER
----------------------------
		local spRendY = 177
		local spRendZ = 0
		-- Output Path and save as type button 
		ImgTag lb_BrowseFolder bitmap:(openBitmap (url+"miauuIToutpath.png")) pos:[-500,-500] width:229 height:32 opacity:1 transparent:(color 0 255 255) enabled:off
		dotNetControl btn_BrowseFolder "System.Windows.Forms.Label" pos:[-500,-500] width:227 height:30
 		ImgTag lb_saveAsType bitmap:(openBitmap (url+"miauuITsaveAs.png")) pos:[-500,-500]  width:51 height:18 opacity:1 transparent:(color 0 255 255) enabled:off
		ImgTag lb_saveAsTypeArrow bitmap:(openBitmap (url+"miauuITsaveAsarrow.png")) pos:[-500,-500]  width:17 height:18 opacity:1 transparent:(color 0 255 255)
		dotNetControl btn_saveAsType "System.Windows.Forms.Label" pos:[-500,-500] width:32 height:15
		--
		ImgTag lb_combMaps bitmap:(openBitmap (url+"miauuITcombineMaps.png")) pos:[-500,-500] width:70 height:14 opacity:1 transparent:(color 0 255 255) 
		checkbox chkbox_combMaps "" pos:[-500,-500] height:14 width:13 tooltip:"All individual maps will be combined in a single resulting map."
		ImgTag btn_CombineSing bitmap:(openBitmap (url+"miauuITcombineSing.png")) pos:[-500,-500] width:53 height:20 opacity:1 transparent:(color 0 255 255) tooltip:"Open Combine Maps dialog"
		checkbox chkbox_selSets "" height:14 width:13 pos:[-500,-500] tooltip:"Open \"Render Selection Sets\" rollout."
		ImgTag lb_selSets bitmap:(openBitmap (url+"miauuITuseSelSets.png")) pos:[-500,-500] width:38 height:10 opacity:1 transparent:(color 0 255 255) tooltip:"Open \"Render Selection Sets\" rollout."	--	enabled:off
		ImgTag lb_preview bitmap:(openBitmap (url+"miauuITpreviewVFB.png")) pos:[-500,-500] width:56 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
		checkbox chkbox_previewVFB "" pos:[-500,-500] height:14 width:13 tooltip:"Shows the progress of every map in the virtual frame buffer."
		--	select map size
		dotNetControl dnet_lb_mapWidth "System.Windows.Forms.Label" pos:[-500,-500] width:17 height:17
 		ImgTag lb_spn_mapWidth bitmap:(openBitmap (url+"miauuITsetMapSize.png")) pos:[-500,-500]  width:39 height:19  opacity:1 transparent:(color 0 255 255) enabled:off
		dotNetControl spn_mapWidth "System.Windows.Forms.TextBox" pos:[-500,-500] width:37 height:18
		dotNetControl dnet_lb_mapHeight "System.Windows.Forms.Label" pos:[-500,-500]  width:17 height:17
 		ImgTag lb_spn_mapHeight bitmap:(openBitmap (url+"miauuITsetMapSize.png")) pos:[-500,-500] width:39 height:19  opacity:1 transparent:(color 0 255 255) enabled:off		
		dotNetControl spn_mapHeight "System.Windows.Forms.TextBox" pos:[-500,-500] width:37 height:18
 		ImgTag ImgTag_getMapSize bitmap:(openBitmap (url+"miauuITmapSize.png")) pos:[-500,-500] width:30 height:17 opacity:1 transparent:(color 0 255 255) --enabled:off
		ImgTag ImgTag_LockSize bitmap:(openBitmap (url+"miauuLockTexSizeBMP.png")) pos:[-500,-500]  width:16 height:17 tooltip:"Lock height to width!"  opacity:1 transparent:(color 0 255 255)
		--	isolate pairs and show or not isolation
		checkbox chkbox_renderIsolate "" pos:[-500,-500] height:14 width:13 tooltip:"If on, objects will be isolated and then baked"
		ImgTag lb_chkbox_renderIsolate bitmap:(openBitmap (url+"miauuITisolatePairs.png")) pos:[-500,-500] width:62 height:10  opacity:1 transparent:(color 0 255 255) 	--		enabled:off		
		checkbox chkbox_redrawViews "" pos:[-500,-500] height:14 width:13 tooltip:"If on, the viewport will show isolated objects"
 		ImgTag lb_chkbox_redrawViews bitmap:(openBitmap (url+"miauuITshowIsolation.png")) pos:[-500,-500] width:69 height:9  opacity:1 transparent:(color 0 255 255) 	--	enabled:off
		--	hide or not all faces of the LP objects when mentalRay is active renderer
		ImgTag lb_chkbox_hideFacesMR bitmap:(openBitmap (url+"miauuIThideFacesMR.png")) pos:[-500,-500] width:72 height:11  opacity:1 transparent:(color 0 255 255) tooltip:"If on - hide faces of the LP objects when MR is active renderer."		
		checkbox chkbox_hideFacesMR "" pos:[-500,-500] height:14 width:13  tooltip:"If on - hide faces of the LP objects when MR is active renderer."
		--	save prset system
		ImgTag lb_textEdit bitmap:(openBitmap (url+"miauuITenterPreset.png")) pos:[-500,-500] width:121 height:18 opacity:1 transparent:(color 0 255 255) enabled:off
		dotNetControl dNet_TextBoxSP "System.Windows.Forms.TextBox" pos:[-500,-500] width:100 height:17
		ImgTag dNet_TextBoxSP_Arrow bitmap:(bitmap 5 5 color:white) pos:[-500,-500] width:20 height:15 opacity:0.0 transparent:(color 255 255 255)
		ImgTag btn_delete bitmap:(openBitmap (url+"miauuITdeletePreset.png")) pos:[-500,-500] width:51 height:19 opacity:1 transparent:(color 0 255 255) tooltip:"Delete preset."
		ImgTag btn_SavePrst bitmap:(openBitmap (url+"miauuITsavePreset.png")) pos:[-500,-500] width:51 height:19 opacity:1 transparent:(color 0 255 255) tooltip:"Save preset."

		--	button to open map settings
		ImgTag btn_openMapSettings bitmap:(openBitmap (url+"miauuITmapsettingsOpen.png")) pos:[spRendZ+1,spRendY+22+70+20]  width:237 height:22  opacity:1 transparent:(color 0 255 255)
----------------------------
	--	MAP SETTINGS
----------------------------
		--	render dialog additional settings
		local sPmapSettY = spRendY+22+70+11+22+20+20		--	== 322	spRendY=177
		local sPmapSettZ = 0
			
		--	spiners background for Padding, UV Channel and Offset
		ImgTag lb_spnProjBG  bitmap:(openBitmap (url+"miauuITspnProjBG.png")) pos:[-500,-500] \
				width:229 height:42 opacity:1 transparent:(color 0 255 255) enabled:off
		
		groupbox gbox_ProjectionMapping "Projection Mapping" pos:[-500,-500]  width:237 height:130 
			checkbox chkbox_UseProjection "" pos:[-500,-500] height:14 width:13 checked:on
		--## Padding spinner
			dotNetControl spn_Padding "System.Windows.Forms.TextBox" pos:[-500,-500]  width:21 height:11	
			ImgTag btn_PaddingUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500]  width:13 height:7  opacity:1 transparent:(color 0 255 255)
			ImgTag btn_PaddingDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]   width:13 height:6 opacity:1 transparent:(color 0 255 255)
		--## UVChannel spinner
			dotNetControl spn_UVChannel "System.Windows.Forms.TextBox" pos:[-500,-500] width:21 height:11	
			ImgTag btn_UVChannelUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500]   width:13 height:7  opacity:1 transparent:(color 0 255 255)
			ImgTag btn_UVChannelDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]  width:13 height:6 opacity:1 transparent:(color 0 255 255)
		--##
			checkbox chkbox_useCage "system.windows.forms.Checkbox" pos:[-500,-500] height:14 width:13				
		--## Offset spinner		
			dotNetControl spn_Offset "System.Windows.Forms.TextBox" pos:[-500,-500] width:21 height:11	
			ImgTag btn_OffsetUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500]   width:13 height:7  opacity:1 transparent:(color 0 255 255)
			ImgTag btn_OffsetDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]   width:13 height:6 opacity:1 transparent:(color 0 255 255)
		--##
			ImgTag lb_mRay  bitmap:(openBitmap (url+"miauuITmentalRay.png")) pos:[-500,-500] width:40 height:14 opacity:1 transparent:(color 0 255 255) tooltip:"Set MentalRay as current render"
			ImgTag lb_scanline  bitmap:(openBitmap (url+"miauuITscanline.png")) pos:[-500,-500] width:40 height:14 opacity:1 transparent:(color 0 255 255) tooltip:"Set scanline as current render"
			--
			ImgTag lb_Raytrace  bitmap:(openBitmap (url+"miauuITraytrace.png")) pos:[-500,-500]  width:44 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_Raytrace "" pos:[-500,-500]  height:14 width:13 checked:on
			ImgTag lb_UVmatch  bitmap:(openBitmap (url+"miauuITuvMatch.png")) pos:[-500,-500]   width:48 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_UVmatch "" pos:[-500,-500]  height:14 width:13
			--
			ImgTag lb_Closest  bitmap:(openBitmap (url+"miauuITclosest.png")) pos:[-500,-500]  width:35 height:14 opacity:1 transparent:(color 0 255 255) enabled:off				
			checkbox chkbox_Closest "Closest" pos:[-500,-500]  height:14 width:13
			ImgTag lb_Furthest  bitmap:(openBitmap (url+"miauuITfurthest.png")) pos:[-500,-500]  width:39 height:14 opacity:1 transparent:(color 0 255 255) enabled:off							
			checkbox chkbox_Furthest "Furthest" pos:[-500,-500] height:14 width:13 checked:on
			--
			ImgTag lb_HitMatchMtlID  bitmap:(openBitmap (url+"miauuITHitOnlMatchMatID.png")) pos:[-500,-500] width:134 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_HitMatchMtlID "" pos:[-500,-500] height:14 width:14
			--
			ImgTag lb_RayMissCheck  bitmap:(openBitmap (url+"miauuITraymisscheck.png")) pos:[-500,-500] width:76 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_RayMissCheck "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_RayMissColor  bitmap:(openBitmap (url+"miauuITrayMissColor.png")) pos:[-500,-500]  width:69 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			ImgTag lb_colorpickerBG  bitmap:(openBitmap (url+"miauuITcolorswatch.png")) pos:[-500,-500]  width:24 height:17 opacity:1 transparent:(color 0 255 255) enabled:off			
			colorpicker colorPick_RayMissColor "" pos:[-500,-500] fieldwidth:20 height:14 color:red title:"Choose Ray miss-check color."
			--
			ImgTag lb_CropAlpha  bitmap:(openBitmap (url+"miauuITcropAlpha.png")) pos:[-500,-500]  width:53 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_CropAlpha "" pos:[-500,-500]  height:14 width:13
			ImgTag lb_filteringlabel  bitmap:(openBitmap (url+"miauuITfilterLabel.png")) pos:[-500,-500]  width:187 height:18 opacity:1 transparent:(color 0 255 255) enabled:off			
			dotNetControl lb_filteringOptions "System.Windows.Forms.Label" pos:[-500,-500] width:185 height:15
			ImgTag btn_SamplerSetup  bitmap:(openBitmap (url+"miauuITfilteringSetup.png")) pos:[-500,-500]  width:39 height:18 opacity:1 transparent:(color 0 255 255) tooltip:"Opens the \"Render Setup\" dialog"
----------------------------------------------
	--	STANDART MAPS
----------------------------------------------
			local selMapGBY = (sPmapSettY+2+15+20+19+17+17+18+23)	--	453
			local selMapGBZ = 0			
		groupbox gbox_TextureMaps "Select Maps" pos:[selMapGBZ,selMapGBY] width:237 height:86
			checkbox chkbox_AlphaMap "" pos:[selMapGBZ+4, selMapGBY+15] height:14 width:13
			dotNetControl dNet_lbl_addAlpha "System.Windows.Forms.Label" pos:[selMapGBZ+19, selMapGBY+15] width:55 height:14
			checkbox chkbox_AmbientOcclusion "" pos:[selMapGBZ+82, selMapGBY+15] height:14 width:13
			dotNetControl dNet_lbl_addAO "System.Windows.Forms.Label" pos:[selMapGBZ+97, selMapGBY+15] width:55 height:14
			checkbox chkbox_BlendMap "" pos:[selMapGBZ+160, selMapGBY+15] height:14 width:13
			dotNetControl dNet_lbl_addBlend "System.Windows.Forms.Label" pos:[selMapGBZ+175, selMapGBY+15] width:55 height:14 
			checkbox chkbox_CompleteMap "" pos:[selMapGBZ+4, selMapGBY+15+17]  height:14 width:13
			dotNetControl dNet_lbl_addComplete "System.Windows.Forms.Label" pos:[selMapGBZ+19, selMapGBY+15+17] width:55 height:14 
			checkbox chkbox_DiffuseMap "" pos:[selMapGBZ+82, selMapGBY+15+17]  height:14 width:13
			dotNetControl dNet_lbl_addDiffuse "System.Windows.Forms.Label" pos:[selMapGBZ+97, selMapGBY+15+17] width:55 height:14
			checkbox chkbox_HeightMap "" pos:[selMapGBZ+160, selMapGBY+15+17]  height:14 width:13
			dotNetControl dNet_lbl_addHeigh "System.Windows.Forms.Label" pos:[selMapGBZ+175, selMapGBY+15+17] width:55 height:14 
			checkbox chkbox_LightingMap "" pos:[selMapGBZ+4, selMapGBY+15+17+17]  height:14 width:13
			dotNetControl dNet_lbl_addLight "System.Windows.Forms.Label" pos:[selMapGBZ+19, selMapGBY+15+17+17]  width:55 height:14 
			checkbox chkbox_normalsMap "" pos:[selMapGBZ+82, selMapGBY+15+17+17]  height:14 width:13
			dotNetControl dNet_lbl_addNormals "System.Windows.Forms.Label" pos:[selMapGBZ+97, selMapGBY+15+17+17] width:55 height:14 
			checkbox chkbox_ShadowsMap "" pos:[selMapGBZ+160, selMapGBY+15+17+17] height:14 width:13
			dotNetControl dNet_lbl_addShadows "System.Windows.Forms.Label" pos:[selMapGBZ+175, selMapGBY+15+17+17] width:55 height:14 
			checkbox chkbox_SpecularMap "" pos:[selMapGBZ+4, selMapGBY+15+17+17+17] height:14 width:13
			dotNetControl dNet_lbl_addSpecular "System.Windows.Forms.Label" pos:[selMapGBZ+19, selMapGBY+15+17+17+17]  width:55 height:14 
			checkbox chkbox_UVMap "" pos:[selMapGBZ+82, selMapGBY+15+17+17+17] height:14 width:13
			dotNetControl dNet_lbl_addUVmap "System.Windows.Forms.Label" pos:[selMapGBZ+97, selMapGBY+15+17+17+17]  width:55 height:14 
----------------------------------------------
	--	VRAY MAPS
----------------------------------------------
			checkbox chkbox_VR_AlphaMap "" pos:[-500,-500] height:14 width:13
			dotNetControl dNet_lbl_VR_addAlpha "System.Windows.Forms.Label" pos:[-500,-500] width:55 height:14
			checkbox chkbox_VR_AmbientOcclusion "" pos:[-500,-500] height:14 width:13
			dotNetControl dNet_lbl_VR_addAO "System.Windows.Forms.Label" pos:[-500,-500] width:55 height:14
			checkbox chkbox_VR_BlendMap "" pos:[-500,-500] height:14 width:13
			dotNetControl dNet_lbl_VR_addBlend "System.Windows.Forms.Label" pos:[-500,-500] width:55 height:14 
			checkbox chkbox_VR_CompleteMap "" pos:[-500,-500]  height:14 width:13
			dotNetControl dNet_lbl_VR_addComplete "System.Windows.Forms.Label" pos:[-500,-500] width:55 height:14 
			checkbox chkbox_VR_DiffuseMap "" pos:[-500,-500]  height:14 width:13
			dotNetControl dNet_lbl_VR_addDiffuse "System.Windows.Forms.Label" pos:[-500,-500] width:55 height:14
			checkbox chkbox_VR_HeightMap "" pos:[-500,-500]  height:14 width:13
			dotNetControl dNet_lbl_VR_addHeigh "System.Windows.Forms.Label" pos:[-500,-500] width:55 height:14 
			checkbox chkbox_VR_LightingMap "" pos:[-500,-500]  height:14 width:13
			dotNetControl dNet_lbl_VR_addLight "System.Windows.Forms.Label" pos:[-500,-500]  width:55 height:14 
			checkbox chkbox_VR_normalsMap "" pos:[-500,-500]  height:14 width:13
			dotNetControl dNet_lbl_VR_addNormals "System.Windows.Forms.Label" pos:[-500,-500] width:55 height:14 
			checkbox chkbox_VR_ShadowsMap "" pos:[-500,-500] height:14 width:13
			dotNetControl dNet_lbl_VR_addShadows "System.Windows.Forms.Label" pos:[-500,-500] width:55 height:14 
			checkbox chkbox_VR_SpecularMap "" pos:[-500,-500] height:14 width:13
			dotNetControl dNet_lbl_VR_addSpecular "System.Windows.Forms.Label" pos:[-500,-500]  width:55 height:14 
			checkbox chkbox_VR_UVMap "" pos:[-500,-500] height:14 width:13
			dotNetControl dNet_lbl_VR_addUVmap "System.Windows.Forms.Label" pos:[-500,-500]  width:55 height:14 
----------------------------------------------
	--	SHOW UNIQUE MAPS SETTINGS
----------------------------------------------	
			local selMapUSY = (selMapGBY+15+17+17+17+22)
			local selMapUSZ = 0
		groupbox gbox_MapUniqueSetings "Selected Map Unique Settings" pos:[selMapUSZ,selMapUSY] width:237 height:82
		--	all maps BG color label
			ImgTag lb_BGcolor bitmap:(openBitmap (url+"miauuITBGcolor.png")) pos:[-500,-500]  width:13 height:9  opacity:1 transparent:(color 0 255 255) enabled:off
		--	settings for Alpha Map
			colorpicker colorPick_EleBGColorAlpha "" pos:[-500,-500] fieldwidth:16 height:14 color:black title:"Choose background color for Alpha map."
		-- 	settings for Ambient Occlusion
			dotNetControl dNet_lbl_AOSamples "System.Windows.Forms.Label" pos:[-500,-500] width:47 height:20
			ImgTag lb_AOSamplesBG bitmap:(openBitmap (url+"miauuITaospnsampl.png")) pos:[-500,-500]  width:37 height:17  opacity:1 transparent:(color 0 255 255) enabled:off
			dotNetControl spn_AOSamples "System.Windows.Forms.TextBox" pos:[-500,-500]  width:21 height:15	
			ImgTag btn_AOSamplesUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500]  width:13 height:7  opacity:1 transparent:(color 0 255 255)
			ImgTag btn_AOSamplesDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]   width:13 height:6 opacity:1 transparent:(color 0 255 255)

			dotNetControl dNet_lbl_AObright "System.Windows.Forms.Label" pos:[-500,-500] width:47 height:20
			colorpicker colorPick_AObright "" pos:[-500,-500] fieldwidth:20 height:20 color:white 
			dotNetControl dNet_lbl_AOdark "System.Windows.Forms.Label" pos:[-500,-500]width:47 height:20
			colorpicker colorPick_AOdark "" pos:[-500,-500] fieldwidth:20 height:20 color:black
			
			dotNetControl dNet_lbl_AOSpread "System.Windows.Forms.Label" pos:[-500,-500] width:70 height:20
			dotNetControl dNet_lbl_AOMaxDist "System.Windows.Forms.Label" pos:[-500,-500] width:70 height:20
			dotNetControl dNet_lbl_AOFalloff "System.Windows.Forms.Label" pos:[-500,-500] width:70 height:20
			ImgTag lb_AOSpn3 bitmap:(openBitmap (url+"miauuITaoSpn3.png")) pos:[-500,-500]  width:37 height:55  opacity:1 transparent:(color 0 255 255) enabled:off
			dotNetControl spn_AOSpread "System.Windows.Forms.TextBox" pos:[-500,-500] width:21 height:15	
			ImgTag btn_AOSpreadUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500]  width:13 height:7  opacity:1 transparent:(color 0 255 255)
			ImgTag btn_AOSpreadDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]   width:13 height:6 opacity:1 transparent:(color 0 255 255)
				
			dotNetControl spn_AOMaxDist "System.Windows.Forms.TextBox" pos:[-500,-500] width:21 height:15		
			ImgTag btn_AOMaxDistUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500]  width:13 height:7  opacity:1 transparent:(color 0 255 255)
			ImgTag btn_AOMaxDistDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]   width:13 height:6 opacity:1 transparent:(color 0 255 255)
				
			dotNetControl spn_AOFalloff "System.Windows.Forms.TextBox" pos:[-500,-500] width:21 height:15	
			ImgTag btn_AOFalloffUP bitmap:(openBitmap (url+"miauuSpinnerControl_UP.png")) pos:[-500,-500]  width:13 height:7  opacity:1 transparent:(color 0 255 255)
			ImgTag btn_AOFalloffDown bitmap:(openBitmap (url+"miauuSpinnerControl_Down.png")) pos:[-500,-500]   width:13 height:6 opacity:1 transparent:(color 0 255 255)
            
			colorpicker colorPick_EleBGColorAO "" pos:[-500,-500] fieldwidth:16 height:14 color:white title:"Choose background color for Ambient occlusion map."
				
		-- 	settings  for Blend Map
			ImgTag lb_chkbox_BlendMLight bitmap:(openBitmap (url+"miauuITlighting.png")) pos:[-500,-500]  width:38 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
 			checkbox chkbox_BlendMLight "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_BlendMShadows  bitmap:(openBitmap (url+"miauuITshadows.png")) pos:[-500,-500]  width:45 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_BlendMShadows "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_BlendMDiffuse  bitmap:(openBitmap (url+"miauuITdiffuse.png")) pos:[-500,-500]  width:34 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_BlendMDiffuse "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_BlendMAmbient  bitmap:(openBitmap (url+"miauuITambient.png")) pos:[-500,-500]  width:40 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_BlendMAmbient "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_BlendMSpecular  bitmap:(openBitmap (url+"miauuITspecular.png")) pos:[-500,-500]  width:43 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_BlendMSpecular "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_BlendMSelf_Illum  bitmap:(openBitmap (url+"miauuITself-ilum.png")) pos:[-500,-500] width:41 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_BlendMSelf_Illum "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_BlendMReflection  bitmap:(openBitmap (url+"miauuITreflection.png")) pos:[-500,-500] width:49 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_BlendMReflection "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_BlendMRefraction  bitmap:(openBitmap (url+"miauuITRefraction.png")) pos:[-500,-500] width:50 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_BlendMRefraction "" pos:[-500,-500] height:14 width:13 checked:on
			colorpicker colorPick_EleBGColorBlend "" pos:[-500,-500] fieldwidth:16 height:14 color:black title:"Choose background color for Blend map."
		--	settings for Complete Map
			checkbox chkbox_ComplMShadows "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_ComplMShadows bitmap:(openBitmap (url+"miauuITshadows.png")) pos:[-500,-500]  width:45 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			colorpicker colorPick_EleBGColorCompl "" pos:[-500,-500] fieldwidth:16 height:14 color:black title:"Choose background color for Complete map."
		--	settings for Diffuse Map
 			checkbox chkbox_DiffMLight "" pos:[-500,-500] height:14 width:13
			ImgTag lb_chkbox_DiffMLight  bitmap:(openBitmap (url+"miauuITlighting.png")) pos:[-500,-500] width:38 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
 			checkbox chkbox_DiffMShadows "" pos:[-500,-500] height:14 width:13
			ImgTag lb_chkbox_DiffMShadows  bitmap:(openBitmap (url+"miauuITshadows.png")) pos:[-500,-500]  width:45 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			colorpicker colorPick_EleBGColorDiff "" pos:[-500,-500] fieldwidth:16 height:14 color:black title:"Choose background color for Diffuse map."
		--	settings for Height Map
			colorpicker colorPick_EleBGColorHeight "" pos:[-500,-500] fieldwidth:16 height:14 color:(color 127 127 127) title:"Choose background color for Height map."
		--	settings for Lightning Map
 			checkbox chkbox_LightMShadows "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_LightMShadows  bitmap:(openBitmap (url+"miauuITshadows.png")) pos:[-500,-500] width:45 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_LightMDirectLight "" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_LightMDirectLight  bitmap:(openBitmap (url+"miauuITdirectLightOn.png")) pos:[-500,-500] width:72 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_LightMIndirectLight "s" pos:[-500,-500] height:14 width:13 checked:on
			ImgTag lb_chkbox_LightMIndirectLight bitmap:(openBitmap (url+"miauuITindirectlighton.png")) pos:[-500,-500]  width:79 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			colorpicker colorPick_EleBGColorLight"" pos:[-500,-500] fieldwidth:16 height:14 color:black title:"Choose background color for Lighting map."
		--	settings for Normals Map
			checkbox chkbox_NormalsMOutToBump "" pos:[-500,-500] height:14 width:13
			ImgTag lb_chkbox_NormalsMOutToBump  bitmap:(openBitmap (url+"miauuITnormalBump.png")) pos:[-500,-500]  width:119 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_NormalsMRenderIntoAlphaChannel "" pos:[-500,-500] height:14 width:13
			ImgTag lb_chkbox_NormalsMRenderIntoAlphaChannel  bitmap:(openBitmap (url+"miauuITheightIntoAlpha.png")) pos:[-500,-500]  width:186 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			colorpicker colorPick_EleBGColorNormals "" pos:[-500,-500] fieldwidth:16 height:14 color:(color 128	128	255) title:"Choose background color for Normals map."
		--	settings for Shadows Map
			colorpicker colorPick_EleBGColorShadows "" pos:[-500,-500] fieldwidth:16 height:14 color:black title:"Choose background color for Shadows map."
		--	settings for Specular Map
			checkbox chkbox_SpecMLight "" pos:[-500,-500] height:14 width:13
			ImgTag lb_chkbox_SpecMLight  bitmap:(openBitmap (url+"miauuITlighting.png")) pos:[-500,-500]  width:38 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_SpecMShadows "" pos:[-500,-500] height:14 width:13
			ImgTag lb_chkbox_SpecMShadows  bitmap:(openBitmap (url+"miauuITshadows.png")) pos:[-500,-500] width:45 height:14 opacity:1 transparent:(color 0 255 255) enabled:off
			colorpicker colorPick_EleBGColorSpec "" pos:[-500,-500] fieldwidth:16 height:14 color:black title:"Choose background color for Specular map."
		--	settings for UV map
			checkbox chkbox_modeNone "" pos:[-500,-500] height:14  width:13 checked:on
			checkbox chkbox_modeSolid "" pos:[-500,-500] height:14  width:13 
			checkbox chkbox_modeNormal "" pos:[-500,-500] height:14  width:13 
			checkbox chkbox_modeShaded "" pos:[-500,-500] height:14  width:13
			ImgTag lb_rbtn_Mode  bitmap:(openBitmap (url+"miauuITmodeUV.png")) pos:[-500,-500]  width:47 height:61 opacity:1 transparent:(color 0 255 255) enabled:off
				
			checkbox chkbox_force2sided "" pos:[-500,-500] height:14  width:13 checked:on
			ImgTag lb_chkbox_force2sided  bitmap:(openBitmap (url+"miauuITforce2sided.png")) pos:[-500,-500]  width:65 height:10 opacity:1 transparent:(color 0 255 255) enabled:off

			colorpicker clrPick_fillColor  pos:[-500,-500] height:14 fieldwidth:20 color:(color 127.5 127.5 127.5)
			ImgTag lb_clrPick_fillColor  bitmap:(openBitmap (url+"miauuITfill.png")) pos:[-500,-500]  width:13 height:10 opacity:1 transparent:(color 0 255 255) enabled:off

			checkbox chkbox_showOverlap "" pos:[-500,-500] height:14  width:13 checked:on
			ImgTag lb_chkbox_showOverlap  bitmap:(openBitmap (url+"miauuITshowOverlap.png")) pos:[-500,-500]  width:74 height:11 opacity:1 transparent:(color 0 255 255) enabled:off

			colorpicker clrPick_overlapColor "" height:14 fieldwidth:20 color:(color 255 0 0) pos:[-500,-500]
			
			colorpicker clrPick_edgesColor "" height:14 fieldwidth:20 pos:[-500,-500] color:(color 255 255 255)
			ImgTag lb_clrPick_edgesColor  bitmap:(openBitmap (url+"miauuITedges.png")) pos:[-500,-500]  width:31 height:11 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_visibleEdges "" height:14  width:13 pos:[-500,-500] checked:on
			ImgTag lb_chkbox_visibleEdges  bitmap:(openBitmap (url+"miauuITvisibEdges.png")) pos:[-500,-500]  width:63 height:11 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_invisibleEdges "" height:14  width:13 pos:[-500,-500]
			ImgTag lb_chkbox_invisibleEdges  bitmap:(openBitmap (url+"miauuITinvisbEdge.png")) pos:[-500,-500]  width:70 height:11 opacity:1 transparent:(color 0 255 255) enabled:off
			checkbox chkbox_seemEdges "" pos:[-500,-500] height:14  width:13 checked:on
			ImgTag lb_chkbox_seemEdges  bitmap:(openBitmap (url+"miauuITseemEdge.png")) pos:[-500,-500]  width:73 height:11 opacity:1 transparent:(color 0 255 255) enabled:off
			colorpicker clrPick_seemEdgesColor "" height:14 fieldwidth:20 pos:[-500,-500] color:(color 0 255 0)
------------------------------			
	--	SMART
------------------------------
		ImgTag lb_minUVarea  bitmap:(openBitmap (url+"miauuITsmartUVarea.png")) pos:[-500,-500]  width:114 height:18 opacity:1 transparent:(color 0 255 255) enabled:off
		ImgTag lb_maxUVarea  bitmap:(openBitmap (url+"miauuITsmartUVarea.png")) pos:[-500,-500]  width:114 height:18 opacity:1 transparent:(color 0 255 255) enabled:off
		dotNetControl dNet_lbl_minUVarea "System.Windows.Forms.Label" pos:[-500,-500] width:110 height:16
		dotNetControl dNet_lbl_maxUVarea "System.Windows.Forms.Label" pos:[-500,-500] width:110 height:16				
		--	unimportant load preset
		ImgTag lb_textEditUnimp bitmap:(openBitmap (url+"miauuITsmartPreset.png")) pos:[-500,-500] width:114 height:18 opacity:1 transparent:(color 0 255 255) enabled:off
		dotNetControl dNet_TextBoxUnimp "System.Windows.Forms.TextBox" pos:[-500,-500] width:93 height:17
		ImgTag dNet_TextBoxUnimp_Arrow bitmap:(bitmap 5 5 color:white) pos:[-500,-500] width:20 height:15 opacity:0.0 transparent:(color 255 255 255)
		--	important load preset	
		ImgTag lb_textEditImp bitmap:(openBitmap (url+"miauuITsmartPreset.png")) pos:[-500,-500] width:114 height:18 opacity:1 transparent:(color 0 255 255) enabled:off
		dotNetControl dNet_TextBoxImp "System.Windows.Forms.TextBox" pos:[-500,-500] width:93 height:17
		ImgTag dNet_TextBoxImp_Arrow bitmap:(bitmap 5 5 color:white) pos:[-500,-500] width:20 height:15 opacity:0.0 transparent:(color 255 255 255)
		-- set unimportant and set inportant object buttons
		ImgTag btn_setUnimp bitmap:(openBitmap (url+"miauuITsetUnimp.png")) pos:[-500,-500] width:67 height:19 opacity:1 transparent:(color 0 255 255) \
			tooltip:"Change the status of the currently selected objects to \"minor\"."
		ImgTag btn_setImp bitmap:(openBitmap (url+"miauuITsetImp.png")) pos:[-500,-500] width:67 height:19 opacity:1 transparent:(color 0 255 255) \
			tooltip:"Change the status of the currently selected objects to \"major\"."
		ImgTag btn_showList bitmap:(openBitmap (url+"miauuITlist.png")) pos:[-500,-500] width:53 height:19 opacity:1 transparent:(color 0 255 255) \
			tooltip:"View list of all low-poly objects and what UV area they have."
--------------------------------------
	--	BATCH
--------------------------------------
		ImgTag btn_Batch_getDir bitmap:(openBitmap (url+"miauuITbatchSelDIr.png")) pos:[-500,-500] width:92 height:22 opacity:1 transparent:(color 0 255 255)
		ImgTag btn_Batch_getFile bitmap:(openBitmap (url+"miauuITbatchSelFile.png")) pos:[-500,-500] width:61 height:22 opacity:1 transparent:(color 0 255 255)
		ImgTag btn_Batch_clear bitmap:(openBitmap (url+"miauuITbatchClear.png")) pos:[-500,-500] width:61 height:22 opacity:1 transparent:(color 0 255 255)

		dotNetControl lv_Batch "system.windows.forms.listView" height:175	width:231 pos:[-500,-500]
		
		checkbox btn_Batch_useAll width:14 height:13 pos:[-500,-500] checked:on 
		ImgTag lb_btn_Batch_useAll bitmap:(openBitmap (url+"miauuITbatchUseAll.png")) pos:[-500,-500] width:36 height:11 opacity:1 transparent:(color 0 255 255) enabled:off
		checkbox btn_Batch_useSelected width:14 height:13 pos:[-500,-500]
		ImgTag lb_btn_Batch_useSelected bitmap:(openBitmap (url+"miauuITbatchUseSel.png")) pos:[-500,-500] width:71 height:11 opacity:1 transparent:(color 0 255 255) 
		checkbox btn_Batch_fullPath "" pos:[-500,-500] width:14 height:13 
		ImgTag lb_btn_Batch_fullPath bitmap:(openBitmap (url+"miauuITbatchFullPath.png")) pos:[-500,-500] width:39 height:11 opacity:1 transparent:(color 0 255 255)

		ImgTag lb_chkbox_Batch_skipInst bitmap:(openBitmap (url+"miauuITbatchSkipInst.png")) pos:[-500,-500] width:69 height:11 opacity:1 transparent:(color 0 255 255)
		checkbox chkbox_Batch_skipInst "Skip Instances" pos:[-500,-500]	width:14 height:13
		
		groupbox gp_BatchOutputPath "Output path:" pos:[-500,-500] width:235 height:35
			ImgTag lb_chkbox_Batch_SameAsSource bitmap:(openBitmap (url+"miauuITbatchSameAsSourceFile.png")) pos:[-500,-500] width:91 height:11 opacity:1 transparent:(color 0 255 255) \
				tooltip: "RMB to open all source folders for the listed files."
			checkbox chkbox_Batch_SameAsSource "Same as source file" pos:[-500,-500] width:14 height:13
			ImgTag lb_chkbox_Batch_usePresetOP bitmap:(openBitmap (url+"miauuITbatchUsePrstOutput.png")) pos:[-500,-500] width:83 height:11 opacity:1 transparent:(color 0 255 255) \
				tooltip: "RMB to open the preset output folder."
			checkbox chkbox_Batch_usePresetOP "Use preset output" pos:[-500,-500] width:14 height:13 checked:on
--------------------------------------
	--	LIVE LOG
--------------------------------------	
	--	errors and messages in main rollout
		dotNetControl dnLbl_errMsgTop "System.Windows.Forms.Label" pos:[-300,-300]  width:237 height:16
		dotNetControl dnLbl_errMsg "System.Windows.Forms.Label" pos:[-300,-300]  width:237 height:38
		dotNetControl dnLbl_errMsgMoreInfo "System.Windows.Forms.Label" pos:[-300,-300]  width:237 height:16
		timer clockT "testClock" active:off interval:1000
			
	--	standart spinner for Bake cage or offset method
		spinner sOffset "Offset:" fieldwidth:45 pos:[-700,-700] type:#worldUnits range:[0,1e9,0]
-------------------------------------------------------------------------------------------------------------
	--	save UI position on screen
		on miauuRTTassist moved pos do
		(
			try(destroyDialog MainPresetRO)catch()
			setSysCur #move
			setIniSetting miauuIniFile "Dialog" "Position" (pos as string)
		)
		--	
		function SwitchToModPannel =
		(
			if getCommandPanelTaskMode() != #modify do setCommandPanelTaskMode #modify
		)
		function UpdateCheckCore type msg =
		(
			try
			(
				local RTTcurVer = ((getINISetting miauuIniFile "Version" "ver") as float)
				global RTTnewVer = execute ((dotNetObject "System.Net.WebClient").downloadString "http://www.vertexbee.com/public_files/version.dat")

				if RTTnewVer > RTTcurVer then
				( 
					rollout RTTAssist_Update "RTTAssist Updater" 
					(
						local url= ((pathConfig.GetDir #userscripts)+"\\RTTAssistUI\\RTTAssistIcons\\")
						
						ImgTag ImgTag_BG bitmap:(openBitmap (url+"RTTAssistUpdateBG.png")) pos:[0,0]  \
							width:309 height:194 opacity:1 transparent:(color 0 255 255) enabled:off
						label lb_1 "RTTAssist v0.0 is available!" pos:[12,30]
						label lb_2 "Click update to download and install it." pos:[12,50]
						hyperLink httpOficialSite "Oficial Site" pos:[213,138] color:(color 176 208 231) hoverColor:(color 82 129 181) visitedColor:(color 65 81 100) address:"http://vertexbee.com/rttassist.htm"
						hyperLink httpVideos "Videos" pos:[213,152] color:(color 176 208 231) hoverColor:(color 82 129 181) visitedColor:(color 65 81 100) address:"http://www.youtube.com/user/RTTassist?feature=mexp"
						hyperLink httpchangeLog "View change log" pos:[213,166] color:(color 176 208 231) hoverColor:(color 82 129 181) visitedColor:(color 65 81 100) address:"www.vertexbee.com/public_files/change log.txt"
						button btn_Update "Update" width:138 height:30 pos:[30,103]
						button btn_Cancel "Cancel" width:138 height:30 pos:[30,145]
						
						on RTTAssist_Update open do
						(
							lb_1.text = "RTTAssist v"+ (RTTnewVer as string) + " is available!"
							global onlineUpdate = true
						)
							
						on btn_Update pressed do
						(
							down_link = "http://www.vertexbee.com/public_files/RTTAssist_v16.mzp"
							( dotNetObject "System.Net.WebClient" ).downloadFile down_link ( getDir #temp + "\\RTTAssist.mzp" )					
							try
								(
									fileIn "$temp\\RTTAssist.mzp"
									deleteFile (getDir #temp + "\\RTTAssist.mzp")
									destroydialog RTTAssist_Update
									lb_1.text = "RTTAssist is updatet to version" + (RTTnewVer as string)
									btn_Cancel.text = "Close"
									btn_Update.pos = [-100,-100]
								) 
							Catch
								(
									MessageBox "Error !" title:"RTTAssist Error"
								)
						)
						
						on btn_Cancel pressed do
						(
							onlineUpdate = false
							destroyDialog RTTAssist_Update
						)
						
						on RTTAssist_Update close do
						(
							onlineUpdate = false
						)
					)
					createDialog RTTAssist_Update height:194 width:309 bgcolor:white fgcolor:black
				)
				else
				(
					if type == 2 do
					(
						mssg = "The latest RTTAssist version "+ "("+(RTTcurVer as string)+ ")"+ " is currently installed"
						messagebox mssg title:"No update available"
					)
				)
				RTTnewVer = undefined
			)catch(if type == 2 do messagebox msg title:"RTTAssist Error")
		)
		--	check for updates
		function UpdateCheck =
		(
			msg = "Retriving update information failed!\n"
			msg += " Unable to connect to the remote server!"
			if internet.CheckConnection url:"http://vertexbee.com/rttassist.htm" force:true == true then
			(
				UpdateCheckCore 2 msg
			)
			else
			(				
				messageBox msg title:"RTTAssist Error"
			)
		)
		--	create RC menu with texture map size
		function CreateRCMenuMapSize =
		(
			rcMenu rcMapSize
			(
				menuItem mapSize128 "128 x 128" checked:false
				menuItem mapSize256 "256 x 256" checked:false
				menuItem mapSize512 "512 x 512" checked:false
				menuItem mapSize768 "768 x 768" checked:false
				menuItem mapSize1024 "1024 x 1024" checked:false
				menuItem mapSize2048 "2048 x 2048" checked:false
				menuItem mapSize4096 "4096 x 4096" checked:false
				
				on mapSize128 picked do
				(
					spn_mapWidth.text = "128"
					spn_mapHeight.text = "128"
				)
				on mapSize256 picked do
				(
					spn_mapWidth.text = "256"
					spn_mapHeight.text = "256"
				)
				on mapSize512 picked do
				(
					spn_mapWidth.text = "512"
					spn_mapHeight.text = "512"
				)
				on mapSize768 picked do
				(
					spn_mapWidth.text = "768"
					spn_mapHeight.text = "768"
				)
				on mapSize1024 picked do
				(
					spn_mapWidth.text = "1024"
					spn_mapHeight.text = "1024"
				)
				on mapSize2048 picked do
				(
					spn_mapWidth.text = "2048"
					spn_mapHeight.text = "2048"
				)
				on mapSize4096 picked do
				(
					spn_mapWidth.text = "4096"
					spn_mapHeight.text = "4096"
				)
			) 
		)
		--	create RC menu "save as type" - png,bmp.jpg,tif,tga
		function CreateRCMenuSaveAs =
		(
			rcMenu rcSaveAs
			(
				menuItem saveAsBMP".BMP" checked:false
				menuItem saveAsJPG ".JPG" checked:false
				menuItem saveAsPNG ".PNG" checked:false
				menuItem saveAsTGA ".TGA" checked:false				
				menuItem saveAsTIF ".TIF" checked:false
				menuItem saveAsDDS ".DDS" checked:false
				menuItem saveAsEPS ".EPS" checked:false
				menuItem saveAsHDR ".HDR" checked:false
				menuItem saveAsEXR ".EXR" checked:false
				menuItem saveAsSIG ".SIG" checked:false
				menuItem saveAsRLA ".RLA" checked:false
				menuItem saveAsRPF ".RPF" checked:false
				
				separator separateTypeFromSettigs
				
				submenu "Maps Settings"
				(
					menuItem changeBMPSettings "BMP settings" checked:false
					menuItem changeJPGSettings "JPG settings" checked:false
					menuItem changePNGSettings "PNG settings" checked:false
					menuItem changeTGASettings "TGA settings" checked:false
					menuItem changeTIFSettings "TIF settings" checked:false
				)
				
				on saveAsBMP picked do
				(
					btn_saveAsType.text = ".BMP"
				)
				on saveAsJPG picked do
				(
					btn_saveAsType.text = ".JPG"
				)
				on saveAsPNG picked do
				(
					btn_saveAsType.text = ".PNG"
				)
				on saveAsTGA picked do
				(
					btn_saveAsType.text = ".TGA"
				)
				
				on saveAsTIF picked do
				(
					btn_saveAsType.text = ".TIF"
				)
				on saveAsDDS picked do
				(
					btn_saveAsType.text = ".DDS"
				)
				on saveAsEPS picked do
				(
					btn_saveAsType.text = ".EPS"
				)
				on saveAsHDR picked do
				(
					btn_saveAsType.text = ".HDR"
				)
				on saveAsEXR picked do
				(
					btn_saveAsType.text = ".EXR"
				)
				on saveAsSIG picked do
				(
					btn_saveAsType.text = ".SIG"
				)
				on saveAsRLA picked do
				(
					btn_saveAsType.text = ".RLA"
				)
				on saveAsRPF picked do
				(
					btn_saveAsType.text = ".RPF"
				)
				
				on changeBMPSettings picked do
				(
					btn_saveAsType.text = ".BMP"
					try(destroydialog roBMP)catch()
					rollout roBMP "BMP Image Control" width:195 height:106
					(
						radioButtons rdo_bmpColors "Colors" pos:[7,13] width:182 height:46 labels:#("8 Bit Optimized palette (256 Color)", "RGB 24 bit (16.7 Million Colors)")
						button btn_bmpOK "OK" pos:[134,75] width:56 height:21
						
						on roBMP open do
						(
							colVal = bmp.ibmpio.getType()
							if colVal == #paletted do
								rdo_bmpColors.state = 1
							if colVal == #true24 do
								rdo_bmpColors.state = 2
						)
						
						on btn_bmpOK pressed do
						(
							if rdo_bmpColors.state == 1 do
								bmp.ibmpio.setType #paletted
							if rdo_bmpColors.state == 2 do
								bmp.ibmpio.setType #true24
							
							destroydialog roBMP
						)						
					)
					createdialog roBMP modal:true
				)
				
				on changeJPGSettings picked do
				(
					btn_saveAsType.text = ".JPG"
					try(destroydialog roJPG)catch()
					rollout roJPG "JPEG Image Control" width:117 height:105
					(
						spinner spn_jpgQuality "Quality    " pos:[9,9] width:92 height:16
						spinner spn_jpgSmothing "Smoothing" pos:[9,35] width:92 height:16
						button btn_jpgOK "OK" pos:[29,72] width:55 height:20
						
						on roJPG open do
						(
							qSpn = jpeg.ijpegio.getQuality()
							spn_jpgQuality.value = qSpn
							
							sSpn = jpeg.ijpegio.getSmoothing()
							spn_jpgSmothing.value = sSpn
						)
						
						on btn_jpgOK pressed do
						(
							jpeg.ijpegio.setQuality spn_jpgQuality.value
							jpeg.ijpegio.setSmoothing spn_jpgSmothing.value
							destroydialog roJPG
						)						
					)
					createdialog roJPG modal:true
				)
				
				on changePNGSettings picked do
				(
					btn_saveAsType.text = ".PNG"
					try(destroyDialog roPNG)catch()
					rollout roPNG "PNG Image Control" width:173 height:184
					(
						radiobuttons rdo1 "Colors:" pos:[3,12] width:141 height:94 labels:#("Optimized palette (256)", "RGB 24 bit (16.7 Million)", "RGB 48 bit (281 Trillion)", "Grayscale 8 bit (256)", "Grayscale 16 bit (65.536)") columns:1
						checkbox chkbox_pngAlpha "Alpha channel" pos:[4,117] width:94 height:15
						checkbox chkbox_pngInterleced "Interlaced" pos:[101,117] width:68 height:13
						button btn_pngOK "OK" pos:[48,154] width:55 height:20

						button btn_pngcancel "Cancel" pos:[109,154] width:55 height:20
						
						on roPNG open do
						(
							colVal = portable_network_graphics.ipngio.getType()
							if colVal == #paletted do
								rdo1.state = 1
							if colVal == #true24 do
								rdo1.state = 2
							if colVal == #true48 do
								rdo1.state = 3
							if colVal == #gray8 do
								rdo1.state = 4
							if colVal == #gray16 do
								rdo1.state = 5
							
							chkbox_pngAlpha.state = portable_network_graphics.ipngio.getAlpha()
							chkbox_pngInterleced.state = portable_network_graphics.ipngio.getInterlaced()
						)
						
						on btn_pngOK pressed do
						(
							if rdo1.state == 1 do
								portable_network_graphics.ipngio.setType #paletted
							if rdo1.state == 2 do
								portable_network_graphics.ipngio.setType #true24
							if rdo1.state == 3 do
								portable_network_graphics.ipngio.setType #true48
							if rdo1.state == 4 do
								portable_network_graphics.ipngio.setType #gray8
							if rdo1.state == 5 do
								portable_network_graphics.ipngio.setType #gray16
							
							if chkbox_pngAlpha.state == on then
								portable_network_graphics.ipngio.setAlpha true
							else
								portable_network_graphics.ipngio.setAlpha false
							
							if chkbox_pngInterleced.state == on then
								portable_network_graphics.ipngio.setInterlaced true
							else
								portable_network_graphics.ipngio.setInterlaced false
							
							destroyDialog roPNG
						)
						
						on btn_pngcancel pressed do
						(
							destroyDialog roPNG
						)						
					)
					createdialog roPNG modal:true
				)
				
				on changeTGASettings picked do
				(
					btn_saveAsType.text = ".TGA"
					rollout miauuTGAimageControl "TGA image Control"
					(
						label lb_bpp "Bits-Per-Pixels:" pos:[2,2]
						checkbox chkbox_16 "16" pos:[72,2]
						checkbox chkbox_24 "24" pos:[110,2]
						checkbox chkbox_32 "32" pos:[150,2] 
						
						checkbox chkbox_Compress "Compress" pos:[2,25] 
						checkbox chkbox_AlphaSplit "Alpha Split" pos:[72,25]
						checkbox chkbox_PreMultiAlpha "Pre-Multiplied Alpha" pos:[2,40]
						
						button btn_OK "OK" pos:[150,40] width:45
					
						on miauuTGAimageControl open do
						(
							
							colDep = Targa.getColorDepth()
							if colDep == 16 do
								chkbox_16.state = on
							if colDep == 24 do
								chkbox_24.state = on
							if colDep == 32 do
								chkbox_32.state = on
							
							comprVal = Targa.getCompressed()
							if comprVal == 1 do
								chkbox_Compress.state = on
							
							alphaVal = 	Targa.getAlphaSplit()
							if alphaVal == true do
								chkbox_AlphaSplit.state = on
								
							preMultiVal = Targa.getPreMultAlpha()
							if preMultiVal == true do
								chkbox_PreMultiAlpha.state = on
							
						)
						on chkbox_16 changed theState do
						(
							if theState then
							(
								chkbox_24.state = off
								chkbox_32.state = off
							)
							else
							(
								if chkbox_24.state == off and chkbox_32.state == off do
									chkbox_16.state = on
							)
						)
						on chkbox_24 changed theState do
						(
							if theState then
							(
								chkbox_16.state = off
								chkbox_32.state = off
							)
							else
							(
								if chkbox_16.state == off and chkbox_32.state == off do
									chkbox_24.state = on
							)
						)
						on chkbox_32 changed theState do
						(
							if theState then
							(
								chkbox_16.state = off
								chkbox_24.state = off
							)
							else
							(
								if chkbox_16.state == off and chkbox_24.state == off do
									chkbox_32.state = on
							)
						)
						on btn_OK pressed do
						(
							if chkbox_16.state == on do
								targa.itgaio.setColorDepth 16
							if chkbox_24.state == on do
								targa.itgaio.setColorDepth 24
							if chkbox_32.state == on do
								targa.itgaio.setColorDepth 32
							
							if chkbox_Compress.state == on then
								targa.itgaio.setCompressed true
							else
								targa.itgaio.setCompressed false
							if chkbox_AlphaSplit.state == on then
								targa.itgaio.setAlphaSplit true
							else
								targa.itgaio.setAlphaSplit false
							if chkbox_PreMultiAlpha.state == on then
								targa.itgaio.setPreMultAlpha true
							else
								targa.itgaio.setPreMultAlpha false
							
							destroydialog miauuTGAimageControl
							
						)
					)
					createdialog miauuTGAimageControl width:200 modal:true
				)
				on changeTIFSettings picked do
				(
					btn_saveAsType.text = ".TIF"
					try(destroyDialog roTIF)catch()
					rollout roTIF "TIF Image Control" width:286 height:147
					(
						radiobuttons rdo_tifImageType "Image Type" pos:[4,12] width:112 height:94 labels:#("8-bit Greyscale", "8-bit Color", "16-bit Color", "16-bit SGI LogL", "32-bit SGI LogLUV")
						checkbox chkbox_tifStoreAlpha "Store Alpha Channel" pos:[4,115] width:130 height:16
						radiobuttons rdo_tifCompression "Compression Type" pos:[145,10] width:100 height:46 labels:#("No Compression", "Packbits") columns:1
						spinner spn_tifDPI "Dots Per Inch  " pos:[180,76] width:100 height:16 enabled:false
						button btn_tifOK "OK" pos:[142,110] width:66 height:24
						button btn_tifCancel "Cancel" pos:[217,110] width:66 height:24
						
						on roTIF open do
						(
							colVal = tif.itifio.getType()
							if colVal == #mono do
								rdo_tifImageType.state = 1
							if colVal == #color do
								rdo_tifImageType.state = 2
							if colVal == #color16   do
								rdo_tifImageType.state = 3
							if colVal == #logL  do
								rdo_tifImageType.state = 4
							if colVal == #logLUV  do
								rdo_tifImageType.state = 5
							
							comprVal = tif.itifio.getCompression()
							if comprVal == #none do
								rdo_tifCompression.state = 1
							if comprVal == #packBits do
								rdo_tifCompression.state = 2
							
							alphVal = tif.itifio.getAlpha()
							if alphVal == true then
								chkbox_tifStoreAlpha.state = on
							else
								chkbox_tifStoreAlpha.state = off
							
							spn_tifDPI.value = tif.itifio.getDPI()
							
						)
						
						on btn_tifOK pressed do
						(
							if rdo_tifImageType.state == 1 do
								tif.itifio.setType #mono
							if rdo_tifImageType.state == 2 do
								tif.itifio.setType #color
							if rdo_tifImageType.state == 3 do
								tif.itifio.setType #color16
							if rdo_tifImageType.state == 4 do
								tif.itifio.setType #logL
							if rdo_tifImageType.state == 5 do
								tif.itifio.setType #logLUV
							
							if rdo_tifCompression.state == 1 do
								tif.itifio.setCompression #none
							if rdo_tifCompression.state == 2 do
								tif.itifio.setCompression #packBits
							
							if chkbox_tifStoreAlpha.state == on then
								tif.itifio.setAlpha #true
							else
								tif.itifio.setAlpha #false
							
-- 							TIF.setDPI  = spn_tifDPI.value	--	now worked. Why?????!!!!!
							
							destroyDialog roTIF
						)
						
						on btn_tifCancel pressed do
						(
							destroyDialog roTIF
						)						
					)
					createdialog roTIF modal:true
				)
			)
		)
		--	help RC menu
		function CreateRCMenuHelp =
		(
			rcMenu rcRTTassistHelp
			(
				menuItem help "Help" checked:false
				menuItem onlineTuts "Online video tutorials" checked:false
				menuItem checkForUpdate "Check for update" checked:false
				
				on help picked do
				(
					--	open help file
					helpFileLocation = GetDir #userscripts + "\\RTTassistUI\\help.chm"
					ShellLaunch helpFileLocation ""
				)
				
				on onlineTuts picked do
				(
					--	open browser and go to tutorial pages
					ShellLaunch @"http://www.youtube.com/user/RTTassist?feature=mexp"  ""
				)
				
				on checkForUpdate picked do
				(
					UpdateCheck()
				)
			)
		)
		-- function to make a filename valid by replacing illegal characters with a '_'
		function MakeFileNameValid fileName = -- fname must be just filename, no path....
		(
			local illegal_characters =":/\\~!@#$%^&*()+=|'?><;[]{}\"" -- illegal characters in file name
			local res = copy fileName
			
			-- make sure the object name is legal for a filename
			local count = res.count
			for i = 1 to count do
				if (findString illegal_characters res[i]) != undefined do -- replace illegal characters with _
					res[i] = "_"
			
			res
		)
		--	check if directory specified as outputpath exist
		function ValidateDirectory _dirNameIn  =
		(
			local _dirName = copy _dirNameIn
			-- remove terminating '\' or '/' character
			local c
			for i = _dirName.count to 1 by -1 while (c=_dirName[i]; c=="\\" or c== "/") do
				_dirName = subString _dirName 1 (i-1)
			
			if doesFileExist _dirName then
				dirExists = true
			else
				dirExists = false
			
			dirExists
		)
		--	file overwrite rollout
		function FileOverwrite  fileName = 
		(
			fileNameForOverwrite = fileName
			rollout fileOverwriteBox "File Exists" width:400 height:113
			(
				local buttonWidth = 90
				button bCancel "Cancel Render" pos:[202,63] width:buttonWidth height:24
				button bOverwriteFiles "Overwrite Files" pos:[99,63] width:buttonWidth height:24
				checkbox cNotAgain "Don't show this message again" pos:[10,90] checked:false 
				groupBox gFile "Confirm File Overwrite:" pos:[3,8] width:393 height:50
				label eFileName "" pos:[4,27] 

				on fileOverwriteBox open do
				(
					overwriteFileName = miauuRTTassist.fileNameForOverwrite
					
					local requiredTextExtent = ((getTextExtent  overwriteFileName).x) + 10
					fileOverwriteBox.width= requiredTextExtent+20
					
					if fileOverwriteBox.width < 200 do
						fileOverwriteBox.width = 210
					
					gFile.width = fileOverwriteBox.width - 7
					local center = ((fileOverwriteBox.width) / 2)
					bOverwriteFiles.pos.x = center - (buttonWidth + 8) 
					bCancel.pos.x = center + 8  					

					eFileName.pos.x = center
					eFileName.text = overwriteFileName 					
				)  
				on bCancel pressed do 
				(
					miauuRTTassist.CancelRenderProcess = true
					destroydialog fileOverwriteBox
				)
				on bOverwriteFiles pressed do
				(
					miauuRTTassist.overwriteAllFile = if cNotAgain.checked then true else false
					destroydialog fileOverwriteBox
				)
				
			)
			createDialog  fileOverwriteBox fgcolor:red modal:true
		)
		--	check and rename duplicate by name objects 		
		function NodeNamesOK _ObjectList =
		(
			local res = true
			dupsFound = false
			--	store duplicate objects handle
 			local allDupsObjHandles = #()
			--	store duplicate objects names
			local allDupsObjName = #()
			
			--	find duplicate objects
			doubledLPObj = #()
			uniqLPobjName = for s in _ObjectList collect s.name
			uniqLPobjNameCOPY = copy uniqLPobjName #nomap
				--	make a uniq array of all names
			allLPobjNameUNIQ = makeUniqueArray uniqLPobjNameCOPY
			for i = 1 to allLPobjNameUNIQ.count do
			(
				tempArr = #() as array
				for j = 1 to uniqLPobjName.count do
				(
					
					if allLPobjNameUNIQ[i] == uniqLPobjName[j] do
						append tempArr _ObjectList[j]
				)
				if tempArr.count > 1 do
				(
					join doubledLPObj tempArr
				)
			)
			-- if twins is found get their names, right in ini file, rename them and go to render 
			if doubledLPObj.count != 0 then
			(
				dupsFound = true
				--	get unique indexes and names for duplicate obj
				for d in doubledLPObj do
				(
					xHandle = GetHandleByAnim d
					append allDupsObjHandles xHandle
					append allDupsObjName d.name
				)
				if startBatchRender == false do
				(
					setIniSetting miauuIniFile "SmartRename" "oN" (allDupsObjName as string)
					setIniSetting miauuIniFile "SmartRename" "pN" (allDupsObjHandles as string)
				)
			
				--	rename duplicate obj
				local nodeNames = #()
				local noDupes = true
				for o in _ObjectList do
				(
					if noDupes do noDupes = (findItem nodeNames o.name) == 0
					append nodeNames o.name
				)
				for i = 1 to _ObjectList.count do
				(
					nodeNames[i] = &undefined
					local k
					while ((k = findItem nodeNames _ObjectList[i].name) != 0) do
						_ObjectList[k].name = nodeNames[k] = uniqueName (_ObjectList[k].name+"_")
				)
			)
			res
		)
		--	return original names of duplicate objects
		function SetOriginalNames =
		(
			allDupsObjName = (readValue ((getIniSetting miauuIniFile "SmartRename" "oN") as stringStream))
			allDupsObjHandles = (readValue ((getIniSetting miauuIniFile "SmartRename" "pN") as stringStream))
			--	set original names
			for i = 1 to allDupsObjHandles.count do
			(
				a = GetAnimByHandle allDupsObjHandles[i]
				a.name = allDupsObjName[i]
				
			)
			delIniSetting miauuIniFile "SmartRename" "oN"
			delIniSetting miauuIniFile "SmartRename" "pN"			
			messagebox "There are Low-Poly objects with duplicate names!\nRTTassist changed the names of the output\nmaps in order to avoid overwriting." title:"RTTAssist Live Log"
		)
		--	check baked objects for applied material
		function CheckObjMaterial _NodesList =
		(
			objWithNoMat = #() as array
			with undo off 
			(
				select _NodesList
				
				for i = 1 to _NodesList.count do
				(	
					local obj = _NodesList[i]
					-- if no material on node, set to standard material. This is needed in order for supersampling to operate correctly.
					local noMtl = obj.material
					if noMtl == undefined do
					(
						obj.material = standard shaderType:5 diffuseColor:obj.wirecolor specularcolor:(color 51 51 51) specularLevel:100 glossiness:20 soften:0
						append objWithNoMat obj
					)	
				)
			)
		)
		--	check wich renderer is active
		function ActiveRenderer =
		(
			local renderer = renderers.current
			local rendererClass = classof renderer
			local txt
			if rendererClass == Default_Scanline_Renderer then
			(
				activeRender = "scanline"
			)
			else
			(	
				if (rendererClass == mental_ray_renderer) then
				(
					activeRender = "mRay"
				)
				else
					activeRender = "Unknown Renderer Type"
			)
			activeRender
		)
		--	change renderers for filtering settings
		function UpdateFilterSettings =
		(
			local renderer = renderers.current
			local rendererClass = classof renderer
			local txt
			if rendererClass == Default_Scanline_Renderer then
			(
				lb_scanline.bitmap = (openBitmap (url+"miauuITscanlineActive.png"))
				lb_mRay.bitmap = (openBitmap (url+"miauuITmentalRay.png"))
				txt = "G.Supersampler: "
				if renderer.globalSamplerEnabled then
					append txt renderer.globalSamplerClassByName
				else
					append txt "None"
			)
			else if (rendererClass == mental_ray_renderer) then
			(
				lb_scanline.bitmap = (openBitmap (url+"miauuITscanline.png"))
				lb_mRay.bitmap = (openBitmap (url+"miauuITmentalRayActive.png"))
				txt = "Samples per pixel: "
				local n = amax renderer.MinimumSamples 0
				local m = amax renderer.MaximumSamples 0
				append txt ((4^n) as string)
				txt += " - " +(((4^m) as string))
			)
			else
				txt = "Unknown Renderer Type"
			
			lb_filteringOptions.text = txt
		)
		function RendererPropChanged =
		(
			UpdateFilterSettings()
		)
		function RendererChanged =
		(
			deleteChangeHandler rendererChange 
			rendererChange = when parameters renderers.current change do RendererPropChanged()
			UpdateFilterSettings()
		)
		--	highlight proper imgtag - Scanline ot mRay
		function CheckActiveRender =
		(
			--	check wich renderer is active and show if there is a filtering added
			UpdateFilterSettings()
			--	check wich renderer is active and highlight proper imgtag
			aR = ActiveRenderer()
			if aR == "scanline" then
				lb_scanline.bitmap = (openBitmap (url+"miauuITscanlineActive.png"))	
			else
			(
				if aR == "mRay" then 
					lb_mRay.bitmap = (openBitmap (url+"miauuITmentalRayActive.png"))
				else
				(
					CancelRenderProcess = false
					lb_scanline.bitmap = (openBitmap (url+"miauuITscanline.png"))
					lb_mRay.bitmap = (openBitmap (url+"miauuITmentalRay.png"))
					messagebox "The current renderer is not supported.\nSwitch to Scanline or Mental Ray!" title:"RTTAssist Live Log"
				)
			)	
			aR
		)
---------------------------------------------	
	--	dotNet Batch ListView Function
---------------------------------------------
		function AddColumns theLv columnsAr=
		(
			if btn_Batch_fullPath.state == off then
				w=(theLv.width)-6
			else
				w=(theLv.width)+400
			for x in columnsAr do
			(
				theLv.columns.add x w
			)
		)
		function PopulateListView theLv=
		(
			rows=#()
			for x=1 to maxFiles.count do
			(
				if btn_Batch_fullPath.state == off then
					mapName = (getFilenameFile maxFiles[x])
				else
					mapName = maxFiles[x]
				
				li=dotNetObject "System.Windows.Forms.ListViewItem" mapName
				append rows li
			)
			theLv.items.addRange rows 
		)
		function InitListView theLv=
		(			
			theLv.clear()
			theLv.view=(dotNetClass "system.windows.forms.view").details
			theLv.FullRowSelect=true	
			theLv.MultiSelect=true	
			theLv.checkBoxes=true				
			theLv.backcolor = (dotNetClass "System.Drawing.Color").DimGray
			theLv.forecolor = (dotNetClass "System.Drawing.Color").lightGray
		)
		function BatchListViewReIinit =
		(
			InitListView lv_Batch
			AddColumns lv_Batch #("Files")	
			PopulateListView lv_Batch
		)
		function TurnBatchLVchkBoxOn =
		(
			for i = 0 to lv_Batch.Items.count-1 do
				lv_Batch.Items.Item[i].checked = true
			lv_Batch.forecolor = disableForeColor
		)
---------------------------------------------
		--	disable the skin modifier to prevent errors when exploding
		function DisableSkin isThereModifier modifierCount =
		(
			for m = 1 to modifierCount do
			(
				if (classof isThereModifier[m]) == Skin do
					isThereModifier[m].enabled = false
			)
		)		
		function EnableSkin isThereModifier modifierCount =
		(
			for m = 1 to modifierCount do
			(
				if (classof isThereModifier[m]) == Skin do
					isThereModifier[m].enabled = true
			)
		)
	--	FUNCTIONs TO INITIALIZE DOTNET CONTROLS
		--	populate dotNet spinners
		function PopulateDotNetSpinners spn_name spn_value =
		(
			spn_name.BorderStyle = dNetBorderStyle
			spn_name.font = dN_sysDrawFont
			spn_name.text = spn_value
			spn_name.foreColor = spn_name.foreColor.lightGray
			spn_name.backcolor = spn_name.backcolor.DimGray
		)
		--	show settings in dotNet spinners
		function ShowDotNetSpinnersValue spn_name spn_value =
		(
			spn_name.BorderStyle	= dNetBorderStyle
			spn_name.text = spn_value	
			spn_name.foreColor = spn_name.foreColor.lightGray
			spn_name.backcolor = spn_name.backcolor.DimGray
		)
		--	show dotNet label text with gray background
		function ShowDotNetLabelsText tb_name tb_value =
		(
			tb_name.text = tb_value
			tb_name.foreColor = tb_name.foreColor.lightGray
			tb_name.backcolor = tb_name.backcolor.Gray
			tb_name.font = dN_sysDrawFont
		)
		--	show dotNet label text with dimGray background
		function ShowDotNetLabelsTextDimGray tb_name tb_value =
		(
			tb_name.text = tb_value
			tb_name.foreColor = tb_name.foreColor.lightGray
			tb_name.backcolor = tb_name.backcolor.DimGray
			tb_name.font = dN_sysDrawFont
		)
		--	dotNet font style
		function DotNetFont ctrlName =
		(
			dnFontStyle = dotNetClass "System.Drawing.FontStyle"
			myFontStyle = dotnet.combineenums dnFontStyle.bold
			ctrlName.font = dotNetObject "System.Drawing.Font" "Arial" 8 myFontStyle
		)
		--	show text in dotNet textboxes
		function FillDotNetTB tb_name tb_value tb_color=
		(
			tb_name.BorderStyle	= dNetBorderStyle
			tb_name.text = tb_value
			tb_name.foreColor = tb_color
			tb_name.backcolor = tb_name.backcolor.DimGray
			DotNetFont tb_name 
		)
		
		on miauuRTTassist open do
		(	
			CreateRCMenuMapSize()
			CreateRCMenuSaveAs()
			CreateRCMenuHelp()
			--	monitor renderer change
			rendererChange = when parameters renderers.current change do RendererPropChanged()
			callbacks.addscript #postRendererChange "miauuRTTassist.RendererChanged()" id:#miauuRTTassist_rendererChange
			callbacks.addscript #postRendererChange "miauuRTTassist.RendererChanged()" id:#miauuRTTassist_rendererChange
			UpdateFilterSettings()
			--	create callbacks to Implode objects when user save the file
			callbacks.addScript #filePreSaveProcess "miauuRTTassist.ImplodeOnSave()" id:#miauuRTTAssist_ImplodeOnSave
			callbacks.addScript #filePostSave "miauuRTTassist.ExplodeAfterSave()" id:#miauuRTTAssist_ExplodeAfterSave
			--	assign value of prefix variables
			global prefixNameLP = ((getIniSetting miauuIniFile "Prefix" "LP") as string)
			global prefixNameHP = ((getIniSetting miauuIniFile "Prefix" "HP") as string)
			global dividerStr = ((getIniSetting miauuIniFile "Prefix" "divideSymb") as string)
			--	to pin or not ErrorMessages in rollout
			pinRolloutErrMssg = (readValue((getIniSetting miauuIniFile "Pin" "State") as stringStream))
			if (pinRolloutErrMssg == 0) then
				btn_errInRollOutPin.bitmap = (openBitmap (url+"miauuITpin.png"))
			else
				btn_errInRollOutPin.bitmap = (openBitmap (url+"miauuITunpin.png")) 
			----------------------------------------------
			--	batch listview
			InitListView lv_Batch
			AddColumns lv_Batch #("Files")
			allIndexes = #()
			----------------------------------------------
			PopulateDotNetSpinners  dNet_TxtBoxAsSpinner "1.0"			
			PopulateDotNetSpinners  dNet_smartSpinner "0.0"
			PopulateDotNetSpinners  dNet_cagePushSpinner "0.0"
			--------------------------------------------	
		--	show text in Selection dotNet labels 
			ShowDotNetLabelsTextDimGray dNet_Label_selLP prefixNameLP
			DotNetFont dNet_Label_selLP
			dNet_LP_label_Tooltip = dotnetobject "System.Windows.Forms.ToolTip"
			dNet_LP_label_Tooltip.SetToolTip dNet_Label_selLP "LMB to select all Low-Poly objects!\nRMB to select only main Low-Poly objects!\nMMB to select only secondary Low-Poly objects!\nCtrl+LMB to add to the current High-Poly selection its corresponding Low-Poly objects."
			dNet_LP_label_Tooltip.Active = True 
			
			ShowDotNetLabelsTextDimGray dNet_Label_selHP prefixNameHP
			DotNetFont dNet_Label_selHP
			dNet_HP_label_Tooltip = dotnetobject "System.Windows.Forms.ToolTip"
			dNet_HP_label_Tooltip.SetToolTip dNet_Label_selHP "LMB to select all High-Poly objects!\nRMB to select only main High-Poly objects!\nMMB to select only secondary High-Poly objects!\nCtrl+LMB to add to the current Low-Poly selection its corresponding High-Poly objects.\nShift+LMB to select all High-Poly objects from this pair."
			dNet_HP_label_Tooltip.Active = True 	
			
			dNet_TextBox_LP.BorderStyle = dNetBorderStyle
			dNet_TextBox_LP.font = dN_sysDrawFont
			dNet_TextBox_LP.foreColor = dNet_TextBox_LP.foreColor.lightGray
			dNet_TextBox_LP.backcolor = dNet_TextBox_LP.backcolor.DimGray

			dNet_TextBox_HP.BorderStyle = dNetBorderStyle
			dNet_TextBox_HP.font = dN_sysDrawFont
			dNet_TextBox_HP.foreColor = dNet_TextBox_HP.foreColor.lightGray
			dNet_TextBox_HP.backcolor = dNet_TextBox_HP.backcolor.DimGray
			
			edittxt_SecondNameDivider.BorderStyle	= dNetBorderStyle
 			edittxt_SecondNameDivider.text = dividerStr
			edittxt_SecondNameDivider.font = dotNetObject "System.Drawing.Font" "Arial" 7
			edittxt_SecondNameDivider.foreColor = edittxt_SecondNameDivider.foreColor.lightGray
			edittxt_SecondNameDivider.backcolor = edittxt_SecondNameDivider.backcolor.DimGray
			
			et_buildParisName.BorderStyle	= dNetBorderStyle
 			et_buildParisName.text = "   enter name"
			et_buildParisName.font = dotNetObject "System.Drawing.Font" "Arial" 7
			et_buildParisName.foreColor = et_buildParisName.foreColor.lightGray
			et_buildParisName.backcolor = et_buildParisName.backcolor.DimGray
		----------------------------------------
		--	settings dotnet controls
			ShowDotNetSpinnersValue spn_faces_threshold ((getIniSetting miauuIniFile "Spinner" "spn_faces_threshold") as string)	
			ShowDotNetSpinnersValue spn_sTime ((getIniSetting miauuIniFile "Spinner" "spn_sTime") as string)
			ShowDotNetSpinnersValue spn_animDistance ((getIniSetting miauuIniFile "Spinner" "spn_animDistance") as string)
		----------------------------------------	
		--	show text in main render dialog
			ShowDotNetLabelsTextDimGray btn_BrowseFolder ((getIniSetting miauuIniFile "Render" "OutpuPath") as string)			
			dNet_btn_BrowseFolder_Tooltip = dotnetobject "System.Windows.Forms.ToolTip"
			dNet_btn_BrowseFolder_Tooltip.ToolTipTitle = "LMB to select output Path: RMB to open selected folder"
			dNet_btn_BrowseFolder_Tooltip.SetToolTip btn_BrowseFolder (btn_BrowseFolder.text as string)
			dNet_btn_BrowseFolder_Tooltip.Active = True 
			--
			btn_saveAsType.text = ((getIniSetting miauuIniFile "Render" "FileExtension") as string)
			btn_saveAsType.foreColor = (dotNetClass "System.Drawing.Color").fromARGB 66 65 65 
			btn_saveAsType.backcolor = (dotNetClass "System.Drawing.Color").fromARGB 137 136 136
			btn_saveAsType.font = dN_sysDrawFont
			--
			ShowDotNetLabelsText dnet_lb_mapWidth "W:"
			ShowDotNetLabelsText dnet_lb_mapHeight "H:"
			--
			ShowDotNetSpinnersValue spn_mapWidth "512"
			ShowDotNetSpinnersValue spn_mapHeight "512" 
		------------------------------------------------------------------
		--	save preset system-
			FillDotNetTB dNet_TextBoxSP "Enter name" (dNet_TextBoxSP.foreColor.lightGray) 

		------------------------------------------------------------------
		--	smart system
			--	unimportant object
			FillDotNetTB dNet_TextBoxUnimp "Enter name" ((dotNetClass "System.Drawing.Color").fromARGB 140 25 25) 
			
			dNet_lbl_minUVarea.text = "min UV area:"
			dNet_lbl_minUVarea.foreColor = (dotNetClass "System.Drawing.Color").fromARGB 140 25 25
			dNet_lbl_minUVarea.backcolor = dNet_lbl_minUVarea.backcolor.DimGray
			DotNetFont dNet_lbl_minUVarea 
			
			--	important object
			FillDotNetTB dNet_TextBoxImp "Enter name" ((dotNetClass "System.Drawing.Color").fromARGB 0 46 17)
			
			dNet_lbl_maxUVarea.text = "max UV area:"
			dNet_lbl_maxUVarea.foreColor = (dotNetClass "System.Drawing.Color").fromARGB 0 46 17
			dNet_lbl_maxUVarea.backcolor = dNet_lbl_maxUVarea.backcolor.DimGray
			DotNetFont  dNet_lbl_maxUVarea

		------------------------------------------------------------------
		--	show text of projection mapping checkboxes and labels
			ShowDotNetSpinnersValue spn_Padding "1"
			ShowDotNetSpinnersValue spn_UVChannel "1"
			ShowDotNetSpinnersValue spn_Offset "0.0"
			
			lb_filteringOptions.text = "No filtering:"
			lb_filteringOptions.font = dN_sysDrawFont
			lb_filteringOptions.foreColor = lb_filteringOptions.foreColor.lightGray
			lb_filteringOptions.backcolor = lb_filteringOptions.backcolor.DimGray
		-------------------------------------------	
		--	show text of add Maps labels
			ShowDotNetLabelsText dNet_lbl_addAlpha "Alpha"
			ShowDotNetLabelsText dNet_lbl_addAO "AO(MR)"
			ShowDotNetLabelsText dNet_lbl_addBlend "Blend"
			ShowDotNetLabelsText dNet_lbl_addComplete "Complete"
			ShowDotNetLabelsText dNet_lbl_addDiffuse "Diffuse"
			ShowDotNetLabelsText dNet_lbl_addHeigh "Height"
			ShowDotNetLabelsText dNet_lbl_addLight "Lighting"
			ShowDotNetLabelsText dNet_lbl_addNormals "Normals"
			ShowDotNetLabelsText dNet_lbl_addShadows "Shadows"
			ShowDotNetLabelsText dNet_lbl_addSpecular "Specular"
			ShowDotNetLabelsText dNet_lbl_addUVmap "UV map"
		------------------------------------------------------
		--	show text in selected map uniqie settings
 		-- for AO
			ShowDotNetLabelsText dNet_lbl_AOSamples "Samples"
			ShowDotNetSpinnersValue spn_AOSamples "16"
			--	
			ShowDotNetLabelsText dNet_lbl_AObright "Bright"
			ShowDotNetLabelsText dNet_lbl_AOdark "Dark"
			--
			ShowDotNetSpinnersValue spn_AOSpread "0.8"
			ShowDotNetSpinnersValue spn_AOMaxDist "0.0"
			ShowDotNetSpinnersValue spn_AOFalloff "1.0"
			--
			ShowDotNetLabelsText dNet_lbl_AOSpread "Spread"
			ShowDotNetLabelsText dNet_lbl_AOMaxDist "Max Dist"
			ShowDotNetLabelsText dNet_lbl_AOFalloff "Falloff"
			
			--	delete zero point helper objects
			for h in objects where h.name== "RTTassist Zero Point" do delete h
			--	get all objects in scene
			selObj = #() as array
			for o in objects where classof o != Biped_Object and superClassOf o != helper do
				append selObj o

			chkbtn_All.bitmap = (openBitmap (url+"miauuITAllobjHover.png"))

			chkbox_AutoCheckOverlap.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_AutoCheckOverlap") as stringStream))
			chkbox_isNodeFrozen.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_isNodeFrozen") as stringStream))
			chkbox_noCageReset.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_noCageReset") as stringStream))
			chkbox_OnOffAnimation.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_OnOffAnimation") as stringStream))
			chkbox_errInViewport.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_errInViewport") as stringStream))
			chkbox_errInRollOut.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_errInRollOut") as stringStream))
			chkbox_errInMsgBox.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_errInMsgBox") as stringStream))
			chkbox_explodeFromTop.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_explodeFromTop") as stringStream))
			chkbox_explodeFromCenter.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_explodeFromCenter") as stringStream))
			chkbox_explodeFromBottom.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_explodeFromBottom") as stringStream))
			chkbox_ZeroPoint.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_ZeroPoint") as stringStream))
			chkbox_moveZeroPointObj.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_moveZeroPointObj") as stringStream))
			chkbox_checkUpdateOnStatUp.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_checkUpdateOnStatUp") as stringStream))
				
			CheckActiveRender()
			curRend = CheckActiveRender()				
			--	auto check for Update
			if chkbox_checkUpdateOnStatUp.state == true do
				UpdateCheckCore 1 ""
		)
-------------------------------------------------------------------------------------------------------------
	--	FUNCTIONS
-------------------------------------------------------------------------------------------------------------		
		function RemoveOnlyRenderSttings =
		(
			local renderControls = #(lb_BrowseFolder,btn_BrowseFolder,btn_saveAsType, btn_SavePrst,chkbox_combMaps,btn_CombineSing, \
				dnet_lb_mapWidth,spn_mapWidth,lb_combMaps,lb_saveAsType,lb_saveAsTypeArrow,chkbox_previewVFB,lb_preview, \
				dnet_lb_mapHeight,spn_mapHeight,ImgTag_getMapSize,ImgTag_LockSize,lb_colorpickerBG,dnLbl_errMsgTop,dNet_TextBoxSP_Arrow, \
				lb_textEdit,dNet_TextBoxSP,btn_delete,btn_openMapSettings,lb_spn_mapHeight,lb_spn_mapWidth,dnLbl_errMsg,dnLbl_errMsgMoreInfo, \
				chkbox_renderIsolate,lb_chkbox_renderIsolate,chkbox_redrawViews,lb_chkbox_redrawViews,chkbox_selSets,lb_selSets,chkbox_hideFacesMR, \
				lb_chkbox_hideFacesMR)
			for c in renderControls do
			(
				c.pos = [-400,-400]
			)
		)
		function RemoveOnlySettings =
		(
			local settingsControl = #(spn_faces_threshold,chkbox_AutoCheckOverlap,chkbox_isNodeFrozen, \
				chkbox_noCageReset,grpbox_animation,spn_sTime,spn_animDistance,chkbox_OnOffAnimation, \
				grpbox_errMsg,chkbox_errInViewport,chkbox_errInRollOut,chkbox_errInMsgBox,grpbox_explodeFrom,lb_faces_threshold, \
				chkbox_explodeFromTop,chkbox_explodeFromCenter,chkbox_explodeFromBottom,chkbox_ZeroPoint,btn_saveSettings,\
				chkbox_moveZeroPointObj,btn_faces_thresholdDown,btn_cancelSettings,chkbox_checkUpdateOnStatUp,lb_chkbox_checkUpdateOnStatUp, \
				btn_faces_thresholdUP,spn_faces_thresholdBG,lb_chkbox_AutoCheckOverlap,lb_chkbox_isNodeFrozen, \
				lb_chkbox_noCageReset,lb_chkbox_OnOffAnimation,lb_chkbox_explodeFromTop,lb_chkbox_explodeFromCenter, \
				lb_chkbox_explodeFromBottom,lb_chkbox_ZeroPoint,lb_chkbox_moveZeroPointObj,lb_animSpnBG, \
				btn_sTimeUP,btn_sTimeDown,btn_animDistanceUP,btn_animDistanceDown,lb_chkbox_errInViewport,lb_chkbox_errInRollOut, \
				lb_chkbox_errInMsgBox,dnLbl_errMsgTop,dnLbl_errMsgMoreInfo,dnLbl_errMsg,btn_errInRollOutPin)
			for sC in settingsControl do
			(
				sC.pos = [-400,-400]
			)
		)
		function RemoveOnlySmartSettings =
		(
			local smartControls = #(dNet_lbl_minUVarea, dNet_lbl_maxUVarea, lb_minUVarea, lb_maxUVarea, lb_textEditUnimp, dNet_TextBoxUnimp,\
				dNet_TextBoxUnimp_Arrow, lb_textEditImp, dNet_TextBoxImp, dNet_TextBoxImp_Arrow, btn_setUnimp, btn_setImp, btn_showList)
			for sC in smartControls do
			(
				sC.pos = [-400,-400]
			)			
		)
		function RemoveOnlyBatchSettings =
		(
			local batchControls = #(btn_Batch_getDir, btn_Batch_getFile, btn_Batch_fullPath, lv_Batch, \
				chkbox_Batch_skipInst, btn_Batch_useAll, btn_Batch_useSelected, btn_Batch_clear,gp_BatchOutputPath, \
				chkbox_Batch_SameAsSource, chkbox_Batch_usePresetOP,lb_btn_Batch_fullPath,lb_chkbox_Batch_usePresetOP, \
				lb_chkbox_Batch_SameAsSource, lb_chkbox_Batch_skipInst,LB_btn_Batch_useAll, \
				lb_btn_Batch_useSelected)
			for sC in batchControls do
			(
				sC.pos = [-600,-600]
			)			
		)
		function RemoveProjectionSettings =
		(
			local projectionControls = #(lb_spnProjBG,gbox_ProjectionMapping,chkbox_UseProjection,spn_Padding,btn_PaddingUP,btn_PaddingDown, \
				spn_UVChannel,btn_UVChannelUP,btn_UVChannelDown,chkbox_useCage,spn_Offset,btn_OffsetUP,btn_OffsetDown,lb_mRay,lb_scanline, \
				lb_Raytrace,chkbox_Raytrace,lb_UVmatch,chkbox_UVmatch,lb_Closest,chkbox_Closest,lb_Furthest,chkbox_Furthest,lb_HitMatchMtlID, \
				chkbox_HitMatchMtlID,lb_RayMissCheck,chkbox_RayMissCheck,lb_RayMissColor,lb_colorpickerBG,colorPick_RayMissColor,lb_CropAlpha, \
				chkbox_CropAlpha,lb_filteringlabel,lb_filteringOptions,btn_SamplerSetup)
			for pC in projectionControls do
			(
				pC.pos = [-600,-600]
			)				
		)
		function RemoveVRayMaps =
		(
			local vRayMaps = #(chkbox_VR_AlphaMap,dNet_lbl_VR_addAlpha,chkbox_VR_AmbientOcclusion,dNet_lbl_VR_addAO,chkbox_VR_BlendMap, \
				dNet_lbl_VR_addBlend,chkbox_VR_CompleteMap,dNet_lbl_VR_addComplete,chkbox_VR_DiffuseMap,dNet_lbl_VR_addDiffuse, \
				chkbox_VR_HeightMap,dNet_lbl_VR_addHeigh,chkbox_VR_LightingMap,dNet_lbl_VR_addLight,chkbox_VR_normalsMap,dNet_lbl_VR_addNormals, \
				chkbox_VR_ShadowsMap,dNet_lbl_VR_addShadows,chkbox_VR_SpecularMap,dNet_lbl_VR_addSpecular,chkbox_VR_UVMap,dNet_lbl_VR_addUVmap)
			for vrM in vRayMaps do
			(
				vrM.pos = [-600,-600]
			)	
		)
		function RemoveStandartMaps =
		(
			local standartMaps = #(chkbox_AlphaMap,dNet_lbl_addAlpha,chkbox_AmbientOcclusion,dNet_lbl_addAO,chkbox_BlendMap, \
				dNet_lbl_addBlend,chkbox_CompleteMap,dNet_lbl_addComplete,chkbox_DiffuseMap,dNet_lbl_addDiffuse, \
				chkbox_HeightMap,dNet_lbl_addHeigh,chkbox_LightingMap,dNet_lbl_addLight,chkbox_normalsMap,dNet_lbl_addNormals, \
				chkbox_ShadowsMap,dNet_lbl_addShadows,chkbox_SpecularMap,dNet_lbl_addSpecular,chkbox_UVMap,dNet_lbl_addUVmap)
			for stdM in standartMaps do
			(
				stdM.pos = [-600,-600]
			)	
		)
		--	place VRay Masps controls
		function PlaceVRayMaps =
		(
			chkbox_VR_AlphaMap.pos = [selMapGBZ+4, selMapGBY+15] 
			dNet_lbl_VR_addAlpha.pos = [selMapGBZ+19, selMapGBY+15]
			chkbox_VR_AmbientOcclusion.pos = [selMapGBZ+82, selMapGBY+15]
			dNet_lbl_VR_addAO.pos = [selMapGBZ+97, selMapGBY+15]
			chkbox_VR_BlendMap.pos = [selMapGBZ+160, selMapGBY+15]
			dNet_lbl_VR_addBlend.pos = [selMapGBZ+175, selMapGBY+15]
			chkbox_VR_CompleteMap.pos = [selMapGBZ+4, selMapGBY+15+17]
			dNet_lbl_VR_addComplete.pos = [selMapGBZ+19, selMapGBY+15+17]
			chkbox_VR_DiffuseMap.pos = [selMapGBZ+82, selMapGBY+15+17]
			dNet_lbl_VR_addDiffuse.pos = [selMapGBZ+97, selMapGBY+15+17]
			chkbox_VR_HeightMap.pos = [selMapGBZ+160, selMapGBY+15+17]
			dNet_lbl_VR_addHeigh.pos = [selMapGBZ+175, selMapGBY+15+17]
			chkbox_VR_LightingMap.pos = [selMapGBZ+4, selMapGBY+15+17+17] 
			dNet_lbl_VR_addLight.pos = [selMapGBZ+19, selMapGBY+15+17+17]
			chkbox_VR_normalsMap.pos = [selMapGBZ+82, selMapGBY+15+17+17]
			dNet_lbl_VR_addNormals.pos = [selMapGBZ+97, selMapGBY+15+17+17]
			chkbox_VR_ShadowsMap.pos = [selMapGBZ+160, selMapGBY+15+17+17]
			dNet_lbl_VR_addShadows.pos = [selMapGBZ+175, selMapGBY+15+17+17]
			chkbox_VR_SpecularMap.pos = [selMapGBZ+4, selMapGBY+15+17+17+17]
			dNet_lbl_VR_addSpecular.pos = [selMapGBZ+19, selMapGBY+15+17+17+17]
			chkbox_VR_UVMap.pos = [selMapGBZ+82, selMapGBY+15+17+17+17]
			dNet_lbl_VR_addUVmap.pos = [selMapGBZ+97, selMapGBY+15+17+17+17]
		)
		--	place Standart Masps controls
		function PlaceStandartMaps =
		(
			chkbox_AlphaMap.pos = [selMapGBZ+4, selMapGBY+15] 
			dNet_lbl_addAlpha.pos = [selMapGBZ+19, selMapGBY+15]
			chkbox_AmbientOcclusion.pos = [selMapGBZ+82, selMapGBY+15]
			dNet_lbl_addAO.pos = [selMapGBZ+97, selMapGBY+15]
			chkbox_BlendMap.pos = [selMapGBZ+160, selMapGBY+15]
			dNet_lbl_addBlend.pos = [selMapGBZ+175, selMapGBY+15]
			chkbox_CompleteMap.pos = [selMapGBZ+4, selMapGBY+15+17]
			dNet_lbl_addComplete.pos = [selMapGBZ+19, selMapGBY+15+17]
			chkbox_DiffuseMap.pos = [selMapGBZ+82, selMapGBY+15+17]
			dNet_lbl_addDiffuse.pos = [selMapGBZ+97, selMapGBY+15+17]
			chkbox_HeightMap.pos = [selMapGBZ+160, selMapGBY+15+17]
			dNet_lbl_addHeigh.pos = [selMapGBZ+175, selMapGBY+15+17]
			chkbox_LightingMap.pos = [selMapGBZ+4, selMapGBY+15+17+17] 
			dNet_lbl_addLight.pos = [selMapGBZ+19, selMapGBY+15+17+17]
			chkbox_normalsMap.pos = [selMapGBZ+82, selMapGBY+15+17+17]
			dNet_lbl_addNormals.pos = [selMapGBZ+97, selMapGBY+15+17+17]
			chkbox_ShadowsMap.pos = [selMapGBZ+160, selMapGBY+15+17+17]
			dNet_lbl_addShadows.pos = [selMapGBZ+175, selMapGBY+15+17+17]
			chkbox_SpecularMap.pos = [selMapGBZ+4, selMapGBY+15+17+17+17]
			dNet_lbl_addSpecular.pos = [selMapGBZ+19, selMapGBY+15+17+17+17]
			chkbox_UVMap.pos = [selMapGBZ+82, selMapGBY+15+17+17+17]
			dNet_lbl_addUVmap.pos = [selMapGBZ+97, selMapGBY+15+17+17+17]
		)
		--	place Settings controls
		function PlaceSettingsControls =	
		(
			removeOnlyRenderSttings()
			removeOnlyBatchSettings()
			removeOnlySmartSettings()
			local sPSettY = 178
			local sPSettZ = 0
			lb_faces_threshold.pos = [sPSettZ+1,sPSettY+1] 
			spn_faces_thresholdBG.pos = [sPSettZ+67,sPSettY+1] 
			spn_faces_threshold.pos = [sPSettZ+67+1,sPSettY+3] 
			btn_faces_thresholdUP.pos = [sPSettZ+67+46,sPSettY+1+2]
			btn_faces_thresholdDown.pos = [sPSettZ+67+46,sPSettY+1+10]
			btn_saveSettings.pos = [sPSettZ+129,sPSettY+1]
			btn_cancelSettings.pos = [sPSettZ+129+53,sPSettY+1]
			grpbox_animation.pos = [sPSettZ+163,sPSettY+1+17+15] 
				lb_animSpnBG.pos = [sPSettZ+166,sPSettY+1+17+15+14]
				spn_sTime.pos = [sPSettZ+200,sPSettY+1+17+15+16] 
				btn_sTimeUP.pos = [sPSettZ+200+22,sPSettY+1+17+15+15]
				btn_sTimeDown.pos = [sPSettZ+200+22,sPSettY+1+17+15+16+7]
				spn_animDistance.pos = [sPSettZ+200,sPSettY+1+17+15+16+18]
				btn_animDistanceUP.pos = [sPSettZ+222,sPSettY+1+17+15+16+17]
				btn_animDistanceDown.pos = [sPSettZ+222,sPSettY+1+17+15+16+17+8]
				chkbox_OnOffAnimation.pos = [sPSettZ+222,sPSettY+1+17+15+15+17+17] 
				lb_chkbox_OnOffAnimation.pos = [sPSettZ+222-18,sPSettY+1+17+15+15+17+17] 
			grpbox_errMsg.pos = [sPSettZ+98,sPSettY+1+17+15] 
				chkbox_errInViewport.pos = [sPSettZ+98+4,sPSettY+1+17+15+14] 
				lb_chkbox_errInViewport.pos = [sPSettZ+98+4+16,sPSettY+1+17+15+17] 
				chkbox_errInRollOut.pos = [sPSettZ+98+4,sPSettY+1+17+15+14+17]
				lb_chkbox_errInRollOut.pos = [sPSettZ+98+4+16,sPSettY+1+17+15+14+17]
				btn_errInRollOutPin.pos = [sPSettZ+98+4+16+30,sPSettY+1+17+15+14+17]
				chkbox_errInMsgBox.pos = [sPSettZ+98+4,sPSettY+1+17+15+19+15+13]
				lb_chkbox_errInMsgBox.pos = [sPSettZ+98+4+16,sPSettY+1+17+15+19+15+13]
			grpbox_explodeFrom.pos = [sPSettZ+1,sPSettY+1+17+15]
				chkbox_explodeFromTop.pos = [sPSettZ+4,sPSettY+1+17+15+14]
				lb_chkbox_explodeFromTop.pos = [sPSettZ+4+14,sPSettY+1+17+15+14]
				chkbox_explodeFromCenter.pos = [sPSettZ+4,sPSettY+1+17+15+14+17]
				lb_chkbox_explodeFromCenter.pos = [sPSettZ+4+14,sPSettY+1+17+15+14+17]
				chkbox_explodeFromBottom.pos = [sPSettZ+4,sPSettY+1+17+15+19+15+13]
				lb_chkbox_explodeFromBottom.pos = [sPSettZ+4+14,sPSettY+1+17+15+19+15+13]
				chkbox_ZeroPoint.pos = [sPSettZ+52,sPSettY+1+17+15+14]
				lb_chkbox_ZeroPoint.pos = [sPSettZ+52+14,sPSettY+1+17+15+14]
				chkbox_moveZeroPointObj.pos = [sPSettZ+52,sPSettY+1+17+15+14+17]
				lb_chkbox_moveZeroPointObj.pos = [sPSettZ+52+14,sPSettY+1+17+15+14+17]

			chkbox_isNodeFrozen.pos = [sPSettZ+4,sPSettY+1+17] 
			lb_chkbox_isNodeFrozen.pos = [sPSettZ+4+14,sPSettY+1+18] 
			chkbox_AutoCheckOverlap.pos = [sPSettZ+103,sPSettY+1+18]
			lb_chkbox_AutoCheckOverlap.pos = [sPSettZ+103+14,sPSettY+1+17]

			chkbox_noCageReset.pos = [sPSettZ+164,sPSettY+1+18] 
			lb_chkbox_noCageReset.pos = [sPSettZ+164+14,sPSettY+1+18] 

			chkbox_checkUpdateOnStatUp.pos = [sPSettZ+4,sPSettY+100] 
			lb_chkbox_checkUpdateOnStatUp.pos = [sPSettZ+4+14,sPSettY+102] 
			for e = 177 to 279+19 by 5 do
			(
				miauuRTTassist.height = e
				sleep 0.002
			)
		)
		--	place render controls
		function PlaceRenderControls =
		(
			removeOnlySettings()
			removeOnlyBatchSettings()
			removeOnlySmartSettings()
			local spRendY = 178
			local spRendZ = 0
			lb_BrowseFolder.pos = [spRendZ+4,spRendY+5]
			btn_BrowseFolder.pos = [spRendZ+5,spRendY+6]
			lb_saveAsType.pos = [spRendZ+182,spRendY+22+18] 
			lb_saveAsTypeArrow.pos = [spRendZ+182+34,spRendY+22+18] 
			btn_saveAsType.pos = [spRendZ+184,spRendY+22+19] 
			lb_combMaps.pos = [spRendZ+95+15,spRendY+39+19] 
			chkbox_combMaps.pos = [spRendZ+95,spRendY+39+19] 
			lb_preview.pos = [spRendZ+95+15,spRendY+39] 
			chkbox_previewVFB.pos = [spRendZ+95,spRendY+39]  
			btn_CombineSing.pos = [spRendZ+128+53,spRendY+39+19]
			
			lb_textEdit.pos = [spRendZ+4,spRendY+22+57+20+16] 
			dNet_TextBoxSP_Arrow.pos = [spRendZ+5+99,spRendY+22+58+20+16]
			dNet_TextBoxSP.pos = [spRendZ+5,spRendY+22+58+20+16]
			btn_delete.pos = [spRendZ+128+54,spRendY+22+57+20+16]
			btn_SavePrst.pos = [spRendZ+128,spRendY+22+57+20+16]
			
			dnet_lb_mapWidth.pos = [spRendZ+4,spRendY+22+17] 
			lb_spn_mapWidth.pos = [spRendZ+24,spRendY+22+17]
			spn_mapWidth.pos = [spRendZ+25,spRendY+22+19]
			dnet_lb_mapHeight.pos = [spRendZ+4,spRendY+22+36] 
			lb_spn_mapHeight.pos = [spRendZ+24,spRendY+22+36] 
			spn_mapHeight.pos = [spRendZ+25,spRendY+22+38] 
			ImgTag_getMapSize.pos = [spRendZ+64,spRendY+22+17] 
			ImgTag_LockSize.pos = [spRendZ+64,spRendY+22+36] 

			chkbox_selSets.pos = [spRendZ+128+54,spRendY+39+19+20]
			lb_selSets.pos = [spRendZ+128+53+16,spRendY+22+57+3] 
			
			chkbox_renderIsolate.pos = [spRendZ+6,spRendY+22+57] 
			lb_chkbox_renderIsolate.pos = [spRendZ+6+15,spRendY+22+57+2] 
			chkbox_redrawViews.pos = [spRendZ+95,spRendY+22+57] 
			lb_chkbox_redrawViews.pos = [spRendZ+95+15,spRendY+22+57+3] 
			
			lb_chkbox_hideFacesMR.pos = [spRendZ+6+15,spRendY+22+57+2+16+3]
			chkbox_hideFacesMR.pos = [spRendZ+6,spRendY+22+57+2+16]
			
			btn_openMapSettings.pos = [spRendZ+0,spRendY+22+57+19+18+20]
			for e = 177 to 279+25+20+13 by 5 do
			(
				miauuRTTassist.height = e
				sleep 0.002
			)
		)
		--	place Smart system controls
		function PlaceSmartControls =	
		(
			removeOnlyRenderSttings()
			removeOnlySettings()
			removeOnlyBatchSettings()
			local spRendY = 178
			local spRendZ = 0
			lb_minUVarea.pos = [spRendZ+3,spRendY+23]
			dNet_lbl_minUVarea.pos = [spRendZ+4,spRendY+24]
			lb_maxUVarea.pos = [spRendZ+119,spRendY+23]
			dNet_lbl_maxUVarea.pos = [spRendZ+120,spRendY+24]
			
			lb_textEditUnimp.pos = [spRendZ+3,spRendY+47]
			dNet_TextBoxUnimp.pos = [spRendZ+4,spRendY+48]
			dNet_TextBoxUnimp_Arrow.pos = [spRendZ+97,spRendY+48]
			
			lb_textEditImp.pos = [spRendZ+119,spRendY+47]
			dNet_TextBoxImp.pos = [spRendZ+120,spRendY+48]			
			dNet_TextBoxImp_Arrow.pos = [spRendZ+212,spRendY+48]
			
			btn_setUnimp.pos = [spRendZ+20,spRendY+2]
			btn_setImp.pos = [spRendZ+146,spRendY+2]
			
			btn_showList.pos = [spRendZ+90,spRendY+2]
			for e = 177 to 250 by 5 do
			(
				miauuRTTassist.height = e
				sleep 0.002
			)
			btn_settings.bitmap = (openBitmap (url+"miauuITsettings.png"))
			if settingsButtonState == 0 do
				settingsButtonState = 1
			btn_renderDialog.bitmap = (openBitmap (url+"miauuITrendersettings.png"))
			if renderButtonState == 0 do
					renderButtonState = 1
			btn_openMapSettings.bitmap = (openBitmap (url+"miauuITmapsettingsOpen.png"))
			if mapButtonState == 0 do
					mapButtonState = 1
		)
		--	place Batch Controls
		function PlaceBatchControls =
		(
			removeOnlyRenderSttings()
			removeOnlySettings()
			removeOnlySmartSettings()
			local spRendY = 178
			local spRendZ = 0
			btn_Batch_getDir.pos = [spRendZ+3,spRendY+4]
			btn_Batch_getFile.pos = [spRendZ+104,spRendY+4]
			btn_Batch_clear.pos = [spRendZ+174,spRendY+4]
			
			lv_Batch.pos = [spRendZ+3,spRendY+26]
			
			btn_Batch_useAll.pos = [spRendZ+116,spRendY+205]
			lb_btn_Batch_useAll.pos = [spRendZ+116+17,spRendY+207]
			btn_Batch_useSelected.pos = [spRendZ+4,spRendY+205]
			lb_btn_Batch_useSelected.pos = [spRendZ+4+17,spRendY+207]
			btn_Batch_fullPath.pos = [spRendZ+116,spRendY+222]
			lb_btn_Batch_fullPath.pos = [spRendZ+116+17,spRendY+224]
			
			chkbox_Batch_skipInst.pos = [spRendZ+4,spRendY+222]
			lb_chkbox_Batch_skipInst.pos = [spRendZ+4+17,spRendY+224]
			
			gp_BatchOutputPath.pos = [spRendZ+1,spRendY+237]
			chkbox_Batch_SameAsSource.pos = [spRendZ+4,spRendY+252]
			lb_chkbox_Batch_SameAsSource.pos = [spRendZ+4+17,spRendY+254]
			chkbox_Batch_usePresetOP.pos = [spRendZ+116,spRendY+252]
			lb_chkbox_Batch_usePresetOP.pos = [spRendZ+116+17,spRendY+254]
			
			for e = 177 to 453 by 5 do
			(
				miauuRTTassist.height = e
				sleep 0.002
			)
			btn_settings.bitmap = (openBitmap (url+"miauuITsettings.png"))
			if settingsButtonState == 0 do
				settingsButtonState = 1
			btn_renderDialog.bitmap = (openBitmap (url+"miauuITrendersettings.png"))
			if renderButtonState == 0 do
					renderButtonState = 1
			btn_openMapSettings.bitmap = (openBitmap (url+"miauuITmapsettingsOpen.png"))
			if mapButtonState == 0 do
					mapButtonState = 1

		)
		--	place Projection Controls
		function PlaceProjectionContros =
		(
			local sPmapSettY = 322+14
			local sPmapSettZ = 0
		
			lb_spnProjBG.pos = [2, 291+22+12+22] 

			gbox_ProjectionMapping.pos = [sPmapSettZ,sPmapSettY]
				chkbox_UseProjection.pos = [sPmapSettZ+5, sPmapSettY+2+15]

				spn_Padding.pos = [sPmapSettZ+112+2,sPmapSettY+2+15+1]
				btn_PaddingUP.pos = [sPmapSettZ+112+24,sPmapSettY+2+15]
				btn_PaddingDown.pos = [sPmapSettZ+112+24,sPmapSettY+2+15+8]

				spn_UVChannel.pos = [sPmapSettZ+192+2,sPmapSettY+2+15+1]
				btn_UVChannelUP.pos = [sPmapSettZ+192+24,sPmapSettY+2+15]
				btn_UVChannelDown.pos = [sPmapSettZ+192+24,sPmapSettY+2+15+8]

				chkbox_useCage.pos = [sPmapSettZ+5,sPmapSettY+2+15+20] 
		
				spn_Offset.pos = [sPmapSettZ+112+2,sPmapSettY+2+15+20+1] 
				btn_OffsetUP.pos = [sPmapSettZ+112+24,sPmapSettY+2+15+20] 
				btn_OffsetDown.pos = [sPmapSettZ+112+24,sPmapSettY+2+15+20+8]
				
				lb_mRay.pos = [sPmapSettZ+152, sPmapSettY+2+15+20] 
				lb_scanline.pos = [sPmapSettZ+190,sPmapSettY+2+15+20] 
				--
				lb_Raytrace.pos = [sPmapSettZ+5+15, sPmapSettY+2+15+20+19]
				chkbox_Raytrace.pos = [sPmapSettZ+5, sPmapSettY+2+15+20+19]
				lb_UVmatch.pos = [sPmapSettZ+70+15, sPmapSettY+2+15+20+19] 
				chkbox_UVmatch.pos = [sPmapSettZ+70, sPmapSettY+2+15+20+19]
				--
				lb_Closest.pos = [sPmapSettZ+5+15, sPmapSettY+2+15+20+17+17] 				
				chkbox_Closest.pos = [sPmapSettZ+5, sPmapSettY+2+15+20+17+17] 
				lb_Furthest.pos = [sPmapSettZ+70+15, sPmapSettY+2+15+20+17+17]					
				chkbox_Furthest.pos = [sPmapSettZ+70, sPmapSettY+2+15+20+17+17]
				--
				lb_HitMatchMtlID.pos = [sPmapSettZ+5+15, sPmapSettY+2+15+20+17+17+17] 
				chkbox_HitMatchMtlID.pos = [sPmapSettZ+5, sPmapSettY+2+15+20+17+17+17] 
				--
				lb_RayMissCheck.pos = [sPmapSettZ+155, sPmapSettY+2+15+20+19] 
				chkbox_RayMissCheck.pos = [sPmapSettZ+70+15+53, sPmapSettY+2+15+20+19]
				lb_RayMissColor.pos = [sPmapSettZ+70+15+53, sPmapSettY+2+15+20+19+17]
				lb_colorpickerBG.pos = [sPmapSettZ+209,sPmapSettY+2+15+20+19+16] 		
				colorPick_RayMissColor.pos = [sPmapSettZ+211,sPmapSettY+2+15+20+19+17] 
				--
				lb_CropAlpha.pos = [sPmapSettZ+160+15,sPmapSettY+2+15+20+19+17+17]  
				chkbox_CropAlpha.pos = [sPmapSettZ+160,sPmapSettY+2+15+20+19+17+17] 
				lb_filteringlabel.pos = [sPmapSettZ+5,sPmapSettY+2+15+20+19+17+17+18] 	
				lb_filteringOptions.pos = [sPmapSettZ+6,sPmapSettY+2+15+20+19+17+17+19]
				btn_SamplerSetup.pos = [sPmapSettZ+194,sPmapSettY+2+15+20+19+17+17+18] 
		)
		--	open folders
		function OpenFolders folderToOpen =
		(
			checkFolderName = substring folderToOpen 1 (folderToOpen.count-1)
			if (symbolicPaths.isPathName checkFolderName) then
			(
				folderToOpen = symbolicPaths.getPathValue checkFolderName
			)				
			shellLaunch "explorer.exe" folderToOpen
		)

		on clockT tick do
		(
			start += 1
			if start >= 3 do 
			(
				for v = dialogHeight+60+16 to dialogHeight by -5 do
				(
					miauuRTTassist.height = v
					sleep 0.002					
				)
				clockT.active = false
			)
			if clockT.active == false do
			(
				if settingsButtonState == 0 do
					PlaceSettingsControls()
				if renderButtonState == 0 do
					PlaceRenderControls()
				if smartIsRuning == true do
					PlaceSmartControls()
				if startBatchRender == true do
					PlaceBatchControls()
			)
		)
		--	unknown author of LiveLog struct
		struct LiveLog
		(
			messageTimeVal=5000,
			messageStr="",
			horizontalDisp=#center,
			verticalDisp=#top,
			showBoxDisp=true,
			textColorDisp=red,
			boxColorDisp=gray,
				
			BoxMessage=undefined,
			startTime=0,
			
			x=0,y=0,
			offsetPos=[0,0],
			alignObj=undefined,
			updatePos=false,
			
			textExtent=[0,0],
						
			function SetPosition=
			(
				if classOf horizontalDisp==name then
				(
					x=case horizontalDisp of
					(
						#left: (10+offsetPos.x)
						#center: ((gw.getWinSizeX())/2-(textExtent.x/2)+offsetPos.x)
						#right: ((gw.getWinSizeX())-textExtent.x-20+offsetPos.x)
						#node: ((worldToScreen alignObj).x)
						default: 10
					)
				)
				else
					x=horizontalDisp
				
				if classOf verticalDisp==name then
				(
					y=case verticalDisp of
					(
						#top: (offsetPos.y)
						#topRowBelow: (20+offsetPos.y)
						#topRowBelow1: (40+offsetPos.y)
						#middle: ((gw.getWinSizeY())/2-10+offsetPos.y)
						#bottom: ((gw.getWinSizeY())-40+offsetPos.y)
						#node: ((worldToScreen alignObj).y)
 						#middleRowDown: ((gw.getWinSizeY())/2+offsetPos.y)	
						default: 10
					)
				)
				else
					y=verticalDisp
			),
			
			function BoxMessage =
			(
				rect = (box2 x y (textExtent.x+12) (textExtent.y+10))
				if updatePos do
					SetPosition()
				if showBoxDisp do
					try( (gw.wrect rect boxColorDisp) ) Catch()
				gw.wtext [x+5,y+20,0] messageStr color:textColorDisp
				gw.enlargeUpdateRect rect 
				gw.updateScreen()	
				curTime=timeStamp()
				if (curTime-startTime)>messageTimeVal do
					unRegisterRedrawViewsCallback BoxMessage
			),

			function StartMessage=
			(
				startTime=timeStamp()
				BoxMessage()
				registerRedrawViewsCallback BoxMessage
			),
			
			function Display message time:5000 vertical:#top horizontal:#center showBox:true textColor:red boxColor:[110,110,110]  \
				offset:[0,0] \
				obj:undefined \
				updatePosition:false=
			(
				messageStr=message
				messageTimeVal=time
				verticalDisp=vertical
				horizontalDisp=horizontal
				showBoxDisp=showBox
				textColorDisp=textColor
				boxColorDisp=boxColor
				offsetPos=offset
				alignObj=obj
				updatePos=updatePosition
				
				textExtent=gw.getTextExtent messageStr
				SetPosition()
				StartMessage()
			)
		)
		function InitErrMsgDotBetLabel lb_name lb_bcolor lb_fcolor =
		(
			lb_name.BackColor = lb_bcolor 
			lb_name.forecolor = lb_fcolor
			lb_name.textalign = (dotnetclass "System.Drawing.ContentAlignment").middlecenter
			DotNetFont lb_name 
		)
		function ErrorMessage errMsg =
		(		
			local errMssg
			case errMsg of
			(
				--	with red color
				1: errMssg = "Enter Prefix labels !"
				2: errMssg = "The Low-Poly and High-Poly prefix labels are the same !"
				3: errMssg = "The output directory does not exist !"
				4: errMssg = "There are overlapped objects !"
				5: errMssg = "First press the \"Explode\" button !"
				6: errMssg = "There are no Low Poly objects with prefix "+"\""+prefixNameLP+"\""
				7: errMssg = "There are no High Poly objects with prefix "+"\""+prefixNameHP+"\""
				8: errMssg = "There are no Low Poly objects with prefix "+"\""+prefixNameLPAdd+"\""
				9: errMssg = "There are no High Poly objects with prefix "+"\""+prefixNameHPAdd+"\""
				10: errMssg = "Only map types that include alpha channel will work with the \"Combine maps\" function!"
				11: errMssg = "The prefix label for Low-Poly objects can't be an empty string !"
				12: errMssg = "The prefix label for High-Poly objects can't be an empty string !"
				13: errMssg = "Select Low-Poly or High-Poly object !"
				14: errMssg = "The selected HP object is not a part of High-Poly group !"
				15: errMssg = "There are no objects in the scene with applied Projection modifier !"
				16: errMssg = "Please choose the desired map types first !"
				17: errMssg = "Please enter the preset name !"
				18: errMssg = "Re-apply the projection modifier or use another render mode(hover over the \"Render\" button for more info) !"
				19: errMssg = "Use the correct decimal symbol in the explode input field !"
				20: errMssg = "You need to load at least two scenes in order to use the batch renderer"
				21: errMssg =  "Please, select some Low-Poly objects first !"
				22: errMssg = "Select more than one object !"
				23: errMssg = "BuildPairs command failed.Please rename the selected objects manually!"
				24: errMssg = "There are no objects in the scene with Projection modifier applied by RTTassist !"
				25: errMssg = "First enter a value in the \"Smart\" spinner to define the minor and major objects"
				26: errMssg = "This object is already set as \"minor\" or this is not a Low-Poly object !"
				28: errMssg = "This object is already set as \"major\" or this is not a Low-Poly object !"
				
				
				--	with green color
				50: errMssg = "Add Projection succesuful !"
				51: errMssg = "Remove Projection succesuful !"
				52: errMssg = "Rename Objects succesuful !"
				55: errMssg = "There are no overlapped objects"
				56: errMssg = "Add projection successful (all Instances are skipped)."
				57: errMssg = "The name of the objects can't be an empty string !"
				58: errMssg = "Default mental ray preset has been updated successfully!"
				59: errMssg = "Cage objects are exported successfully!!"
				60: errMssg = "Cage objects are imported successfully!!"
				61: errMssg = "Cage objects are imported and permanently deleted!"
 				62: errMssg = "Cage objects are permanently deleted!"
			)
			
 			if chkbox_errInViewport.state == on do
			(
				message=LiveLog()
				message.Display "RTTassist Live Log" time:3000 vertical:#top horizontal:#center textColor:[0,215,226] updatePosition:false showBox:false
				message=LiveLog()
				if errMsg > 0 and errMsg < 50 then
					message.Display errMssg time:3000 vertical:#topRowBelow horizontal:#center textColor:red updatePosition:true showBox:false
				else
					message.Display errMssg time:3000 vertical:#topRowBelow1 horizontal:#center textColor:green updatePosition:true showBox:false
			)
 			if chkbox_errInRollOut.state == on do
			(
				removeOnlyRenderSttings()
				removeOnlySettings()
				removeOnlySmartSettings()
				removeOnlyBatchSettings()
				if smartState == 0 do smartState = 1
				if batchState == 0 do batchState = 1
				--	show messsages
				dnLbl_errMsgTop.pos = [0,178]
				dnLbl_errMsg.pos = [0,194]
				dnLbl_errMsgMoreInfo.pos = [0,232]
				start = 0
				local dH
				if errMsg <50 then
					dH = dialogHeight+60+14
				else
					dH = dialogHeight+58
				for v = dialogHeight to dH by 5 do
				(
					miauuRTTassist.height = v
					sleep 0.002					
				)
				local bcolor1 = (dotNetClass "System.Drawing.Color").LightSteelBlue
				local fcolor1 = (dotnetclass "System.Drawing.Color").black
				dnLbl_errMsgTop.text = "         ------- RTTassist Live Log -------         X"
				InitErrMsgDotBetLabel dnLbl_errMsgTop bcolor1 fcolor1
				
				dnLbl_errMsg.Text = errMssg
				dnLbl_errMsg.BorderStyle	= (dotNetClass "System.Windows.Forms.BorderStyle").fixedsingle
				if errMsg > 0 and errMsg < 50 then
				(
					dnLbl_errMsg.BackColor	= (dotNetClass "System.Drawing.Color").FromArgb 111 33 33 
					dnLbl_errMsg.forecolor = (dotnetclass "System.Drawing.Color").FromArgb 237 184 27 
 					dnLbl_errMsg.textalign = (dotnetclass "System.Drawing.ContentAlignment").middlecenter
 					DotNetFont dnLbl_errMsg
				)
				else
				(
					dnLbl_errMsg.BackColor = (dotNetClass "System.Drawing.Color").FromArgb 45 66 47 
					dnLbl_errMsg.forecolor = (dotnetclass "System.Drawing.Color").FromArgb 176 237 168
					dnLbl_errMsg.textalign = (dotnetclass "System.Drawing.ContentAlignment").middlecenter
 					DotNetFont dnLbl_errMsg
				)
				dnLbl_errMsgMoreInfo.text = "                                 click here for more info"
				InitErrMsgDotBetLabel dnLbl_errMsgMoreInfo bcolor1 fcolor1
				
				btn_openMapSettings.bitmap = (openBitmap (url+"miauuITmapsettingsOpen.png"))
				if mapButtonState == 0 do
						mapButtonState = 1
				--	to stay or not the Rollout openned
				if pinRolloutErrMssg == 1 then	
					clockT.active = true
			)
			if chkbox_errInMsgBox.state == on do
				messagebox errMssg title:"RTTAssist LiveLog"
		)
		--	compare the content of two sub-arrays in array
		function CompareSubArrays first second =
		(
			result = true 
			if first.count != second.count then 
				result = false 
			else
			(
				for i = 1 to first.count do 
				(
					if first[i] != second[i] do result = false 
				)								
			)
			result 
		) 
		--	function to find root parrent of selected object. Created by Panayot "Anubis" Karabakalov
		function FindRootParrent obj = 
		(
			parent = obj.parent
			if parent != undefined then
				FindRootParrent parent
			else
				obj
		) 
		--	find average position of all selected objects
 		function AveragePos oArray =
		(
			sum = [0,0,0]
			for obj in oArray do sum += obj.center
			sum / oArray.count				
		)
		--	find objects lower position
		function LowerPos oArray =
		(
			--	find objects lower position
			local objLowerPos = #() as array	
			objLowerPos = for o in oArray collect o.min.z
			minVal = amin objLowerPos
			--	find objects center position
			local objCenterPos = AveragePos oArray
			--	return lower position of all objects
			objCenterPos[3] = minVal
			
			objCenterPos			
		)
		--	find objects higher position
		function HigherPos oArray =
		(
			--	find objects higher position
			local objHigherPos = #() as array	
			objHigherPos = for o in oArray collect o.max.z			
			maxVal = amax objHigherPos
			--	find objects center position
			local objCenterPos = AveragePos oArray
			--	find higher position of all objects
			objCenterPos[3] = maxVal
			
			objCenterPos			
		)
		--	calculate zero point of expolsion
		function PointOfExplosion =
		(
			local pointToExp			
			if isValidNode miauuZeroPoint then
				pointToExp = miauuZeroPoint.pos
			else
			(
				if chkbox_explodeFromTop.state == on do
					pointToExp = HigherPos selObj
				if chkbox_explodeFromCenter.state == on do
					pointToExp = AveragePos selObj
				if chkbox_explodeFromBottom.state == on do
					pointToExp = LowerPos selObj
			)
			pointToExp		
		)
		function GetAllObj = 
		(
			selObj = #() as array
			for o in objects where classof o != Biped_Object and superClassOf o != helper do
			(
				if ((findString o.name prefixNameLP) != undefined) do
					append selObj o
				if ((findString o.name prefixNameHP) != undefined) do
					append selObj o
				if prefixNameLPAdd != undefined and prefixNameHPAdd != undefined do
				(
					if ((findString o.name prefixNameLPAdd) != undefined) do
						append selObj o
					if ((findString o.name prefixNameHPAdd) != undefined) do
						append selObj o
				)
			)
			selObj
		)
		function GetVisibleObj =
		(
			selObj = #() as array
			for o in objects where classof o != Biped_Object and superClassOf o != helper do
			(
				if o.isHidden == false do
				(
					if ((findString o.name prefixNameLP) != undefined) do
						append selObj o
					if ((findString o.name prefixNameHP) != undefined) do
						append selObj o
					if prefixNameLPAdd != undefined and prefixNameHPAdd != undefined do
					(
						if ((findString o.name prefixNameLPAdd) != undefined) do
							append selObj o
						if ((findString o.name prefixNameHPAdd) != undefined) do
							append selObj o
					)
				)
			)
			selObj
		)
		function GetSelectedObj =
		(
			selObj = #() as array
			for s in selection where classof s != Biped_Object and superClassOf o != helper do
			(
				if ((findString s.name prefixNameLP) != undefined) do
						append selObj s
				if ((findString s.name prefixNameHP) != undefined) do
					append selObj s
				if prefixNameLPAdd != undefined and prefixNameHPAdd != undefined do
				(
					if ((findString s.name prefixNameLPAdd) != undefined) do
						append selObj s
					if ((findString s.name prefixNameHPAdd) != undefined) do
						append selObj s
				)				
			)
			
			selObj
		)
		function GetProperObj =
		(
			if prefixNameLP != undefined and prefixNameHP != undefined then
			(
				if allObjITState == 1 do
					GetAllObj()
				if isSelectObj == 1 do
					GetSelectedObj()
				if visibleObj == 1 do
					GetVisibleObj()
				selObj
			)
			else
			(
				errMssg = 1
				ErrorMessage 1 
			)
		)
		--	select only main LP objects
		function ObjSelect prefName=
		(
			clearSelection()
			newobjects = #()
			for obj in selObj do
			(
				if ((findString obj.name (prefName as string)) != undefined) do
					append newobjects obj
			)
			select newobjects
		)
		--	select only imported LP objects or both
		function ObjSelectAdd prefName allOrImp=
		(
			clearSelection()
			local newobjectsAdd = #()
			for obj in selObj do
			(
				if ((findString obj.name (prefName as string)) != undefined) do
					append newobjectsAdd obj
			)
			if allOrImp == 1 then
			(
				join newobjects newobjectsAdd
				select newobjects
			)
			else
				select newobjectsAdd
		)		
		function ObjExport prefName =
		(
			objToExport = GetProperObj()
			clearSelection()
			local newobjects = #()
			for obj in objToExport do
			(
				if ((findString obj.name (prefName as string)) != undefined) do
					append newobjects obj
			)
			select newobjects
			actionMan.executeAction 0 "40373"
		)
		--	remove prefix labels from names of LP objects
		function GetNoPrefixNameLP prefixNameLP = 
		(
			GetProperObj()
			--	check if there is HP objects with wrong name
			local arrLP_Prefix1 = #() as array
			local pairsNamesNoPrefixLP1 = #() as array
			--	get all objects that are not children of other objects
			local rootNodes1 = for o in selObj where o.parent == undefined collect o
			--	creates two arrays with LP and HP names
			for curO in rootNodes1 do
			(					
				--	get all names of LP objects
				if ((findString curO.name prefixNameLP) != undefined) do
					append arrLP_Prefix1  curO.name
			)				
			
			global prefixNameLPNumb = prefixNameLP.count
			--	clear the prefix  from objects name	
			for l in arrLP_Prefix1 do
			(					
				local lowName_TrimmedC = replace l 1 prefixNameLPNumb ""
				append pairsNamesNoPrefixLP1 lowName_TrimmedC
			)
			pairsNamesNoPrefixLP1
		)
		--	remove prefix labels from names of HP objects
		function GetNoPrefixNameHP prefixNameHP = 
		(
			GetProperObj()
			local pairsNamesNoPrefixHP1 = #() as array
			local arrHP_Prefix1 = #() as array
			local rootNodes1 = for o in selObj where o.parent == undefined collect o
			for curO in rootNodes1 do
			(
				if ((findString curO.name prefixNameHP) != undefined) do
					append arrHP_Prefix1  curO.name
			)				
			
			global prefixNameHPNumb = prefixNameHP.count	
			for h in arrHP_Prefix1 do
			(					
				local highName_TrimmedC = replace h 1 prefixNameHPNumb ""
				append pairsNamesNoPrefixHP1 highName_TrimmedC
			)
			pairsNamesNoPrefixHP1
		)	
		function CheckNames prefixNameLP =
		(
			GetProperObj()
			local HPnames = #() as array
			local LPtoHP = #() as array	--	store LP objects coresponding to wrong HP obects
			--	get LP and HP object names without prefix
			global pairsNamesNoPrefixLP = GetNoPrefixNameLP prefixNameLP
			global pairsNamesNoPrefixHP = GetNoPrefixNameHP prefixNameHP				
			--	make compairson and store only objects with error
			for k = 1 to pairsNamesNoPrefixLP.count do
			(
				for j = pairsNamesNoPrefixHP.count to 1 by -1 do
				(
					if (matchPattern pairsNamesNoPrefixLP[k] pattern:pairsNamesNoPrefixHP[j]) == true do
						deleteItem pairsNamesNoPrefixHP j	--	HP objects with wrong names
				)	
			)
			pairsNamesNoPrefixHP
		)
		function CheckNames1 prefixNameLPAdd =
		(	--	work with additional prefixes
			GetProperObj()
			local HPnamesAdd = #() as array
			local LPtoHPAdd = #() as array	--	store LP objects coresponding to wrong HP obects
			--	get LP and HP object names without prefix
			global pairsNamesNoPrefixLPAdd = GetNoPrefixNameLP prefixNameLPAdd
			global pairsNamesNoPrefixHPAdd = GetNoPrefixNameHP prefixNameHPAdd				
			for k = 1 to pairsNamesNoPrefixLPAdd.count do
			(
				for j = pairsNamesNoPrefixHPAdd.count to 1 by -1 do
				(
					if (matchPattern pairsNamesNoPrefixLPAdd[k] pattern:pairsNamesNoPrefixHPAdd[j]) == true do
						deleteItem pairsNamesNoPrefixHPAdd j	--	add HP objects with wrong names
				)	
			)
			pairsNamesNoPrefixHPAdd
		)
		function CheckObjAndPrefixLPAdd = 
		(	--	work with additional objects
			GetProperObj()
			local result = false
			local arr_LPobj = #() as array
			for obj in selObj do
			(
				if ((findString obj.name (prefixNameLPAdd as string)) != undefined) do
					append arr_LPobj obj
			)
			if arr_LPobj.count == 0 then	--	if thre is no LP with prefix
			(
				errMssg = 8
				ErrorMessage 8
			)
			else
				result = true
			
			result
		)
		function CheckObjAndPrefixHPAdd = 
		(	--	work with additional objects
			GetProperObj()
			local result = false
			local arr_HPobj = #() as array
			for obj in selObj do
			(
				if ((findString obj.name (prefixNameHPAdd as string)) != undefined) do
					append arr_HPobj obj
			)
			if arr_HPobj.count == 0 then	--	if thre is no LP with prefix
			(
				errMssg = 9
				ErrorMessage 9
			)
			else
				result = true
			
			result
		)
		function CheckObjAndPrefixLP = 
		(
			GetProperObj()
			local result = false
			if prefixNameLP != undefined then
			(
				local arrLP_obj = #() as array
				for obj in selObj do
				(
					if ((findString obj.name (prefixNameLP as string)) != undefined) do
						append arrLP_obj obj
				)
				if arrLP_obj.count == 0 then	--	if thre is no LP with prefix
				(
					errMssg = 6
					ErrorMessage 6
				)
				else
					result = true
			)
			else
			(
				errMssg = 1
				ErrorMessage 1
			)
			result
		)
		function CheckObjAndPrefixHP = 
		(
			GetProperObj()
			local result = false
			if prefixNameHP != undefined then
			(
				local arrHP_obj = #() as array
				for obj in selObj do
				(
					if ((findString obj.name (prefixNameHP as string)) != undefined) do
						append arrHP_obj obj
				)				
				if arrHP_obj.count == 0 then	--	if thre is no HP with prefix
				(
					errMssg = 7
					ErrorMessage 7
				)
				else
					result = true
			)
			else
			(
				errMssg = 1
				ErrorMessage 1
			)
			
			result
		)
		--	add Projection Modifier function to sub_HP objects
		function AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R =
		(
			local arr_HPchildren = #() as array
			for c in highBuddy do join arr_HPchildren c.children 
			local arr_HPchildrenNoLink = #() as array

			if arr_HPchildren.count != 0 then
			(
				--	add main HP part
				$.modifiers[#Projection].addObjectNode highBuddy
				--	if there is second HP that is not linked to main
				if dividerStr != undefined and dividerStr != "---" do
				(
					--	try to find second HP objects and put them to Projection list
					currHPname = highBuddy.name
					secondHPname = currHPname + dividerStr
					for hpObj in allHPobj do
					(
						if ((findString hpObj.name secondHPname) != undefined) do
						(
							--	find if sub-HP is in range
							if ( ((distance hpObj.center highBuddy.center) <= r) or ((intersects hpObj highBuddy) == true) ) do
								appendIfUnique arr_HPchildrenNoLink hpObj																
						)
					)
				)	
				--	add children objects of main HP part
				for childHP in arr_HPchildren do
				(
					$.modifiers[#Projection].addObjectNode childHP					
				)
				if arr_HPchildrenNoLink.count != 0 then
				(
					for i = 1 to arr_HPchildren.count do
					(
						for j = arr_HPchildrenNoLink.count to 1 by -1 do
						(
							if arr_HPchildren[i].name == arr_HPchildrenNoLink[j].name do
								deleteItem arr_HPchildrenNoLink j
						)
					)
					for childHP in arr_HPchildrenNoLink do
					(
						$.modifiers[#Projection].addObjectNode childHP					
					)
				)
			)
			else	--	if current HP object do not have a children
			(							
				if dividerStr != undefined and dividerStr != "---" do
				(
					--	try to find all second HP objects and put them to Projection list
					arr_HPobjSingle = #() as array
					curr_HPname = highBuddy.name
					second_HPname = curr_HPname + dividerStr
					for hpObj in allHPobj do
					(
						if ((findString hpObj.name second_HPname) != undefined) do

							if ((distance hpObj.center highBuddy.center) <= r) or ((intersects hpObj highBuddy) == true) do
								appendIfUnique arr_HPobjSingle hpObj
					)
					if arr_HPobjSingle.count != 0 do
					(
						for childHP in arr_HPobjSingle do
						(
							$.modifiers[#Projection].addObjectNode childHP					
						)
					)
				)
				$.modifiers[#Projection].addObjectNode highBuddy
			)
		)
		--	when Control is pressed select HP or LP buddy of selected LP/HP object
		function ControlPressedSel LH =
		(
			local LPobjs = #() as array
			local prefixNameHPNumb1 = undefined
			local prefixNameLP1 = undefined
			local tempHPsel = undefined
			if LH == 1 then	--	select HP budy of LP objects
			(
				prefixNameHPNumb1 = prefixNameHP.count
				prefixNameLP1 = prefixNameLP
				--	get all LP pbjects
				for obj in selObj do
				(
					if ((findString obj.name prefixNameLP) != undefined) do
					append LPobjs obj
				)
			)
			if LH == 2 then	--	select LP budy of HP objects
			(
				prefixNameHPNumb1 = prefixNameLP.count
				prefixNameLP1 = prefixNameHP
				--	get all HP pbjects
				for obj in selObj do
				(
					if ((findString obj.name prefixNameHP) != undefined) do
					append LPobjs obj
				)
			)
			if LH == 3 then	--	used by ShifrPressedSel function - work with HP objects
			(
				prefixNameHPNumb1 = prefixNameHP.count
				prefixNameLP1 = prefixNameHP
				--	get all HP pbjects
				for obj in selObj do
				(
					if ((findString obj.name prefixNameHP) != undefined) do
					append LPobjs obj
				)
			)
			--	get current LP selection
			selCountCtrl = selection
			if selCountCtrl.count != 0 then
			(
				tempHPsel = selCountCtrl			
				--	find LP buddy of curr HP objcts
				for s in tempHPsel do
				(	
					--	get position of cur LP object
					local currLPpos1 = s.center
					local R = (distance s.max s.min) / 2
					--	find coresponding LP name
					local lowName_Trimmed = replace s.name 1 prefixNameHPNumb1 ""
					local l = prefixNameLP1 + lowName_Trimmed
					--	find LP buddy and add it to selection
					for o in selObj do
					(
						local currHPpos1 = o.center
						local foundObj = #() as array
						if o.name == l then	--	if this is true the selected HP onject is a main HP object
						(
							if currLPpos1 == currHPpos1 then
								append foundObj o
							else
							(
								if (distance currHPpos1 currLPpos1) <= (R*0.10) then
									append foundObj o
								else
									if ((distance currHPpos1 currLPpos1) <= r) and ((intersects s o) == true) do
										append foundObj o
							)
							if foundObj.count != 0 do
							(
								selectMore foundObj[1]
								--	get the children of current object if they exist
								local arrLP_children = #() as array
								for c in o do join arrLP_children c.children
								local arrLP_childrenNoLink = #() as array
								--	if current LP object have a children objects linked to him
								if arrLP_children.count != 0 then
								(
									--	if there is second HP that is not linked to main
									if dividerStr != undefined and dividerStr != "---" do
									(
										--	try to find second HP objects
										currHPname = o.name
										secondHPname = currHPname + dividerStr
										for hpObj in LPobjs do
										(
											if ((findString hpObj.name secondHPname) != undefined) and hpObj.parent == undefined and ( ((intersects hpObj o) == true) /* or ((intersects hpObj highBuddy) == true)*/)  do
												appendIfUnique arrLP_childrenNoLink hpObj
										)
									)
									--	add children objects of selection
									for childHP in arrLP_children do
									(
										selectMore childHP					
									)
									if arrLP_childrenNoLink.count != 0 do
									(
										for childHP in arrLP_childrenNoLink do
										(
											selectMore childHP					
										)
									)
								)
								else	--	if current HP object do not have a children
								(							
									if dividerStr != undefined and dividerStr != "---" do
									(
										--	try to find all second HP objects and put them to Projection list
										arrHPobj_Single = #() as array
										currHP_name = o.name
										secondHP_name = currHP_name + dividerStr
										for j in LPobjs do
										(
											if ((findString j.name secondHP_name) != undefined) and ( ((intersects j o) == true) /* or ((intersects hpObj highBuddy) == true)*/)  do
												appendIfUnique arrHPobj_Single j
										)
										if arrHPobj_Single.count != 0 do
										(
											for childHP in arrHPobj_Single do
											(
												selectMore childHP					
											)
										)
									)
								)
							)
						)						
					)
				)
			)
			else
			(
				errMssg = 13
				ErrorMessage 13
			)
		)
		--	when Contrio is pressed for HP objects - determin if the object is main or subHP
		function MainOrSubHP =
		(
			selO = GetProperObj()
			local prefixNameHPNumb2 = prefixNameHP.count
			local tempHPsel1 = undefined
			local tempHPsubSel1 = undefined
			--	get current HP selections name
			selCount = selection
			
			currCmndPanelMode = getCommandPanelTaskMode()
			setCommandPanelTaskMode mode:#create
			
			if selCount.count != 0 then
			(
				tempHPsel1 = selCount[1].name
				tempHPsubSel1 = selCount[1]
			
				--	check if that selected subHP is a children
				if tempHPsubSel1.parent != undefined then
				(
					--	select main HP
					rootParent1 = FindRootParrent tempHPsubSel1					
					select rootParent1
					ControlPressedSel 1
				)
				else	--	if current subHP is not a children of any others HP objects in scene
				(
					--	curent HP object name with no prefix
					local tempHPselNoPrefix1 = replace tempHPsel1 1 prefixNameHPNumb2 ""
					--	get only main name by removing divider stymbol and additional name
					local selHPnamePrfx1 = undefined	--	only main name of curr selected HP object with prefix
					if dividerStr != undefined and dividerStr != "---" then
					(
						local mainHPname1 = undefined
						--	the position of divider symbol in HP name - integer
						divSymbPos1 = (findString tempHPselNoPrefix1 "_")
						--	remove additional name
						if divSymbPos1 != undefined then
						(
							--	main HP name
							mainHPname1 = replace tempHPselNoPrefix1 divSymbPos1 (tempHPselNoPrefix1.count-divSymbPos1+1) ""
						)
						else
							mainHPname1 = tempHPselNoPrefix1
							--	add prefix to main HP name
						selHPnamePrfx1 = prefixNameHP + mainHPname1				
					)
					else
						selHPnamePrfx1 = tempHPsel1
					local mainHPnameMatch1 = #() as array
					for o in selO do
					(
						--	if there is another HP object with name as main name of selected additional HP
						if o.name == selHPnamePrfx1 do
							append mainHPnameMatch1 o
					)
					--	find wich mainHP is "parent" HP to selected sub-HP object
					if mainHPnameMatch1.count != 0 then
					(
						--	if mainHP is only one then select it and execute controlPressedselfunction
						if mainHPnameMatch1.count == 1 then
						(
							select mainHPnameMatch1[1]
							ControlPressedSel 1
						)
						else	--	if there is more than one main HP with the same name
						(
							--	select first main HP and try to find if the selected subHP is in volume
							rightMainHP1 = #() as array
							for mH in mainHPnameMatch1 do
							(
								select mH
								ControlPressedSel 3
								temSelHPGroup1 = selection
								if temSelHPGroup1.count != 0 do
								(
									for i in temSelHPGroup1 do
									(
										if (i.name == tempHPsel1) and  ((intersects mH tempHPsubSel1) == true) do
											append rightMainHP1 mH
									)
								)
								clearselection()
							)
							--	if there is only one main HP containing selected subHP
							if rightMainHP1.count == 1 then
							(
								select rightMainHP1[1]
								ControlPressedSel 1
							)
							else
							(
								messagebox "Shift+LMB!!!\nThere are tow or more HP objects with same name!!!" title:"RTTAssist Live Log"
							)
						)
					)
					else
					(
						errMssg = 14
						ErrorMessage 14
					)
				)
			)
			else
			(
				errMssg = 13
				ErrorMessage 13
			)
			
			setCommandPanelTaskMode mode:currCmndPanelMode
		) 
		--	when Shift is pressed select HP objects + selObj
		function ShiftPressedSel =
		(
			selO = GetProperObj()
			local mainHPS = #() as array		--	store main HP object if it exist
			local allLPobjS = #() as array
			local prefixNameHPNumb1 = prefixNameHP.count
			local tempHPselS = undefined
			local tempHPsubSelS = undefined
			--	get current HP selections name
			selCountS = selection
			
			currCmndPanelMode = getCommandPanelTaskMode()
			setCommandPanelTaskMode mode:#create
			
			if selCountS.count != 0 then
			(
				tempHPselS = selCountS[1].name
				tempHPsubSelS = selCountS[1]
			
				--	check if that selected subHP is a children
				if tempHPsubSelS.parent != undefined then
				(
					--	select main HP
					rootParent = FindRootParrent tempHPsubSelS					
					select rootParent
					ControlPressedSel 3
				)
				else	--	if current subHP is not a children of any others HP objects in scene
				(
					--	curent HP object name with no prefix
					local tempHPselNoPrefixS = replace tempHPselS 1 prefixNameHPNumb1 ""
					--	get only main name by removing divider stymbol and additional name
					local selHPnamePrfxS = undefined	--	only main name of curr selected HP object with prefix
					if dividerStr != undefined and dividerStr != "---" then
					(
						local mainHPnameS = undefined
						--	the position of divider symbol in HP name - integer
						divSymbPosS = (findString tempHPselNoPrefixS "_")
						--	remove additional name
						if divSymbPosS != undefined then
						(
							--	main HP name
							mainHPnameS = replace tempHPselNoPrefixS divSymbPosS (tempHPselNoPrefixS.count-divSymbPosS+1) ""
						)
						else
							mainHPnameS = tempHPselNoPrefixS
							--	add prefix to main HP name
						selHPnamePrfxS = prefixNameHP + mainHPnameS				
					)
					else
						selHPnamePrfxS = tempHPselS
					local mainHPnameMatchS = #() as array
					for o in selO do
					(
						--	if there is another HP object with name as main name of selected additional HP
						if o.name == selHPnamePrfxS do
							append mainHPnameMatchS o
					)
					--	find wich mainHP is "parent" HP to selected sub-HP object
					if mainHPnameMatchS.count != 0 then
					(
						--	if mainHP is only one then select it and execute controlPressedselfunction
						if mainHPnameMatchS.count == 1 then
						(
							select mainHPnameMatchS[1]
							ControlPressedSel 3
						)
						else	--	if there is more than one main HP with the same name
						(
							--	select first main HP and try to find if the selected subHP is in volume
							rightMainHPS = #() as array
							for mH in mainHPnameMatchS do
							(
								select mH
								ControlPressedSel 3
								temSelHPGroupS = selection
								if temSelHPGroupS.count != 0 do
								(
									for i in temSelHPGroupS do
									(
										if (i.name == tempHPselS) and  ((intersects mH tempHPsubSelS) == true) do
										append rightMainHPS mH
									)
								)
								clearselection()
							)
							--	if there is only one main HP containing selected subHP
							if rightMainHPS.count == 1 then
							(
								select rightMainHPS[1]
								ControlPressedSel 3
								selectMore tempHPsubSelS
							)
							else
							(
								messagebox "Shift+LMB!!!\nThere are tow or more HP objects with same name!!!" title:"RTTAssist Live Log"
							)
						)
					)
					else
					(
						errMssg = 14
						ErrorMessage 14
					)
				)
			)
			else
			(
				errMssg = 13
				ErrorMessage 13
			)			
			setCommandPanelTaskMode mode:currCmndPanelMode
		) 
		--	explode LP objects
		function ExplodeLPHPObj prefixNameLP prefixNameHP expImp allHPobj1 obj highbuddy proj unIn =
		(
			local theZeroPointI = PointOfExplosion()
			local allHPobjI = allHPobj1
			--	to explode or implode objects
			if expImp == 1 do	--	explode
				expImpEI = (obj.center - theZeroPointI) * proj  + theZeroPointI
			if expImp == 0 do	--	implode
				expImpEI = (obj.center - theZeroPointI) / proj  + theZeroPointI
			
			--	check if the LP obj have SKIN modifier applied and turn it Off
			local isThereModifierL = obj.modifiers	--	check if the object have applied modifiers
			if isThereModifierL.count != 0 do
				DisableSkin isThereModifierL isThereModifierL.count
			local arrHPobjSingleI = #() as array	--	HP with second name
			for subNameHP in allHPobjI do
			(
				--	check if the HP obj have SKIN modifier applied and turn it Off
				isThereModifierH = subNameHP.modifiers	--	check if the object have applied modifiers
				if isThereModifierH.count != 0 do
					DisableSkin isThereModifierH isThereModifierH.count
				--	try to find second HP objects and move them in correct position
				if dividerStr != undefined and dividerStr != "---" do
				(
					-- define second name
					if unIn == 1 then
						secondHPnameI = highBuddy.name + dividerStr
					else	--	get the first tow letters of name of main HP
						secondHPnameI = substring highBuddy.name 1 (prefixNameHP.count+2)
					--	find all second HP					
					if ((findString subNameHP.name secondHPnameI) != undefined) and subNameHP.parent == undefined and ( ((intersects subNameHP obj) == true) or ((intersects subNameHP highBuddy) == true)) do
						append arrHPobjSingleI subNameHP					
				)				
			)
			--	move LP object
			local oldLPposI = obj.center	--	get the current obj center pos
			obj.center = expImpEI	--	(obj.center - theCenter) * proj  + theCenter	--	move the obj
			local newLPposI = obj.center	--	get the new obj center position
			--	move HP objects
			local oldCentPosI = undefined
			local newCentPosI = undefined			
			--	move the main and subHP objects
			r = (distance highBuddy.max highBuddy.min) / 2	--	the raduis of BBox of main HP object
			local subHP = #() as array
			if arrHPobjSingleI.count != 0 do
			(
				--	remove main HP from the array of main and sub HP objects				
				find = (findItem arrHPobjSingleI highBuddy)
				if find != 0 do
					deleteItem arrHPobjSingleI find
				for subHPI in arrHPobjSingleI do
				(
					if  ((intersects subHPI highBuddy) == true) or ((distance subHPI.center highBuddy.center) <= r) or ((intersects subHPI obj) == true) do
						append subHP subHPI
				)						
			)
			--	move the main HP object
			oldCentPosI = highBuddy.center	--	get current HP center pos
			highBuddy.center = highBuddy.center + (newLPposI - oldLPposI)
			newCentPosI = highBuddy.center	--	get new HP center pos
			--	move the object that are Second HP to main HP
			if subHP.count != 0  do
			(
				for childHP in subHP do
				(
					centr = childHP.center
					childHP.center = centr + (newCentPosI - oldCentPosI)
				)						
			)	
		)
		--	find main LP and its main HP buddy
		function FindMainLPandHP obj prefixNameLP1 prefixNameHP1 allHPobj1 proj expImp unIn =
		(
			prfNameL = prefixNameLP1
			prfNameH = prefixNameHP1
			allHPo = allHPobj1
			--	find LP object position
			local currLPpos = obj.center	--	get the current LP obj center pos
			--	add HP part and its children-if they exist
			--	clear the prefix of low poly object
			local prefixNameLPNumb = prfNameL.count
			local lowName_Trimmed = replace obj.name 1 prefixNameLPNumb ""
			-- find the high poly buddy!
			local h = prfNameH + lowName_Trimmed
			for highBuddy in allHPo do
			(
				if (((highBuddy.name)as name) == (h as name)) do
				(--	find the right main HP
					--	check the position of HP buddy and move if is nesecery
					local R = (distance highBuddy.max highBuddy.min) / 2	--	the raduis of BBox - define area to search for LP's BBox center
					--	if pos of curr HP and curr LP obj is match add projection modifier
					if currLPpos == highBuddy.center then	
						ExplodeLPHPObj prefixNameLP prefixNameHP expImp allHPo obj highbuddy proj	unIn
					else	--	if center of LP and HP does not match
					(	--	try to find curr HP in radius of 10% of curr LP radius to BBox corner
						if (distance currLPpos highBuddy.center) <= (R*0.10) then
							ExplodeLPHPObj prefixNameLP prefixNameHP expImp allHPo obj highbuddy proj	unIn
						else	--	if curr HP is far from curr LP center
						(	--	try to find if curr HP is in radius of curr LP radius to BBox corner and two ogjects are intercest
							if ((distance obj.center highBuddy.center) <= r) and ((intersects obj highBuddy) == true) do
								ExplodeLPHPObj prefixNameLP prefixNameHP expImp allHPo obj highbuddy proj	unIn
						)						
					)
				)
			)	
		)
  		--	explode objects with main + additional prefix
		function ExplodeObjPrep SpinnerValue animDistValue expImp=
		(					
			local allLPobj = #() as array
			local allLPobjAdd = #() as array
			local allHPobj = #() as array
			local allHPobjAdd = #() as array
			local doubledLPObj = #() as array
			local doubledLPObjAdd = #() as array
			local instObjAdd = #() as array
			local step  = SpinnerValue
			local animDist = animDistValue
			local LPobjOverlap01 = #() as array
			local LPobjOverlap02 = #() as array
			local escIsPressed = 0
			local selObj = #() as array
			local selObjAdd = #() as array
			
			currCmndPanelMode = getCommandPanelTaskMode()
			setCommandPanelTaskMode mode:#create
			
			objSel = GetProperObj()		

			if chkbox_moveZeroPointObj.state == off then
			(			
				local theZeroPoint = PointOfExplosion()
				local allObjCenterPos = #() as array
				local allObjwithPos = #() as array
				for o in objSel do
				(
					if ((findString o.name prefixNameLP) != undefined) do
					(
						dist = (distance o.center theZeroPoint)
						append allObjCenterPos dist
						append allObjwithPos o
					)
				)
				lowDistValue = amin allObjCenterPos
				objWithLowerDistValue = findItem allObjCenterPos lowDistValue
				objToBeStatic = allObjwithPos[objWithLowerDistValue]
			)
			else
				objToBeStatic = undefined
			--	collect all LP objects with main prefix
			for obj in objSel do
			(
				if ((findString obj.name prefixNameLP) != undefined) and not isGroupMember obj then
				(
					append allLPobj obj
				)
				else
				(
					if ((findString obj.name prefixNameHP) != undefined) and not isGroupMember obj do
					append allHPobj obj
				)
			)
			--	collect all instances of LP objects if they exist
			local instObj = #() as array
			for obj in allLPobj do
			(
				--	get all instances of current LP object
				local instances = #()
				if InstanceMgr.Getinstances obj &instances != 1 do
				(
					InstanceMgr.Getinstances obj &instances
					append instObj instances
				)				
			)
			if instObj.count != 0 do
			(
				for i = 1 to instObj.count do
				(
					for j = instObj.count to i+1 by -1 do
					(
						if CompareSubArrays instObj[i] instObj[j] do 
							deleteItem instObj j
					)
				)
			)
			--	work with/without frozen main objects
			if chkbox_isNodeFrozen.state == off then
			(
				selObj = #() as array
				for s in allLPobj where s.isFrozen != true do
					append selObj s
			)
			else
				selObj = allLPobj
			-- remove all instanc objects from array with all LP objects
			if instObj.count != 0 do
			(
				for i = 1 to instObj.count do
				(
					arrInst = instObj[i]
					for j = 1 to arrInst.count do
					(
						find = (findItem selObj arrInst[j])
						if find != 0 do
							deleteItem selObj find
					)
					
				)
			)
			--	find if two or more LP objects with the main prefix have identical name
				--	create an independent copy of all unique LP objects names
			uniqLPobjName = for s in selObj collect s.name
			uniqLPobjNameCOPY = copy uniqLPobjName #nomap
				--	make a uniq array of all names
			allLPobjNameUNIQ = makeUniqueArray uniqLPobjNameCOPY
			for i = 1 to allLPobjNameUNIQ.count do
			(
				tempArr = #() as array
				for j = 1 to uniqLPobjName.count do
				(
					
					if allLPobjNameUNIQ[i] == uniqLPobjName[j] do
						append tempArr selObj[j]
				)
				if tempArr.count > 1 do
				(
					join doubledLPObj tempArr
				)
			)			
			--	remova all main twins objects
			if doubledLPObj.count != 0 do
			(
				for i = 1 to doubledLPObj.count do
				(
					for j = selObj.count to 1 by -1 do
					(
						if doubledLPObj[i].name == selObj[j].name do
							deleteItem selObj j
					)				
				)				
			)
			--	now:
				--	selObj == LP objects excluding instances and twins by name
				--	instObj == all instances of LP objects
				--	doubledLPObj == all twins by name LP objects	
			--	work with additional objects
 			if prefixNameLPAdd != undefined and prefixNameHPAdd != undefined do
			(
				for obj in objSel do
				(
					if ((findString obj.name prefixNameLPAdd) != undefined) and not isGroupMember obj then
					(
						append allLPobjAdd obj
					)
					else
					(
						if prefixNameHPAdd != undefined do
						(
							if ((findString obj.name prefixNameHPAdd) != undefined) and not isGroupMember obj do
								append allHPobjAdd obj
						)
					)
				)
				local instObjAdd = #() as array
				for obj in allLPobjAdd do
				(
					local instances = #()
					if InstanceMgr.Getinstances obj &instances != 1 do
					(
						InstanceMgr.Getinstances obj &instances
						append instObj instances
					)				
				)
				if instObjAdd.count != 0 do
				(
					for i = 1 to instObjAdd.count do
					(
						for j = instObjAdd.count to i+1 by -1 do
						(
							if CompareSubArrays instObjAdd[i] instObjAdd[j] do 
								deleteItem instObjAdd j
						)
					)
				)
				if chkbox_isNodeFrozen.state == off then
				(
					selObjAdd = #() as array
					for s in allLPobjAdd where s.isFrozen != true do
						append selObjAdd s
				)
				else
					selObjAdd = allLPobjAdd
				if instObjAdd.count != 0 do
				(
					for i = 1 to instObjAdd.count do
					(
						arrInstAdd = instObjAdd[i]
						for j = 1 to arrInstAdd.count do
						(
							find = (findItem selObjAdd arrInstAdd[j])
							if find != 0 do
								deleteItem selObjAdd find
						)					
					)
				)
				uniqLPobjNameAdd = for s in selObjAdd collect s.name
				uniqLPobjNameCOPYAdd = copy uniqLPobjNameAdd #nomap
				allLPobjNameUNIQAdd = makeUniqueArray uniqLPobjNameCOPYAdd
				for i = 1 to allLPobjNameUNIQAdd.count do
				(
					tempArrAdd = #() as array
					for j = 1 to uniqLPobjNameAdd.count do
					(
						
						if allLPobjNameUNIQAdd[i] == uniqLPobjNameAdd[j] do
							append tempArrAdd selObjAdd[j]
					)
					if tempArrAdd.count > 1 do
					(
						join doubledLPObjAdd tempArrAdd
					)
				)
				if doubledLPObjAdd.count != 0 do
				(
					for i = 1 to doubledLPObjAdd.count do
					(
						for j = selObjAdd.count to 1 by -1 do
						(
							if doubledLPObjAdd[i].name == selObjAdd[j].name do
								deleteItem selObjAdd j
						)				
					)				
				)
			) 	
			if step != undefined then
			(	
				if expImp == 1 do
				(				
					if ((spn_sTime.text as float) == "0") or (chkbox_OnOffAnimation.state == on) or (noAnimExplByCntrl == 1) then
					(	--	explode without animation
						proj = step
					--	move uniq objects
						for obj in selObj where obj != objToBeStatic do
						(
							FindMainLPandHP obj prefixNameLP prefixNameHP allHPobj proj 1	1		
						)
						--	move objects with additional prefix
						if selObjAdd.count != 0 do
						(
							for obj in selObjAdd do
							(
								FindMainLPandHP obj prefixNameLPAdd prefixNameHPAdd allHPobjAdd proj 1 1
							)
						)
					--	move twins
						for obj in doubledLPObj where obj != objToBeStatic do
						(
							FindMainLPandHP obj prefixNameLP prefixNameHP allHPobj proj 1 1				
						)
						--	move objects with additional prefix
						if doubledLPObjAdd.count != 0 do
						(
							for obj in doubledLPObjAdd do
							(
								FindMainLPandHP obj prefixNameLPAdd prefixNameHPAdd allHPobjAdd proj 1 1
							)
						) 
					--	move instances of main LP obj
						if instObj.count != 0 do
						(
							for i = 1 to instObj.count do
							(
								arrInst = instObj[i]
								for j = 1 to arrInst.count do
								(
									obj = arrInst[j]	--	current LP object
									FindMainLPandHP obj prefixNameLP prefixNameHP allHPobj proj 1 0	
								)						
							)	 
						)
						--	move instancec of additional LP objects
						if instObjAdd.count != 0 do
						(
							for i = 1 to instObjAdd.count do
							(
								arrInst = instObjAdd[i]
								for j = 1 to arrInst.count do
								(
									obj = arrInst[j]	--	current LP object
									FindMainLPandHP obj prefixNameLPAdd prefixNameHPAdd allHPobjAdd proj 1 0	
								)						
							)	 
						)
					)
					else
					(	--	start animated explode
						proj = animDist	--	1.1
						sleepTime = 1 - (spn_sTime.text as float) + 0.01
						
						for i = 1 to step do
						(
							if keyboard.escPressed do
							(
								escIsPressed = 1
								exit
							)						
							--	move uniq objects
							for obj in selObj where obj != objToBeStatic do
							(
								FindMainLPandHP obj prefixNameLP prefixNameHP allHPobj proj 1	1				
							)
							--	move objects with additional prefix
							if selObjAdd.count != 0 do
							(
								for obj in selObjAdd do
								(
									FindMainLPandHP obj prefixNameLPAdd prefixNameHPAdd allHPobjAdd proj 1 1
								)
							)
						--	move twins
							for obj in doubledLPObj where obj != objToBeStatic do
							(
								FindMainLPandHP obj prefixNameLP prefixNameHP allHPobj proj 1 1				
							)
							--	move objects with additional prefix
							if doubledLPObjAdd.count != 0 do
							(
								for obj in doubledLPObjAdd do
								(
									FindMainLPandHP obj prefixNameLPAdd prefixNameHPAdd allHPobjAdd proj 1 1
								)
							) 
						--	move instances of main LP obj
							if instObj.count != 0 do
							(
								for i = 1 to instObj.count do
								(
									arrInst = instObj[i]
									for j = 1 to arrInst.count do
									(
										obj = arrInst[j]	--	current LP object
										FindMainLPandHP obj prefixNameLP prefixNameHP allHPobj proj 1 0	
									)						
								)	 
							)
							--	move instancec of additional LP objects
							if instObjAdd.count != 0 do
							(
								for i = 1 to instObjAdd.count do
								(
									arrInst = instObjAdd[i]
									for j = 1 to arrInst.count do
									(
										obj = arrInst[j]	--	current LP object
										FindMainLPandHP obj prefixNameLPAdd prefixNameHPAdd allHPobjAdd proj 1 0	
									)						
								)	 
							)
							completeRedraw()
							sleep sleepTime
						)
					)
				)
				if expImp == 0 do
				(
					proj = animDist	
					--	move uniq objects
					for obj in selObj where obj != objToBeStatic do
					(
						FindMainLPandHP obj prefixNameLP prefixNameHP allHPobj proj 0	1		
					)
					--	move objects with additional prefix
					if selObjAdd.count != 0 do
					(
						for obj in selObjAdd do
						(
							FindMainLPandHP obj prefixNameLPAdd prefixNameHPAdd allHPobjAdd proj 0 1
						)
					)
				--	move twins
					for obj in doubledLPObj where obj != objToBeStatic do
					(
						FindMainLPandHP obj prefixNameLP prefixNameHP allHPobj proj 1	1					
					)
					--	move objects with additional prefix
					if doubledLPObjAdd.count != 0 do
					(
						for obj in doubledLPObjAdd do
						(
							FindMainLPandHP obj prefixNameLPAdd prefixNameHPAdd allHPobjAdd proj 0 1
						)
					) 
				--	move instances of main LP obj
					if instObj.count != 0 do
					(
						for i = 1 to instObj.count do
						(
							arrInst = instObj[i]
							for j = 1 to arrInst.count do
							(
								obj = arrInst[j]	--	current LP object
								FindMainLPandHP obj prefixNameLP prefixNameHP allHPobj proj 0 0
							)						
						)	 
					)
					--	move instancec of additional LP objects
					if instObjAdd.count != 0 do
					(
						for i = 1 to instObjAdd.count do
						(
							arrInst = instObjAdd[i]
							for j = 1 to arrInst.count do
							(
								obj = arrInst[j]	--	current LP object
								FindMainLPandHP obj prefixNameLPAdd prefixNameHPAdd allHPobjAdd proj 0 0
							)						
						)	 
					)
				)  
				--	turn off the automatic check for overlap if the "Selected" button is pressed
				if isSelectObj == 0 then
				(
					if noAutoCOByShift != 1 do
					(
						if escIsPressed == 0 and chkbox_AutoCheckOverlap.state == on do
						(				
							--check for overlapping
							allLPobj = for obj in selObj where ((findString obj.name prefixNameLP) != undefined) collect obj
							for i = 1 to allLPobj.count do
							(
								for j = i+1 to allLPobj.count do
								(
									if (intersects allLPobj[i] allLPobj[j]) == true do
									(
										append LPobjOverlap01 allLPobj[i]
										append LPobjOverlap02 allLPobj[j]
									)
								)				
							)
							if LPobjOverlap01.count != 0 then
							(
								join LPobjOverlap01 LPobjOverlap02
								select LPobjOverlap01
								--	explode selected overlaped objects
									ExplodeObjPrep step animDist 1
							)
							else
								max select none
						)
					)
				)
			)
			else
			(
				errMssg = 19
				ErrorMessage 19
			)
			setCommandPanelTaskMode mode:currCmndPanelMode
		)
		function ImplodeObj =
		(
			ExplodeObjPrep 1.1 1.1 0
		)
		--	set the typed in dotNet textbox prefix labels for LP objects
		function SetLPprefix prefixStr =
		(
			if prefixStr != "" then
			(
				local pNLP = prefixStr
				--	search for comma sign in LP object prefix name
				prfxL = findString pNLP ","
				--	if comma sign is found - divide two prefixes
				if prfxL != undefined then
				(
					pL = filterString pNLP ","
					prefixNameLP = pL[1]
					prefixNameLPAdd = pL[2]
					--	check if there a empty space in additional prefix label
					if ((findstring prefixNameLPAdd " ") != undefined) then
					(
						subStr = substring prefixNameLPAdd 2 (prefixNameLPAdd.count-1)
						prefixNameLPAdd = subStr
					)
					else
						prefixNameLPAdd = pL[2]
					
					dNet_Label_selLP.text = pNLP
					DotNetFont dNet_Label_selLP
				)
				else
				(
					prefixNameLP = pNLP
					prefixNameLPAdd = undefined
					dNet_Label_selLP.flatStyle=dNet_Label_selLP.flatStyle.flat
					dNet_Label_selLP.text = prefixNameLP
					DotNetFont dNet_Label_selLP
				)
				if prefixNameLP == prefixNameHP do
				(
					errMssg = 2
					ErrorMessage 2
				)
				
				dNet_Label_selLP.pos = [61,32]
				dNet_TextBox_LP.pos = [-58,-58]
			)
			else
			(
				dNet_TextBox_LP.Focus()
				errMssg = 11
				ErrorMessage 11
				prefixNameLP = undefined
				prefixNameLPAdd = undefined
			)	
		)
		--	set the typed in dotNet textbox prefix labels for HP objects
		function SetHPprefix prefixStr =
		(
			if prefixStr != "" then
			(
				local pNHP = prefixStr
				--	search for comma sign in LP object prefix name
				prfxH = findString pNHP ","
				--	if comma sign is found - divide two prefixes
				if prfxH != undefined then
				(
					pH = filterString pNHP ","
					prefixNameHP = pH[1]
					prefixNameHPAdd = pH[2]
					--	check if there a empty symbol in additional prefix label
					if ((findstring prefixNameHPAdd " ") != undefined) then
					(
						subStr = substring prefixNameHPAdd 2 (prefixNameHPAdd.count-1) 
						prefixNameHPAdd = subStr
					)
					else
						prefixNameHPAdd = pH[2]
					dNet_Label_selHP.text = pNHP
					DotNetFont dNet_Label_selHP
				)
				else
				(
					prefixNameHP = pNHP
					prefixNameHPAdd = undefined
					dNet_Label_selHP.flatStyle=dNet_Label_selHP.flatStyle.flat
					dNet_Label_selHP.text = prefixNameHP
					DotNetFont dNet_Label_selHP
				)
				if prefixNameLP == prefixNameHP do
				(
					errMssg = 2
					ErrorMessage 2
				)
				
				dNet_Label_selHP.pos = [61,51]
				dNet_TextBox_HP.pos = [-74,-78]
			)
			else
			(
				errMssg = 12
				ErrorMessage 12
				prefixNameHP = undefined
				prefixNameHPAdd = undefined
			)
		)

		function GetMapSize sizeVal HorW=
		(
			if sizeVal != "" do
			(
				--	if size is locked
				if SizeLockState == 1 do
				(
					if HorW == 1 do
						spn_mapWidth.text = spn_mapHeight.text	
					if HorW == 2 do
						spn_mapHeight.text = spn_mapWidth.text	
				)				
			)
		)
		function HideMainLPobj =
		(
			if CheckObjAndPrefixLP() == true then
			(
				isVisibleHideLP = #() as array
				for obj in selObj do
				(
					if visibleObj == 1 then
					(
						if ((findString obj.name (prefixNameLP as string)) != undefined) do
						(
							append isVisibleHideLP obj
							hide obj
						)
					)
					else
					(
						if ((findString obj.name (prefixNameLP as string)) != undefined) do
							hide obj
					)
				)
			)
			else
			(
				ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
				ImgTag_chkbtn_low_hide.tooltip = "Hide All Low Poly objects!"
			)
		)
		function UnhideMainLPobj = 
		(
			if visibleObj == 1 do
				unhide isVisibleHideLP
			for obj in selObj do
			(
				if ((findString obj.name (prefixNameLP as string)) != undefined) do
					unhide obj
			)
		)
		function HideImportedLPobj =
		(
			if CheckObjAndPrefixLPAdd() == true then
			(
				isVisibleHideLPAdd = #() as array
				for obj in selObj do
				(
					if visibleObj == 1 then
					(
						if ((findString obj.name (prefixNameLPAdd as string)) != undefined) do
						(
							append isVisibleHideLPAdd obj
							hide obj
						)
					)
					else
					(
						
						if ((findString obj.name (prefixNameLPAdd as string)) != undefined) do
							hide obj
					)
				)
			)
			else
			(
				ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
				ImgTag_chkbtn_low_hide.tooltip = "Hide All Low Poly objects!"
			)
		)
		function UnhideImportedLPobj =
		(
			if visibleObj == 1 then
				unhide isVisibleHideLPAdd
			for obj in selObj do
			(
				if ((findString obj.name (prefixNameLPAdd as string)) != undefined) do
					unhide obj				
			)
		)
		function HideMainHPobj =
		(
			if CheckObjAndPrefixHP() == true then
			(
				isVisibleHideHP = #() as array
				for obj in selObj do
				(
					if visibleObj == 1 then
					(
						if ((findString obj.name (prefixNameHP as string)) != undefined) do
						(
							append isVisibleHideHP obj
							hide obj
						)
					)
					else
					(
						if ((findString obj.name (prefixNameHP as string)) != undefined) do
							hide obj
					)
				)
			)
			else
			(
				ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
				ImgTag_chkbtn_high_hide.tooltip = "Hide All High-Poly objects!"
			)
		)
		function UnhideMainHPobj =
		(
			if visibleObj == 1 then
				unhide isVisibleHideHP
			for obj in selObj do
			(
				if ((findString obj.name (prefixNameHP as string)) != undefined) do
					unhide obj
			)
		)
		function HideImportedHPobj =
		(
			if CheckObjAndPrefixHPAdd() == true then
			(
				isVisibleHideHPAdd = #() as array
				for obj in selObj do
				(
					if visibleObj == 1 then
					(
						if ((findString obj.name (prefixNameHPAdd as string)) != undefined) do
						(
							append isVisibleHideHPAdd obj
							hide obj
						)
					)
					else
					(
						if ((findString obj.name (prefixNameHPAdd as string)) != undefined) do
							hide obj
					)
				)
			)
			else
			(
				ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
				ImgTag_chkbtn_high_hide.tooltip = "Hide All High-Poly objects!"
			)
		)
		function UnhideImportedHPobj =
		(
			if visibleObj == 1 then
				unhide isVisibleHideHPAdd
			for obj in selObj do
			(
				if ((findString obj.name (prefixNameHPAdd as string)) != undefined) do
					unhide obj
			)
		)
--------------------------------------------
	--	Add Projection Modifier Functions
--------------------------------------------
		function AddProjMain =
		(
			local pairsNamesNoPrefixLP = GetNoPrefixNameLP prefixNameLP
			local pairsNamesNoPrefixHP = GetNoPrefixNameHP prefixNameHP
			local allLPobj = #() as array
			local allLPobjName =#() as array
			local allHPobj = #() as array
			local uniqDoubledLPObj = #() as array	
			local instDoubledLPObj = #() as array
			local selO = GetProperObj()	
			allLPwithProjFromScript = #() as array
			allLPwithProjFromScriptInst = #()
			
			if addBatchProj == true then
				GetAllObj()
			else
				GetProperObj()
			
			--	collect all LP and HP objects with main prefix
			for obj in selObj do
			(
				if ((findString obj.name prefixNameLP) != undefined) and not isGroupMember obj then
				(
					--	check if object is a Shape
					if (superclassof obj == Shape) then
					(
						--	check if shape is renderable or not
						if obj.render_renderable == true do
							append allLPobj obj
					)
					else
						append allLPobj obj
				)
				else
				(
					if ((findString obj.name prefixNameHP) != undefined) and not isGroupMember obj do
					(
						if (superclassof obj == Shape) then
						(
							if obj.render_renderable == true do
								append allHPobj obj
						)
						else
							append allHPobj obj						
					)
				)
			)

			--	collect all instances of LP objects if they exist
			local instObj = #() as array
			for obj in allLPobj do
			(
				--	get all instances of current LP object
				local instances = #()
				if InstanceMgr.Getinstances obj &instances != 1 do
				(
					InstanceMgr.Getinstances obj &instances
					append instObj instances
				)				
			)
			if instObj.count != 0 do
			(
				for i = 1 to instObj.count do
				(
					for j = instObj.count to i+1 by -1 do
					(
						if CompareSubArrays instObj[i] instObj[j] do 
							deleteItem instObj j
					)
				)
			)
			--	work with/without frozen objects
			if chkbox_isNodeFrozen.state == off then
			(
				selO = #() as array
				for s in allLPobj where s.isFrozen != true do
					append selO s
			)
			else
				selO = allLPobj
			-- remove all instanc objects from array with all LP objects
			if instObj.count != 0 do
			(
				for i = 1 to instObj.count do
				(
					arrInst = instObj[i]
					for j = 1 to arrInst.count do
					(
						find = (findItem selO arrInst[j])
						if find != 0 do
							deleteItem selO find
					)
					
				)
			)
			--	find if two or more LP objects with the main prefix have identical name
				--	create an independent copy of all unique LP objects names
			uniqLPobjName = for s in selO collect s.name
			uniqLPobjNameCOPY = copy uniqLPobjName #nomap
				--	make a uniq array of all names
			allLPobjNameUNIQ = makeUniqueArray uniqLPobjNameCOPY
			for i = 1 to allLPobjNameUNIQ.count do
			(
				tempArr = #() as array
				for j = 1 to uniqLPobjName.count do
				(
					
					if allLPobjNameUNIQ[i] == uniqLPobjName[j] do
						append tempArr selO[j]
				)
				if tempArr.count > 1 do
				(
					join uniqDoubledLPObj tempArr
				)
			)
			--	remove all twins from selO array
			if uniqDoubledLPObj.count != 0 do
			(
				for i = 1 to uniqDoubledLPObj.count do
				(
					for j = selO.count to 1 by -1 do
					(
						if uniqDoubledLPObj[i].name == selO[j].name do
							deleteItem selO j
					)				
				)				
			)
			--	now:
				--	selO == LP objects excluding instances and twins by name
				--	instObj == all instances of LP objects
				--	uniqDoubledLPObj == all twins by name LP objects
			currCmndPanelMode = getCommandPanelTaskMode()
			setCommandPanelTaskMode mode:#create
			
			--	add Projection modifier to all unique LP objects - no instances, no twins			
			for obj in selO do
			(
				clearSelection()
				select obj
				addModifier obj (Projection())
				append allLPwithProjFromScript obj
				--	reset or not Cage
				if chkbox_noCageReset.checked == on do
				(
					$.modifiers[#Projection].resetCage()	
					$.modifiers[#Projection].displayCage = off
				)
				--	find LP object position
				local currLPpos = obj.center
				local prefixNameLPNumb = prefixNameLP.count
				local lowName_Trimmed = replace obj.name 1 prefixNameLPNumb ""
				-- find the high poly buddy!
				local h = prefixNameHP + lowName_Trimmed
				for highBuddy in selObj do
				(
					if (((highBuddy.name)as name) == (h as name)) do
					(
						--	check the position of HP buddy and move if is nesecery
						local R = (distance highBuddy.max highBuddy.min) / 2	--	the raduis of BBox - define area to search for LP's BBox center
						--	if pos of curr HP and curr LP obj is match add projection modifier
						if currLPpos == highBuddy.center then
							AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R
						else	--	if center of LP and HP does not match
						(	--	try to find curr HP in radius of 10% of curr LP radius to BBox corner
							if (distance currLPpos highBuddy.center) <= (R*0.10) then
								AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R
							else	--	if curr HP is far from curr LP center
							(	--	try to find if curr HP is in radius of curr LP radius to BBox corner and two ogjects are intercest
								if ((distance obj.center highBuddy.center) <= r) and ((intersects obj highBuddy) == true) do
									AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R
							)						
						)
					)										
				)
			)
			--	add Projection modifier to all twins LP objects - no instances
			if uniqDoubledLPObj.count != 0 do
			(
				for obj in uniqDoubledLPObj do
				(
					clearSelection()
					select obj
					addModifier obj (Projection())
					append allLPwithProjFromScript obj
					--	reset or not Cage
					if chkbox_noCageReset.checked == on do
					(
						$.modifiers[#Projection].resetCage()	
						$.modifiers[#Projection].displayCage = off
					)
					--	find LP object position
					local currLPpos = obj.center
					local prefixNameLPNumb = prefixNameLP.count
					local lowName_Trimmed = replace obj.name 1 prefixNameLPNumb ""
					-- find the high poly buddy!
					local h = prefixNameHP + lowName_Trimmed
					for highBuddy in selObj do
					(
						if (((highBuddy.name)as name) == (h as name)) do
						(
							--	check the position of HP buddy and move if is nesecery
							local R = (distance highBuddy.max highBuddy.min) / 2	--	the raduis of BBox - define area to search for LP's BBox center
							--	if pos of curr HP and curr LP obj is match add projection modifier
							if currLPpos == highBuddy.center then
								AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R
							else	--	if center of LP and HP does not match
							(	--	try to find curr HP in radius of 10% of curr LP radius to BBox corner
								if (distance currLPpos highBuddy.center) <= (R*0.10) then
									AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R
								else	--	if curr HP is far from curr LP center
								(	--	try to find if curr HP is in radius of curr LP radius to BBox corner and two ogjects are intercest
									if ((distance obj.center highBuddy.center) <= r) and ((intersects obj highBuddy) == true) do
										AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R
								)						
							)
						)										
					)
				)
			)
			--	add Projection modifier to all instance LP objects
			if skipInstances != 1 do
			(
				if instObj.count != 0 do
				(
					--	add projection modifier to one LP instance from every instance group				
					for i = 1 to instObj.count do
					(
						obj = instObj[i][instObj[i].count]
						clearSelection()
						select obj	
						addModifier obj (Projection())
						append allLPwithProjFromScriptInst obj
						--	reset or not Cage
						if chkbox_noCageReset.checked == on do
						(
							$.modifiers[#Projection].resetCage()
							$.modifiers[#Projection].displayCage = off
						)
						--	find LP object position
						local currLPpos = obj.center
						local prefixNameLPNumb = prefixNameLP.count
						local lowName_Trimmed = replace obj.name 1 prefixNameLPNumb ""
						-- find the high poly buddy!
						local h = prefixNameHP + lowName_Trimmed
						for highBuddy in selObj do
						(
							if (((highBuddy.name)as name) == (h as name)) do
							(
								--	check the position of HP buddy and move if is nesecery
								local R = (distance highBuddy.max highBuddy.min) / 2	--	the raduis of BBox - define area to search for LP's BBox center
								--	if pos of curr HP and curr LP obj is match add projection modifier
								if currLPpos == highBuddy.center then
									AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R
								else	--	if center of LP and HP does not match
								(	--	try to find curr HP in radius of 10% of curr LP radius to BBox corner
									if (distance currLPpos highBuddy.center) <= (R*0.10) then
										AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R
									else	--	if curr HP is far from curr LP center
									(	--	try to find if curr HP is in radius of curr LP radius to BBox corner and two ogjects are intercest
										if ((distance obj.center highBuddy.center) <= r) and ((intersects obj highBuddy) == true) do
											AddProjModToSubHPi highBuddy prefixNameLP prefixNameHP allHPobj R
									)						
								)
							)										
						)					
					)	 
				)
			)
			setCommandPanelTaskMode mode:currCmndPanelMode
			if skipInstances == 1 then
				ErrorMessage 56	--	add projection modifier successuful (all inctances are scipped)
			else
				ErrorMessage 50	--	add projection modifier successuful
		)
 		function AddProjMainAdd =
		(
			local pairsNamesNoPrefixLPAdd = GetNoPrefixNameLP prefixNameLPAdd
			local pairsNamesNoPrefixHPAdd = GetNoPrefixNameHP prefixNameHPAdd
			local allLPobjAdd = #() as array
			local allLPobjNameAdd =#() as array
			local allHPobjAdd = #() as array
			local uniqDoubledLPObjAdd = #() as array
			local instDoubledLPObjAdd = #() as array
			local selOAdd = GetProperObj()
			allLPwithProjFromScriptAdd = #() as array 
			allLPwithProjFromScriptInstAdd = #()
			
			GetProperObj()
			for obj in selObj do
			(
				if ((findString obj.name prefixNameLPAdd) != undefined) and not isGroupMember obj then
				(
					if (superclassof obj == Shape) then
					(
						if obj.render_renderable == true do
							append allLPobjAdd obj
					)
					else
						append allLPobjAdd obj
				)
				else
				(
					if ((findString obj.name prefixNameHPAdd) != undefined) and not isGroupMember obj do
					(
						if (superclassof obj == Shape) then
						(
							if obj.render_renderable == true do
								append allHPobjAdd obj
						)
						else
							append allHPobjAdd obj	
					)
				)
			)				
			
			local instObjAdd = #() as array
			for obj in allLPobjAdd do
			(
				local instances = #()
				if InstanceMgr.Getinstances obj &instances != 1 do
				(
					InstanceMgr.Getinstances obj &instances
					append instObj instances
				)					
			)
			if instObjAdd.count != 0 do
			(
				for i = 1 to instObjAdd.count do
				(
					for j = instObjAdd.count to i+1 by -1 do
					(
						if CompareSubArrays instObjAdd[i] instObjAdd[j] do 
							deleteItem instObjAdd j
					)
				)
			)
			if chkbox_isNodeFrozen.state == off then
			(
				selOAdd = #() as array
				for s in allLPobjAdd where s.isFrozen != true do
					append selOAdd s
			)
			else
				selOAdd = allLPobjAdd

			if instObjAdd.count != 0 do
			(
				for i = 1 to instObjAdd.count do
				(
					arrInst = instObjAdd[i]
					for j = 1 to arrInst.count do
					(
						find = (findItem selOAdd arrInst[j])
						if find != 0 do
							deleteItem selOAdd find
					)
					
				)
			)		
			uniqLPobjNameAdd = for s in selOAdd collect s.name
			uniqLPobjNameCOPYAdd = copy uniqLPobjNameAdd #nomap
			allLPobjNameUNIQAdd = makeUniqueArray uniqLPobjNameCOPYAdd
			for i = 1 to allLPobjNameUNIQAdd.count do
			(
				tempArrAdd = #() as array
				for j = 1 to uniqLPobjNameAdd.count do
				(
					
					if allLPobjNameUNIQAdd[i] == uniqLPobjNameAdd[j] do
						append tempArrAdd selOAdd[j]
				)
				if tempArrAdd.count > 1 do
				(
					join uniqDoubledLPObjAdd tempArrAdd
				)
			)
			if uniqDoubledLPObjAdd.count != 0 do
			(
				for i = 1 to uniqDoubledLPObjAdd.count do
				(
					for j = selOAdd.count to 1 by -1 do
					(
						if uniqDoubledLPObjAdd[i].name == selOAdd[j].name do
							deleteItem selOAdd j
					)				
				)				
			)
			currCmndPanelMode = getCommandPanelTaskMode()
			setCommandPanelTaskMode mode:#create
			for obj in selOAdd do
			(
				clearSelection()
				select obj
				addModifier obj (Projection())
				append allLPwithProjFromScriptAdd obj
				if chkbox_noCageReset.checked == on do
				(
					$.modifiers[#Projection].resetCage()	
					$.modifiers[#Projection].displayCage = off
				)
				local currLPposAdd = obj.center
				local prefixNameLPNumbAdd = prefixNameLPAdd.count
				local lowName_TrimmedAdd = replace obj.name 1 prefixNameLPNumbAdd ""
				local h = prefixNameHPAdd + lowName_TrimmedAdd
				for highBuddy in selObj do
				(
					if (((highBuddy.name)as name) == (h as name)) do
					(
						local R = (distance highBuddy.max highBuddy.min) / 2	
						if currLPposAdd == highBuddy.center then
							AddProjModToSubHPi highBuddy prefixNameLPAdd prefixNameHPAdd allHPobjAdd R
						else
						(
							if (distance currLPposAdd highBuddy.center) <= (R*0.10) then
								AddProjModToSubHPi highBuddy prefixNameLPAdd prefixNameHPAdd allHPobjAdd R
							else	
							(
								if ((distance obj.center highBuddy.center) <= r) and ((intersects obj highBuddy) == true) do
									AddProjModToSubHPi highBuddy prefixNameLPAdd prefixNameHPAdd allHPobjAdd R
							)						
						)
					)										
				)
			)
			if uniqDoubledLPObjAdd.count != 0 do
			(
				for obj in uniqDoubledLPObjAdd do
				(
					clearSelection()
					select obj
					addModifier obj (Projection())
					append allLPwithProjFromScriptAdd obj
					if chkbox_noCageReset.checked == on do
					(
						$.modifiers[#Projection].resetCage()
						$.modifiers[#Projection].displayCage = off
					)
					local currLPposAdd = obj.center
					local prefixNameLPNumbAdd = prefixNameLPAdd.count
					local lowName_TrimmedAdd = replace obj.name 1 prefixNameLPNumbAdd ""
					local h = prefixNameHPAdd + lowName_TrimmedAdd
					for highBuddy in selObj do
					(
						if (((highBuddy.name)as name) == (h as name)) do
						(
							
							local R = (distance highBuddy.max highBuddy.min) / 2
							if currLPposAdd == highBuddy.center then
								AddProjModToSubHPi highBuddy prefixNameLPAdd prefixNameHPAdd allHPobjAdd R
							else
							(
								if (distance currLPposAdd highBuddy.center) <= (R*0.10) then
									AddProjModToSubHPi highBuddy prefixNameLPAdd prefixNameHPAdd allHPobjAdd R
								else
								(
									if ((distance obj.center highBuddy.center) <= r) and ((intersects obj highBuddy) == true) do
										AddProjModToSubHPi highBuddy prefixNameLPAdd prefixNameHPAdd allHPobjAdd R
								)						
							)
						)										
					)
				)
			)

			if skipInstances != 1 do
			(
				if instObjAdd.count != 0 do
				(
					for i = 1 to instObjAdd.count do
					(
						obj = instObjAdd[i][instObjAdd[i].count]
						clearSelection()
						select obj
						addModifier obj (Projection())
						append allLPwithProjFromScriptInstAdd obj
						if chkbox_noCageReset.checked == on do
						(
							$.modifiers[#Projection].resetCage()	
							$.modifiers[#Projection].displayCage = off
						)
						local currLPposAdd = obj.center
						local prefixNameLPNumbAdd = prefixNameLPAdd.count
						local lowName_TrimmedAdd = replace obj.name 1 prefixNameLPNumbAdd ""
						local h = prefixNameHPAdd + lowName_TrimmedAdd
						for highBuddy in selObj do
						(
							if (((highBuddy.name)as name) == (h as name)) do
							(
								local R = (distance highBuddy.max highBuddy.min) / 2
								if currLPposAdd == highBuddy.center then
									AddProjModToSubHPi highBuddy prefixNameLPAdd prefixNameHPAdd allHPobjAdd R
								else
								(
									if (distance currLPposAdd highBuddy.center) <= (R*0.10) then
										AddProjModToSubHPi highBuddy prefixNameLPAdd prefixNameHPAdd allHPobjAdd R
									else
									(
										if ((distance obj.center highBuddy.center) <= r) and ((intersects obj highBuddy) == true) do
											AddProjModToSubHPi highBuddy prefixNameLPAdd prefixNameHPAdd allHPobjAdd R
									)						
								)
							)										
						)
					)	 
				)
			)
-- 			)
			setCommandPanelTaskMode mode:currCmndPanelMode
			if skipInstances == 1 then
				ErrorMessage 56	--	add projection modifier successuful(all inctances are skipped)
			else
				ErrorMessage 50	--	add projection modifier successuful
		)
		
		--	Implode objects on SAVE FILE, then explode them again
		function ImplodeOnSave =
		(
			--	FIRST IMPLODE OBJECTS
			if explodeImplodeImgTagState == 0 do
			(
				try(delete miauuZeroPoint)catch()
				isImplodeOnSaveActive = 1
				--	store the value of spn_explodeImplode spinner
				explodeMultiplier = dNetTBasSpn
				--	turn off Implode button
				explodeImplodeImgTagState = 1
				ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITexplode.png"))
				ImgTag_ExplodeImplode.tooltip = "LMB to explode the scene using default settings!\nAlt + LMB to turn on \"EXPLODE\"mode!\nCtrl+LMB to explode without animation!\nShift+LMB to explode without automaticaly checks\nfor overpalled objects!"
				--	return objects to starting position
				for i = 1 to allObjInScene.count where isValidNode allObjInScene[i] do
				(
					allObjInScene[i].center = startingObjPos[i]
					isThereModifier = allObjInScene[i].modifiers
					if isThereModifier.count != 0 do
						EnableSkin isThereModifier isThereModifier.count
				)
				dNetTBasSpn = 1.0
				dNet_TxtBoxAsSpinner.text = "1.0"
			)
		)
		--	Explode after SAVE FILE
		function ExplodeAfterSave =
		(
			--	if Implode mode is active
			if isImplodeOnSaveActive == 1 then
			(
				isImplodeOnSaveActive = 0
				--	turn on Implode button
				explodeImplodeImgTagState = 0
				GetProperObj()
				--	store position of all objects
				if CheckObjAndPrefixLP() == true and CheckObjAndPrefixHP() == true do
				(
					allObjInScene = for obj in objects where classof obj != Biped_Object and superClassOf obj != helper collect obj
					startingObjPos = for i = 1 to  allObjInScene.count collect allObjInScene[i].center
					explodeImplodeImgTagState == 0
					ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITimplode.png"))
					ImgTag_ExplodeImplode.tooltip = "LMB to explode the scene using default settings!\nAlt + LMB to turn on \"EXPLODE\"mode!\nCtrl+LMB to explode without animation!\nShift+LMB to explode without automaticaly checks\nfor overpalled objects!"
					GetProperObj()
				)
				--	do the explode with previous stored value of spn_explodeImplode
				--	return objects to their position before opening CompareNames
				ExplodeObjPrep explodeMultiplier 1.03 1
				dNetTBasSpn = explodeMultiplier
				dNet_TxtBoxAsSpinner.text = (explodeMultiplier as string)
			)
		)
-------------------------------
	--	Function to show and hide Selected Map Unique Settings
-------------------------------
		function ShowAlpha =
		(
			lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20]
			colorPick_EleBGColorAlpha.pos = [selMapUSZ+141+75,selMapUSY+18] 				
		)
		function HideAlpha =
		(
			lb_BGcolor.pos = [-200,-200] 
			colorPick_EleBGColorAlpha.pos = [-300,-300]
		)
		function ShowAO =
		(
				dNet_lbl_AOSpread.pos = [selMapUSZ+93,selMapUSY+17] 
				dNet_lbl_AOMaxDist.pos = [selMapUSZ+93,selMapUSY+17+20] 
				dNet_lbl_AOFalloff.pos = [selMapUSZ+93,selMapUSY+17+20+20] 
				
				dNet_lbl_AOSamples.pos = [selMapUSZ+4,selMapUSY+17] 
				lb_AOSamplesBG.pos = [selMapUSZ+52,selMapUSY+17] 
				spn_AOSamples.pos = [selMapUSZ+53,selMapUSY+19] 
				btn_AOSamplesUP.pos = [selMapUSZ+52+23,selMapUSY+17+1]
				btn_AOSamplesDown.pos = [selMapUSZ+52+23,selMapUSY+17+9]
				--
				dNet_lbl_AObright.pos = [selMapUSZ+5,selMapUSY+17+22]
				colorPick_AObright.pos = [selMapUSZ+50,selMapUSY+17+22] 
				dNet_lbl_AOdark.pos = [selMapUSZ+5,selMapUSY+17+22+20] 
				colorPick_AOdark.pos = [selMapUSZ+50,selMapUSY+17+22+20] 
				--
				lb_AOSpn3.pos = [selMapUSZ+140,selMapUSY+17]
				spn_AOSpread.pos = [selMapUSZ+141,selMapUSY+18] 
				btn_AOSpreadUP.pos = [selMapUSZ+141+22,selMapUSY+18] 
				btn_AOSpreadDown.pos = [selMapUSZ+141+22,selMapUSY+18+8] 			
				
				spn_AOMaxDist.pos = [selMapUSZ+141,selMapUSY+18+20] 
				btn_AOMaxDistUP.pos = [selMapUSZ+141+22,selMapUSY+18+19]
				btn_AOMaxDistDown.pos = [selMapUSZ+141+22,selMapUSY+18+20+7]
					
				dNet_lbl_AOFalloff.pos = [selMapUSZ+93,selMapUSY+17+20+20] 
				spn_AOFalloff.pos = [selMapUSZ+141,selMapUSY+18+20+19] 
				btn_AOFalloffUP.pos = [selMapUSZ+141+22,selMapUSY+18+20+18]
				btn_AOFalloffDown.pos = [selMapUSZ+141+22,selMapUSY+18+20+19+7]
				
				lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20]
				colorPick_EleBGColorAO.pos = [selMapUSZ+141+75,selMapUSY+18] 
		)
		function HideAO =
		(
				dNet_lbl_AOSamples.pos = [-200,-200] 
				spn_AOSamples.pos = [-200,-200] 
				lb_AOSamplesBG.pos = [-200,-200] 
				btn_AOSamplesUP.pos = [-200,-200] 
				btn_AOSamplesDown.pos = [-200,-200] 
				dNet_lbl_AObright.pos = [-200,-200] 
				colorPick_AObright.pos = [-200,-200] 
				dNet_lbl_AOdark.pos = [-200,-200] 
				colorPick_AOdark.pos = [-200,-200] 
				lb_AOSpn3.pos = [-200,-200] 
				dNet_lbl_AOSpread.pos = [-200,-200] 
				spn_AOSpread.pos = [-200,-200] 
				btn_AOSpreadUP.pos = [-200,-200] 
				btn_AOSpreadDown.pos = [-200,-200]  
				dNet_lbl_AOMaxDist.pos = [-200,-200] 
				spn_AOMaxDist.pos = [-200,-200] 
				btn_AOMaxDistUP.pos = [-200,-200] 
				btn_AOMaxDistDown.pos = [-200,-200] 
				dNet_lbl_AOFalloff.pos = [-200,-200] 
				spn_AOFalloff.pos = [-200,-200] 
				btn_AOFalloffUP.pos = [-200,-200] 
				btn_AOFalloffDown.pos = [-200,-200] 
				lb_BGcolor.pos = [-200,-200]
				colorPick_EleBGColorAO.pos = [-200,-200] 
		)
		function ShowBlend =
		(
 			chkbox_BlendMLight.pos = [selMapUSZ+4,selMapUSY+15]
			chkbox_BlendMShadows.pos = [selMapUSZ+4,selMapUSY+15+15]
			chkbox_BlendMDiffuse.pos = [selMapUSZ+4,selMapUSY+15+15+15]
			chkbox_BlendMAmbient.pos = [selMapUSZ+4,selMapUSY+15+15+15+15]
			chkbox_BlendMSpecular.pos = [selMapUSZ+100,selMapUSY+15]
			chkbox_BlendMSelf_Illum.pos = [selMapUSZ+100,selMapUSY+15+15]
			chkbox_BlendMReflection.pos = [selMapUSZ+100,selMapUSY+15+15+15]
			chkbox_BlendMRefraction.pos = [selMapUSZ+100,selMapUSY+15+15+15+15]
 			lb_chkbox_BlendMLight.pos = [selMapUSZ+4+15,selMapUSY+15]
			lb_chkbox_BlendMShadows.pos = [selMapUSZ+4+15,selMapUSY+15+15]
			lb_chkbox_BlendMDiffuse.pos = [selMapUSZ+4+15,selMapUSY+15+15+15]
			lb_chkbox_BlendMAmbient.pos = [selMapUSZ+4+15,selMapUSY+15+15+15+15]
			lb_chkbox_BlendMSpecular.pos = [selMapUSZ+100+15,selMapUSY+15]
			lb_chkbox_BlendMSelf_Illum.pos = [selMapUSZ+100+15,selMapUSY+15+15]
			lb_chkbox_BlendMReflection.pos = [selMapUSZ+100+15,selMapUSY+15+15+15]
			lb_chkbox_BlendMRefraction.pos = [selMapUSZ+100+15,selMapUSY+15+15+15+15]
			lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20]
			colorPick_EleBGColorBlend.pos = [selMapUSZ+141+75,selMapUSY+18]
		)
		function HideBlend =
		(
 			chkbox_BlendMLight.pos = [-200,-200]
			chkbox_BlendMShadows.pos = [-200,-200]
			chkbox_BlendMDiffuse.pos = [-200,-200]
			chkbox_BlendMAmbient.pos = [-200,-200]
			chkbox_BlendMSpecular.pos = [-200,-200]
			chkbox_BlendMSelf_Illum.pos = [-200,-200]
			chkbox_BlendMReflection.pos = [-200,-200]
			chkbox_BlendMRefraction.pos = [-200,-200]
 			lb_chkbox_BlendMLight.pos = [-200,-200]
			lb_chkbox_BlendMShadows.pos = [-200,-200]
			lb_chkbox_BlendMDiffuse.pos = [-200,-200]
			lb_chkbox_BlendMAmbient.pos = [-200,-200]
			lb_chkbox_BlendMSpecular.pos = [-200,-200]
			lb_chkbox_BlendMSelf_Illum.pos = [-200,-200]
			lb_chkbox_BlendMReflection.pos = [-200,-200]
			lb_chkbox_BlendMRefraction.pos = [-200,-200]
			lb_BGcolor.pos = [-200,-200]
			colorPick_EleBGColorBlend.pos = [-200,-200]
		)
		function ShowComplete =
		(
			chkbox_ComplMShadows.pos = [selMapUSZ+4,selMapUSY+15]
			lb_chkbox_ComplMShadows.pos = [selMapUSZ+4+15,selMapUSY+15]
			lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20]
			colorPick_EleBGColorCompl.pos = [selMapUSZ+141+75,selMapUSY+18]
		)
		function HideComplete =
		(
			chkbox_ComplMShadows.pos = [-200,-200]
			lb_chkbox_ComplMShadows.pos = [-200,-200]
			lb_BGcolor.pos = [-200,-200]
			colorPick_EleBGColorCompl.pos = [-200,-200]
		)
		function ShowDiffuse =
		(
  			chkbox_DiffMLight.pos = [selMapUSZ+4,selMapUSY+15]
 			chkbox_DiffMShadows.pos = [selMapUSZ+4,selMapUSY+15+15]
			lb_chkbox_DiffMLight.pos = [selMapUSZ+4+15,selMapUSY+15]
 			lb_chkbox_DiffMShadows.pos = [selMapUSZ+4+15,selMapUSY+15+15]
			lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20]
			colorPick_EleBGColorDiff.pos = [selMapUSZ+141+75,selMapUSY+18] 
		)
		function HideDiffuse =
		(
  			chkbox_DiffMLight.pos = [-200,-200]
 			chkbox_DiffMShadows.pos = [-200,-200]
			lb_chkbox_DiffMLight.pos = [-200,-200]
 			lb_chkbox_DiffMShadows.pos = [-200,-200]
			lb_BGcolor.pos = [-200,-200]
			colorPick_EleBGColorDiff.pos = [-200,-200]
		)
		function ShowHeight =
		(
			lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20]
			colorPick_EleBGColorHeight.pos = [selMapUSZ+141+75,selMapUSY+18]
		)
		function HideHeight =
		(
			lb_BGcolor.pos = [-200,-200]
			colorPick_EleBGColorHeight.pos = [-200,-200]
		)
		function ShowLight =
		(
 			chkbox_LightMShadows.pos = [selMapUSZ+4,selMapUSY+15]
			chkbox_LightMDirectLight.pos = [selMapUSZ+4,selMapUSY+15+15]
			chkbox_LightMIndirectLight.pos = [selMapUSZ+4,selMapUSY+15+15+15]
			lb_chkbox_LightMShadows.pos = [selMapUSZ+4+15,selMapUSY+15]
			lb_chkbox_LightMDirectLight.pos = [selMapUSZ+4+15,selMapUSY+15+15]
			lb_chkbox_LightMIndirectLight.pos = [selMapUSZ+4+15,selMapUSY+15+15+15]
			lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20]
			colorPick_EleBGColorLight.pos = [selMapUSZ+141+75,selMapUSY+18] 
		)
		function HideLight =
		(
 			chkbox_LightMShadows.pos = [-200,-200]
			chkbox_LightMDirectLight.pos = [-200,-200]
			chkbox_LightMIndirectLight.pos = [-200,-200]
			lb_chkbox_LightMShadows.pos = [-200,-200]
			lb_chkbox_LightMDirectLight.pos = [-200,-200]
			lb_chkbox_LightMIndirectLight.pos = [-200,-200]
			lb_BGcolor.pos = [-200,-200] 
			colorPick_EleBGColorLight.pos = [-200,-200]
		)
		function ShowNormals =
		(
			chkbox_NormalsMOutToBump.pos = [selMapUSZ+4,selMapUSY+15]
			chkbox_NormalsMRenderIntoAlphaChannel.pos = [selMapUSZ+4,selMapUSY+15+15]
			lb_chkbox_NormalsMOutToBump.pos = [selMapUSZ+4+15,selMapUSY+15]
			lb_chkbox_NormalsMRenderIntoAlphaChannel.pos = [selMapUSZ+4+15,selMapUSY+15+15]
			lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20]
			colorPick_EleBGColorNormals.pos = [selMapUSZ+141+75,selMapUSY+18]
		)
		function HideNormals =
		(
			chkbox_NormalsMOutToBump.pos = [-200,-200]
			chkbox_NormalsMRenderIntoAlphaChannel.pos = [-200,-200]
			lb_chkbox_NormalsMOutToBump.pos = [-200,-200]
			lb_chkbox_NormalsMRenderIntoAlphaChannel.pos = [-200,-200]
			lb_BGcolor.pos = [-200,-200] 
			colorPick_EleBGColorNormals.pos = [-200,-200]
		)
		function ShowShadows =
		(
			lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20] 
			colorPick_EleBGColorShadows.pos = [selMapUSZ+141+75,selMapUSY+18] 
		)
		function HideShadows =
		(
			lb_BGcolor.pos = [-200,-200] 
			colorPick_EleBGColorShadows.pos = [-200,-200]
		)
		function ShowSpecular =
		(
			chkbox_SpecMLight.pos = [selMapUSZ+4,selMapUSY+15]
			chkbox_SpecMShadows.pos = [selMapUSZ+4,selMapUSY+15+15]
			lb_chkbox_SpecMLight.pos = [selMapUSZ+4+15,selMapUSY+15]
			lb_chkbox_SpecMShadows.pos = [selMapUSZ+4+15,selMapUSY+15+15]
			lb_BGcolor.pos = [selMapUSZ+141+55,selMapUSY+20]
			colorPick_EleBGColorSpec.pos = [selMapUSZ+141+75,selMapUSY+18] 
		)
		function HideSpecular =
		(
			chkbox_SpecMLight.pos = [-200,-200]
			chkbox_SpecMShadows.pos = [-200,-200]
			lb_chkbox_SpecMLight.pos = [-200,-200]
			lb_chkbox_SpecMShadows.pos = [-200,-200]
			lb_BGcolor.pos = [-200,-200]
			colorPick_EleBGColorSpec.pos = [-200,-200]
		)
		function ShowUVmap =
		(
			chkbox_modeNone.pos = [selMapUSZ+4,selMapUSY+15]
			chkbox_modeSolid.pos = [selMapUSZ+4,selMapUSY+15+15]
			chkbox_modeNormal.pos = [selMapUSZ+4,selMapUSY+15+15+15]
			chkbox_modeShaded.pos = [selMapUSZ+4,selMapUSY+15+15+15+15]			
			lb_rbtn_Mode.pos = [selMapUSZ+4+13,selMapUSY+15]
			chkbox_visibleEdges.pos = [selMapUSZ+67,selMapUSY+15]
			lb_chkbox_visibleEdges.pos = [selMapUSZ+67+14,selMapUSY+17]
			chkbox_invisibleEdges.pos = [selMapUSZ+67,selMapUSY+15+15]
			lb_chkbox_invisibleEdges.pos = [selMapUSZ+67+15,selMapUSY+15+17]
			chkbox_seemEdges.pos = [selMapUSZ+67,selMapUSY+15+15+15]
			lb_chkbox_seemEdges.pos = [selMapUSZ+67+14,selMapUSY+15+15+17]
			clrPick_seemEdgesColor.pos = [selMapUSZ+155,selMapUSY+15+15+15]
			chkbox_force2sided.pos = [selMapUSZ+155,selMapUSY+15]
			lb_chkbox_force2sided.pos = [selMapUSZ+155+13,selMapUSY+17]
			clrPick_fillColor.pos = [selMapUSZ+215,selMapUSY+15+15]
			lb_clrPick_fillColor.pos = [selMapUSZ+200,selMapUSY+15+17]
			clrPick_edgesColor.pos = [selMapUSZ+215,selMapUSY+15+15+15]
			lb_clrPick_edgesColor.pos = [selMapUSZ+182,selMapUSY+15+15+17]
			chkbox_showOverlap.pos = [selMapUSZ+67,selMapUSY+15+15+15+15]
			lb_chkbox_showOverlap.pos = [selMapUSZ+67+14,selMapUSY+15+15+15+17]
			clrPick_overlapColor.pos = [selMapUSZ+155,selMapUSY+15+15+15+15]
		)
		function HideUVmap =
		(
			chkbox_modeNone.pos = [-200,-200]
			chkbox_modeSolid.pos = [-200,-200]
			chkbox_modeNormal.pos = [-200,-200]
			chkbox_modeShaded.pos = [-200,-200]			
			lb_rbtn_Mode.pos = [-200,-200]
			chkbox_visibleEdges.pos = [-200,-200]
			lb_chkbox_visibleEdges.pos = [-200,-200]
			chkbox_invisibleEdges.pos = [-200,-200]
			lb_chkbox_invisibleEdges.pos = [-200,-200]
			chkbox_seemEdges.pos = [-200,-200]
			lb_chkbox_seemEdges.pos = [-200,-200]
			clrPick_seemEdgesColor.pos = [-200,-200]
			chkbox_force2sided.pos = [-200,-200]
			lb_chkbox_force2sided.pos = [-200,-200]
			clrPick_fillColor.pos = [-200,-200]
			lb_clrPick_fillColor.pos = [-200,-200]
			clrPick_edgesColor.pos = [-200,-200]
			lb_clrPick_edgesColor.pos = [-200,-200]
			chkbox_showOverlap.pos = [-200,-200]
			lb_chkbox_showOverlap.pos = [-200,-200]
			clrPick_overlapColor.pos = [-200,-200]
		)
		function HideOthers =
		(			
			allFnSMUS = #(HideUVmap(), HideSpecular(), HideShadows(), HideNormals(), HideLight(), HideHeight(), HideDiffuse(), HideComplete(), HideBlend(), HideAO(), HideAlpha()) as array
			for m in allFnSMUS do m
		)
		function CheckForSelectedMaps =
		(
			local result = true
			chkboxStrState = (chkbox_AlphaMap.state as string)+","+(chkbox_AmbientOcclusion.state as string)+","+(chkbox_BlendMap.state as string)+","+ \
			(chkbox_CompleteMap.state as string)+","+(chkbox_DiffuseMap.state as string)+","+(chkbox_HeightMap.state as string)+","+ \
			(chkbox_LightingMap.state as string)+","+(chkbox_normalsMap.state as string)+","+(chkbox_ShadowsMap.state as string)+","+ \
			(chkbox_SpecularMap.state as string)+","+(chkbox_UVMap.state as string)
			
			if chkboxStrState != "false,false,false,false,false,false,false,false,false,false,false" then
				result = true
			else
				result = false
			
			result
		)
-----------------------------------
	--	Bakin System Function
-----------------------------------
		function CombineImages bitmapsToCombine combineMapName offOnPreview BGcolor cMapName=
		(
			if bitmapsToCombine.count > 1 then
			(
				--	PART ONE - CREATE COMBINED MAP WITH PROPER ALPHA CHANNEL
					--	get the size of maps
					mapInfo = (getBitmapInfo bitmapsToCombine[1])
					sizeWidth = mapInfo[3]
					sizeHeight = mapInfo[4]						
					m_Extension = getFilenameType bitmapsToCombine[1]
					m_RenderPath = btn_BrowseFolder.text  as string
					m_RenderPath += "\\"
					
					texList = #() as array
					texListM = #() as array
					theComp = CompositeTextureMap()
					
					--Create all maps with proper texture loaded
						--	loop backwards to prevent combineMapBG to be on the top of all other maps
					for i = bitmapsToCombine.count to 1 by -1 do					
					(
						--	add layer
						theComp.add()
						--	add maps
						theMap1 = Bitmaptexture fileName:bitmapsToCombine[i]
						theMap1m = Bitmaptexture fileName:bitmapsToCombine[i]
						--	set mono output channel to alpha
						theMap1m.monoOutput = 1
						--	set RGB output channel to alpha
						theMap1m.RGBOutput = 1
						--	set source alpha to alpha
						theMap1m.alphasource = 0
						
						append texList theMap1
						append texListM theMap1m				
					)
					--	composite the two maps
					theComp.mapList = texList as array
					--	composite the mask of two maps
					theComp.mask = texListM as array		

					objForCombMap = Sphere segs:32 mapcoords:true pos:[-1000000,-1000000,-1000000]
					objForCombMap.material = standard diffusemap:theComp
					intoBitMap = bitmap sizeWidth sizeHeight
					--	render map
					comMap = renderMap objForCombMap.material.diffuseMap into:intoBitMap filter:false Display:offOnPreview
					
					comMap.filename = m_RenderPath+"Proper_Alpha_"+combineMapName+m_Extension						
					-- save combined maps with no BG color but with proper alpha channel
					save comMap
					try(delete objForCombMap)catch()
				
				--	PART TWO - CREATE COMBINED MAP WITH PROPER BACKGROUND COLOR
					--	make bitmap with background color
					bmBG = bitmap sizeWidth sizeHeight  color:BGcolor
					--	save map to output folder
					bmBG.filename = m_RenderPath+cMapName+m_Extension
					bmBGpath = bmBG.filename
					save bmBG
					--	get the combined map with proper alpha channel
					bmCombMapPropAlphaArr = getFiles (m_RenderPath+"/Proper_Alpha_*"+m_Extension)
					bmCombMapPropAlpha = bmCombMapPropAlphaArr[1]
					bitmapsToCombine2 = #(bmCombMapPropAlpha,bmBGpath)
					texList = #() as array
					texListM = #() as array
					theCompBG = CompositeTextureMap()
					
					for i = bitmapsToCombine2.count to 1 by -1 do					
					(
						theCompBG.add()
						theMap1 = Bitmaptexture fileName:bitmapsToCombine2[i]
						theMap1m = Bitmaptexture fileName:bitmapsToCombine2[i]
						theMap1m.monoOutput = 1
						theMap1m.RGBOutput = 1
						theMap1m.alphasource = 0						
						append texList theMap1
						append texListM theMap1m				
					)
					theCompBG.mapList =	texList as array
					theCompBG.mask = texListM as array	
					objForCombMapBG = Sphere segs:32 mapcoords:true pos:[-1000000,-1000000,-1000000]
					objForCombMapBG.material = standard diffusemap:theCompBG
					intoBitMapBG = bitmap sizeWidth sizeHeight
					--	render map
					comMapBG = renderMap objForCombMapBG.material.diffuseMap into:intoBitMapBG filter:false Display:offOnPreview
					
					comMapBG.filename = m_RenderPath+combineMapName+m_Extension
					save comMapBG							
					close comMap
				
					freeSceneBitmaps()
					deleteFile bmBGpath	
					try(delete objForCombMapBG)catch()
				
				--	PART THREE - SWAP ALPHA CHANNELS OF TWO BITMAPS
					--	Writen by Dave Worty
					fileA = comMap.filename
					fileB = comMapBG.filename
					thebmpA = openbitmap fileA
					thebmpB = openbitmap fileB
					newBmpA = bitmap thebmpA.width thebmpA.height
					newBmpB = bitmap thebmpB.width thebmpB.height
					for i = 1 to thebmpA.height do
					(
						AR_thepixels_A = Getpixels thebmpA [0,i] thebmpA.width
						AR_thepixels_B = Getpixels thebmpB [0,i] thebmpB.width
						for j = 1 to AR_thepixels_A.count do
						(
							swap AR_thepixels_A[j].a AR_thepixels_B[j].a
						)
						setpixels newbmpB [0,i] AR_thepixels_B 
					)
					close thebmpA
					close thebmpB
					newBmpA.filename = fileA
					newBmpB.filename = fileB
					Save newBmpA
					Save newBmpB
					Close NewBmpA
					Close NewBmpB
					try(deleteFile comMap.filename)catch()
					freeSceneBitmaps()
					gc()
			)			
		)
---------------------------------------------------------------
	--	The next six functions are writen by Sven Fraeys
	--	modified by Kostadin Kotev "miauu"
---------------------------------------------------------------
		function EmptyArraysStoringPath =
		(
			pathToSaveDiffuseMap =#()
			pathToSaveSpecularMap =#()
			pathToSaveCompleteMap =#()
			pathToSaveShadowsMap =#()
			pathToSaveLightingMap =#()
			pathToSaveNormalsMap =#()
			pathToSaveBlendMap =#()
			pathToSaveAlphaMap =#()
			pathToSaveHeightMap =#()
			pathToSaveAmbOccMap =#()
			pathToSaveMaterialID =#()
			pathToSaveUVMap = #()
		)
		function SelectedMapDefaultSettings =
		(
			file_Extension = btn_saveAsType.text as string
			file_RenderPath = btn_BrowseFolder.text as string
			file_RenderPath += "\\"
			
			selectedMap.outputSzX =mapTextureWidth
			selectedMap.outputSzY = mapTextureHeight			
			selectedMap.fileType = file_RenderPath+(bakedMapName as string)+file_Extension			
			selectedMap.fileName = file_RenderPath+(bakedMapName as string)+file_Extension
		)
		function BakeTextures =
		(
			--set bake	
			bakedObject.INodeBakeProperties.bakeEnabled = true
			bakedObject.INodeBakeProperties.bakeChannel = useUVWChannel
			bakedObject.INodeBakeProperties.nDilations = texture_Padding
		
			--	use cage instead of rayoffset
			if chkbox_useCage.tristate != 2 do
			(
				bakedObject.INodeBakeProjProperties.useCage = chkbox_useCage.state
				if not sOffset.indeterminate do
					bakedObject.INodeBakeProjProperties.rayOffset = sOffset.value
			)
			--	use or not HitOnlyMatchingMaterialID
			if chkbox_HitMatchMtlID.tristate != 2 do 
				bakedObject.INodeBakeProjProperties.hitMatchMtlID = chkbox_HitMatchMtlID.state
				
			--	determin color of ray miss-check
			if chkbox_RayMissCheck.state == on then
				bakedObject.INodeBakeProjProperties.rayMissColor = colorPick_RayMissColor.color
			else
				bakedObject.INodeBakeProjProperties.rayMissColor = black
			if chkbox_RayMissCheck.tristate != 2 do
				bakedObject.INodeBakeProjProperties.warnRayMiss = chkbox_RayMissCheck.state
			
			--	use or not Crop Alpha	
			if chkbox_CropAlpha.tristate != 2 do
				bakedObject.INodeBakeProjProperties.cropAlpha = chkbox_CropAlpha.state
			
			--	use closest or furthrest resolve hit
			if chkbox_Closest.state == on do
				bakedObject.INodeBakeProjProperties.hitResolveMode = #closest
			if chkbox_Furthest.state == on do
				bakedObject.INodeBakeProjProperties.hitResolveMode = #furthest
				
			--	use Raytrace or UVMatch proj space
			if chkbox_Raytrace.state == on do
				bakedObject.INodeBakeProjProperties.projSpace = #raytrace
			if chkbox_UVmatch.state == on do
				bakedObject.INodeBakeProjProperties.projSpace = #uvw_match
				
			--	if Projection checkbox is On or Off == Enabled on defoult RTT dialog
			if chkbox_UseProjection.state == on then
				bakedObject.INodeBakeProjProperties.enabled = true
			else
				bakedObject.INodeBakeProjProperties.enabled = false
			
			if CancelRenderProcess != true do
			(
				--	if MentalRay is active render
				local mrIsActive = false
				--	if mentalRay is active renderer:
				if (renderers.current.classID[1] == 1492548972) do
				(
					--	hide LP objects to prevent error only if mentalRay is active renderer and the checkbox is checked
					if chkbox_hideFacesMR.state == true do
					(
						mrIsActive = true
						max modify mode
						--	copy the top Projection modifier
						local tempProjModCopy = copy bakedObject.modifiers[1]
						--	delete the projection modifier
						deletemodifier bakedObject 1
						--	add Edit_Poly modifier on top of the stack
						addModifier bakedObject (Edit_Poly())
						--	go to Face subobject level
						subobjectLevel = 4
						--	select all faces
						max select all
						--	hide all faces of LP object
						bakedObject.modifiers[#Edit_Poly].ButtonOp #HideFace
						--	add the saved Projection modifier on top of the stack
						addmodifier bakedObject tempProjModCopy
					)			
				)
				--	start of default RTT dialog, if not the rayOffset will not work????!!!!Don't know why!
				macros.run "Render" "BakeDialog"
				--	start rendering of maps				
				render renderType:#bakeSelected vfb:chkbox_previewVFB.state outputSize:[mapTextureWidth,mapTextureHeight] cancelled:&wascancelled  progressBar:true
				
				if mrIsActive == true do
				(
					--	unhide all faces of LP object
					bakedObject.modifiers[#Edit_Poly].ButtonOp #UnhideAllFace
					--	delete the Edit_Poly modifier
					deletemodifier bakedObject 2
				)
			)
			--	cancell rendering proces
			if wascancelled == true do
			(
				CancelRenderProcess = true
				try(delete objForCombMap)catch()
			)
			
  			try(destroyDialog gTextureBakeDialog)catch()
			
			--	remove all bake elements of selected object
			bakedObject.INodeBakeProperties.removeAllBakeElements()				
		)
		function AddMapToBake =
		(
			m_Extension = btn_saveAsType.text as string
			m_RenderPath = btn_BrowseFolder.text  as string
			m_RenderPath += "\\"

			isMapAdded = false
			--	currently selected object
			bakedObject.INodeBakeProperties.removeAllBakeElements()
			--	STANDART Maps definition
			if(addAlphaMap  == true) then 
			(
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_AlphaMap"
				bakedMapName = MakeFileNameValid bakedMapName1
				addAlphaMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = AlphaMap()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorAlpha.color
				bakedObject.INodeBakeProperties.addBakeElement selectedMap
				--	check if file exist
				if doesFileExist addAlphaMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addNormalsMapPath
						append pathToSaveAlphaMap addAlphaMapPath
					)
					else
						append pathToSaveAlphaMap addAlphaMapPath
				)	
				else
					append pathToSaveAlphaMap addAlphaMapPath	
				if isMapAdded != false do
					BakeTextures()

			)
			
			if(addAmbOccMap  == true) then 
			(
				--	switch to mRay
				if (renderers.current.classID[1] != 1492548972) then
				(
-- 					print "AddMap AO"
					renderers.current = mental_ray_renderer()
-- 					print "MR is active renderer"
-- 					print "Load defaultMRpreset.rps"
					defaultMRPreset = GetDir #userscripts + "\\RTTassist\\Presets\\defaultMRpreset.rps"
					pathToPresets = GetDir #userscripts + "\\RTTassist\\Presets\\defaultMRpreset.rpf"
					if (doesfileexist defaultMRPreset) and (doesFileExist pathToPresets) do
					(
						renderpresets.LoadAll 0 defaultMRPreset
						--	load RTTAssist settings for defaultMRpreset
						pathToPresets = GetDir #userscripts + "\\RTTassist\\Presets\\defaultMRpreset.rpf"

						--	load maps
-- 						chkbox_AlphaMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_AlphaMap") as stringStream))
						chkbox_AmbientOcclusion.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_AmbientOcclusion") as stringStream))
-- 						chkbox_BlendMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMap") as stringStream))
-- 						chkbox_CompleteMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_CompleteMap") as stringStream))
-- 						chkbox_DiffuseMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffuseMap") as stringStream))
-- 						chkbox_HeightMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_HeightMap") as stringStream))
-- 						chkbox_LightingMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightingMap") as stringStream))
-- 						chkbox_normalsMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_normalsMap") as stringStream))
-- 						chkbox_ShadowsMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_ShadowsMap") as stringStream))
-- 						chkbox_SpecularMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecularMap") as stringStream))
-- 						chkbox_UVMap.state = false	--	(readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UVMap") as stringStream))
-- 						--	load projection controls
-- 						chkbox_renderIsolate.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_renderIsolate") as stringStream))
-- 						chkbox_redrawViews.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_redrawViews") as stringStream))
-- 						chkbox_useCage.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_useCage") as stringStream))
-- 						chkbox_combMaps.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_combMaps") as stringStream))
-- 						chkbox_UseProjection.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UseProjection") as stringStream))
-- 						chkbox_Raytrace.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Raytrace") as stringStream))
-- 						chkbox_UVmatch.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UVmatch") as stringStream))
-- 						chkbox_Closest.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Closest") as stringStream))
-- 						chkbox_Furthest.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Furthest") as stringStream))
-- 						chkbox_HitMatchMtlID.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_HitMatchMtlID") as stringStream))
-- 						chkbox_RayMissCheck.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_RayMissCheck") as stringStream))
-- 						chkbox_CropAlpha.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_CropAlpha") as stringStream))
-- 						--	blend map selected map unique settings
-- 						chkbox_BlendMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMLight") as stringStream))
-- 						chkbox_BlendMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMShadows") as stringStream))
-- 						chkbox_BlendMDiffuse.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMDiffuse") as stringStream))
-- 						chkbox_BlendMAmbient.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMAmbient") as stringStream))
-- 						chkbox_BlendMSpecular.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMSpecular") as stringStream))
-- 						chkbox_BlendMSelf_Illum.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMSelf_Illum") as stringStream))
-- 						chkbox_BlendMReflection.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMReflection") as stringStream))
-- 						chkbox_BlendMRefraction.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMRefraction") as stringStream))
-- 						--	Complete map selected map unique settings 
-- 						chkbox_ComplMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_ComplMShadows") as stringStream))
-- 						--	Diffuse Map selected map unique settings
-- 						chkbox_DiffMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffMLight") as stringStream))
-- 						chkbox_DiffMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffMShadows") as stringStream))
-- 						--	Lighting Map selected map unique settings
-- 						chkbox_LightMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMShadows") as stringStream))
-- 						chkbox_LightMDirectLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMDirectLight") as stringStream))
-- 						chkbox_LightMIndirectLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMIndirectLight") as stringStream))
-- 						--	Normals Map selected map unique settings					
-- 						chkbox_NormalsMOutToBump.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_NormalsMOutToBump") as stringStream))
-- 						chkbox_NormalsMRenderIntoAlphaChannel.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_NormalsMRenderIntoAlphaChannel") as stringStream))
-- 						--	Specular Map selected map unique settings
-- 						chkbox_SpecMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecMLight") as stringStream))
-- 						chkbox_SpecMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecMShadows") as stringStream))
-- 						--	UV Map selected map unique settings
-- 						chkbox_showOverlap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_showOverlap") as stringStream))
-- 						chkbox_modeNone.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeNone") as stringStream))
-- 						chkbox_modeSolid.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeSolid") as stringStream))
-- 						chkbox_modeNormal.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeNormal") as stringStream))
-- 						chkbox_modeShaded.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeShaded") as stringStream))
-- 						chkbox_force2sided.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_force2sided") as stringStream))
-- 						chkbox_visibleEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_visibleEdges") as stringStream))
-- 						chkbox_invisibleEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_invisibleEdges") as stringStream))
-- 						chkbox_seemEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_seemEdges") as stringStream))

-- 						--	load output path
-- 						btn_BrowseFolder.text = ((getIniSetting pathToPresets "Render" "OutpuPath") as string)
-- 						--	load map file extension
-- 						btn_saveAsType.text = ((getIniSetting pathToPresets "Render" "FileExtension") as string)
-- 						--	load map size
-- 						spn_mapHeight.text = ((getIniSetting pathToPresets "Render" "Height") as string)
-- 						spn_mapWidth.text = ((getIniSetting pathToPresets "Render" "Width") as string)
-- 						--	load ray-miss check color
-- 						colorPick_RayMissColor.color  = (readValue(( getIniSetting pathToPresets "Color" "Ray-miss color") as stringStream))
-- 						--	load UV Map colors
-- 						clrPick_seemEdgesColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_seemEdgesColor") as stringStream))
-- 						clrPick_edgesColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_edgesColor") as stringStream))
-- 						clrPick_overlapColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_overlapColor") as stringStream))
-- 						clrPick_fillColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_fillColor") as stringStream))							
-- 						--	load background colors of all maps
-- 						colorPick_EleBGColorAlpha.color = (readValue(( getIniSetting pathToPresets "Color" "Alpha BG color") as stringStream))
						colorPick_EleBGColorAO.color = (readValue(( getIniSetting pathToPresets "Color" "AO BG color") as stringStream))
-- 						colorPick_EleBGColorBlend.color = (readValue(( getIniSetting pathToPresets "Color" "Blend BG color") as stringStream))
-- 						colorPick_EleBGColorCompl.color = (readValue(( getIniSetting pathToPresets "Color" "Complete BG color") as stringStream))
-- 						colorPick_EleBGColorDiff.color = (readValue(( getIniSetting pathToPresets "Color" "DIffuse BG color") as stringStream))
-- 						colorPick_EleBGColorHeight.color = (readValue(( getIniSetting pathToPresets "Color" "Height BG color") as stringStream))
-- 						colorPick_EleBGColorLight.color = (readValue(( getIniSetting pathToPresets "Color" "Lighting BG color") as stringStream))
-- 						colorPick_EleBGColorNormals.color = (readValue(( getIniSetting pathToPresets "Color" "Normals BG color") as stringStream))
-- 						colorPick_EleBGColorShadows.color = (readValue(( getIniSetting pathToPresets "Color" "Shadows BG color") as stringStream))
-- 						colorPick_EleBGColorSpec.color = (readValue(( getIniSetting pathToPresets "Color" "Specular BG color") as stringStream))
						colorPick_AObright.color = (readValue(( getIniSetting pathToPresets "Color" "AO Bright color") as stringStream))
						colorPick_AOdark.color = (readValue(( getIniSetting pathToPresets "Color" "AO Dark color") as stringStream))
						--	spinners
-- 						spn_Padding.text = ((getIniSetting pathToPresets "Spinner" "Padding") as string)
-- 						spn_UVChannel.text = ((getIniSetting pathToPresets "Spinner" "UVChannel") as string)
-- 						spn_Offset.text = ((getIniSetting pathToPresets "Spinner" "Offset") as string)
-- 						sOffset.value = (readValue((getIniSetting pathToPresets "Spinner" "OffsetStd") as stringStream))
						spn_AOSamples.text = ((getIniSetting pathToPresets "Spinner" "AOSamples") as string)
						spn_AOSpread.text = ((getIniSetting pathToPresets "Spinner" "AOSpread") as string)
						spn_AOMaxDist.text = ((getIniSetting pathToPresets "Spinner" "AOMaxDist") as string)
						spn_AOFalloff.text = ((getIniSetting pathToPresets "Spinner" "AOFalloff") as string)
-- 						print "----MRAY values after the default preset is loaded-----"
-- 						format "btn_saveAsType.text: %\n" btn_saveAsType.text
-- 						format "spn_mapHeight.text: %\n" spn_mapHeight.text
-- 						format "spn_mapWidth.text: %\n" spn_mapWidth.text
-- 						print "----"
-- 						format "spn_AOSamples.text: %\n" spn_AOSamples.text
-- 						format "spn_AOMaxDist.text: %\n" spn_AOMaxDist.text
-- 						format "spn_AOFalloff.text: %\n" spn_AOFalloff.text
-- 						format "spn_AOSpread.text: %\n" spn_AOSpread.text
-- 						print "------------------------------------------------------------------"
					) 
				)else(/* print "MR is only active renderer(no switching SL-MR, no adding of defaultMRpreset)" */)
			
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_AmbientOcclusion_MR"
				bakedMapName = MakeFileNameValid bakedMapName1
				addAmbOccMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = Ambient_Occlusion()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.samples = spn_AOSamples.text as integer	
				selectedMap.bright = colorPick_AObright.color	
				selectedMap.dark = colorPick_AOdark.color
				selectedMap.falloff = spn_AOFalloff.text as float
				selectedMap.maxDistance = spn_AOMaxDist.text as float
				selectedMap.spread = spn_AOSpread.text as float
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorAO.color
				bakedObject.INodeBakeProperties.addBakeElement selectedMap
				--	check if file exist
				if doesFileExist addAmbOccMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addNormalsMapPath
						append pathToSaveAmbOccMap addAmbOccMapPath
					)
					else
						append pathToSaveAmbOccMap addAmbOccMapPath
				)	
				else
					append pathToSaveAmbOccMap addAmbOccMapPath
				if isMapAdded != false do
				(					
					BakeTextures()
					
					--	switch back to scanline if needed
					if curRend == "scanline" do
					(
						--	set renderer to Scanline
						renderers.current = default_scanline_renderer()
						--	switching to MR and adding its rttMRpreset will change all controls, so - add temp rttScanlinepreset, wich is a copy of starting preset or of starting values of rttassist controls
-- 							print "Load temp scalnlie preset when script finish baking of AO"
-- 							pathToPresets = GetDir #userscripts + "\\RTTassist\\Presets\\tempRTTScanPrst.rpf"
							--	load maps
-- 							chkbox_AlphaMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_AlphaMap") as stringStream))
-- 							chkbox_AmbientOcclusion.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_AmbientOcclusion") as stringStream))
-- 							chkbox_BlendMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMap") as stringStream))
-- 							chkbox_CompleteMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_CompleteMap") as stringStream))
-- 							chkbox_DiffuseMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffuseMap") as stringStream))
-- 							chkbox_HeightMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_HeightMap") as stringStream))
-- 							chkbox_LightingMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightingMap") as stringStream))
-- 							chkbox_normalsMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_normalsMap") as stringStream))
-- 							chkbox_ShadowsMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_ShadowsMap") as stringStream))
-- 							chkbox_SpecularMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecularMap") as stringStream))
-- 							chkbox_UVMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UVMap") as stringStream))
-- 							--	load projection controls
-- 							chkbox_renderIsolate.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_renderIsolate") as stringStream))
-- 							chkbox_redrawViews.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_redrawViews") as stringStream))
-- 							chkbox_useCage.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_useCage") as stringStream))
-- 							chkbox_combMaps.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_combMaps") as stringStream))
-- 							chkbox_UseProjection.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UseProjection") as stringStream))
-- 							chkbox_Raytrace.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Raytrace") as stringStream))
-- 							chkbox_UVmatch.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UVmatch") as stringStream))
-- 							chkbox_Closest.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Closest") as stringStream))
-- 							chkbox_Furthest.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Furthest") as stringStream))
-- 							chkbox_HitMatchMtlID.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_HitMatchMtlID") as stringStream))
-- 							chkbox_RayMissCheck.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_RayMissCheck") as stringStream))
-- 							chkbox_CropAlpha.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_CropAlpha") as stringStream))
-- 							--	blend map selected map unique settings
-- 							chkbox_BlendMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMLight") as stringStream))
-- 							chkbox_BlendMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMShadows") as stringStream))
-- 							chkbox_BlendMDiffuse.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMDiffuse") as stringStream))
-- 							chkbox_BlendMAmbient.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMAmbient") as stringStream))
-- 							chkbox_BlendMSpecular.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMSpecular") as stringStream))
-- 							chkbox_BlendMSelf_Illum.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMSelf_Illum") as stringStream))
-- 							chkbox_BlendMReflection.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMReflection") as stringStream))
-- 							chkbox_BlendMRefraction.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMRefraction") as stringStream))
-- 							--	Complete map selected map unique settings 
-- 							chkbox_ComplMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_ComplMShadows") as stringStream))
-- 							--	Diffuse Map selected map unique settings
-- 							chkbox_DiffMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffMLight") as stringStream))
-- 							chkbox_DiffMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffMShadows") as stringStream))
-- 							--	Lighting Map selected map unique settings
-- 							chkbox_LightMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMShadows") as stringStream))
-- 							chkbox_LightMDirectLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMDirectLight") as stringStream))
-- 							chkbox_LightMIndirectLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMIndirectLight") as stringStream))
-- 							--	Normals Map selected map unique settings					
-- 							chkbox_NormalsMOutToBump.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_NormalsMOutToBump") as stringStream))
-- 							chkbox_NormalsMRenderIntoAlphaChannel.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_NormalsMRenderIntoAlphaChannel") as stringStream))
-- 							--	Specular Map selected map unique settings
-- 							chkbox_SpecMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecMLight") as stringStream))
-- 							chkbox_SpecMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecMShadows") as stringStream))
-- 							--	UV Map selected map unique settings
-- 							chkbox_showOverlap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_showOverlap") as stringStream))
-- 							chkbox_modeNone.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeNone") as stringStream))
-- 							chkbox_modeSolid.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeSolid") as stringStream))
-- 							chkbox_modeNormal.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeNormal") as stringStream))
-- 							chkbox_modeShaded.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeShaded") as stringStream))
-- 							chkbox_force2sided.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_force2sided") as stringStream))
-- 							chkbox_visibleEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_visibleEdges") as stringStream))
-- 							chkbox_invisibleEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_invisibleEdges") as stringStream))
-- 							chkbox_seemEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_seemEdges") as stringStream))

-- 							--	load output path
-- 							btn_BrowseFolder.text = ((getIniSetting pathToPresets "Render" "OutpuPath") as string)
-- 							--	load map file extension
-- 							btn_saveAsType.text = ((getIniSetting pathToPresets "Render" "FileExtension") as string)
-- 							--	load map size
-- 							spn_mapHeight.text = ((getIniSetting pathToPresets "Render" "Height") as string)
-- 							spn_mapWidth.text = ((getIniSetting pathToPresets "Render" "Width") as string)
-- 							--	load ray-miss check color
-- 							colorPick_RayMissColor.color  = (readValue(( getIniSetting pathToPresets "Color" "Ray-miss color") as stringStream))
-- 							--	load UV Map colors
-- 							clrPick_seemEdgesColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_seemEdgesColor") as stringStream))
-- 							clrPick_edgesColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_edgesColor") as stringStream))
-- 							clrPick_overlapColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_overlapColor") as stringStream))
-- 							clrPick_fillColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_fillColor") as stringStream))							
-- 							--	load background colors of all maps
-- 							colorPick_EleBGColorAlpha.color = (readValue(( getIniSetting pathToPresets "Color" "Alpha BG color") as stringStream))
-- 							colorPick_EleBGColorAO.color = (readValue(( getIniSetting pathToPresets "Color" "AO BG color") as stringStream))
-- 							colorPick_EleBGColorBlend.color = (readValue(( getIniSetting pathToPresets "Color" "Blend BG color") as stringStream))
-- 							colorPick_EleBGColorCompl.color = (readValue(( getIniSetting pathToPresets "Color" "Complete BG color") as stringStream))
-- 							colorPick_EleBGColorDiff.color = (readValue(( getIniSetting pathToPresets "Color" "DIffuse BG color") as stringStream))
-- 							colorPick_EleBGColorHeight.color = (readValue(( getIniSetting pathToPresets "Color" "Height BG color") as stringStream))
-- 							colorPick_EleBGColorLight.color = (readValue(( getIniSetting pathToPresets "Color" "Lighting BG color") as stringStream))
-- 							colorPick_EleBGColorNormals.color = (readValue(( getIniSetting pathToPresets "Color" "Normals BG color") as stringStream))
-- 							colorPick_EleBGColorShadows.color = (readValue(( getIniSetting pathToPresets "Color" "Shadows BG color") as stringStream))
-- 							colorPick_EleBGColorSpec.color = (readValue(( getIniSetting pathToPresets "Color" "Specular BG color") as stringStream))
-- 							colorPick_AObright.color = (readValue(( getIniSetting pathToPresets "Color" "AO Bright color") as stringStream))
-- 							colorPick_AOdark.color = (readValue(( getIniSetting pathToPresets "Color" "AO Dark color") as stringStream))
-- 							--	spinners
-- 							spn_Padding.text = ((getIniSetting pathToPresets "Spinner" "Padding") as string)
-- 							spn_UVChannel.text = ((getIniSetting pathToPresets "Spinner" "UVChannel") as string)
-- 							spn_Offset.text = ((getIniSetting pathToPresets "Spinner" "Offset") as string)
-- 							sOffset.value = (readValue((getIniSetting pathToPresets "Spinner" "OffsetStd") as stringStream))
-- 							spn_AOSamples.text = ((getIniSetting pathToPresets "Spinner" "AOSamples") as string)
-- 							spn_AOSpread.text = ((getIniSetting pathToPresets "Spinner" "AOSpread") as string)
-- 							spn_AOMaxDist.text = ((getIniSetting pathToPresets "Spinner" "AOMaxDist") as string)
-- 							spn_AOFalloff.text = ((getIniSetting pathToPresets "Spinner" "AOFalloff") as string)
						--	load temporary Filtering preset
						tempScanFilteringPreset = GetDir #userscripts + "\\RTTassist\\Presets\\tempScanFiltPrst.rps"
						if (doesfileexist tempScanFilteringPreset) do
						(
							renderpresets.LoadAll 0 tempScanFilteringPreset
						)		
-- 						print "----SCANLINE values after the default preset is loaded-----"
-- 						format "btn_saveAsType.text: %\n" btn_saveAsType.text
-- 						format "spn_mapHeight.text: %\n" spn_mapHeight.text
-- 						format "spn_mapWidth.text: %\n" spn_mapWidth.text
-- 						print "------------------------------------------------------------------"
					)
				)
			)
			
			if(addBlendMap  == true) then
			(
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_BlendMap"
				bakedMapName = MakeFileNameValid bakedMapName1
				addBlendMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = BlendMap()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.ambientOn = chkbox_BlendMAmbient.state
				selectedMap.specularOn = chkbox_BlendMSpecular.state
				selectedMap.emissionOn = chkbox_BlendMSelf_Illum.state
				selectedMap.reflectionOn = chkbox_BlendMReflection.state
				selectedMap.refractionOn = chkbox_BlendMRefraction.state
				selectedMap.lightingOn = chkbox_BlendMLight.state
				selectedMap.shadowsOn = chkbox_BlendMShadows.state
				selectedMap.diffuseOn = chkbox_BlendMDiffuse.state
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorBlend.color
				bakedObject.INodeBakeProperties.addBakeElement selectedMap	
				--	check if file exist
				if doesFileExist addBlendMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addNormalsMapPath
                       append pathToSaveBlendMap addBlendMapPath
					)
					else
						append pathToSaveBlendMap addBlendMapPath
				)	
				else
					append pathToSaveBlendMap addBlendMapPath
				if isMapAdded != false do
					BakeTextures()
			)

			if(addCompleteMap  == true) then
			(
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_CompleteMap"
				bakedMapName = MakeFileNameValid bakedMapName1
				addCompleteMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = CompleteMap()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.shadowsOn = chkbox_ComplMShadows.state
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorCompl.color
				bakedObject.INodeBakeProperties.addBakeElement selectedMap	
				--	check if file exist
				if doesFileExist addCompleteMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addNormalsMapPath
						append pathToSaveCompleteMap addCompleteMapPath
					)
					else
						append pathToSaveCompleteMap addCompleteMapPath
				)	
				else
					append pathToSaveCompleteMap addCompleteMapPath
				if isMapAdded != false do
					BakeTextures()
			)

			if(addDiffuseMap == true)then
			(
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_DiffuseMap"
				bakedMapName = MakeFileNameValid bakedMapName1
				addDiffuseMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = DiffuseMap()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.shadowsOn = chkbox_DiffMShadows.state	
				selectedMap.lightingOn = chkbox_DiffMLight.state
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorDiff.color
				bakedObject.INodeBakeProperties.addBakeElement selectedMap
				--	check if file exist
				if doesFileExist addDiffuseMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addNormalsMapPath
						append pathToSaveDiffuseMap addDiffuseMapPath
					)
					else
						append pathToSaveDiffuseMap addDiffuseMapPath
				)	
				else	
					append pathToSaveDiffuseMap addDiffuseMapPath
				if isMapAdded != false do
					BakeTextures()
			)		
			
			if(addHeightMap   == true) then 
			(
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_HeightMap"
				bakedMapName = MakeFileNameValid bakedMapName1
				addHeightMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = HeightMap()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorHeight.color
				bakedObject.INodeBakeProperties.addBakeElement selectedMap
				--	check if file exist
				if doesFileExist addHeightMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addNormalsMapPath
						append pathToSaveHeightMap addHeightMapPath
					)
					else
						append pathToSaveHeightMap addHeightMapPath
				)	
				else
					append pathToSaveHeightMap addHeightMapPath	
				if isMapAdded != false do
					BakeTextures()				
			)
			
			if(addLightningMap  == true) then
			(
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_LightningMap"
				bakedMapName = MakeFileNameValid bakedMapName1
				addLightningMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = LightingMap()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.shadowsOn = chkbox_LightMShadows.state
				selectedMap.directOn = chkbox_LightMDirectLight.state
				selectedMap.indirectOn = chkbox_LightMIndirectLight.state
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorLight.color
				bakedObject.INodeBakeProperties.addBakeElement selectedMap	
				--	check if file exist
				if doesFileExist addLightningMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addNormalsMapPath
						append pathToSaveLightingMap addLightningMapPath
					)
					else
						append pathToSaveLightingMap addLightningMapPath
				)	
				else
					append pathToSaveLightingMap addLightningMapPath
				if isMapAdded != false do
					BakeTextures()
			)
			
			if(addNormalsMap == true) then
			(
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_NormalsMap"
				bakedMapName = MakeFileNameValid bakedMapName1			
				addNormalsMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = NormalsMap()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.useNormalBump = chkbox_NormalsMOutToBump.state
				selectedMap.useHeightAsAlpha = chkbox_NormalsMRenderIntoAlphaChannel.state
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorNormals.color
				
				bakedObject.INodeBakeProperties.addBakeElement selectedMap
				
				--	check if file exist
				if doesFileExist addNormalsMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addNormalsMapPath
                       append pathToSaveNormalsMap addNormalsMapPath
					)
					else
						append pathToSaveNormalsMap addNormalsMapPath
				)	
				else
 					append pathToSaveNormalsMap addNormalsMapPath
				
				if isMapAdded != false do
					BakeTextures()
			)

			if(addShadowsMap  == true) then
			(
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_ShadowsMap"
				bakedMapName = MakeFileNameValid bakedMapName1
				addShadowsMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = ShadowsMap()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorShadows.color
				bakedObject.INodeBakeProperties.addBakeElement selectedMap	
				
				--	check if file exist
				if doesFileExist addShadowsMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addShadowsMapPath
						append pathToSaveShadowsMap addShadowsMapPath
					)
					else
						append pathToSaveShadowsMap addShadowsMapPath
				)	
				else
					append pathToSaveShadowsMap addShadowsMapPath
				
				if isMapAdded != false do
					BakeTextures()
			)	
			
			if(addSpecularMap  == true) then
			(
				isMapAdded = true
				bakedMapName1 = bakedObject.name + "_SpecularMap"
				bakedMapName = MakeFileNameValid bakedMapName1
				addSpecularMapPath = m_RenderPath+(bakedMapName as string)+m_Extension
				selectedMap = SpecularMap()
				SelectedMapDefaultSettings()
				selectedMap.filterOn = false
				selectedMap.shadowsOn = chkbox_SpecMShadows.state
				selectedMap.lightingOn = chkbox_SpecMLight.state
				selectedMap.enabled = true
				selectedMap.backgroundColor = colorPick_EleBGColorSpec.color
				bakedObject.INodeBakeProperties.addBakeElement selectedMap
				--	check if file exist
				if doesFileExist addSpecularMapPath then
				(
					if overwriteAllFile == false then
					(
						FileOverwrite addNormalsMapPath
						append pathToSaveSpecularMap addSpecularMapPath
					)
					else
						append pathToSaveSpecularMap addSpecularMapPath
				)	
				else
					append pathToSaveSpecularMap addSpecularMapPath
				if isMapAdded != false do
					BakeTextures()
			)
			
			--	bake UV template
			if chkbox_UVMap.state == true then
			(
				max modify mode
				--	define Unwrap_UVW modifier
				defUnwrapMod = Unwrap_UVW()
				--	set map chanel to 1
				defUnwrapMod.setMapChannel 1
				--	add Unwrap_UVW modifier to baked object
				addModifier bakedObject defUnwrapMod
				--	define the size of UV template map
				defUnwrapMod.renderuv_width = (spn_mapWidth.text as integer)
				defUnwrapMod.renderuv_height = (spn_mapHeight.text as integer)
				
				local _fillMode = undefined
				if chkbox_modeNone.state == on do _fillMode = 0
				if chkbox_modeSolid.state == on do _fillMode = 1
				if chkbox_modeNormal.state == on do _fillMode = 2
				if chkbox_modeShaded.state == on do _fillMode = 3
				defUnwrapMod.renderuv_fillmode = _fillMode	--	0, 1, 2, 3
				defUnwrapMod.renderuv_seamColor = clrPick_seemEdgesColor.color	
				defUnwrapMod.renderuv_showframebuffer = chkbox_previewVFB.state
				defUnwrapMod.renderuv_force2sided = chkbox_force2sided.state
				defUnwrapMod.renderuv_fillColor = clrPick_fillColor.color
				defUnwrapMod.renderuv_showoverlap = chkbox_showOverlap.state
				defUnwrapMod.renderuv_overlapColor = clrPick_overlapColor.color
				defUnwrapMod.renderuv_edgeColor = clrPick_edgesColor.color
				defUnwrapMod.renderuv_visibleedges = chkbox_visibleEdges.state
				defUnwrapMod.renderuv_invisibleedges = chkbox_invisibleEdges.state
				defUnwrapMod.renderuv_seamedges = chkbox_seemEdges.state				
				
				--	define the path where to store UV template map
				uvSavePath = m_RenderPath + bakedObject.name + "_UVmap" + m_Extension
				uvRenderPath = uvSavePath
				--	add current object to array so Combine map can be baked
				append pathToSaveUVMap uvSavePath
				--	render UV template
				defUnwrapMod.renderUV uvRenderPath	
				--	delete Unwrap_UVW modifier
				deleteModifier bakedObject 1				
			)
		)	
		function CombineMaps currObjName =
		(
			if (chkbox_combMaps.state == true) do
			(
				if (chkbox_selSets.state != true) then
				(
					objName = MakeFileNameValid currObjName
					CombineImages pathToSaveAlphaMap ("Combine_AlphaMap_"+objName) chkbox_previewVFB.state colorPick_EleBGColorAlpha.color "alphaBG"
					CombineImages pathToSaveAmbOccMap ("Combine_AOMap_"+objName) chkbox_previewVFB.state colorPick_EleBGColorAO.color "aoBG"
					CombineImages pathToSaveBlendMap ("Combine_BlendMap_"+objName) chkbox_previewVFB.state colorPick_EleBGColorBlend.color "blendBG"
					CombineImages pathToSaveCompleteMap ("Combine_CompleteMap_"+objName) chkbox_previewVFB.state colorPick_EleBGColorCompl.color "completeBG"
					CombineImages pathToSaveDiffuseMap ("Combine_DiffuseMap_"+objName) chkbox_previewVFB.state	colorPick_EleBGColorDiff.color	 "diffuseBG"	
					CombineImages pathToSaveHeightMap ("Combine_HeightMap_"+objName) chkbox_previewVFB.state colorPick_EleBGColorHeight.color "heightBG"
					CombineImages pathToSaveLightingMap ("Combine_LightingMap_"+objName) chkbox_previewVFB.state colorPick_EleBGColorLight.color "lightingBG"
					CombineImages pathToSaveNormalsMap ("Combine_NormalsMap_"+objName) chkbox_previewVFB.state colorPick_EleBGColorNormals.color "normalsBG"
					CombineImages pathToSaveShadowsMap ("Combine_ShadowsMap_"+objName) chkbox_previewVFB.state colorPick_EleBGColorShadows.color "shadowsBG"
					CombineImages pathToSaveSpecularMap ("Combine_SpecularMap_"+objName) chkbox_previewVFB.state colorPick_EleBGColorSpec.color "specularBG"
					CombineImages pathToSaveUVMap ("Combine_UVmap_"+objName) chkbox_previewVFB.state (color 0 0 0) "UVBG"
				)
				else
				(	--	use the selectionsets names
					objName = MakeFileNameValid currObjName
					CombineImages pathToSaveAlphaMap ("Combine_AlphaMap_"+selectionSetsName) chkbox_previewVFB.state colorPick_EleBGColorAlpha.color "alphaBG"
					CombineImages pathToSaveAmbOccMap ("Combine_AOMap_"+selectionSetsName) chkbox_previewVFB.state colorPick_EleBGColorAO.color "aoBG"
					CombineImages pathToSaveBlendMap ("Combine_BlendMap_"+selectionSetsName) chkbox_previewVFB.state colorPick_EleBGColorBlend.color "blendBG"
					CombineImages pathToSaveCompleteMap ("Combine_CompleteMap_"+selectionSetsName) chkbox_previewVFB.state colorPick_EleBGColorCompl.color "completeBG"
					CombineImages pathToSaveDiffuseMap ("Combine_DiffuseMap_"+selectionSetsName) chkbox_previewVFB.state	colorPick_EleBGColorDiff.color	 "diffuseBG"	
					CombineImages pathToSaveHeightMap ("Combine_HeightMap_"+selectionSetsName) chkbox_previewVFB.state colorPick_EleBGColorHeight.color "heightBG"
					CombineImages pathToSaveLightingMap ("Combine_LightingMap_"+selectionSetsName) chkbox_previewVFB.state colorPick_EleBGColorLight.color "lightingBG"
					CombineImages pathToSaveNormalsMap ("Combine_NormalsMap_"+selectionSetsName) chkbox_previewVFB.state colorPick_EleBGColorNormals.color "normalsBG"
					CombineImages pathToSaveShadowsMap ("Combine_ShadowsMap_"+selectionSetsName) chkbox_previewVFB.state colorPick_EleBGColorShadows.color "shadowsBG"
					CombineImages pathToSaveSpecularMap ("Combine_SpecularMap_"+selectionSetsName) chkbox_previewVFB.state colorPick_EleBGColorSpec.color "specularBG"
					CombineImages pathToSaveUVMap ("Combine_UVmap_"+selectionSetsName) chkbox_previewVFB.state (color 0 0 0) "UVBG"
				)
			)
		)		
		function CheckObjBeforeBakeing nodeToBake =
		(
			if smartIsRuning == false do
				EmptyArraysStoringPath()
			
			if nodeToBake.count != 0 then
			(
				--	set the active render to render that user defined in start of batch processing
				if startBatchRender == true do
				(
					--	set renderer to Scanline
					if batchMAX2011ActRender == "scanline" do
						renderers.current = default_scanline_renderer()
					--	set renderer to mentalRay
					if batchMAX2011ActRender == "mRay" do
						renderers.current = mental_ray_renderer()
				)
				
				--	define wich Standart maps will be bajed
				addDiffuseMap  = chkbox_DiffuseMap.state
				addSpecularMap  = chkbox_SpecularMap.state
				addCompleteMap  = chkbox_CompleteMap.state
				addShadowsMap  = chkbox_ShadowsMap.state
				addLightningMap  = chkbox_LightingMap.state
				addNormalsMap  = chkbox_normalsMap.state
				addBlendMap  = chkbox_BlendMap.state
				addAlphaMap  = chkbox_AlphaMap.state
				addHeightMap  = chkbox_HeightMap.state
				addAmbOccMap  = chkbox_AmbientOcclusion.state
				offOnProjection = chkbox_UseProjection.state				
			
				mapTextureWidth = (spn_mapWidth.text as integer)
				mapTextureHeight = (spn_mapHeight.text as integer)
				
				texture_Padding = (spn_Padding.text as integer)
				useUVWChannel = (spn_UVChannel.text as integer)

				for i = 1 to nodeToBake.count do
				(
					if( iskindof nodeToBake[i] GeometryClass) then
					(
						if(iskindof nodeToBake[i] TargetObject) do
							CancelRenderProcess = true
					)
					else
						CancelRenderProcess = true
				)
				--	check Projection list and if there is a Hidden HP unhide them
				for i = 1 to nodeToBake.count do
				(
					restoreToGroup = false
					if (isGroupMember nodeToBake[i]) then
					(
						setGroupMember nodeToBake[i] false
						restoreToGroup = true
					)
					currObj = nodeToBake[i]
					select currObj
					
					hiddenFound = false
					geomNodes = $.modifiers[#Projection].geomNodes
					for o in geomNodes where o.isHidden == true do hiddenFound = true
					if hiddenFound == true and mssgHiddenHPfound == false then
					(
						rollout hiddenHPfound "RTTAssist Live Log" width:400 height:113
						(
							local buttonWidth = 90
							local geomNodes = #() as array
							label objName "" pos:[7,27] 
							button bCancel "No" pos:[202,63] width:buttonWidth height:24
							button bOverwriteFiles "Yes" pos:[99,63] width:buttonWidth height:24
							checkbox cNotAgain "Apply this for the rest of the objects." pos:[10,90] checked:false

							on hiddenHPfound open do
							(
								geomNodes = $.modifiers[#Projection].geomNodes

								mssgHiddenHPfound = "Some of the High-Poly objects of \""+$.name+"\" are hidden , do you want to unhide them?"
								
								local requiredTextExtent = ((getTextExtent  mssgHiddenHPfound).x) + 10
								
								hiddenHPfound.width= requiredTextExtent+20
								
								local center = ((hiddenHPfound.width) / 2)
								bOverwriteFiles.pos.x = center - (buttonWidth + 8)
								bCancel.pos.x = center + 8				

								objName.pos.x = center
								objName.text = mssgHiddenHPfound
							)  
							on bCancel pressed do 
							(
								destroydialog hiddenHPfound
								miauuRTTassist.mssgHiddenHPfound = false
							)
							on bOverwriteFiles pressed do
							(
								for o in geomNodes where o.isHidden == true do o.isHidden = false
								redrawViews()
								miauuRTTassist.mssgHiddenHPfound = if cNotAgain.checked then true else false
								destroydialog hiddenHPfound
							)
							
						)
						createDialog  hiddenHPfound fgcolor:red modal:true
					)
					else
					(
						for o in geomNodes where o.isHidden == true do o.isHidden = false
						redrawViews()
					)
							
					if restoreToGroup == true do
						setGroupMember nodeToBake[i] true 
				)
			
				if smartIsRuning == false do
					objNameForCombineMap  = ""
				--	store array of selected objects
-- 				nodeToBake = nodeToBake as Array
				--	render maps one by one
				for i = 1 to nodeToBake.count do
				(
					restoreToGroup = false
					if (isGroupMember nodeToBake[i]) then
					(
						setGroupMember nodeToBake[i] false
						restoreToGroup = true
					)
					
					bakedObject = nodeToBake[i]	
				--	isolate LP and its HPs objects
					if chkbox_renderIsolate.state == true then
					(
						select bakedObject
						--	check all HP obj in Projection list and if there is a Hidden HP unhide it
						geomNodes = $.modifiers[#Projection].geomNodes
						--	add HP buddys to LP object selection
						for o in geomNodes do selectMore o
						--	invert selection
						max select invert
						--	hide all objects that will not be baked
						isolatedObj = selection as array
						hide isolatedObj
						if chkbox_redrawViews.state == true do redrawviews()
					--	bake object					
						objNameForCombineMap += ((bakedObject.name as string)+"_")
						select bakedObject						
						if CancelRenderProcess != true do AddMapToBake()	

						if restoreToGroup == true do setGroupMember nodeToBake[i] true 
					--	unisolate objects
						unhide isolatedObj
					)
					else
					(
						--	bake object					
						objNameForCombineMap += ((bakedObject.name as string)+"_")
						select bakedObject						
						if CancelRenderProcess != true do AddMapToBake()

						if restoreToGroup == true do setGroupMember nodeToBake[i] true 
					)
				)
				--	render Combine maps
				if smartIsRuning == false do
				(
					if CancelRenderProcess != true then
					(
						if objNameForCombineMap.count < 40 then
						(
							CombineMaps objNameForCombineMap
						)
						else
						(
							shortername = substring objNameForCombineMap 1 40
							CombineMaps shortername	
						)					
					)	
				)	
			)
			else()
		)
--------------------------------------------------------------------------------------------------------------
		function DestroyPresetRollout =
		(
			try(destroyDialog MainPresetRO)catch()
			try(destroyDialog smartPresetUnimpRO)catch()
			try(destroyDialog smartPresetImpRO)catch()
		)
		--	close Rollout LiveLog
		on dnLbl_errMsgTop mouseDown senderArg arg do
		(
			if arg.button==arg.button.left then
			(
				clockT.active = false
				miauuRTTassist.height = 177
				btn_openMapSettings.bitmap = (openBitmap (url+"miauuITmapsettingsOpen.png"))
				if mapButtonState == 0 do
					mapButtonState = 1
				if settingsButtonState == 0 do
					placeSettingsControls()
				if renderButtonState == 0 do
					PlaceRenderControls()
			)
		)
		--	open help on specific location dependent from error message
		on dnLbl_errMsgMoreInfo mouseDown senderArg arg do
		(
			if arg.button==arg.button.left then
			(
				clockT.active = false
				miauuRTTassist.height = 177
				btn_openMapSettings.bitmap = (openBitmap (url+"miauuITmapsettingsOpen.png"))
				if mapButtonState == 0 do
					mapButtonState = 1
				if settingsButtonState == 0 do
					placeSettingsControls()
				if renderButtonState == 0 do
					PlaceRenderControls()
				if batchState == 0 do
					PlaceBatchControls()
				if smartState == 0 do
					PlaceSmartControls()
				
				case errMssg of
				(
					1: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#prefix"	--	"Enter Prefix labels!"
					2: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#dublicate_prefix"	--	"The Low-Poly and High-Poly prefix labels are the same !"
					3: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#no_output"	--	"The output directory does not exist !"
					4: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#overlaping"	--	"There are overlapped objects !"
					5: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#press_explode"	--	"First press the \"Explode\" button !"
					6: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#no_lp_prefix"	--	"There are no Low Poly objects with prefix "+"\""+prefixNameLP+"\""
					7: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#no_hp_prefix"	--	"There are no High Poly objects with prefix "+"\""+prefixNameHP+"\""
					8: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#no_lp_prefix"	--	"There are no Low Poly objects with prefix "+"\""+prefixNameLPAdd+"\""
					9: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#no_hp_prefix"	--	"There are no High Poly objects with prefix "+"\""+prefixNameHPAdd+"\""
					10: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#need_alpha"	--	"Only map types that include alpha channel will work with the \"Combine maps\" function!"
					11: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#empty_lp_prefix"	--	"The prefix label for Low-Poly objects can't be an empty string !"
					12: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#empty_hp_prefix"	--	"The prefix label for High-Poly objects can't be an empty string !"
					13: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#select_lp_and_hp"	--	"Select Low-Poly or High-Poly object !"
					14: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#prefix"	--	"The selected HP object is not a part of High-Poly group !"
					15: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#no_proj"	--	"There are no objects in the scene with applied Projection modifier !"
					16: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#choose_maps"	--	"Please choose the desired map types first !"
					17: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#enter_preset"	--	"Please enter the preset name !"
					18: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#apply_proj"	--	"Re-apply the projection modifier or use another render mode(hover over the \"Render\" button for more info) !"
					19: errMssg = s"mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#decimal_symbol"	--	"Use the correct decimal symbol in the explode input field !"
					21: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#select_lp_first"	--	"Please, select some Low-Poly objects first !"
					22: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#select_object"	--	"Select more than one object !"
					23: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#buildpairs_failed"	--	"BuildPairs command failed.Please rename the selected objects manually!"
					24: errMssg = "mk:@MSITStore:"+helpFile+"::/LLiveLog_Messages.htm#proj_modifier"	--	"There are no objects in the scene with Projection modifier applied by RTTassist !"
					25: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#smart_spinner"	--	"First enter a value in the \"Smart\" spinner to define the minor and major objects"
					26: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#already_minor"	--	"This object is already set as \"minor\" or this is not a Low-Poly object !"
					28: errMssg = "mk:@MSITStore:"+helpFile+"::/LiveLog_Messages.htm#already_major"	--	"This object is already set as \"major\" or this is not a Low-Poly object !"
				)
				shellLaunch "hh" errMssg
			)
		)
		--	divider string
		function DividerStrReInit =
		(
			edittxt_SecondNameDivider.text = dividerStr
			DotNetFont edittxt_SecondNameDivider
		)
		on edittxt_SecondNameDivider KeyUp s e do
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				if edittxt_SecondNameDivider.text != undefined then
				(	
					dividerStr = edittxt_SecondNameDivider.text as string
					DividerStrReInit()
				)
				else
					dividerStr = undefined
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				if edittxt_SecondNameDivider.text != undefined then
				(
					dividerStr = edittxt_SecondNameDivider.text as string
					DividerStrReInit()
				)
				else
					dividerStr = undefined
			)
		)
		on  edittxt_SecondNameDivider LostFocus e do
		(
			if edittxt_SecondNameDivider.text != undefined then
			(
				dividerStr = edittxt_SecondNameDivider.text as string
				DividerStrReInit()
			)
			else
				dividerStr = undefined			
		) 
--------------------------------
	-- 	Select LP objects label
--------------------------------
		--	select LP objects
		on dNet_Label_selLP mouseDown senderArg arg do
		(
			--	on LMB click select all main and imported LP objects
			if arg.button==arg.button.left then
			(		
				if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
				(
					local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#low_prefix"
					shellLaunch "hh" goToHelp
				)
				else
				(
					GetProperObj()
					if keyboard.controlPressed then
						MainOrSubHP()
					else
					(
						if prefixNameLP != undefined then
							if CheckObjAndPrefixLP() == true do
								ObjSelect prefixNameLP
						else
						(
							errMssg = 1
							ErrorMessage 1
						)
						
						if prefixNameLPAdd != undefined do
							if CheckObjAndPrefixLPAdd() == true do
								ObjSelectAdd prefixNameLPAdd 1
					)
				)
			)
 			--	on RMB click select all main objects
			if arg.button==arg.button.right then
			(				
				GetProperObj()
				if CheckObjAndPrefixLP() == true then
				(
					if keyboard.controlPressed then
						MainOrSubHP()
					else
					(
						if prefixNameLP != undefined then
							if CheckObjAndPrefixLP() == true do
								ObjSelect prefixNameLP
						else
						(
							errMssg = 1
							ErrorMessage 1
						)
					)
				)
			)
			--	on MMB click select all imported LP objects
			if arg.button==arg.button.middle then
			(
				GetProperObj()
				if prefixNameLPAdd != undefined then
				(
					if keyboard.controlPressed then
						MainOrSubHP()
					else
						ObjSelectAdd prefixNameLPAdd 2
				)	
			) 			
		)
		--	swap LP label and LP textbox places
		on dNet_Label_selLP  DoubleClick  senderArg arg do
		(
			dNet_Label_selLP.pos = [-58,-58]
			dNet_TextBox_LP.pos = [61,32]
			dNet_TextBox_LP.Focus()
		)
		--	enter new LP prefix labels in textbox
		on dNet_TextBox_LP KeyUp s e do
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				SetLPprefix dNet_TextBox_LP.text
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				SetLPprefix dNet_TextBox_LP.text
			)
		)
		on  dNet_TextBox_LP LostFocus e do
		(
			SetLPprefix dNet_TextBox_LP.text
		) 
--------------------------------
	-- Select HP objects label
--------------------------------
		--	select HP pbjects
		on dNet_Label_selHP mouseDown senderArg arg do
		(
 			--	on RMB click select all main LP objects
			if arg.button==arg.button.right then
			(				
				GetProperObj()
				if CheckObjAndPrefixHP() == true then
				(
					if keyboard.controlPressed then
						ControlPressedSel 2
					else
					(
						if prefixNameHP != undefined then
							if CheckObjAndPrefixHP() == true do
								ObjSelect prefixNameHP
						else
						(
							errMssg = 1
							ErrorMessage 1
						)
					)
				)
			)
			--	on MMB click select all imported LP objects
			if arg.button==arg.button.middle then
			(
				GetProperObj()
				if prefixNameHPAdd != undefined then
				(
					if keyboard.controlPressed then
						ControlPressedSel 2
					else
						ObjSelectAdd prefixNameHPAdd 2
				)	
			)
 			--	on LMB click select all main and imported LP objects
			if arg.button==arg.button.left then
			(	
				if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
				(
					local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#high_prefix"
					shellLaunch "hh" goToHelp
				)
				else
				(
					GetProperObj()
					if keyboard.controlPressed then
						ControlPressedSel 2
					else
					(
						if keyboard.shiftPressed then
							ShiftPressedSel()
						else
						(
						if prefixNameHP != undefined then
							if CheckObjAndPrefixHP() == true do
								ObjSelect prefixNameHP
						else
						(
							errMssg = 1
							ErrorMessage 1
						)
						
						if prefixNameHPAdd != undefined do
							if CheckObjAndPrefixHPAdd() == true do
								ObjSelectAdd prefixNameHPAdd 1
						)
					)
				)
			)
		)
		--	swap HP label and HP textbox places
		on dNet_Label_selHP  DoubleClick  senderArg arg do
		(
			dNet_Label_selHP.pos = [-78,-78]
			dNet_TextBox_HP.pos = [61,51]
			dNet_TextBox_HP.Focus()
		)
		--	enter new HP prefix labels in textbox
		on dNet_TextBox_HP KeyUp s e do
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				SetHPprefix dNet_TextBox_HP.text
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				SetHPprefix dNet_TextBox_HP.text
			)
		)
		on  dNet_TextBox_HP LostFocus e do
		(
			SetHPprefix dNet_TextBox_HP.text
		)
------------------------------------------------------------------------------
	--	Freeze/Unfreeze/Hide/Unhide/Export low poly and high poly objects
------------------------------------------------------------------------------
		--	hide and unhide all main and imported LP objects
		on ImgTag_chkbtn_low_hide lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#hidetoggle"
				shellLaunch "hh" goToHelp
			)
			else
			(
				case of
				(
					(hideUnhideLPImgTagState ==1) : 
					(
						ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideA.png"))
						ImgTag_chkbtn_low_hide.tooltip = "Unhide all Low-Poly objects!\nRMB to unhide all main Low-Poly objects!\nMMB to unhide all imported Low-Poly objects"
						GetProperObj()			
						if prefixNameLP != undefined then
							HideMainLPobj()
						else
						(
							errMssg = 1
							ErrorMessage 1
						)
						if prefixNameLPAdd != undefined do
							HideImportedLPobj()
						
						hideUnhideLPImgTagState = 0
					)
					(hideUnhideLPImgTagState ==0) : 
					(
						ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
						ImgTag_chkbtn_low_hide.tooltip = "Hide all Low-Poly objects!\nRMB to hide all main Low-Poly objects!\nMMB to hide all imported Low-Poly objects"
						GetProperObj()			
						if prefixNameLP != undefined then
							UnhideMainLPobj()
						else
						(
							errMssg = 1
							ErrorMessage 1
						)
						if prefixNameLPAdd != undefined do
							UnhideImportedLPobj()
						hideUnhideLPImgTagState = 1
					)
				)
			)
		)
		--	hide/unhide only main LP objects
		on ImgTag_chkbtn_low_hide rbuttonup do
		(
			DestroyPresetRollout()
			case of
			(
				(hideUnhideLPImgTagStateRB ==1) : 
				(
					ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideA.png"))
					GetProperObj()			
					if prefixNameLP != undefined then
						HideMainLPobj()
					else
					(
						errMssg = 1
						ErrorMessage 1
					)
					hideUnhideLPImgTagStateRB = 0
				)
				(hideUnhideLPImgTagStateRB ==0) : 
				(
					ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
					GetProperObj()			
					if prefixNameLP != undefined then
						UnhideMainLPobj()
					else
					(
						errMssg = 1
						ErrorMessage 1
					)
					hideUnhideLPImgTagStateRB = 1
				)
			)
		)
		--	hide/inhide only imported LP objects
		on ImgTag_chkbtn_low_hide mbuttonup do
		(
			DestroyPresetRollout()
			case of
			(
				(hideUnhideLPImgTagStateMB ==1) : 
				(
					ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideA.png"))
					GetProperObj()
					if prefixNameLPAdd != undefined do
						HideImportedLPobj()
					hideUnhideLPImgTagStateMB = 0
				)
				(hideUnhideLPImgTagStateMB ==0) : 
				(
					ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
					GetProperObj()
					if prefixNameLPAdd != undefined do
						UnhideImportedLPobj()
					hideUnhideLPImgTagStateMB = 1
				)
			)
		)
		on ImgTag_chkbtn_low_hide mouseover do
		(
			if hideUnhideLPImgTagState == 0 do
				ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideAHover.png"))
			if hideUnhideLPImgTagState == 1 do
				ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideIAHover.png"))
		)
		on ImgTag_chkbtn_low_hide mouseout do
		(
			if hideUnhideLPImgTagState == 0 do
				ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideA.png"))
			if hideUnhideLPImgTagState == 1 do
				ImgTag_chkbtn_low_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
		)
		--	freeze selected LP objects
		on ImgTag_btn_FreezeSelectedLP lbuttonup do
		(			
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#freezetoggle"
				shellLaunch "hh" goToHelp
			)
			else
			(
				freezeState = 1
				ImgTag_btn_FreezeSelectedLP.bitmap = (openBitmap (url+"miauuITfreeze.png"))
				GetProperObj()
				for o in selection where ((findString o.name prefixNameLP) != undefined) do
					freeze o
				if prefixNameLPAdd != undefined do
				(
					for o in selection where ((findString o.name prefixNameLPAdd) != undefined) do
						freeze o
				)
			)
		)
		--	unfreeze all LP objects
		on ImgTag_btn_FreezeSelectedLP rbuttonup do
		(			
			DestroyPresetRollout()
			freezeState = 0
			ImgTag_btn_FreezeSelectedLP.bitmap = (openBitmap (url+"miauuITunfreeze.png"))
			GetProperObj()
			for o in selObj where ((findString o.name prefixNameLP) != undefined) do
				if o.isFrozen == true do
					unfreeze o
			if prefixNameLPAdd != undefined do
			(
				for o in selObj where ((findString o.name prefixNameLPAdd) != undefined) do
					if o.isFrozen == true do
						unfreeze o
			)
		)
		on ImgTag_btn_FreezeSelectedLP mouseover do
		(
			if freezeState == 1 do
				ImgTag_btn_FreezeSelectedLP.bitmap = (openBitmap (url+"miauuITfreezeHover.png"))
			if freezeState == 0 do
				ImgTag_btn_FreezeSelectedLP.bitmap = (openBitmap (url+"miauuITunfreezeHover.png"))
		)
		on ImgTag_btn_FreezeSelectedLP mouseout do
		(
			if freezeState == 1 do
				ImgTag_btn_FreezeSelectedLP.bitmap = (openBitmap (url+"miauuITfreeze.png"))
			if freezeState == 0 do
				ImgTag_btn_FreezeSelectedLP.bitmap = (openBitmap (url+"miauuITunfreeze.png"))		
		)
		on ImgTag_button_low_export lbuttondown do
		(			
			DestroyPresetRollout()
			ImgTag_button_low_export.bitmap = (openBitmap (url+"miauuITexportIA.png"))
		)
		on ImgTag_button_low_export lbuttonup do
		(	
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#exportbutton"
				shellLaunch "hh" goToHelp
			)
			else
			(
				if prefixNameLP != undefined then
				(
					if CheckObjAndPrefixLP() == true do
						ObjExport prefixNameLP
				)
				else
				(
					errMssg = 1
					ErrorMessage 1
				)
				if prefixNameLPAdd != undefined do
				(
					if CheckObjAndPrefixLP() == true do
						ObjExport prefixNameLPAdd
				)
			)
		)
		on ImgTag_button_low_export mouseover do
		(
			ImgTag_button_low_export.bitmap = (openBitmap (url+"miauuITexportIAHover.png"))
		)
		on ImgTag_button_low_export mouseout do
		(
			ImgTag_button_low_export.bitmap = (openBitmap (url+"miauuITexportIA.png"))
		)
		--	for HP objects
		on ImgTag_chkbtn_high_hide lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#hidetoggle"
				shellLaunch "hh" goToHelp
			)
			else
			(
				case of
				(
					(hideUnhideHPImgTagState ==1) : 
					(
						ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideA.png"))
						ImgTag_chkbtn_high_hide.tooltip = "Unhide all High-Poly objects!\nRMB to unhide only main High-Poly objects!\nMMB to unhide only imported High-Poly objects!"
						GetProperObj()			
						if prefixNameHP != undefined then
							HideMainHPobj()
						else
						(
							errMssg = 
							ErrorMessage 1
						)
						if prefixNameHPAdd != undefined do
							HideImportedHPobj()
						hideUnhideHPImgTagState = 0
					)
					(hideUnhideHPImgTagState ==0) : 
					(
						ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
						ImgTag_chkbtn_high_hide.tooltip = "Hide all High-Poly objects!\nRMB to hide only main High-Poly objects!\nMMB to hide only imported High-Poly objects!"
						GetProperObj()			
						if prefixNameHP != undefined then
							UnhideMainHPobj()
						else
						(
							errMssg = 1
							ErrorMessage 1
						)
						if prefixNameHPAdd != undefined do
							UnhideImportedHPobj()
						hideUnhideHPImgTagState = 1
					)
				)
			)
		)
		--	hide/unhide main HP objects
		on ImgTag_chkbtn_high_hide rbuttonup do
		(
			DestroyPresetRollout()
			case of
			(
				(hideUnhideHPImgTagStateRB ==1) : 
				(
					ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideA.png"))
					GetProperObj()			
					if prefixNameHP != undefined then
						HideMainHPobj()
					else
					(
						errMssg = 1
						ErrorMessage 1
					)
					hideUnhideHPImgTagStateRB = 0
				)
				(hideUnhideHPImgTagStateRB ==0) : 
				(
					ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
					GetProperObj()			
					if prefixNameHP != undefined then
						UnhideMainHPobj()
					else
					(
						errMssg = 1
						ErrorMessage 1
					)
					
					hideUnhideHPImgTagStateRB = 1
				)
			)
		)
		--	hide/unhide imported HP objects
		on ImgTag_chkbtn_high_hide mbuttonup do
		(
			DestroyPresetRollout()
			case of
			(
				(hideUnhideHPImgTagStateMB ==1) : 
				(
					ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideA.png"))
					GetProperObj()
					if prefixNameHPAdd != undefined do
						HideImportedHPobj()
					hideUnhideHPImgTagStateMB = 0
				)
				(hideUnhideHPImgTagStateMB ==0) : 
				(
					ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
					GetProperObj()
					if prefixNameHPAdd != undefined do
						UnhideImportedHPobj()
					hideUnhideHPImgTagStateMB = 1
				)
			)
		)
 		on ImgTag_chkbtn_high_hide mouseover do
		(
			if hideUnhideHPImgTagState == 0 do
				ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideAHover.png"))
			if hideUnhideHPImgTagState == 1 do
				ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideIAHover.png"))
		)
		on ImgTag_chkbtn_high_hide mouseout do
		(
			if hideUnhideHPImgTagState == 0 do
				ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideA.png"))
			if hideUnhideHPImgTagState == 1 do
				ImgTag_chkbtn_high_hide.bitmap = (openBitmap (url+"miauuIThideIA.png"))
		) 
		--	freeze selected HP objects
		on ImgTag_btn_FreezeSelectedHP lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#freezetoggle"
				shellLaunch "hh" goToHelp
			)
			else
			(
				freezeStateH = 1
				ImgTag_btn_FreezeSelectedHP.bitmap = (openBitmap (url+"miauuITfreeze.png"))
				GetProperObj()
				for o in selection where ((findString o.name prefixNameHP) != undefined) do
					freeze o
				if prefixNameHPAdd != undefined do
				(
					for o in selection where ((findString o.name prefixNameHPAdd) != undefined) do
						freeze o
				)
			)
		)
		--	unfreeze all HP objects
		on ImgTag_btn_FreezeSelectedHP rbuttonup do
		(
			DestroyPresetRollout()
			freezeStateH = 0
			ImgTag_btn_FreezeSelectedHP.bitmap = (openBitmap (url+"miauuITunfreeze.png"))
			GetProperObj()
			for o in selObj where ((findString o.name prefixNameHP) != undefined) do
				if o.isFrozen == true do
					unfreeze o
			if prefixNameHPAdd != undefined do
			(
				for o in selObj where ((findString o.name prefixNameHPAdd) != undefined) do
					if o.isFrozen == true do
						unfreeze o
			)
		)
		on ImgTag_btn_FreezeSelectedHP mouseover do
		(
			if freezeStateH == 1 do
				ImgTag_btn_FreezeSelectedHP.bitmap = (openBitmap (url+"miauuITfreezeHover.png"))
			if freezeStateH == 0 do
				ImgTag_btn_FreezeSelectedHP.bitmap = (openBitmap (url+"miauuITunfreezeHover.png"))
		)
		on ImgTag_btn_FreezeSelectedHP mouseout do
		(
			if freezeStateH == 1 do
				ImgTag_btn_FreezeSelectedHP.bitmap = (openBitmap (url+"miauuITfreeze.png"))
			if freezeStateH == 0 do
				ImgTag_btn_FreezeSelectedHP.bitmap = (openBitmap (url+"miauuITunfreeze.png"))		
		)
		on ImgTag_button_high_export lbuttondown do
		(
			DestroyPresetRollout()
			ImgTag_button_high_export.bitmap = (openBitmap (url+"miauuITexportIA.png"))
		)
		on ImgTag_button_high_export lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#exportbutton"
				shellLaunch "hh" goToHelp
			)
			else
			(
				GetProperObj()			
				if prefixNameHP != undefined then
				(
					if CheckObjAndPrefixHP() == true do
						ObjExport prefixNameHP
				)
				else
				(
					errMssg = 1
					ErrorMessage 1
				)
				if prefixNameHPAdd != undefined do
				(
					if CheckObjAndPrefixHP() == true do
						ObjExport prefixNameHPAdd
				)	
			)	
		)
		on ImgTag_button_high_export mouseover do
		(
			ImgTag_button_high_export.bitmap = (openBitmap (url+"miauuITexportIAHover.png"))
		)
		on ImgTag_button_high_export mouseout do
		(
			ImgTag_button_high_export.bitmap = (openBitmap (url+"miauuITexportIA.png"))
		)
---------------------------
	--	Explode/Implode
--------------------------
		on ImgTag_ExplodeImplode lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Explode_function.htm"
				shellLaunch "hh" goToHelp
			)
			else
			(
				if prefixNameLP != undefined and prefixNameHP != undefined then
				(
					case of
					(
						--	EXPLODE
						(explodeImplodeImgTagState == 1) : 
						(
							
						--	main code
							GetProperObj()
							if CheckObjAndPrefixLP() == true and CheckObjAndPrefixHP() == true then
							(
								ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITimplode.png"))
								ImgTag_ExplodeImplode.tooltip = "Bring objects back to their initial place!\nRMB to select the \"origin of explosion\" helper."
								--	explode without Animation
								if keyboard.controlPressed then
								(
									noAnimExplByCntrl = 1
								)
								--	explode without Auto Check for Overlaps when use spinner
								if keyboard.shiftPressed then
								(
									noAutoCOByShift = 1
								)
								--	create zero point helper object
								if chkbox_ZeroPoint.state == on do
								(	
									--	calculate diameter of all objects BBoxes
									local allObjDiameter = #() as array
									for o in selObj do
									(
										objDiameter = ( distance o.max o.min) as float
										append allObjDiameter objDiameter
									)
									zeroPointSize = amax allObjDiameter
									
									local theZeroPoint = PointOfExplosion()
									
									try(delete miauuZeroPoint)catch()
									miauuZeroPoint =  Point pos:theZeroPoint
									miauuZeroPoint.wirecolor = red
									miauuZeroPoint.size = zeroPointSize
									miauuZeroPoint.name = "RTTassist Zero Point"
								)
								-- save starting position of all objects in scene
								allObjInScene = for obj in objects where classof obj != Biped_Object and superClassOf obj != helper collect obj
								startingObjPos = for i = 1 to  allObjInScene.count collect allObjInScene[i].center
								GetProperObj()
								--	if Alt is pressed enter in Explode mode - user can move Zero Point Hepler
								--	if Alt is not pressed do automatic explosion
								if not keyboard.AltPressed then
								(
									--	explode without Auto Check for Overlaps when use spinner
									if keyboard.shiftPressed then
									(
										noAutoCOByShift = 1
									)
									--	explode without Animation
									if keyboard.controlPressed then
									(
										noAnimExplByCntrl = 1
									)
									--	calculate diameter of all objects BBoxes
									local allObjDiameter = #() as array
									for o in selObj do
									(
										objDiameter = ( distance o.max o.min) as float
										append allObjDiameter objDiameter
									)
									dist = amax allObjDiameter 

									--	do the explode
									if chkbox_OnOffAnimation.state == on then	--	if animation is turned Off
									(
										dNet_TxtBoxAsSpinner.text = "1.3"
										dNetTBasSpn = dNet_TxtBoxAsSpinner.text as float
										ExplodeObjPrep 1.3 1.01 1
									)
									else	--	if animation is turned On
									(
										distOnlyfirst2digit = substring (dist as string) 1 3
										dNet_TxtBoxAsSpinner.text = (distOnlyfirst2digit as string)
										dNetTBasSpn = dNet_TxtBoxAsSpinner.text as float
										ExplodeObjPrep dist 1.05 1
									)
								)
							)
							else
							(
								ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITexplode.png"))
								ImgTag_ExplodeImplode.tooltip = "LMB to explode the scene using default settings!\nAlt + LMB to turn on \"EXPLODE\"mode!\nCtrl+LMB to explode without animation!\nShift+LMB to explode without automaticaly checks\nfor overpalled objects!"
								explodeImplodeImgTagState = 1
							)		
						--	end main code
							explodeImplodeImgTagState = 0
						)
						--	IMPLODE
						(explodeImplodeImgTagState == 0) : 
						(
						--	main code	
							--	try to delete zero point helper object
							try(delete miauuZeroPoint)catch()

							for i = 1 to allObjInScene.count where isValidNode allObjInScene[i] do
							(
								-- move object to initial position
								allObjInScene[i].center = startingObjPos[i]
								--	check if the object have a Skin modifier and turn it on
								isThereModifier = allObjInScene[i].modifiers
								if isThereModifier.count != 0 do
									EnableSkin isThereModifier isThereModifier.count
							)
							if noAutoCOByShift == 1 do
								noAutoCOByShift = 0
							if noAnimExplByCntrl == 1 do
								noAnimExplByCntrl = 0
							ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITexplode.png"))
							ImgTag_ExplodeImplode.tooltip = "LMB to explode the scene using default settings!\nAlt + LMB to turn on \"EXPLODE\"mode!\nCtrl+LMB to explode without animation!\nShift+LMB to explode without automaticaly checks\nfor overpalled objects!"
							dNet_TxtBoxAsSpinner.text = "1.0"
							--	end main code
							explodeImplodeImgTagState = 1
						)
					)
				)
				else
				(
					errMssg = 1
					ErrorMessage 1
				)
			)
		)
		--	select Zero Point helper when right click over implode ImgTag
		on ImgTag_ExplodeImplode rbuttonup  do
		(
			DestroyPresetRollout()
			if isValidNode miauuZeroPoint do
			(
				select miauuZeroPoint
				max move
			)
		)
		on ImgTag_ExplodeImplode mouseover  do
		(
			if explodeImplodeImgTagState == 0 do
				ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITimplodeHover.png"))
			if explodeImplodeImgTagState == 1 do 
				ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITexplodeHover.png"))
		)
		on ImgTag_ExplodeImplode mouseout  do
		(
			if explodeImplodeImgTagState == 0 do
				ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITimplode.png"))
			if explodeImplodeImgTagState == 1 do
				ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITexplode.png"))
		)
-------------------------------
	--	Compare Name Rollout
-------------------------------
		on btn_CompareName lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/The_Names_Function.htm"
				shellLaunch "hh" goToHelp
			)
			else
			(
				GetProperObj()
				if prefixNameLP != undefined and prefixNameHP != undefined  then
				(
					if CheckObjAndPrefixLP() == true and CheckObjAndPrefixHP() == true do
					(
						try(destroydialog miauuCompairNames)catch()
						rollout miauuCompairNames "Fix the errors in objects names!" width:310 height:270
						(
							local pairsNamesNoPrefixHP = #() as array	--	store the names of HP parts that have an error in their names
							local HPnames = #() as array
							local pairsNamesNoPrefixHPAdd = #() as array	--	store the names of HP parts that have an error in their names
							local HPnamesAdd = #() as array			
							local checkedNames1 = undefined
							local checkedNames2 = undefined
							local BBoxLP = #() as array	--	store LP objects of BBox method suggeston
							local BBoxLPname = #() as array	--	sotre names of BBox method suggestion
							local centerMatch = #() as array
							local LPtoHP = #() as array	--	store LP objects coresponding to wrong HP obects
							local correspondingLPnames = #() as array		--	store LP objects with suggested coresponding names
							local toSelect = #() as array	--	store objects with more than desired face count
							local isImplodeActive = undefined	--	Explode/Implode checkbutton state
							local explodeMultiplier = undefined	--	store the spn_explodeImplode value
							local dataSelLP = #() as array
							local dataSelHP = #() as array
							
							button btn_findNoPairLP "Find High Poly objects with wrong names" pos:[0,-50]
							label lb1 "Choose miss-writen object to Display suggestions for its match." pos:[7,5] align:#center
							label lb2 "Double click the correct name to rename both objects in the pair." pos:[2,20] align:#center
							label lb3 "HP with wrong name:                    Coresponding LP suggestion" pos:[6,35] align:#center
							listbox HPwithWrongName "" pos:[6,50] width:136 height:12
							listbox corespondingLPtoHP "" pos:[168,50] width:136 height:12
							button btn_DelLP "Delete" pos:[-40,-40] width:40 height:20 tooltip:"Removes the object from\nthe list without renaming it!"
							
							button btn_delSingleHP "Delete" pos:[50,215] width:50 height:12 tooltip:"Removes the object from\nthe list without renaming it!"
							checkbox chkbox_Select "Select" pos:[5,240] width:50 height:20 checked:true	tooltip:"Will select the object in the viewport\nfor more visual feedback" highLightColor:(color 255 168 40)
							checkbox chkbox_Color "Color" pos:[57,240] width:50 height:20 tooltip:"Will change the object's material for more visual feedback." highLightColor:(color 255 168 40)
							checkbox chkbox_Zoom "Zoom" pos:[109,240] width:50 height:20 tooltip:"Zoom Extents Selected." highLightColor:(color 255 168 40)
							checkbox chkbox_StringCompair "by Name" pos:[164,230] width:70 height:16 checked:true	tooltip:"List suggestions based on objects names" highLightColor:(color 255 168 40)
							checkbox chkbox_PosCompair "by Position" pos:[164,250] width:70 height:16 checked:true	tooltip:"List suggestions based on objects position.\nThis option will exclude unrelated objects\nif they are too far apart" highLightColor:(color 255 168 40)
							checkbox chkbox_mainPrefix "main Obj" pos:[240,230] width:70 height:16 checked:true	tooltip:"Process only objects including\nthe main prefix in their names" highLightColor:(color 255 168 40)
							checkbox chkbox_addPrefix "add Obj" pos:[240,250] width:70 height:16 checked:false tooltip:"Process all objects which prefix\ndiffers from the main one" highLightColor:(color 255 168 40)
							--	find if selected object is in volume of another object. Created by Borislav "Bobo" Petrov
							function IsInVolume theNode theVolume=
							(
								local theVect = theVolume.center - theNode.center
								local theInt = intersectRay theVolume (Ray theNode.center theVect)
								if theInt == undefined then true
								else
									distance theInt.pos theNode.center > length theVect
							)
							
							on miauuCompairNames open do
							(
								--	check if Implode mode is active
								if explodeImplodeImgTagState == 0 do
								(
									isImplodeActive = 1
									--	store the value of spn_explodeImplode spinner
									explodeMultiplier = dNetTBasSpn
									--	turn off Implode button
									explodeImplodeImgTagState = 1
									ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITexplode.png"))
									ImgTag_ExplodeImplode.tooltip = "LMB to explode the scene using default settings!\nAlt + LMB to turn on \"EXPLODE\"mode!\nCtrl+LMB to explode without animation!\nShift+LMB to explode without automaticaly checks\nfor overpalled objects!"
									--	return objects to starting position
									for i = 1 to allObjInScene.count where isValidNode allObjInScene[i] do
									(
										-- move object to initial position
										allObjInScene[i].center = startingObjPos[i]
										--	check if the object have a Skin modifier and turn it on
										isThereModifier = allObjInScene[i].modifiers
										if isThereModifier.count != 0 do
											EnableSkin isThereModifier isThereModifier.count
									)
									dNetTBasSpn = 1.0
									miauuRTTassist.dNet_TxtBoxAsSpinner.text = "1.0"
								)
								--	check names of LP and HP objects for errors
								checkedNames1 = CheckNames prefixNameLP
								if prefixNameLPAdd != undefined and prefixNameHPAdd != undefined do
								(
									checkedNames2 = CheckNames1 prefixNameLPAdd
									if checkedNames2 != undefined do
									(	
										--	convert no prefix names to names with prefix so they can make select in scene by selecting names in listbox
										for HPobjName in checkedNames2 do
										(
											HPobjName  = prefixNameHPAdd + HPobjName
											append HPnamesAdd HPobjName
										)
									)							
								)
								if checkedNames1 != undefined do
								(	
									--	convert no prefix names to names with prefix so they can make select in scene by selecting names in listbox
									for HPobjName in checkedNames1 do
									(
										HPobjName  = prefixNameHP + HPobjName
										append HPnames HPobjName
									)				
									for aControl in miauuCompairNames.controls do
									(
										try
										(
											case classof aControl of
											(
												CheckBoxControl: aControl.state = (readValue ((getIniSetting miauuIniFile "Checkbox" (aControl.name as string)) as stringStream))
											)
										)catch()	
									)
									--	show if there a HP object with wrong prefix - LP with face count more than spinner value
									local faceLPname = #() as array
									local faceLP = #() as array
									if (miauuRTTassist.spn_faces_threshold.text as string) != "0" do
									(
										toSelect = #()
										for o in geometry where classof o != TargetObject  do
										(
											theMesh = snapshotasmesh o
											theTest = theMesh.numfaces > miauuRTTassist.spn_faces_threshold.text as integer
											delete theMesh
											if ((findString o.name prefixNameLP) != undefined) do
											(	
												if chkbox_Select.checked or chkbox_Color.checked do
												(	
													if theTest do append toSelect o
												)
											)
										)
										if chkbox_Select.checked or chkbox_Color.checked do
										(
											max select none
											select toSelect
											if toSelect.count != 0 do
											(
												btn_DelLP.pos = [50,68]
												btn_delSingleHP.pos = [-50,-215]
												corespondingLPtoHP.pos = [95,50]
												HPwithWrongName.pos = [-150,-150]
												faceLPname = for f in toSelect collect f.name								
											)
											if faceLPname.count != 0 do
											(
												corespondingLPtoHP.items = faceLPname
												--	create dialog that shows the message for "by face count"
												if faceLPname.count == 1 then
												(
													--	change the labels text
													lb1.text = "This object have more than "+(miauuRTTassist.spn_faces_threshold.text as string)+" faces.May be it is a HP"
													lb2.text = "object.Double click to rename it correctly or press the"
													lb3.text = "\"Delete\" button to remove it from the list."
												)
												else
												(
													lb1.text = "These objects have more than "+(miauuRTTassist.spn_faces_threshold.text as string)+" faces.May be they are a HP"	--	"These objects are propably a HP objects.Double click to rename"
													lb2.text = "objects.Double click to rename them correctly or press the"
													lb3.text = "\"Delete\" button to remove them from the list"
												)
											)
										)							
									)
								)
								if chkbox_mainPrefix.checked == on and toSelect.count == 0 do
									HPwithWrongName.items = HPnames	--	show all HP objects with wrong names+prefixes so they can be selected in viewport
								if chkbox_addPrefix.checked == on do
									HPwithWrongName.items = HPnamesAdd	--	show all HP objects with wrong names+prefixes so they can be selected in viewport
							)
							--	switch checkbox to avoid problems
							on chkbox_mainPrefix changed theState do
							(
								if chkbox_addPrefix.state == on then
									chkbox_addPrefix.state = off
								else
									chkbox_mainPrefix.state = on
								HPwithWrongName.items = HPnames
							)
							on chkbox_addPrefix changed theState do
							(
								if chkbox_mainPrefix.state == on then
									chkbox_mainPrefix.state = off
								else
									chkbox_addPrefix.state = on
								HPwithWrongName.items = HPnamesAdd
							)
							--	show suggested names when select HP with wrong name
							on HPwithWrongName selected nameIndex do
							(
								if dataSelHP.count != 0 do
								(
									for d in dataSelHP do d[1].material = d[2]
									dataSelHP = #() as array
								)
								--	define prefix name depends of wich checkbox is checked
								if chkbox_mainPrefix.checked == on do
								(	
									prefixNameHPO = prefixNameHP
									prefixNameLPO = prefixNameLP
								)
								if chkbox_addPrefix.checked == on do
								(	
									prefixNameHPO = prefixNameHPAdd
									prefixNameLPO = prefixNameLPAdd
								)
								wrongHP = getNodeByName HPwithWrongName.items[nameIndex]
								--	find if there is a LP object that contain wrong HP in its volume
								haveInVolumeLPname = for o in objects where ((findString o.name prefixNameLPO) != undefined) and IsInVolume wrongHP o collect o.name
								--	use objects boundingbox center
								BBoxLP = #() as array	--	store LP objects of BBox method suggeston
								BBoxLPname = #() as array	--	sotre names of BBox method suggestion
								LPtoHP = #() as array	--	store LP objects coresponding to wrong HP obects
								correspondingLPnames = #() as array		--	store LP objects with suggested coresponding names
								corespondingLPtoHP.items = #()
							--	try to find coresponding LP with right names using BBox compair of objects
								wrongHPcenter = wrongHP.center
								r = (distance wrongHP.max wrongHP.min) / 2	--	the raduis of BBox - define area to search for LP's BBox center
								for o in objects where classof o != Biped_Object and superClassOf o != helper do
								(
									--	find LP objects only if they have intersection and the center of LP BBox is in HP BBox volume
									if ((distance o.center wrongHPcenter) <= r) and ((intersects o wrongHP) == true) do
									(
										append BBoxLP o
										append BBoxLPname o.name
									)
								)
								--	remove all HP objects from LP suggestions
								if BBoxLPname.count != 0 do
								(
									for h = BBoxLPname.count to 1 by -1 do
									(
										if ((findString BBoxLPname[h] prefixNameHPO) != undefined) do
											deleteItem BBoxLPname h								
									)
								)
								--	try to find closest center of LP to current HP center
								centerMatch = #() as array	--	perfect match of centers of BBox
								centerMatchR = #() as array	--	BBox centers of LP objects in radius of 10%
								for lp in BBoxLPname do
								(
									currLP = getNodeByName lp
									if currLP.center == wrongHPcenter then
										append centerMatch lp
									else
									(
										if (distance currLP.center wrongHPcenter) <= (r*0.10) do
											append centerMatchR lp
									)									
								)
								--	join tow "by Position" arrays
								if haveInVolumeLPname.count != 0 do
									join BBoxLPname haveInVolumeLPname
							--	try to find coresponding LP with right names using String Compair of names
								prefixNameLPNumb = prefixNameLPO.count
								for m = 1 to pairsNamesNoPrefixLP.count do
								(
									b = pairsNamesNoPrefixLP[m]	--	all LP objects with the correct names - no prefix for names
									indexHP = (HPwithWrongName.items[nameIndex])	as string --	current HP object with wrong name - no prefix for names
									local highName_TrimmedC = replace indexHP 1 prefixNameLPNumb ""
									a = highName_TrimmedC as string
									if a.count > b.count do
									(
										match = 0
										noMatch = 0
										for i = 1 to a.count do
										(
											if a[i] == b[i] then
												match +=1
											else
											(
												n = i+1
												if a[n] == b[i] then
													match +=1
												else
													noMatch +=1
											)
										)		
									)						
									if a.count < b.count do
									(
										match = 0
										noMatch = 0
										for i = 1 to a.count do
										(
											if a[i] == b[i] then
												match +=1
											else
											(
												n = i+1
												if a[i] == b[n] then
													match +=1
												else
													noMatch +=1
											)
										)		
									)						
									if a.count == b.count do
									(
										match = 0
										noMatch = 0
										for i = 1 to a.count do
										(
											if a[i] == b[i] then
												match +=1
											else
											(
												n = i+1
												if a[i] == b[n] then
													match +=1
												else
												(
													if a[n] == b[i] then
														match +=1
													else
														noMatch +=1
												)
											)
										)		
									)						
									if match > noMatch do
									(
										matchPercent = a.count * 0.70
										if match >= matchPercent do
											appendifUnique LPtoHP pairsNamesNoPrefixLP[m]
									)
								)
								--	convert no prefix names to names with prefix so the objects can be selected in scene by selecting names in listbox
								for oName in LPtoHP do
								(
									oName  = prefixNameLPO + oName
									appendifUnique correspondingLPnames oName
								)
								
								if chkbox_StringCompair.checked do
								(
									corespondingLPtoHP.items = correspondingLPnames
								)
								if chkbox_PosCompair.checked do
								(
									--	if there is perfect match of centers of BBox
									if centerMatch.count != 0 then
										corespondingLPtoHP.items = centerMatch
									else
									(	--	if no perfect center match but have wrong HP object in volume of one LP
										if haveInVolumeLPname.count == 1 then
											corespondingLPtoHP.items = haveInVolumeLPname
										else
										(	--	if no perfect match and no wrong HP in volume of LP
											if centerMatchR.count == 1 then	--	if there is single LP in radius of 10 %
												corespondingLPtoHP.items = centerMatchR
											else
											(	--	if there is more than one LP in radius of 10 % and there is more than one LP with wrong HP in theier volume
												if centerMatchR.count >1 then
												(	--	delete twin names
													for i = 1 to centerMatchR.count do
													(
														for o = haveInVolumeLPname.count to 1 by -1 do
														(
															if (findString centerMatchR[i] haveInVolumeLPname[o]) != undefined do
																deleteItem haveInVolumeLPname o
														)
													)
													join centerMatchR haveInVolumeLPname
													corespondingLPtoHP.items = centerMatchR
												)
												else
												(
													if haveInVolumeLPname.count > 1 then
														corespondingLPtoHP.items = haveInVolumeLPname
													else
														corespondingLPtoHP.items = BBoxLPname
												)
											)
										)
									)
								)
								if chkbox_StringCompair.checked and chkbox_PosCompair.checked do
								(
									bothMethod = #() as array
									if correspondingLPnames.count != 0 then
									(
										if BBoxLPname.count != 0 then
										(	--	if two arrays is not empty
											for o = correspondingLPnames.count to 1 by -1 do
											(
												if (findItem BBoxLPname correspondingLPnames[o]) == true do
													deleteItem BBoxLPname o
											)
											bothMethod = join BBoxLPname correspondingLPnames
										)
										else								
											bothMethod = correspondingLPnames
									)
									else
									(	--	if corresponding LPnames is empty then
										if BBoxLPname.count != 0 then
										(	--	if BBox is not empty
											bothMethod = BBoxLPname
										)
										else
											bothMethod = #() as array
									)							
								)
								--	select highlighted HP object in viewport
								if chkbox_Color.checked do
								(
									clearSelection()
									selectedObj =  (getNodeByName HPwithWrongName.items[nameIndex])
									select selectedObj
									local selHP = selectedObj
									--	store old material
									dataSelHP = for o in selHP collect #(o, o.material)	
									--	applay new material	
									selHP.material = standardMaterial diffuse:(color 146 0 0) ambient:(color 146 0 0) selfIllumAmount: 50.0 showInViewport:true
								)
								if chkbox_Select.checked do
								(	
									clearSelection()
									select (getNodeByName HPwithWrongName.items[nameIndex])	
								)
								if chkbox_Zoom.checked do
								(		
									clearSelection()
									select (getNodeByName HPwithWrongName.items[nameIndex])	
									max tool zoomextents	all						
								)
							)			
							on corespondingLPtoHP selected nameIndex do
							(
								if dataSelLP.count != 0 do
								(
									for d in dataSelLP do d[1].material = d[2]
									dataSelLP = #() as array
								)
								if chkbox_Color.checked do
								(
									clearSelection()
									selectedObj =  (getNodeByName corespondingLPtoHP.items[nameIndex])
									select selectedObj
									--	store old material
									dataSelLP = for o in selectedObj collect #(o, o.material)	
									--	applay new material	
									selectedObj.material = standardMaterial diffuse:(color 146 0 0) ambient:(color 146 0 0) selfIllumAmount: 50.0 showInViewport:true
								)
								if chkbox_Select.checked do
								(	
									clearSelection()
									select (getNodeByName corespondingLPtoHP.items[nameIndex])
								)
								if chkbox_Zoom.checked do
								(		
									clearSelection()
									select (getNodeByName corespondingLPtoHP.items[nameIndex])
									max tool zoomextents	all						
								)
							)
							--	rename with mouse double click
							on corespondingLPtoHP doubleClicked nameIndex do
							with undo "Rename Object" on
							(
								if corespondingLPtoHP.selection != 0 then
								(
									if chkbox_mainPrefix.checked == on do
									(	
										prefixNameHPO = prefixNameHP
										prefixNameLPO = prefixNameLP
									)
									if chkbox_addPrefix.checked == on do
									(	
										prefixNameHPO = prefixNameHPAdd
										prefixNameLPO = prefixNameLPAdd
									)
									--	rename objects with more than desired face count
									if toSelect.count != 0 then
									(
										tempItems = corespondingLPtoHP.items
										local indexLPautoR = corespondingLPtoHP.selection	--	integer
										local nameLPautoR = (corespondingLPtoHP.items[indexLPautoR])	--	string
										prefixNameLPNumb = prefixNameLPO.count
										local lowName_TrimmedAR = replace nameLPautoR 1 prefixNameLPNumb ""
										highName_TrimmedAR = prefixNameHPO + lowName_TrimmedAR
										LPnameToChange = (getNodeByName corespondingLPtoHP.items[indexLPautoR])
										LPnameToChange.name = highName_TrimmedAR
										deleteItem tempItems indexLPautoR
										corespondingLPtoHP.items = tempItems
										if tempItems.count == 1 do
										(
											lb1.text = "This object have more than "+(miauuRTTassist.spn_faces_threshold.text as string)+" faces.May be it is a HP"	--	"This object is propably a HP object.Double click to rename"
											lb2.text = "object.Double click to rename it correctly or press the"
											lb3.text = "\"Delete\" button to remove it from the list."
										)
										if tempItems.count == 0 do
										(
											lb1.text = "Choose miss-writen object to Display suggestions for its match."
											lb2.text = "Double click the correct name to rename both objects in the pair."
											toSelect = #() as array
											btn_DelLP.pos = [-50,-68]
											btn_delSingleHP.pos = [50,215]
											corespondingLPtoHP.pos = [168,50]
											HPwithWrongName.pos = [6,50]
											HPwithWrongName.items = HPnames
										)
									)
									else
									(
										tempItems = HPwithWrongName.items
										--	get two selected names
										local indexLPautoR = corespondingLPtoHP.selection	--	integer
										local indexHPautoR = HPwithWrongName.selection		--	integer
										local nameLPautoR = (corespondingLPtoHP.items[indexLPautoR])	--	string
										local nameHPautoR = (HPwithWrongName.items[indexHPautoR])	--	string
										--	delete the prefixes of selected names
										prefixNameLPNumb = prefixNameLPO.count
										prefixNameHPNumb = prefixNameHPO.count
										local lowName_TrimmedAR = replace nameLPautoR 1 prefixNameLPNumb ""
										local highName_TrimmedAR = replace nameHPautoR 1 prefixNameHPNumb ""
										--	make HP name to match to LP name
										highName_TrimmedAR = prefixNameHPO + lowName_TrimmedAR
										--	rename HP object with new corrected name
										HPnTc =HPwithWrongName.selection
										HPnameToChange = (getNodeByName HPwithWrongName.items[HPnTc])
										HPnameToChange.name = highName_TrimmedAR
										--	clear LP listbox
										corespondingLPtoHP.items = #()
										--	update HP listbox
										deleteItem tempItems HPnTc
										HPwithWrongName.items = tempItems
									)
								)
							)						
							--	dynamicaly change the LP listbox when "by Pos-by Name" changing its state
							on HPwithWrongName doubleClicked nameIndex do
							with undo "Rename Object" on
							(
								if corespondingLPtoHP.selection != 0 then
								(
									if chkbox_mainPrefix.checked == on do
									(	
										prefixNameHPO = prefixNameHP
										prefixNameLPO = prefixNameLP
									)
									if chkbox_addPrefix.checked == on do
									(	
										prefixNameHPO = prefixNameHPAdd
										prefixNameLPO = prefixNameLPAdd
									)
									tempItems = HPwithWrongName.items
									--	get two selected names
									local indexLPautoR = corespondingLPtoHP.selection
									local indexHPautoR = HPwithWrongName.selection
									local nameLPautoR = (corespondingLPtoHP.items[indexLPautoR])
									local nameHPautoR = (HPwithWrongName.items[indexHPautoR])
									prefixNameLPNumb = prefixNameLPO.count
									prefixNameHPNumb = prefixNameHPO.count
									--	delete the prefixes of selected names
									local lowName_TrimmedAR = replace nameLPautoR 1 prefixNameLPNumb ""
									local highName_TrimmedAR = replace nameHPautoR 1 prefixNameHPNumb ""
									--	make LP name to match to HP name
									lowName_TrimmedAR = prefixNameLPO + highName_TrimmedAR
									--	rename HP object with new corrected name
									LPnTc =corespondingLPtoHP.selection
									HPnTc = HPwithWrongName.selection
									LPnameToChange = (getNodeByName corespondingLPtoHP.items[LPnTc])
									LPnameToChange.name = lowName_TrimmedAR
									--	clear LP listbox
									corespondingLPtoHP.items = #()
									--	update HP listbox
									deleteItem tempItems HPnTc
									HPwithWrongName.items = tempItems
								)
							)
							--	delete HP name from listbox - for max2010 and up
							on HPwithWrongName rightClick nameIndex do
							(
									tempItems = HPwithWrongName.items
									HPnTc = HPwithWrongName.selection
									deleteItem tempItems HPnTc
									HPwithWrongName.items = tempItems
							)
							--	delete objects with right click from "by face count" listbox
							on corespondingLPtoHP rightClick nameIndex do
							(
								tempItems = corespondingLPtoHP.items
								LPnTc = corespondingLPtoHP.selection
								deleteItem tempItems LPnTc
								corespondingLPtoHP.items = tempItems
								if tempItems.count == 1 do
								(
									lb1.text = "This object have more than "+(miauuRTTassist.spn_faces_threshold.text as string)+" faces.May be it is a HP"	--	"This object is propably a HP object.Double click to rename"
									lb2.text = "object.Double click to rename it correctly or press the"
									lb3.text = "\"Delete\" button to remove it from the list."
								)
								if tempItems.count == 0 do
								(
									lb1.text = "Choose miss-writen object to Display suggestions for its match."
									lb2.text = "Double click the correct name to rename both objects in the pair."
									toSelect = #() as array
									btn_DelLP.pos = [-50,-68]
									btn_delSingleHP.pos = [50,215]
									corespondingLPtoHP.pos = [168,50]
									HPwithWrongName.pos = [6,50]
									HPwithWrongName.items = HPnames
								)							
							)
							--	delete single HP objects from HP's listbox - for max2009 and below
							on btn_delSingleHP pressed do
							(
								tempItems = HPwithWrongName.items
								HPnTc = HPwithWrongName.selection
								if HPnTc != 0 do
									deleteItem tempItems HPnTc
								HPwithWrongName.items = tempItems
							)

							on btn_DelLP pressed do
							(
								tempItems = corespondingLPtoHP.items
								LPnTc = corespondingLPtoHP.selection
								if LPnTc != 0 do
									deleteItem tempItems LPnTc
								corespondingLPtoHP.items = tempItems
								if tempItems.count == 1 do
								(
									lb1.text = "This object have more than "+(miauuRTTassist.spn_faces_threshold.text as string)+" faces.May be it is a HP"	--	"This object is propably a HP object.Double click to rename"
									lb2.text = "object.Double click to rename it correctly or press the"
									lb3.text = "\"Delete\" button to remove it from the list."
								)
								if tempItems.count == 0 do
								(
									lb1.text = "Choose miss-writen object to Display suggestions for its match."
									lb2.text = "Double click the correct name to rename both objects in the pair."
									toSelect = #() as array
									btn_DelLP.pos = [-50,-68]
									btn_delSingleHP.pos = [50,215]
									corespondingLPtoHP.pos = [168,50]
									HPwithWrongName.pos = [6,50]
									HPwithWrongName.items = HPnames
								)							
							)
							--	delete with mouse right click - FOR MAX 2010 and up
							on chkbox_StringCompair changed theState do
							(
								if theState == true then
									corespondingLPtoHP.items = correspondingLPnames
								else
								(
									if chkbox_PosCompair.state == on then
									(
										if centerMatch.count != 0 then
											corespondingLPtoHP.items = centerMatch
										else
											corespondingLPtoHP.items = BBoxLPname
									)
									else
									(
										chkbox_StringCompair.state = on
										corespondingLPtoHP.items = #()
									)
								)
							)
							on chkbox_PosCompair changed theState do
							(
								if theState == true then
								(
									if centerMatch.count != 0 then
										corespondingLPtoHP.items = centerMatch
									else
										corespondingLPtoHP.items = BBoxLPname
								)	
								else
								(
									if chkbox_StringCompair.state == on then
										corespondingLPtoHP.items = correspondingLPnames
									else
									(
										corespondingLPtoHP.items = #()
										chkbox_PosCompair.state = on
									)
								)
							)
							on  chkbox_Color changed theState do
							(
								if theState then
								()
								else
								(
									if dataSelHP.count != 0 do
										for d in dataSelHP do d[1].material = d[2]

									if dataSelLP.count != 0 do
										for d in dataSelLP do d[1].material = d[2] 
								)
							)
							on miauuCompairNames lbuttondown pos do
							(
								if dataSelHP.count != 0 do
									for d in dataSelHP do d[1].material = d[2]

								if dataSelLP.count != 0 do
									for d in dataSelLP do d[1].material = d[2] 
							)
							on miauuCompairNames close do
							(
								--	apply original material to last selected HP object
								if dataSelHP.count != 0 do
									for d in dataSelHP do d[1].material = d[2]
								--	apply original material to last selected LP object
								if dataSelLP.count != 0 do
									for d in dataSelLP do d[1].material = d[2]
										
								--	if Implode mode is active
								if isImplodeActive == 1 then
								(
									--	turn on Implode button
									explodeImplodeImgTagState = 0
									GetProperObj()
									--	store position of all objects including renamed one
									if CheckObjAndPrefixLP() == true and CheckObjAndPrefixHP() == true do
									(
										allObjInScene = for obj in objects where classof obj != Biped_Object and superClassOf obj != helper collect obj
										startingObjPos = for i = 1 to  allObjInScene.count collect allObjInScene[i].center
										explodeImplodeImgTagState == 0
										miauuRTTassist.ImgTag_ExplodeImplode.bitmap = (openBitmap (url+"miauuITexplode.png"))
										miauuRTTassist.ImgTag_ExplodeImplode.tooltip = "LMB to explode the scene using default settings!\nAlt + LMB to turn on \"EXPLODE\"mode!\nCtrl+LMB to explode without animation!\nShift+LMB to explode without automaticaly checks\nfor overpalled objects!"
										GetProperObj()
									)
									--	return objects to their position before opening CompareNames
									miauuRTTassist.ExplodeObjPrep explodeMultiplier 1.03 1
									dNetTBasSpn = explodeMultiplier
									miauuRTTassist.dNet_TxtBoxAsSpinner.text = (explodeMultiplier as string)
								)
								BBoxLP = #() as array
								BBoxLPname = #() as array
								pairsNamesNoPrefixHP = #() as array
								HPnames = #() as array
								pairsNamesNoPrefixHPAdd = #() as array
								HPnamesAdd = #() as array		
								LPtoHP = #() as array
								correspondingLPnames = #() as array
								for aControl in miauuCompairNames.controls do
								(
									case classof aControl of
									(
										CheckBoxControl: setIniSetting miauuIniFile "Checkbox" (aControl.name as string) (aControl.state as string)
									)
								)
							)
						)
						createDialog miauuCompairNames
					)
				)
				else
				(
					errMssg = 1
					ErrorMessage 1
				)
			)
		)
		on btn_CompareName mouseover  do
		(
			btn_CompareName.bitmap = (openBitmap (url+"miauuITnamesHover.png"))
		)
		on btn_CompareName mouseout  do
		(
			btn_CompareName.bitmap = (openBitmap (url+"miauuITnames.png"))
		)
------------------------------------
	--	Add Projection modifier
------------------------------------
		function ImportAndDeleteCage delImp =
		(	--	import the cage of all or selected LP objects and delete it
			WM_SETREDRAW=0xB
			commandHWND = windows.getChildHWND #max "Command Panel"	 
			windows.sendmessage commandHWND[1]  WM_SETREDRAW 0 0
			local exportedOnly = undefined
			objAndCageArr = #()
			local allObjWithProjMod = undefined
			if isSelectObj == 1 then
				allObjWithProjMod = selObjWithProjMod
			else
				allObjWithProjMod = FindObjWithProjMod()
			
			local prefixNameLPNumb = prefixNameLP.count
			--	import the cage of each object
			if allObjWithProjMod.count != 0 then
			(
				for o in allObjWithProjMod do
				(
					select o
					local lowName_Trimmed = replace o.name 1 prefixNameLPNumb ""
					-- get the High-poly name
					local cageName = "CG_" + lowName_Trimmed
					--	find the proper cage
					curObjChildren = o.children
					for child in curObjChildren where child.name == cageName do
					(
						if delImp == 0 then
						(--	delete only
							delete child
							exportedOnly = 1
						)
						else
						(
							o.modifiers[#Projection].importCage child
							delete child
							exportedOnly = 2
						)
					)
				)
				exportImportCage = 0	--	means that the cages are imported and deleted
				if exportedOnly == 1 then
				(
					errMssg = 62
					ErrorMessage 62
				)
				else
				(
					errMssg = 61
					ErrorMessage 61
				)
			)
			else
			(
				errMssg = 15	--	"There are no objects in the scene with applied Projection modifier !"
				ErrorMessage 15
			)
			windows.sendmessage commandHWND[1]  WM_SETREDRAW 1 0
			
		)
		--	rollout to show LP+HP groups
		rollout showLPandHPgroupsWithProj "Projections list"
		(	
			dotNetControl treeView "System.Windows.Forms.TreeView" pos:[0,0] width:150 height:170 align:#center
			radiobuttons rb_projListOrCageList "" labels:#("projection list","cages list ") pos:[0,175] default:1 columns:2
			button btn_expand "Expand All" pos:[0,195]
			button btn_collapse "Collapse All" pos:[75,195]				
				
			function FillTreeView =
			(
				treeView.Nodes.Clear()
				treeView.sorted = true
				treeView.scrollable = true
				treeView.backcolor = (dotNetClass "System.Drawing.Color").DimGray
				treeView.forecolor = (dotNetClass "System.Drawing.Color").lightGray	
				allLPwithProjInScene = miauuRTTassist.FindObjWithProjMod()
				allCagesInScene = miauuRTTassist.objAndCageArr
				if rb_projListOrCageList.state == 1 then
				(--	show the reference list
					for o in allLPwithProjInScene do
					(
						geomNodes = o.modifiers[#Projection].geomNodes
						nodeLPhandle = (GetHandleByAnim o)
						nodeLP = dotNetObject "System.Windows.Forms.TreeNode" (((GetAnimByHandle nodeLPhandle).name) + " ("+(geomNodes.count as string)+")")
						
						for g in geomNodes do
						(
							hpName = dotNetObject "System.Windows.Forms.TreeNode" (g.name)
							nodeLP.Nodes.Add hpName
							hpName.tag = dotNetMXSValue g
						)
						treeView.Nodes.Add  nodeLP
						nodeLP.tag = dotNetMXSValue o
					)
				)
				else
				(--	show the cages list
					for i = 1 to allCagesInScene.count do
					(
						lpObj = allCagesInScene[i][1]
						cgObj =allCagesInScene[i][2]
						nodeLPhandle = (GetHandleByAnim lpObj)
						nodeLP = dotNetObject "System.Windows.Forms.TreeNode" ( (GetAnimByHandle nodeLPhandle).name )
						
						hpName = dotNetObject "System.Windows.Forms.TreeNode" (cgObj.name)
						nodeLP.Nodes.Add hpName
						hpName.tag = dotNetMXSValue (cgObj)
						
						treeView.Nodes.Add  nodeLP
						nodeLP.tag = dotNetMXSValue lpObj
					)
					
				)
			)
			on showLPandHPgroupsWithProj open do
			(
				FillTreeView()
			)
			on rb_projListOrCageList changed theState do
			(
				FillTreeView()
				if theState == 1 then
					showLPandHPgroupsWithProj.title = "Projections list"
				else
					showLPandHPgroupsWithProj.title = "Cages list"
			)
			on treeView mouseClick arg do
			(
				hitNode = treeView.GetNodeAt (dotNetObject "System.Drawing.Point" arg.x arg.y)
				if hitNode != undefined do
				(
					try(select hitNode.tag.value)catch(max select none)
				)
			)
			
			on btn_expand pressed do
			(
				treeView.ExpandAll()
			)
			on btn_collapse pressed do
			(
				treeView.CollapseAll()
			)
			on showLPandHPgroupsWithProj resized Point2 do
			(
				local ro_size = GetDialogSize showLPandHPgroupsWithProj
				treeView.width = ro_size[1]
				treeView.height = ro_size[2] - 50
				rb_projListOrCageList.pos = [0,(ro_size[2]-45)]
				btn_expand.pos = [0,(ro_size[2]-25)]
				btn_collapse.pos = [75,(ro_size[2]-25)]
				
				if showLPandHPgroupsWithProj.width < 150 do showLPandHPgroupsWithProj.width = 150
				if showLPandHPgroupsWithProj.height < 220 do showLPandHPgroupsWithProj.height = 220
			)
		)
		--	rollout for existing exported cages
		rollout rol_ExportedCageFound ""
		(
			label lbl_expCageFound "Exported cage found. What you want to do?" pos:[5,5]
			button btn_impAndDel "Import and Delete" pos:[5,30]  height:24
			button btn_delete "Delete" pos:[110,30]  height:24
			button btn_cancel "Cancel" pos:[160,30] height:24
			
			--	import cages and delete them
			on btn_impAndDel pressed do
			(				
				miauuRTTassist.ImportAndDeleteCage 1
				destroyDialog rol_ExportedCageFound
			)
			--	only delete cages, don't import them
			on btn_delete pressed do
			(				
				miauuRTTassist.ImportAndDeleteCage 0
				destroyDialog rol_ExportedCageFound
			)
			
			on btn_cancel pressed do
			(
				miauuRTTassist.isCanceled = true
				miauuRTTassist.exportImportCage = 0
				destroyDialog rol_ExportedCageFound
			)
		)
		--	add projection modifier
		on btn_AddProjMod lbuttonup do
		with undo "Add Projection Mod" on
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/The__Project__button.htm"
				shellLaunch "hh" goToHelp
			)
			else
			(
				GetProperObj()
				if keyboard.altPressed then
					skipInstances = 1
				else
					skipInstances = 0
				--	add Projection Modifier				
				if prefixNameLP != undefined and prefixNameHP != undefined then
				(
					if CheckObjAndPrefixLP() == true do
						AddProjMain()
				)
				else
				(
					errMssg = 1
					ErrorMessage 1
				)
				
				if prefixNameLPAdd != undefined and prefixNameHPAdd != undefined do
				(
					if CheckObjAndPrefixLP() == true do
						AddProjMainAdd()
				)
			)
		)
		--	remove projetion modifier
		on btn_AddProjMod rbuttonup do
		with undo "Remove Projection Mod" on
		(
			DestroyPresetRollout()
			try(destroyDialog showLPandHPgroupsWithProj)catch()
			objSel = GetProperObj()
			selOPR = GetProperObj()
			if chkbox_isNodeFrozen.state == off then
			(
				selOPR = #() as array
				for s in objSel where s.isFrozen != true do
					append selOPR s
			)
			if prefixNameLP != undefined and prefixNameHP != undefined then
			(
				if CheckObjAndPrefixLP() == true do
				(
					currCmndPanelMode = getCommandPanelTaskMode()
					setCommandPanelTaskMode mode:#create
					for s  in selOPR do
					(
						--	remove Projection from objects with main prefix
						if ((findString s.name prefixNameLP) != undefined) do
						(
							isThereModifierPrj = s.modifiers
							if isThereModifierPrj.count != 0 do
							(	
								for m = 1 to isThereModifierPrj.count do
								(
									if (classof isThereModifierPrj[m]) == Projection do
										deleteModifier s m
								)
							)
						)						
						--	remove Projection from objects with additional prefix
						if prefixNameLPAdd != undefined do
						(
							if ((findString s.name prefixNameLPAdd) != undefined) do
							(
								isThereModifierPrj = s.modifiers
								if isThereModifierPrj.count != 0 do
								(	
									for m = 1 to isThereModifierPrj.count do
									(
										if (classof isThereModifierPrj[m]) == Projection do
											deleteModifier s m
									)
								)
							)
						)
					)
					setCommandPanelTaskMode mode:currCmndPanelMode
					ErrorMessage 51
				)					
			)
			else
			(
				errMssg = 1
				ErrorMessage 1
			)
		)
		--	show Projection modifier reference list
		on btn_AddProjMod mbuttonup  do
		(
			try(destroyDialog showLPandHPgroupsWithProj)catch()
			if keyboard.controlPressed then
			(
				SwitchToModPannel()
				--	stop the flickering of the modify pannep - credits to DenisT
				WM_SETREDRAW=0xB
				commandHWND = windows.getChildHWND #max "Command Panel"	 
				windows.sendmessage commandHWND[1]  WM_SETREDRAW 0 0
				case exportImportCage of
				(
					0:
					(--	export the cage of all or selected LP objects
						--	collect all objects with projection modifier
						local allObjWithProjMod = FindObjWithProjMod()
						if isSelectObj == 1 do selObjWithProjMod = allObjWithProjMod
						local prefixNameLPNumb = prefixNameLP.count
						local exportedOnly = false
						--	export the cage of each object
						if allObjWithProjMod.count != 0 then
						(							
							isCanceled = false
							for o in allObjWithProjMod while isCanceled == false do
							(
								select o
								--	clear the prefix of the LP name				
								local lowName_Trimmed = replace o.name 1 prefixNameLPNumb ""
								-- get the High-poly name
								local cageName = "CG_" + lowName_Trimmed
								--	check for existing exported cages
								local curObjChildren = o.children
								local expCage = undefined
								if (expCage = (for child in curObjChildren where child.name == cageName collect child)).count != 0 then
								(
									--	show messagebox with "Import and Delete", "Delete" and "Cancel" button
										createdialog rol_ExportedCageFound width:220
								)
								else
								(
									--	export the cage as separate Editable_Poly object
									o.modifiers[#Projection].exportCage cageName
									--	get the cage
									cageNode = for obj in geometry where obj.isHidden == false and classof obj == Editable_Poly and obj.name == cageName collect obj
									if cageNode.count == 1 then
									(--	there is only one LP object with that name, so there is only one cage Node with that name
										--	make the cage unrenderable
										cageNode[1].renderByLayer = false
										cageNode[1].renderable = false
										--	link the cage to the LP object
										cageNode[1].parent = o
										--	store the object and it cage
										append objAndCageArr #(o,cageNode[1])
									)
									else
									(--	there are two or more LP objects with that name, so .....
										for cN in cageNode where cN.pos == o.pos do
										(
											--	make the cage unrenderable
											cN.renderByLayer = false
											cN.renderable = false
											--	link the cage to the LP object
											cN.parent = o
											--	store the object and it cage
											append objAndCageArr #(o,cN)
										)
									)
									exportedOnly = true
								)	
							)
							exportImportCage = 1	--	means that the cages are exported
							if exportedOnly == true do
							(
								errMssg = 59	--	"the projection modifier cages are exported"
								ErrorMessage 59
							)
						)
						else
						(
							errMssg = 15	--	"There are no objects in the scene with applied Projection modifier !"
							ErrorMessage 15
						)
					)
					1:
					(	--	import the cage of all or selected LP objects and delete it
						ImportAndDeleteCage 1
						errMssg = 60	--	"Theprojection modifier cages are imported!"
						ErrorMessage 60
					)
				)
				windows.sendmessage commandHWND[1]  WM_SETREDRAW 1 0
			)
			else
			(					
				local roWidth = 150
				local roHeight = 220
				
				local roPos = GetDialogPos miauuRTTassist
				if roPos.x <= (sysinfo.desktopSize.x - 437) then
					roPos.x = roPos.x+237
				else
					roPos.x = roPos.x-150
				createDialog showLPandHPgroupsWithProj roWidth roHeight roPos.x roPos.y \
					style:#(#style_titlebar, #style_sysmenu, #style_resizing)						
			)
		)
		on btn_AddProjMod mouseover do
		(
			btn_AddProjMod.bitmap = (openBitmap (url+"miauuITprojHover.png"))
		)
		on btn_AddProjMod mouseout do
		(
			btn_AddProjMod.bitmap = (openBitmap (url+"miauITProj.png"))
		)
-----------------------------------------------		
	--	Update the Projectiom Modifier Cage 
-----------------------------------------------
		function FindProjMod objArr =
		(
			local allLPwithProjInScene = #() as array
			currCmndPanelMode = getCommandPanelTaskMode()
			setCommandPanelTaskMode mode:#create
			for s  in objArr do
			(
				--	find objects with  Projection modifier					
				isThereModifierPrj = s.modifiers
				if isThereModifierPrj.count != 0 do
				(	
					for m = 1 to isThereModifierPrj.count do
					(
						if (classof isThereModifierPrj[m]) == Projection do
							append allLPwithProjInScene s
					)
				)
			)
			setCommandPanelTaskMode mode:currCmndPanelMode
			
			allLPwithProjInScene
		)
		function FindObjWithProjMod =
		(
			selOPR = #()
			
			if chkbox_isNodeFrozen.state == off then
			(
				if allObjITState == 1 do
				(
					selOPR = for o in objects where classof o != Biped_Object  and superClassOf o != helper and not o.isFrozen collect o
				)
				if visibleObj == 1 do
				(
					selOPR = for o in objects where classof o != Biped_Object  and superClassOf o != helper and o.isHidden == false and not o.isFrozen collect o
				)
				if isSelectObj == 1 do
				(
					selOPR = for o in selection where classof o != Biped_Object  and superClassOf o != helper and o.isHidden == false and not o.isFrozen collect o
				)
			)
			else
			(
				if allObjITState == 1 do
					selOPR = for o in objects where classof o != Biped_Object  and superClassOf o != helper collect o
				if visibleObj == 1 do
					selOPR = for o in objects where classof o != Biped_Object  and superClassOf o != helper and o.isHidden == false collect o
				if isSelectObj == 1 do
					selOPR = for o in selection where classof o != Biped_Object  and superClassOf o != helper collect o
			)
			
			allLPwithProjInScene = FindProjMod selOPR
		)
		--	set the cage push amount
		function SetPushAmount objArr cageVal =
		(
			WM_SETREDRAW=0xB
			commandHWND = windows.getChildHWND #max "Command Panel"	 
			windows.sendmessage commandHWND[1]  WM_SETREDRAW 0 0
			for o in objArr do
			(
				select o
				$.modifiers[#Projection].pushCage cageVal
			)
			windows.sendmessage commandHWND[1]  WM_SETREDRAW 1 0
		)
		--	dotNet spinner event
		function CageAmountSpinnerEvent =
		(
			local val = (dNet_cagePushSpinner.text as float)
			objWithProjMod = FindObjWithProjMod()
			if objWithProjMod.count != 0 then
			(
				currCmndPanelMode = getCommandPanelTaskMode()								
				setCommandPanelTaskMode mode:#modify
				SetPushAmount objWithProjMod val
				setCommandPanelTaskMode mode:currCmndPanelMode
			)
			else
			(
				errMssg = 15
				ErrorMessage 15
			)
		)
		on dNet_cagePushSpinner KeyUp s e do 
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				if dNet_cagePushSpinner.text != undefined do
				(
					CageAmountSpinnerEvent()
				)
				dNet_cagePushSpinner.text = "0.0"
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				if dNet_cagePushSpinner.text != undefined do
				(
					CageAmountSpinnerEvent()
				)
				dNet_cagePushSpinner.text = "0.0"
			)
		)

		on  dNet_cagePushSpinner LostFocus e do
		(
			if dNet_cagePushSpinner.text != undefined do
			(
				dNet_cagePushSpinner.text = "0.0"
			)
			
		) 
		on btn_cagePushSpinnerUP lbuttondown do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/The__Project__button.htm#projspinner"
				shellLaunch "hh" goToHelp
			)
			else
			(
				DestroyPresetRollout()

				dNet_cagePushSpinner.text = ((dNet_cagePushSpinner.text as float) + 0.01) as string				
				
					objWithProjMod = FindObjWithProjMod()
				if objWithProjMod.count != 0 then
				(
					currCmndPanelMode = getCommandPanelTaskMode()								
					setCommandPanelTaskMode mode:#modify
					SetPushAmount objWithProjMod 0.01
					setCommandPanelTaskMode mode:currCmndPanelMode
				)
				else
				(
					errMssg = 15
					ErrorMessage 15
				)
			)
		)
		on btn_cagePushSpinnerDown lbuttondown do
		(	
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/The__Project__button.htm#projspinner"
				shellLaunch "hh" goToHelp
			)
			else
			(
				DestroyPresetRollout()

				dNet_cagePushSpinner.text = ((dNet_cagePushSpinner.text as float) - 0.01) as string			
				
				if (dNet_cagePushSpinner.text as float) < 0.0 then 
					dNet_cagePushSpinner.text = "0.0"
				
				objWithProjMod = FindObjWithProjMod()
				if objWithProjMod.count != 0 then
				(
					currCmndPanelMode = getCommandPanelTaskMode()								
					setCommandPanelTaskMode mode:#modify
					SetPushAmount objWithProjMod -0.01
					setCommandPanelTaskMode mode:currCmndPanelMode
				)
				else
				(
					errMssg = 15
					ErrorMessage 15
				)
			)
		)
		--	set spinner value to zero and reset the cage
		on btn_cagePushSpinnerDown rbuttonup do
		(			
			DestroyPresetRollout()
			dNet_cagePushSpinner.text = "0.0"
			objWithProjMod = FindObjWithProjMod()
			if objWithProjMod.count != 0 then
			(
				currCmndPanelMode = getCommandPanelTaskMode()								
				setCommandPanelTaskMode mode:#modify
				WM_SETREDRAW=0xB
				commandHWND = windows.getChildHWND #max "Command Panel"	 
				windows.sendmessage commandHWND[1]  WM_SETREDRAW 0 0	
				for o in objWithProjMod do
				(
					select o
					$.modifiers[#Projection].resetCage()
				)
				windows.sendmessage commandHWND[1]  WM_SETREDRAW 1 0
				setCommandPanelTaskMode mode:currCmndPanelMode
			)
			else
			(
				errMssg = 15
				ErrorMessage 15
			)
		)
		--	equivalent to pressing the UPDATE button in autoWrap group
		function ProjCageAutoWrap =
		(
			dNet_cagePushSpinner.text = "0.0"
			objWithProjMod = FindObjWithProjMod()
			if objWithProjMod.count != 0 then
			(
				currCmndPanelMode = getCommandPanelTaskMode()								
				setCommandPanelTaskMode mode:#modify
				WM_SETREDRAW=0xB
				commandHWND = windows.getChildHWND #max "Command Panel"	 
				windows.sendmessage commandHWND[1]  WM_SETREDRAW 0 0
				for o in objWithProjMod do
				(
					select o
					$.modifiers[#Projection].autowrapCage()
				)
				windows.sendmessage commandHWND[1]  WM_SETREDRAW 1 0
				setCommandPanelTaskMode mode:currCmndPanelMode
			)
			else
			(
				errMssg = 15
				ErrorMessage 15
			)
		)
		on btn_cagePushSpinnerDown mbuttonup do
		(
			DestroyPresetRollout()
			ProjCageAutoWrap()
		)
		on btn_cagePushSpinnerUP mbuttonup do
		(
			DestroyPresetRollout()
			ProjCageAutoWrap()
		)
-----------------------------------
	--	show SelectionSets rollout
-----------------------------------
		on chkbox_selSets changed theState do
		(
			DestroyPresetRollout()
			if theState then
			(
				rollout rol_SelectionSets "RTTAssist Selection Sets Baking"
				(
					local selectionSetsIndexes = #()
					local curSelSet = undefined
					local lbBackColor = (dotNetClass "System.Drawing.Color").DimGray
					local lbForeColor = (dotNetClass "System.Drawing.Color").lightGray

					button btn_checkAll "Check All" pos:[10,5] width:85 height:20
					button btn_uncheckAll "Uncheck All" pos:[105,5] width:85 height:20
					dotNetControl lv "system.windows.forms.listView" height:150 width:190 pos:[5,30]
					button btn_saveSelection "OK" pos:[40,185] width:120 height:30
					
					function AddColumns theLv columnsAr=
					(
						w=(theLv.width)-6
						for x in columnsAr do
						(
							theLv.columns.add x w
						)
					)
					function PopulateListView theLv=
					(
						rows=#()
						for x=1 to curSelSet.count do
						(
							li=dotNetObject "System.Windows.Forms.ListViewItem" curSelSet[x].name
							append rows li
						)
						theLv.items.addRange rows 
					)
					function InitListView theLv=
					(
						
						lv.clear()
						theLv.view=(dotNetClass "system.windows.forms.view").details
						theLv.FullRowSelect=true
						theLv.MultiSelect=true
						theLv.checkBoxes=true			
						theLv.backcolor = lbBackColor
						theLv.forecolor = lbForeColor
					)
					
					on rol_SelectionSets open do
					(
						curSelSet = selectionSets
						InitListView lv
						AddColumns lv #("Selection Sets")
						PopulateListView lv
						selectionSetsIndexes = #()
					)
					
					on lv ItemChecked itemCheckedEventArgs do
					(		
						local listViewItem = itemCheckedEventArgs.item
						local index = listViewItem.index

						if (i = (findItem selectionSetsIndexes index)) != 0 then
							deleteItem selectionSetsIndexes i
						else
							appendIfUnique selectionSetsIndexes index
					)
					on btn_checkAll pressed do
					(--	check all checkboxes
						for i = 0 to lv.Items.count-1 do
							lv.Items.Item[i].checked = true
					)
					on btn_uncheckAll pressed do
					(--	uncheck all checkoxes in listview
						for i = 0 to lv.Items.count-1 do
							lv.Items.Item[i].checked = false
					)
					--	collect all selectionSets that user wants to bake
					on btn_saveSelection pressed do
					(
						if selectionSetsIndexes.count != 0 then
						(
							for i=1 to selectionSetsIndexes.count do
							(
								selectionSetsIndexes[i] = selectionSetsIndexes[i]+1
							)
							sort selectionSetsIndexes
							miauuRTTassist.useSelectionSets = true
							destroyDialog rol_SelectionSets
						)
						else
							messagebox "Select some selection sets!" title:"RTTAssist ERROR!!!"
					)
					on rol_SelectionSets resized Point2 do
					(
						local ro_size = GetDialogSize rol_SelectionSets
						lv.width = ro_size[1] - 2
						lv.height = ro_size[2] - 65
						btn_saveSelection.pos = [40,(ro_size[2] - 30)]
						if rol_SelectionSets.width < 200 do rol_SelectionSets.width = 200
						if rol_SelectionSets.height < 220 do rol_SelectionSets.height = 220
					)
				)
				createdialog rol_SelectionSets width:200 height:220 \
					style:#(#style_titlebar, #style_sysmenu, #style_resizing, #style_toolwindow) lockWidth:true
			)
			else
			(
				try(destroyDialog rol_SelectionSets)catch()
				--	reset the using of selectionsets
				useSelectionSets = false
			)
		)
		on lb_selSets lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed do
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+":://Render_Selection_Sets.htm#sel_sets"
				shellLaunch "hh" goToHelp
			)
		)
-------------------------------------------------
	--	Prepare objects for rendering
-------------------------------------------------
		--	load presets for Smart system
		function LoadSmartPreset impUnimp =
		(
			pathToPresets = (getIniSetting miauuIniFile "Smart" (impUnimp)) as string
			pathToPresetsRPS = (getIniSetting miauuIniFile "Smart" (impUnimp+"R")) as string
			if (doesfileexist pathToPresetsRPS) then
			(
				renderpresets.LoadAll 0 pathToPresetsRPS
			)
			if (doesfileexist pathToPresets) then
			(
				--	load maps
				miauuRTTassist.chkbox_AlphaMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_AlphaMap") as stringStream))
				miauuRTTassist.chkbox_AmbientOcclusion.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_AmbientOcclusion") as stringStream))
				miauuRTTassist.chkbox_BlendMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMap") as stringStream))
				miauuRTTassist.chkbox_CompleteMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_CompleteMap") as stringStream))
				miauuRTTassist.chkbox_DiffuseMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffuseMap") as stringStream))
				miauuRTTassist.chkbox_HeightMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_HeightMap") as stringStream))
				miauuRTTassist.chkbox_LightingMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightingMap") as stringStream))
				miauuRTTassist.chkbox_normalsMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_normalsMap") as stringStream))
				miauuRTTassist.chkbox_ShadowsMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_ShadowsMap") as stringStream))
				miauuRTTassist.chkbox_SpecularMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecularMap") as stringStream))
				miauuRTTassist.chkbox_UVMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UVMap") as stringStream))
				--	load projection controls
				miauuRTTassist.chkbox_renderIsolate.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_renderIsolate") as stringStream))
				miauuRTTassist.chkbox_redrawViews.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_redrawViews") as stringStream))
				miauuRTTassist.chkbox_useCage.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_useCage") as stringStream))
				miauuRTTassist.chkbox_combMaps.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_combMaps") as stringStream))
				miauuRTTassist.chkbox_UseProjection.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UseProjection") as stringStream))
				miauuRTTassist.chkbox_Raytrace.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Raytrace") as stringStream))
				miauuRTTassist.chkbox_UVmatch.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UVmatch") as stringStream))
				miauuRTTassist.chkbox_Closest.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Closest") as stringStream))
				miauuRTTassist.chkbox_Furthest.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Furthest") as stringStream))
				miauuRTTassist.chkbox_HitMatchMtlID.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_HitMatchMtlID") as stringStream))
				miauuRTTassist.chkbox_RayMissCheck.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_RayMissCheck") as stringStream))
				miauuRTTassist.chkbox_CropAlpha.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_CropAlpha") as stringStream))
				--	blend map selected map unique settings
				miauuRTTassist.chkbox_BlendMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMLight") as stringStream))
				miauuRTTassist.chkbox_BlendMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMShadows") as stringStream))
				miauuRTTassist.chkbox_BlendMDiffuse.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMDiffuse") as stringStream))
				miauuRTTassist.chkbox_BlendMAmbient.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMAmbient") as stringStream))
				miauuRTTassist.chkbox_BlendMSpecular.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMSpecular") as stringStream))
				miauuRTTassist.chkbox_BlendMSelf_Illum.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMSelf_Illum") as stringStream))
				miauuRTTassist.chkbox_BlendMReflection.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMReflection") as stringStream))
				miauuRTTassist.chkbox_BlendMRefraction.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMRefraction") as stringStream))
				--	Complete map selected map unique settings 
				miauuRTTassist.chkbox_ComplMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_ComplMShadows") as stringStream))
				--	Diffuse Map selected map unique settings
				miauuRTTassist.chkbox_DiffMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffMLight") as stringStream))
				miauuRTTassist.chkbox_DiffMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffMShadows") as stringStream))
				--	Lighting Map selected map unique settings
				miauuRTTassist.chkbox_LightMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMShadows") as stringStream))
				miauuRTTassist.chkbox_LightMDirectLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMDirectLight") as stringStream))
				miauuRTTassist.chkbox_LightMIndirectLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMIndirectLight") as stringStream))
				--	Normals Map selected map unique settings					
				miauuRTTassist.chkbox_NormalsMOutToBump.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_NormalsMOutToBump") as stringStream))
				miauuRTTassist.chkbox_NormalsMRenderIntoAlphaChannel.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_NormalsMRenderIntoAlphaChannel") as stringStream))
				--	Specular Map selected map unique settings
				miauuRTTassist.chkbox_SpecMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecMLight") as stringStream))
				miauuRTTassist.chkbox_SpecMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecMShadows") as stringStream))
				--	UV Map selected map unique settings
				miauuRTTassist.chkbox_showOverlap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_showOverlap") as stringStream))
				miauuRTTassist.chkbox_modeNone.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeNone") as stringStream))
				miauuRTTassist.chkbox_modeSolid.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeSolid") as stringStream))
				miauuRTTassist.chkbox_modeNormal.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeNormal") as stringStream))
				miauuRTTassist.chkbox_modeShaded.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeShaded") as stringStream))
				miauuRTTassist.chkbox_force2sided.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_force2sided") as stringStream))
				miauuRTTassist.chkbox_visibleEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_visibleEdges") as stringStream))
				miauuRTTassist.chkbox_invisibleEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_invisibleEdges") as stringStream))
				miauuRTTassist.chkbox_seemEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_seemEdges") as stringStream))

				--	load output path
				miauuRTTassist.btn_BrowseFolder.text = ((getIniSetting pathToPresets "Render" "OutpuPath") as string)
				--	load map file extension
				miauuRTTassist.btn_saveAsType.text = ((getIniSetting pathToPresets "Render" "FileExtension") as string)
				--	load map size
				miauuRTTassist.spn_mapHeight.text = ((getIniSetting pathToPresets "Render" "Height") as string)
				miauuRTTassist.spn_mapWidth.text = ((getIniSetting pathToPresets "Render" "Width") as string)
				--	load ray-miss check color
				miauuRTTassist.colorPick_RayMissColor.color  = (readValue(( getIniSetting pathToPresets "Color" "Ray-miss color") as stringStream))
				--	load UV Map colors
				miauuRTTassist.clrPick_seemEdgesColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_seemEdgesColor") as stringStream))
				miauuRTTassist.clrPick_edgesColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_edgesColor") as stringStream))
				miauuRTTassist.clrPick_overlapColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_overlapColor") as stringStream))
				miauuRTTassist.clrPick_fillColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_fillColor") as stringStream))							
				--	load background colors of all maps
				miauuRTTassist.colorPick_EleBGColorAlpha.color = (readValue(( getIniSetting pathToPresets "Color" "Alpha BG color") as stringStream))
				miauuRTTassist.colorPick_EleBGColorAO.color = (readValue(( getIniSetting pathToPresets "Color" "AO BG color") as stringStream))
				miauuRTTassist.colorPick_EleBGColorBlend.color = (readValue(( getIniSetting pathToPresets "Color" "Blend BG color") as stringStream))
				miauuRTTassist.colorPick_EleBGColorCompl.color = (readValue(( getIniSetting pathToPresets "Color" "Complete BG color") as stringStream))
				miauuRTTassist.colorPick_EleBGColorDiff.color = (readValue(( getIniSetting pathToPresets "Color" "DIffuse BG color") as stringStream))
				miauuRTTassist.colorPick_EleBGColorHeight.color = (readValue(( getIniSetting pathToPresets "Color" "Height BG color") as stringStream))
				miauuRTTassist.colorPick_EleBGColorLight.color = (readValue(( getIniSetting pathToPresets "Color" "Lighting BG color") as stringStream))
				miauuRTTassist.colorPick_EleBGColorNormals.color = (readValue(( getIniSetting pathToPresets "Color" "Normals BG color") as stringStream))
				miauuRTTassist.colorPick_EleBGColorShadows.color = (readValue(( getIniSetting pathToPresets "Color" "Shadows BG color") as stringStream))
				miauuRTTassist.colorPick_EleBGColorSpec.color = (readValue(( getIniSetting pathToPresets "Color" "Specular BG color") as stringStream))
				miauuRTTassist.colorPick_AObright.color = (readValue(( getIniSetting pathToPresets "Color" "AO Bright color") as stringStream))
				miauuRTTassist.colorPick_AOdark.color = (readValue(( getIniSetting pathToPresets "Color" "AO Dark color") as stringStream))
				--	spinners
				miauuRTTassist.spn_Padding.text = ((getIniSetting pathToPresets "Spinner" "Padding") as string)
				miauuRTTassist.spn_UVChannel.text = ((getIniSetting pathToPresets "Spinner" "UVChannel") as string)
				miauuRTTassist.spn_Offset.text = ((getIniSetting pathToPresets "Spinner" "Offset") as string)
				miauuRTTassist.sOffset.value = (readValue((getIniSetting pathToPresets "Spinner" "OffsetStd") as stringStream))
				miauuRTTassist.spn_AOSamples.text = ((getIniSetting pathToPresets "Spinner" "AOSamples") as string)
				miauuRTTassist.spn_AOSpread.text = ((getIniSetting pathToPresets "Spinner" "AOSpread") as string)
				miauuRTTassist.spn_AOMaxDist.text = ((getIniSetting pathToPresets "Spinner" "AOMaxDist") as string)
				miauuRTTassist.spn_AOFalloff.text = ((getIniSetting pathToPresets "Spinner" "AOFalloff") as string)
			)
			else
			(
				messagebox "The preset for minor or major objects dosn't exist!" title:"RTTAssist Live Log"
			)
		)
		--
		function StartRender objArr =
		(
			CancelRenderProcess = false	
			overwriteAllFile = false
			mssgHiddenHPfound = false
			CheckObjBeforeBakeing objArr			
			CancelRenderProcess = false
			overwriteAllFile = false
		)
		--
		function GoToRender01 objArr =
		(
				if lb_filteringOptions.text != "No filtering:"  or lb_filteringOptions.text != "G.Supersampler: None" do
				(
					CheckObjMaterial objArr
					--	create two temp presets only if the current render is scanline and AO checkbox in on
					if (renderers.current.classID[1] == 1) and (chkbox_AmbientOcclusion.state == true) do
					(
-- 						print "Mray is active and AO is checked. Start creating the Scanline presets\n"
						--	save temp scanline preset for RTTAssist						
-- 						miauuIniPresetFile = GetDir #userscripts + "\\RTTassist\\Presets\\tempRTTScanPrst.rpf"
-- 						--	save checkbox settings
-- 						--	Maps
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_AlphaMap" (chkbox_AlphaMap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_AmbientOcclusion" (chkbox_AmbientOcclusion.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMap" (chkbox_BlendMap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_CompleteMap" (chkbox_CompleteMap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_DiffuseMap" (chkbox_DiffuseMap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_HeightMap" (chkbox_HeightMap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightingMap" (chkbox_LightingMap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_normalsMap" (chkbox_normalsMap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_ShadowsMap" (chkbox_ShadowsMap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_SpecularMap" (chkbox_SpecularMap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_UVMap" (chkbox_UVMap.state as string)
-- 						--	Projection setting
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_renderIsolate" (chkbox_renderIsolate.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_redrawViews" (chkbox_redrawViews.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_useCage" (chkbox_useCage.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_combMaps" (chkbox_combMaps.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_UseProjection" (chkbox_UseProjection.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_Raytrace" (chkbox_Raytrace.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_UVmatch" (chkbox_UVmatch.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_Closest" (chkbox_Closest.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_Furthest" (chkbox_Furthest.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_HitMatchMtlID" (chkbox_HitMatchMtlID.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_RayMissCheck" (chkbox_RayMissCheck.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_CropAlpha" (chkbox_CropAlpha.state as string)
-- 						--	Blend Map
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMLight" (chkbox_BlendMLight.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMShadows" (chkbox_BlendMShadows.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMDiffuse" (chkbox_BlendMDiffuse.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMAmbient" (chkbox_BlendMAmbient.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMSpecular" (chkbox_BlendMSpecular.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMSelf_Illum" (chkbox_BlendMSelf_Illum.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMReflection" (chkbox_BlendMReflection.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMRefraction" (chkbox_BlendMRefraction.state as string)
-- 						--	Complete map
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_ComplMShadows" (chkbox_ComplMShadows.state as string)
-- 						--	Diffuse Map
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_DiffMLight" (chkbox_DiffMLight.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_DiffMShadows" (chkbox_DiffMShadows.state as string)
-- 						--	Lighting Map
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightMShadows" (chkbox_LightMShadows.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightMDirectLight" (chkbox_LightMDirectLight.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightMIndirectLight" (chkbox_LightMIndirectLight.state as string)
-- 						--	Normals Map
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_NormalsMOutToBump" (chkbox_NormalsMOutToBump.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_NormalsMRenderIntoAlphaChannel" (chkbox_NormalsMRenderIntoAlphaChannel.state as string)
-- 						--	Specular Map
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_SpecMLight" (chkbox_SpecMLight.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_SpecMShadows" (chkbox_SpecMShadows.state as string)
-- 						--	Uv map
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_showOverlap" (chkbox_showOverlap.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeNone" (chkbox_modeNone.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeSolid" (chkbox_modeSolid.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeNormal" (chkbox_modeNormal.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeShaded" (chkbox_modeShaded.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_force2sided" (chkbox_force2sided.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_visibleEdges" (chkbox_visibleEdges.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_invisibleEdges" (chkbox_invisibleEdges.state as string)
-- 						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_seemEdges" (chkbox_seemEdges.state as string)
-- 						
-- 						--	save output path
-- 						if btn_BrowseFolder.text != undefined do
-- 							setIniSetting miauuIniPresetFile "Render" "OutpuPath" (btn_BrowseFolder.text as string)
-- 						--	save extension of files to save as
-- 						if btn_saveAsType.text != undefined do
-- 							setIniSetting miauuIniPresetFile "Render" "FileExtension" (btn_saveAsType.text as string)						
-- 						--	save map size
-- 						if spn_mapHeight.text != undefined do
-- 							setIniSetting miauuIniPresetFile "Render" "Height" (spn_mapHeight.text as string)
-- 						if spn_mapWidth.text != undefined do
-- 							setIniSetting miauuIniPresetFile "Render" "Width" (spn_mapWidth.text as string)						
-- 						--	save ray-miss color
-- 						setIniSetting miauuIniPresetFile "Color" "Ray-miss color" (colorPick_RayMissColor.color as string)						
-- 						--	save colors for UV map
-- 						setIniSetting miauuIniPresetFile "Color" "clrPick_seemEdgesColor" (clrPick_seemEdgesColor.color as string)
-- 						setIniSetting miauuIniPresetFile "Color" "clrPick_edgesColor" (clrPick_edgesColor.color as string)
-- 						setIniSetting miauuIniPresetFile "Color" "clrPick_overlapColor" (clrPick_overlapColor.color as string)
-- 						setIniSetting miauuIniPresetFile "Color" "clrPick_fillColor" (clrPick_fillColor.color as string)						
-- 						--	save background colors of maps
-- 							--	alpha
-- 							setIniSetting miauuIniPresetFile "Color" "Alpha BG color" (colorPick_EleBGColorAlpha.color as string)
-- 							--AO
-- 							setIniSetting miauuIniPresetFile "Color" "AO BG color" (colorPick_EleBGColorAO.color as string)
-- 							--	Blend
-- 							setIniSetting miauuIniPresetFile "Color" "Blend BG color" (colorPick_EleBGColorBlend.color as string)
-- 							--	Complete
-- 							setIniSetting miauuIniPresetFile "Color" "Complete BG color" (colorPick_EleBGColorCompl.color as string)
-- 							--	Diffuse
-- 							setIniSetting miauuIniPresetFile "Color" "DIffuse BG color" (colorPick_EleBGColorDiff.color as string)
-- 							--	Height
-- 							setIniSetting miauuIniPresetFile "Color" "Height BG color" (colorPick_EleBGColorHeight.color as string)
-- 							--	Ligthing
-- 							setIniSetting miauuIniPresetFile "Color" "Lighting BG color" (colorPick_EleBGColorLight.color as string)
-- 							--	Normals
-- 							setIniSetting miauuIniPresetFile "Color" "Normals BG color" (colorPick_EleBGColorNormals.color as string)
-- 							--	Shadows
-- 							setIniSetting miauuIniPresetFile "Color" "Shadows BG color" (colorPick_EleBGColorShadows.color as string)
-- 							--	Specular
-- 							setIniSetting miauuIniPresetFile "Color" "Specular BG color" (colorPick_EleBGColorSpec.color as string)
-- 							--	AO btight
-- 							setIniSetting miauuIniPresetFile "Color" "AO Bright color" (colorPick_AObright.color as string)
-- 							--	AO dark
-- 							setIniSetting miauuIniPresetFile "Color" "AO Dark color" (colorPick_AOdark.color as string)													
-- 						--	save spinners values
-- 							--	padding
-- 							setIniSetting miauuIniPresetFile "Spinner" "Padding" (spn_Padding.text as string)
-- 							--	channel
-- 							setIniSetting miauuIniPresetFile "Spinner" "UVChannel" (spn_UVChannel.text as string)
-- 							--	offset dotnet spinnet
-- 							setIniSetting miauuIniPresetFile "Spinner" "Offset" (spn_Offset.text as string)
-- 							--	offset 3ds max spinnet
-- 							setIniSetting miauuIniPresetFile "Spinner" "OffsetStd" (sOffset.value as string)
-- 							--	AO Samples
-- 							setIniSetting miauuIniPresetFile "Spinner" "AOSamples" (spn_AOSamples.text as string)
-- 							--	AO SpreadS
-- 							setIniSetting miauuIniPresetFile "Spinner" "AOSpread" (spn_AOSpread.text as string)
-- 							--	AO Max Dist
-- 							setIniSetting miauuIniPresetFile "Spinner" "AOMaxDist" (spn_AOMaxDist.text as string)
-- 							--	AO Falloff
-- 							setIniSetting miauuIniPresetFile "Spinner" "AOFalloff" (spn_AOFalloff.text as string)	
							
						-- save temp scanline preset for RENDER SETUP 
						tempScanFilteringPreset = GetDir #userscripts + "\\RTTassist\\Presets\\tempScanFiltPrst.rps"
						renderpresets.SaveAll 0 tempScanFilteringPreset 													
					)												
				)				
				StartRender objArr				
				if dupsFound == true do
					SetOriginalNames()
				
				--	delete temp scanline preset
				tempPrstFileToDel = GetDir #userscripts + "\\RTTassist\\Presets\\tempScanFiltPrst.rps"
				if doesFileExist tempPrstFileToDel do deleteFile tempPrstFileToDel
-- 				tempPrstFileToDel1 = GetDir #userscripts + "\\RTTassist\\Presets\\tempRTTScanPrst.rpf"
-- 				if doesFileExist tempPrstFileToDel1 do deleteFile tempPrstFileToDel1
		)
		function LMButtonRender =
		(
			if allLPwithProjFromScript.count != 0 then
			(
				for obj in allLPwithProjFromScriptInst do
				(
					local instances = #()
					if InstanceMgr.Getinstances obj &instances != 1 do
					(
						InstanceMgr.Getinstances obj &instances
						join allLPwithProjFromScript instances
					)
				)

				if (NodeNamesOK allLPwithProjFromScript) == true then
				(
					GoToRender01 allLPwithProjFromScript
-- 					tempPrstFileToDel = GetDir #userscripts + "\\RTTassist\\Presets\\tempScanFiltPrst.rps"
-- 					deleteFile tempPrstFileToDel
				)
				else
					CancelRenderProcess = true
			)
			else
			(
				errMssg = 18
				ErrorMessage 18
			)
			if allLPwithProjFromScriptAdd.count != 0 then
			(
				if (NodeNamesOK allLPwithProjFromScriptAdd) == true then
				(
					GoToRender01 allLPwithProjFromScriptAdd
-- 					tempPrstFileToDel = GetDir #userscripts + "\\RTTassist\\Presets\\tempScanFiltPrst.rps"
-- 					deleteFile tempPrstFileToDel
				)
				else
					CancelRenderProcess = true
			)
		)
		function CheckMapsOf2preset =
		(
			local continueWithDifferentMaps = true
			local pathToPresetsU = (getIniSetting miauuIniFile "Smart" "UnimpPrst") as string
			local pathToPresetsI = (getIniSetting miauuIniFile "Smart" "ImpPrst") as string
			
			local alU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_AlphaMap") as string)
			local aoU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_AmbientOcclusion") as string)
			local blU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_BlendMap") as string)
			local coU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_CompleteMap") as string)
			local diU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_DiffuseMap") as string)
			local heU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_HeightMap") as string)
			local liU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_LightingMap") as string)
			local noU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_normalsMap") as string)
			local shU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_ShadowsMap") as string)
			local spU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_SpecularMap") as string)
			local uvU = ((getIniSetting pathToPresetsU "Checkbox" "chkbox_UVMap") as string)
			
			local alI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_AlphaMap") as string)
			local aoI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_AmbientOcclusion") as string)
			local blI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_BlendMap") as string)
			local coI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_CompleteMap") as string)
			local diI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_DiffuseMap") as string)
			local heI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_HeightMap") as string)
			local liI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_LightingMap") as string)
			local noI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_normalsMap") as string)
			local shI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_ShadowsMap") as string)
			local spI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_SpecularMap") as string)
			local uvI = ((getIniSetting pathToPresetsI "Checkbox" "chkbox_UVMap") as string)
			
			if  alU == "true" do alU = "AlphaMap"
			if  aoU == "true" do aoU = "AmbientOcclusion"
			if  blU == "true" do blU = "BlendMap"
			if  coU == "true" do coU = "CompleteMap"
			if  diU == "true" do diU = "DiffuseMap"
			if  heU == "true" do heU = "HeightMap"
 			if  liU == "true" do liU = "LightingMap"
			if  noU == "true" do noU = "NormalsMap"
			if  shU == "true" do shU = "ShadowsMap"
			if  spU == "true" do spU = "SpecularMap"
			if  uvU == "true" do uvU = "UVMap"
						
			if  alI == "true" do alI = "AlphaMap"
			if  aoI == "true" do aoI = "AmbientOcclusion"
			if  blI == "true" do blI = "BlendMap"
			if  coI == "true" do coI = "CompleteMap"
			if  diI == "true" do diI = "DiffuseMap"
			if  heI == "true" do heI = "HeightMap"
			if  liI == "true" do liI = "LightingMap"
			if  noI == "true" do noI = "NormalsMap"
			if  shI == "true" do shI = "ShadowsMap"
			if  spI == "true" do spI = "SpecularMap"
			if  uvI == "true" do uvI = "UVMap"
				
			local mapsU = #(alU, aoU, blU, coU, diU, heU, liU, noU, shU, spU, uvU)
			local mapsI = #(alI, aoI, blI, coI, diI, heI, liI, noI, shI, spI, uvI)

				
			local matchedMaps = #()
			local notMatchedMaps = #()
			for i = 1 to mapsU.count do
			(
				if mapsU[i] == mapsI[i] then
				(
					if mapsU[i] != "false" do
						appendIfUnique matchedMaps mapsU[i]
				)
				else
				(
					if mapsU[i] != "false" do
						append notMatchedMaps mapsU[i]
					if mapsI[i] != "false" do
						append notMatchedMaps mapsI[i]
				)
				
			)
				
			if matchedMaps.count == 0 then
			(
				msg = "The \"Smart\" presets include completely different map types.\n"
				msg += "Change their preset map settings and then\n"
				msg += "continue the rendering! "
				messagebox msg title:"RTTAssist Live Log"
				continueWithDifferentMaps = true
			)
			else
				continueWithDifferentMaps = false
			
			if matchedMaps.count != 0 and notMatchedMaps.count == 0 then
				continueWithDifferentMaps = false
			
			if matchedMaps.count != 0 and notMatchedMaps.count != 0 then
			(
				msg = "The \"Smart\" presets need to include the same map types.\n"
				msg += "Change their preset map settings and then\n"
				msg += "continue the rendering! "
				messagebox msg title:"RTTAssist Live Log"
				continueWithDifferentMaps = true
			)
 			
			continueWithDifferentMaps
		)
		--	compare SaveAs file type of tow presets
		function CheckFileTypeOf2preset =
		(
			local continueWithDifferentFileTypes = false
			local pathToPresetsU = (getIniSetting miauuIniFile "Smart" "UnimpPrst") as string
			local pathToPresetsI = (getIniSetting miauuIniFile "Smart" "ImpPrst") as string
			local fileTypeUn = ((getIniSetting pathToPresetsU "Render" "FileExtension") as string)
			local fileTypeIm = ((getIniSetting pathToPresetsI "Render" "FileExtension") as string)
			if fileTypeUn.count != 0 and fileTypeIm.count != 0 do
			(
				if fileTypeUn != fileTypeIm do
				(
					rollout compareFileTypes "RTTAssist LiveLog: Smart System Error!"
					(
						local me = getSourceFileName()
						local dir = getFilenamePath me 
						local miauuIniFile = dir + "miauu.ini"

						local pathToPresetsU = (getIniSetting miauuIniFile "Smart" "UnimpPrst") as string
						local pathToPresetsI = (getIniSetting miauuIniFile "Smart" "ImpPrst") as string
						local fileTypeUn = ((getIniSetting pathToPresetsU "Render" "FileExtension") as string)
						local fileTypeIm = ((getIniSetting pathToPresetsI "Render" "FileExtension") as string)
						
						label lbl_1 "The \"Smart\" presets use different output file formats!" align:#center
						label lbl_2 " for the \"minor\", and" align:#center
						label lbl_3 "Click \"Continue anyway\" to render the maps using " align:#center
						label lbl_4 "or \"Cancel\" to stop the operation." align:#center
						
						button btn_OK "Continue anyway" pos:[80,80] width:100
						button btn_Cancel "Cancel" pos:[200,80] width:60
						
						on compareFileTypes open do
						(
							lbl_2.text = fileTypeUn+" for the \"minor\", and "+fileTypeIm+" for the \"major\" preset." 
							lbl_3.text =  "Click \"Continue anyway\" to render the maps using "+fileTypeIm+"," 
						)						
						on btn_OK pressed do
						(
							miauuRTTassist.continueWithDifferentFileTypes = false
							destroydialog compareFileTypes
						)
						on btn_cancel pressed do
						(
							miauuRTTassist.continueWithDifferentFileTypes = true
							destroydialog compareFileTypes
						)						
					)
					createdialog compareFileTypes  width:340 height:110 fgcolor:red modal:true					
				)	
			)
			continueWithDifferentFileTypes
		)
		--	compare Output path for two presets
		function CheckOutputPathOf2preset =
		(
			local continueWithDifferentOutputPath = true
			local pathToPresetsU = (getIniSetting miauuIniFile "Smart" "UnimpPrst") as string
			local pathToPresetsI = (getIniSetting miauuIniFile "Smart" "ImpPrst") as string
			local OutpuPathUn = ((getIniSetting pathToPresetsU "Render" "OutpuPath") as string)
			local OutpuPathIm = ((getIniSetting pathToPresetsI "Render" "OutpuPath") as string)
			if OutpuPathUn.count != 0 and OutpuPathIm.count != 0 do
			(
				if OutpuPathUn != OutpuPathIm do
				(
					rollout DifferentOutputPath "RTTAssist LiveLog: Smart System Error!" width:300 height:113
					(
						local me = getSourceFileName()
						local dir = getFilenamePath me 
						local miauuIniFile = dir + "miauu.ini"
						
						local pathToPresetsU = (getIniSetting miauuIniFile "Smart" "UnimpPrst") as string
						local pathToPresetsI = (getIniSetting miauuIniFile "Smart" "ImpPrst") as string
						local OutpuPathUn = ((getIniSetting pathToPresetsU "Render" "OutpuPath") as string)
						local OutpuPathIm = ((getIniSetting pathToPresetsI "Render" "OutpuPath") as string)

						local buttonWidth = 90
						local geomNodes = #() as array
						
						label lbl_0 "The \"Smart\" presets use different output directories." align:#center
						label lbl_3 "Click \"Continue anyway\" to proceed with the rendering or" align:#center
						label lbl_4 "\"Cancel\" to stop the operation and manually fix the problem." align:#center

						button bCancel "Cancel" pos:[202,83] width:buttonWidth height:24
						button bOverwriteFiles "Continue anyway" pos:[99,83] width:buttonWidth height:24
						
						on DifferentOutputPath open do
						(		
							local center = ((DifferentOutputPath.width) / 2)
							bOverwriteFiles.pos.x = center - (buttonWidth + 8)
							bCancel.pos.x = center + 8			

						)  
						on bCancel pressed do 
						(							
							miauuRTTassist.continueWithDifferentOutputPath = false
							destroydialog DifferentOutputPath
						)
						on bOverwriteFiles pressed do
						(
							miauuRTTassist.continueWithDifferentOutputPath =  true
							destroydialog DifferentOutputPath
						)
						
					)
					createDialog  DifferentOutputPath fgcolor:red modal:true					
				)	
			)
			continueWithDifferentOutputPath
		)
		--	compare map size of two preset
		function CheckMapSizeOf2preset =
		(
			pathToPresetsU = (getIniSetting miauuIniFile "Smart" "UnimpPrst") as string
			pathToPresetsI = (getIniSetting miauuIniFile "Smart" "ImpPrst") as string
			local mapSizeUnH = ((getIniSetting pathToPresetsU "Render" "Height") as string)
			local mapSizeUnW = ((getIniSetting pathToPresetsU "Render" "Width") as string)
			local mapSizeImH = ((getIniSetting pathToPresetsI "Render" "Height") as string)
			local mapSizeImW = ((getIniSetting pathToPresetsI "Render" "Width") as string)
			sizeUn = mapSizeUnH+"x"+mapSizeUnW
			sizeIm = mapSizeImH+"x"+mapSizeImW
			if sizeUn.count > 1 and sizeIm.count > 1 do
			(
				if sizeUn != sizeIm do
				(
					rollout compareMapSize "RTTAssist LiveLog: Smart System Error!"
					(
						local me = getSourceFileName()
						local dir = getFilenamePath me 
						local miauuIniFile = dir + "miauu.ini"

						local pathToPresetsU = (getIniSetting miauuIniFile "Smart" "UnimpPrst") as string
						local pathToPresetsI = (getIniSetting miauuIniFile "Smart" "ImpPrst") as string
						local mapSizeUnH = ((getIniSetting pathToPresetsU "Render" "Height") as string)
						local mapSizeUnW = ((getIniSetting pathToPresetsU "Render" "Width") as string)
						local mapSizeImH = ((getIniSetting pathToPresetsI "Render" "Height") as string)
						local mapSizeImW = ((getIniSetting pathToPresetsI "Render" "Width") as string)
						
						label lbl_1 "The \"Smart\" preset's map size don't match !" align:#center
						label lbl_2 "Select which size do you want to use (this will overwrite the preset files)" align:#center
						label lbl_3 "or press \"Continue anyway\" to render the" align:#center
						label lbl_4 "objects using different map sizes." align:#center
						
						button btn_small "" pos:[20,80] width:60
						button btn_big "" pos:[100,80] width:60
						button btn_cancel "Continue anyway" pos:[180,80]
						
						on compareMapSize open do
						(
							btn_small.text = mapSizeUnH
							btn_big.text = mapSizeImH
						)						
						on btn_small pressed do
						(
							--	rewrite map size with smaller value
							setIniSetting pathToPresetsU "Render" "Height" (mapSizeUnH as string)
							setIniSetting pathToPresetsU "Render" "Width" (mapSizeUnH as string)
							
							setIniSetting pathToPresetsI "Render" "Height" (mapSizeUnH as string)
							setIniSetting pathToPresetsI "Render" "Width" (mapSizeUnH as string)
							
							destroydialog compareMapSize
						)
						on btn_big pressed do
						(
							--	rewrite map size with bigger value
							setIniSetting pathToPresetsU "Render" "Height" (mapSizeImH as string)
							setIniSetting pathToPresetsU "Render" "Width" (mapSizeImH as string)
							
							setIniSetting pathToPresetsI "Render" "Height" (mapSizeImH as string)
							setIniSetting pathToPresetsI "Render" "Width" (mapSizeImH as string)
							
							destroydialog compareMapSize
						)
						on btn_cancel pressed do
						(
							destroydialog compareMapSize
						)						
					)
					createdialog compareMapSize  width:340 fgcolor:red modal:true
				)	
			)
		)
		--	render all objects in scene that have Projection modifier
		function RMButtonRender =
		(
			if keyboard.controlPressed then
			(--	render only objects with predefined prefixes				
				objSel = GetProperObj()
				selOPR = GetProperObj()
				allLPwithProjInScene = #() as array
				if chkbox_isNodeFrozen.state == off then
				(
					selOPR = #() as array
					for s in objSel where s.isFrozen != true do
						append selOPR s
				)
				if prefixNameLP != undefined and prefixNameHP != undefined then
				(
					if CheckObjAndPrefixLP() == true and CheckObjAndPrefixHP() == true do
					(
						currCmndPanelMode = getCommandPanelTaskMode()
						setCommandPanelTaskMode mode:#create
						for s  in selOPR do
						(
							--	find objects with  Projection modifier
							if ((findString s.name prefixNameLP) != undefined)  and superClassOf s != helper do
							(
								isThereModifierPrj = s.modifiers
								if isThereModifierPrj.count != 0 do
								(	
									for m = 1 to isThereModifierPrj.count do
									(
										if (classof isThereModifierPrj[m]) == Projection do
											append allLPwithProjInScene s
									)
								)
							)
							if prefixNameLPAdd != undefined do
							(
								if ((findString s.name prefixNameLPAdd) != undefined)  and not isGroupMember s do
								(
									isThereModifierPrj = s.modifiers
									if isThereModifierPrj.count != 0 do
									(	
										for m = 1 to isThereModifierPrj.count do
										(
											if (classof isThereModifierPrj[m]) == Projection do
												append allLPwithProjInScene s
										)
									)
								)
							)
						)
					)
					setCommandPanelTaskMode mode:currCmndPanelMode
				)
				else
				(
					errMssg = 1
					ErrorMessage 1
				)
				
				if allLPwithProjInScene.count != 0 then
				(
					if (NodeNamesOK allLPwithProjInScene) == true then
					(
						if lb_filteringOptions.text != "No filtering:"  or lb_filteringOptions.text != "G.Supersampler: None" do
						(
							CheckObjMaterial allLPwithProjInScene
							if (renderers.current.classID[1] == 1) do
							(
								tempScanFilteringPreset = GetDir #userscripts + "\\RTTassist\\Presets\\tempScanFiltPrst.rps"
								renderpresets.SaveAll 0 tempScanFilteringPreset 
								
							)
						)
						StartRender allLPwithProjInScene	
						
						if dupsFound == true do
							SetOriginalNames()
-- 						tempPrstFileToDel = GetDir #userscripts + "\\RTTassist\\Presets\\tempScanFiltPrst.rps"
-- 						deleteFile tempPrstFileToDel
					)
					else
						CancelRenderProcess = true
				)
				else
				(
					errMssg = 18
					ErrorMessage 18
				)
			)
			else
			(	--	render all objects
				 --	use smart 
				if smartIsRuning == true then
				(
					diffMaps = CheckMapsOf2preset()
					if diffMaps == false then
					(
						diffOutputPath = CheckOutputPathOf2preset()
						if diffOutputPath == true then
						(
							CheckMapSizeOf2preset()
							
							diffFileType = CheckFileTypeOf2preset()
							if	diffFileType == false then
							(
								EmptyArraysStoringPath()
								objNameForCombineMap  = ""
								if dataSelMinorLP.count != 0 do
									for d in dataSelMinorLP do d[1].material = d[2]
										
								redrawViews()
								LoadSmartPreset "UnimpPrst"
								--	render only unimportant object
								if smartArrMinor.count != 0 then
								(
									if (NodeNamesOK smartArrMinor) == true then
									(--	render
										GoToRender01 smartArrMinor
										for o in smartArrMinor do
											o.material = standardMaterial diffuse:(color 146 0 0) ambient:(color 146 0 0) selfIllumAmount: 50.0 showInViewport:true	
									)
									else
										CancelRenderProcess = true
								)
								LoadSmartPreset "ImpPrst"
								--	render only Important objects
								if smartArrMajor.count != 0 do
								(
									if (NodeNamesOK smartArrMajor) == true then
									(	
										GoToRender01 smartArrMajor
										for o in smartArrMajor do
											o.material = standardMaterial diffuse:(color 0 71 0) ambient:(color 0 71 0) selfIllumAmount: 50.0 showInViewport:true	
									)
									else
										CancelRenderProcess = true
								)
								--	combineMaps
								if chkbox_combMaps.state == on then
								(
									--	render Combine maps
									if CancelRenderProcess != true then
									(
										if objNameForCombineMap.count < 40 then
										(
											CombineMaps objNameForCombineMap
										)
										else
										(
											shortername = substring objNameForCombineMap 1 40
											CombineMaps shortername	
										)					
									)										
								)
							)
						)
					)
				)
				else	
				(
					--	Batch rendering
					if startBatchRender == true then
					(
						--	if Use All is pressed get all listed files and render them
						if btn_Batch_useAll.state == true do
							maxFilesToBatch = maxFiles
						--	id Use selected is pressed get the list of checked files and render them
						if btn_Batch_useSelected.state == true do
						(
							--	turn 0_based array to 1-based
							if allIndexes.count != 0 then
							(
								for i=1 to allIndexes.count do
								(
									allIndexes[i] = allIndexes[i]+1
								)
								--	sort indexes to match to proper map
								sort allIndexes
								--	get selectd by user maps
								maxFilesToBatch = #()
								for i = 1 to allIndexes.count do
								(
									append maxFilesToBatch maxFiles[allIndexes[i]]
								)
								--	mapsToCombine contains all maps that user has checkd and wants to combine
							)
							else
								messagebox "Select some files!" title:"RTTAssist Combine Maps"
						)
						if maxFilesToBatch.count > 1 then
						(
							--	get the current renderer
							batchMAX2011ActRender = ActiveRenderer()
							--	get current state of LiveLog
							local tempLiveLog = undefined
							case of
							(
								(chkbox_errInViewport.state == true): tempLiveLog = 1
								(chkbox_errInRollOut.state == true): tempLiveLog = 2
								(chkbox_errInMsgBox.state == true): tempLiveLog = 3
							)
							--	turn off LiveLog. This prevents error and memory leaking
							chkbox_errInViewport.state = false
							chkbox_errInRollOut.state = false
							chkbox_errInMsgBox.state = false
							--	turn off Preview checkbox
							chkbox_previewVFB.state = false
							--	turn on Isolate Pairs
							chkbox_renderIsolate.state = true
							--	temp save the preset output path
							presetOutputPath = btn_BrowseFolder.text
							--	reset max
							resetMaxFile #noPrompt

							--	loop throu all  max files and render them
							for f=1 to maxFilesToBatch.count do
							(
								--	reset max
								resetMaxFile #noPrompt
								--	clear memory
								gc()
								--	load max files one by one
								loadMaxFile maxFilesToBatch[f] useFileUnits:true quiet:true

								--	refrech scripts array of all objects in current scene
								GetProperObj()
								--	skip instances to prevent problems
								if chkbox_Batch_skipInst.state == true do
									skipInstances = 1
							
								--	start rendering
								selOPR = #()
								allLPwithProjInScene = #() as array
								if chkbox_isNodeFrozen.state == off then
								(
									if allObjITState == 1 do
									(
										selOPR = for o in objects where classof o != Biped_Object  and superClassOf o != helper and not o.isFrozen collect o
									)
									if visibleObj == 1 do
									(
										selOPR = for o in objects where classof o != Biped_Object  and superClassOf o != helper and o.isHidden == false and not o.isFrozen collect o
									)
								)
								else
								(
									if allObjITState == 1 do
										selOPR = for o in objects where classof o != Biped_Object  and superClassOf o != helper collect o
									if visibleObj == 1 do
										selOPR = for o in objects where classof o != Biped_Object  and superClassOf o != helper and o.isHidden == false collect o
								)
								currCmndPanelMode = getCommandPanelTaskMode()
								setCommandPanelTaskMode mode:#create
								
								for s  in selOPR do
								(
									--	find objects with  Projection modifier	
									if s.modifiers[#Projection] != undefined then
									(
										geomNodes = s.modifiers[#Projection].geomNodes
										for o in geomNodes where o.isHidden == true do o.isHidden = false

										append allLPwithProjInScene s
									)
									else	--	if object does not have a Proj modifier add new one
									(
										if ((findString s.name prefixNameLP) != undefined) do
										(
											--	if user wants to process only visible objects force add Projection function to search in all objects, not
												--	only in visible for hidden HP buddys for current LP object
											if visibleObj == 1 do
												addBatchProj = true
											AddProjMain()
											if s.modifiers[#Projection] != undefined do
											(
												geomNodes = s.modifiers[#Projection].geomNodes
												for o in geomNodes where o.isHidden == true do o.isHidden = false
												append allLPwithProjInScene s
											)
											addBatchProj = false
										)
									)
								)
								setCommandPanelTaskMode mode:currCmndPanelMode
								
								
								--	set the path where to be saved rendered maps
								--	save rendered maps in source file folder
								if chkbox_Batch_SameAsSource.state == true do
								(
									--	create new folder in preset output directory
									local fileName = (getFilenameFile maxFilesToBatch[f])
									local mainDir = (getFilenamePath maxFilesToBatch[f]) + "\\" + fileName + "_Textures"
									local mainFolder = makeDir mainDir
									--	if creating new folder is successuful
									if (mainFolder == true) then
									(
										--	set the output path label text to new directory path
										btn_BrowseFolder.text = mainDir
									)
								)
								--	save rendered maps to preset output path, but create separate folder for each file
								if chkbox_Batch_usePresetOP.state == true do
								(
									--	create new folder in preset output directory
									local fileName = (getFilenameFile maxFilesToBatch[f])
									local mainDir = presetOutputPath + "\\" + fileName + "_Textures"
									local mainFolder = makeDir mainDir
									--	if creating new folder is successuful
									if (mainFolder == true) then
									(
										--	set the output path label text to new directory path
										btn_BrowseFolder.text = mainDir
									)
								)
								
								if allLPwithProjInScene.count != 0 then
								(
									NodeNamesOK allLPwithProjInScene
									if lb_filteringOptions.text != "No filtering:"  or lb_filteringOptions.text != "G.Supersampler: None" do
									(
										CheckObjMaterial allLPwithProjInScene
										--	save temporary preset file for filtering options
										if (renderers.current.classID[1] == 1) do
										(
											tempScanFilteringPreset = GetDir #userscripts + "\\RTTassist\\Presets\\tempScanFiltPrst.rps"
											renderpresets.SaveAll 0 tempScanFilteringPreset 													
										)
									)
									--	show process of rendering hgow many files are remaining
 									rollout currentRenderedFile "RTTAssist Batch Render"
									(
										on currentRenderedFile close do
										(
											miauuRTTassist.maxFilesToBatch = #()
										)
									)
									posX = (gw.getWinSizex() / 2) - 200
									createdialog currentRenderedFile 400 0 posX 130 style:#(#style_sysmenu,#style_toolwindow) 
									currentRenderedFile.title = "RTTAssist Batch Render:"+" file remaining: "+ ((maxFilesToBatch.count - f) as string)  + \
										" :::    stop rendering --->"
	
									Startrender allLPwithProjInScene	
								)								
								--	clear Undo buffer
								clearUndoBuffer()
								--	clear memory
								gc()								
							)
							try(destroydialog currentRenderedFile)catch()
							--	return LiveLog initial state
							case of
							(
								(tempLiveLog == 1): chkbox_errInViewport.state = true
								(tempLiveLog == 2): chkbox_errInRollOut.state = true
								(tempLiveLog == 3): chkbox_errInMsgBox.state = true
							)
							--	set the original preset output path
							btn_BrowseFolder.text = presetOutputPath
							--	reset max
							resetMaxFile #noPrompt
						)
						else
							ErrorMessage 20	--	you need to load at least two scenes in order to use batch render.
					)
					else
					(	--	Render SelectionSets 
						if useSelectionSets == true then
						(
							selectionSetsToBake = rol_SelectionSets.selectionSetsIndexes
							--	
							for i in selectionSetsToBake do	--	get each selSets one by one
							(
								--	get the name of the current selection set
								selectionSetsName = selectionsets[i].name
								allLPwithProjInScene = #() as array
								currCmndPanelMode = getCommandPanelTaskMode()
								setCommandPanelTaskMode mode:#create
								for s in selectionSets[i] do	--	get objects in current selSets one by one
								(
									--	find objects with  Projection modifier					
									isThereModifierPrj = s.modifiers
									if isThereModifierPrj.count != 0 do
									(	
										for m = 1 to isThereModifierPrj.count do
										(
											if (classof isThereModifierPrj[m]) == Projection do
												append allLPwithProjInScene s
										)
									)
								)
								setCommandPanelTaskMode mode:currCmndPanelMode
								if allLPwithProjInScene.count != 0 then
								(
									if (NodeNamesOK allLPwithProjInScene) == true then
									(	--	render
										GoToRender01 allLPwithProjInScene
									)
									else
										CancelRenderProcess = true
								)
								else 
								(
									errMssg = 18
									ErrorMessage 18
								)
							)
						)
						else
						(	--	standart rendering
							allLPwithProjInScene = FindObjWithProjMod()
							if allLPwithProjInScene.count != 0 then
							(
								if (NodeNamesOK allLPwithProjInScene) == true then
								(	--	render
									for s in allLPwithProjInScene where s.isHidden == true do s.isHidden = false
									GoToRender01 allLPwithProjInScene
								)
								else
									CancelRenderProcess = true
							)
							else 
							(
								errMssg = 18
								ErrorMessage 18
							)
						)
					)
				)
			)
		)
		--	render only selected objects
		function MMButtonRender =
		(
			selectedLPobj = for o in selection where superClassOf o != helper collect o
			if selectedLPobj.count != 0 then
			(
				if (NodeNamesOK selectedLPobj) == true then
				(	
-- 					if lb_filteringOptions.text != "No filtering:"  or lb_filteringOptions.text != "G.Supersampler: None" do
-- 					(
-- 						CheckObjMaterial selectedLPobj
-- 						--	save temporary preset file for filtering options
-- 						if (renderers.current.classID[1] == 1) do
-- 						(
--- 							tempScanFilteringPreset = GetDir #userscripts + "\\RTTassist\\Presets\\tempScanFiltPrst.rps"
-- 							renderpresets.SaveAll 0 tempScanFilteringPreset 													
-- 						)
-- 					)
					StartRender selectedLPobj
					
-- 					if dupsFound == true do
-- 						SetOriginalNames()
				)
				else
					CancelRenderProcess = true
			)
			else
			(
				errMssg = 21
				ErrorMessage 21	--	Please, select some Low-Poly objects first
			)
		)
		--	
		function LRMmbPressed mbFn =
		(
			case mbFn of
			(
				1: (LMButtonRender() )
				2: (RMButtonRender() )
				3: (MMButtonRender() )
			)
		)
		--	on Render button pressed
		function RenderButtonPressedR_MMB mmbFn =
		(
			DestroyPresetRollout()
			CheckActiveRender()
			curRend = CheckActiveRender()
			if lb_filteringOptions.text != "Unknown Renderer Type" do
			(
				if (ValidateDirectory (btn_BrowseFolder.text as string)) == true then
				(
					if CheckForSelectedMaps() then
					(
						if btn_saveAsType.text != ".PNG"  and btn_saveAsType.text != ".TGA" and btn_saveAsType.text != ".TIF"  then
						(
							if chkbox_combMaps.state == on then
							(
								errMssg = 10
								ErrorMessage 10
							)
							else
							(
								LRMmbPressed	mmbFn	
							)
						)
						else	
						(-- if TGA is selected but color depth is not 32 bit
							if btn_saveAsType.text == ".TGA" then
							(
								if chkbox_combMaps.state == on then
								(
									targa.itgaio.setColorDepth 32
									LRMmbPressed	mmbFn
								)
								else
								(
									LRMmbPressed	mmbFn
								)
							)
							else
							(--	if PNG is selected but Alpha is not turned ON
								if btn_saveAsType.text == ".PNG" then
								(
									if chkbox_combMaps.state == on then
									( 
										portable_network_graphics.ipngio.setAlpha true
										LRMmbPressed	mmbFn											
									)
									else
									(
										LRMmbPressed	mmbFn
									)
								)
								else
								(--	if TIF is selected but Alpha is not turned ON
									if btn_saveAsType.text == ".PNG" then
									(
										if chkbox_combMaps.state == on then
										( 
											tif.itifio.setAlpha #true
											tif.itifio.setType #color
											LRMmbPressed	mmbFn													
										)
										else
										(
											LRMmbPressed	mmbFn
										)
									)
									else
									(	
										LRMmbPressed	mmbFn
									)
								)
							)
						)
						--	clear standart material if we set this to objects with no material before baking
						if objWithNoMat.count != 0 do
						(
							for obj in objWithNoMat do
								obj.material = undefined
						)
					)
					else
					(
						errMssg = 16
						ErrorMessage 16
					)
				)
				else
				(
					errMssg = 3
					ErrorMessage 3
				)
			)
		)
		--	Render button events
		on btn_RenderToTexture lbuttonup do
		(			
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/The__Render__Button.htm#render_modes"
				shellLaunch "hh" goToHelp
			)
			else
			(
				if keyboard.controlPressed then
				(--	select all LP objects with Projection modifier applied by RTTassist
					if allLPwithProjFromScript.count != 0 then
					(
						select allLPwithProjFromScript
						for obj in allLPwithProjFromScriptInst do
						(
							local instances = #()
							if InstanceMgr.Getinstances obj &instances != 1 do
							(
								InstanceMgr.Getinstances obj &instances
								selectMore instances
							)
						)
					)
					else
					(
						errMssg = 24
						ErrorMessage 24	-- there is no object with Projmod applied by RTTassist
					)
					if allLPwithProjFromScriptAdd.count != 0 then
					(
						selectMore allLPwithProjFromScriptAdd
						for obj in allLPwithProjFromScriptInstAdd do
						(
							local instances = #()
							if InstanceMgr.Getinstances obj &instances != 1 do
							(
								InstanceMgr.Getinstances obj &instances
								selectMore instances
							)
						)
					)
				)
				else
				(
					if keyboard.altPressed then
					(--	select all object with Projection modifier applyed manualy by user
						local allLPwithProjInScene = FindObjWithProjMod()
						if allLPwithProjInScene.count != 0 then
							select allLPwithProjInScene
						else
						(
							errMssg = 15
							ErrorMessage 15
						)
					)
					else
					(
						RenderButtonPressedR_MMB 1
					)
				)
			)
		)			
		on btn_RenderToTexture rbuttonup do
		(
			RenderButtonPressedR_MMB 2
		)
		on btn_RenderToTexture mbuttonup do
		(
			RenderButtonPressedR_MMB 3
		)
		on btn_RenderToTexture mouseover do
		(
			btn_RenderToTexture.bitmap = (openBitmap (url+"miauuITrenderHover.png"))
		)
		on btn_RenderToTexture mouseout do
		(
			btn_RenderToTexture.bitmap = (openBitmap (url+"miauuITrender.png"))
		)
------------------------------------
	--	Smart Render Rollout
-----------------------------------
		--	show dotnet listview with all minor and major objects and their UV area by %
		rollout ObjByUVArea "Objects UV area" width:200 height:200
		(
			dotNetControl lv "system.windows.forms.listView" height:200
			local lbBackColor = (dotNetClass "System.Drawing.Color").DimGray
			local lbForeColor = (dotNetClass "System.Drawing.Color").lightGray	
			
			function GetSelection =
			(
				for x=0 to lv.selectedIndices.count-1 collect lv.selectedIndices.item[x]
			)
			function AddColumns theLv columnsAr=
			(
				w=(theLv.width/columnsAr.count)-1
				for x in columnsAr do
				(
					theLv.columns.add x w
				)
			)
			function QuickArraySort arr1 arr2 x:1 =
			(
				case of
				(
					(arr1[x] < arr2[x]):-1
					(arr1[x] > arr2[x]):1
					default:0
				)
			)
			function PopulateListView theLv=
			(
				rows=#()
				arr = miauuRTTassist.smartArr
				qsort arr QuickArraySort x:1
				for x=1 to arr.count do
				(
					li=dotNetObject "System.Windows.Forms.ListViewItem" arr[x][2].name
					li.subitems.add (((arr[x][1]) as string)+" %")
					li.tag = dotnetmxsvalue arr[x][2]
					append rows li
				)
				theLv.items.addRange rows 
			)
			
			function InitListView theLv=
			(
				theLv.view=(dotNetClass "system.windows.forms.view").details
				theLv.FullRowSelect=true	
				theLv.MultiSelect=true	
				theLv.backcolor = lbBackColor
				theLv.forecolor = lbForeColor
			)
			function ColorTheObjectsBackground =
			(
				if miauuRTTassist.smartArrMinor.count != 0 then
				(
					for o=1 to miauuRTTassist.smartArrMinor.count do
					(
						for i = 0 to lv.Items.count-1 do
						(
							if miauuRTTassist.smartArrMinor[o].name == lv.Items.Item[i].text do
							(
								lv.Items.Item[i].backColor = (dotNetClass "System.Drawing.Color").fromARGB 126 18 18 
								lv.Items.Item[i].foreColor = (dotNetClass "System.Drawing.Color").fromARGB 237 184 127
							)
						)
					)
				)
				if miauuRTTassist.smartArrMajor.count != 0 then
				(
					for o=1 to miauuRTTassist.smartArrMajor.count do
					(
						for i = 0 to lv.Items.count-1 do
						(
							if miauuRTTassist.smartArrMajor[o].name == lv.Items.Item[i].text do
							(
								lv.Items.Item[i].backColor = (dotNetClass "System.Drawing.Color").fromARGB 41 70 44 
								lv.Items.Item[i].foreColor = (dotNetClass "System.Drawing.Color").fromARGB 176 237 168 
							)
						)
					)
				)
			)
			on ObjByUVArea open do
			(
				InitListView lv
				AddColumns lv #("Object","UV area")
				PopulateListView lv
				if miauuRTTassist.smartArrMinor.count != 0 then
					ColorTheObjectsBackground()
			)
			on lv SelectedIndexChanged s a do
			(
				with undo off 
				(
					nodes = for k=0 to s.selectedItems.count-1 where isvalidnode (node = s.selectedItems.item[k].tag.value) collect node
					if nodes.count == 0 then clearselection() else select nodes
				)
			)
			on ObjByUVArea resized Point2 do
			(
				local ro_size = GetDialogSize ObjByUVArea
				lv.width = ro_size[1] - 25
				lv.height = ro_size[2] - 10
				if ObjByUVArea.width < 200 do ObjByUVArea.width = 200
				if ObjByUVArea.height < 200 do ObjByUVArea.height = 200
			)
		)

		on btn_showList lbuttonup do
		(
			btn_showList.bitmap = (openBitmap (url+"miauuITlistHover.png"))
			try(destroyDialog ObjByUVArea)catch()
			local roWidth = 200
			local roHeight = 200
			
			local roPos = GetDialogPos miauuRTTassist
			if roPos.x <= (sysinfo.desktopSize.x - 437) then
				roPos.x = roPos.x+237
			else
				roPos.x = roPos.x-200
			createDialog ObjByUVArea roWidth roHeight roPos.x roPos.y \
				style:#(#style_titlebar, #style_sysmenu, #style_resizing)
		)
		on btn_showList mouseover do
		(
			btn_showList.bitmap = (openBitmap (url+"miauuITlistHover.png"))
		)
		on btn_showList mouseout do
		(
			btn_showList.bitmap = (openBitmap (url+"miauuITlist.png"))
		)
		--	calculate UV area
		function GetUVbyBitmap =
		(
			--	stop flickering of modify pannel - credits to DenisT
			WM_SETREDRAW=0xB
			commandHWND = windows.getChildHWND #max "Command Panel"	 
			windows.sendmessage commandHWND[1]  WM_SETREDRAW 0 0
			
			--	get UV area
			AddModifier $ (Unwrap_UVW ())
			cOmod = $.modifiers[#unwrap_uvw]
			cOmod.renderuv_showframebuffer = false
			cOmod.renderuv_height = 100
			cOmod.renderuv_width =  100
			cOmod.renderuv_fillmode = 1
			cOmod.renderuv_seamColor = color 255 255 255
			cOmod.renderuv_fillColor = color 255 255 255					
			cOmod.renderuv_showoverlap = false		
			curObjUVTemplate = GetDir #userscripts + "\\RTTAssistUI\\calculateUVarea.bmp"
			cOmod.renderUV curObjUVTemplate
			--	delete Unwrap_UVW modifier
			DeleteModifier $ 1
			--	open UV bitmap
			curObjUVTemplateBMP = openBitMap curObjUVTemplate
			curObjUVarea = 0
			for i = 0 to (curObjUVTemplateBMP.height-1) do
			(
				--	get each row of the bitmap and...
				getRow = getPixels curObjUVTemplateBMP [0,i] 100
				for j = 1 to curObjUVTemplateBMP.width do
				(
					if (getRow[j] == (color 255 255 255)) do
					(	--	count the white pixels - the UV area
						curObjUVarea +=1
					)
				)
			)
			--	calculate the UV area in percents of whole bitmap
			uvAreaInPercents = (curObjUVarea as float / 100.0)
			
			append smartArr #(uvAreaInPercents,$)
			append onlyUVarea uvAreaInPercents
			
			deleteFile curObjUVTemplate
			
			windows.sendmessage commandHWND[1]  WM_SETREDRAW 1 0
		) 		
		--	rollout to show progres when calculatin uvarea
		rollout rol_showUVcalculProgres "Calculatin UV area..." width:450 height:220
		(
			
		)		
		--	open Smart dialog and make or not calculation for UV area
		on btn_smartRender lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Using__Smart_.htm"
				shellLaunch "hh" goToHelp
			)
			else
			(
				btn_smartRender.bitmap = (openBitmap (url+"miauuITsmartHover.png"))
				clockT.active = false
				case of
				(
					(smartState == 1):
					(
						if smartIsRuning == false then
						(
							SmartAllLPwithProj = FindObjWithProjMod()
							dataSelMinorLP = #()
							select SmartAllLPwithProj
							dataSelMinorLP = for o in SmartAllLPwithProj collect #(o, o.material)
							
							if SmartAllLPwithProj.count != 0 then
							(
								--	set to true to prevent multiple calculations if Preset or Settings are pressed or LiveLog Display a message
								smartIsRuning = true
								smartArr = #()
								onlyUVarea = #()
								--	get objects UV space
								for s = 1 to SmartAllLPwithProj.count do
								(
									--	shgow the calculatin UV progres dialog
									local progressScale = (100.0*s/SmartAllLPwithProj.count) as integer
									posX = (gw.getWinSizex() / 2) - 200
									createdialog rol_showUVcalculProgres 500 0 posX 130 style:#(#style_toolwindow) 
									rol_showUVcalculProgres.title = "RTTAssist Live Log:"+" Calculating UV area: Total Progress: "+ (/* (maxFilesToBatch.count - f) */progressScale as string)+"%"+ \
									"     Objects left: "+((SmartAllLPwithProj.count - s) as string)
									
									select SmartAllLPwithProj[s]
									if getCommandPanelTaskMode() != #modify do setCommandPanelTaskMode #modify
									GetUVbyBitmap()
								)
								freeSceneBitmaps()
								--	destroy calculating UV pogres dialog
								destroyDialog rol_showUVcalculProgres
								--	open Smart rollout to select presets
								PlaceSmartControls()
								--	set the text for min and max UV area
								dNet_lbl_minUVarea.text = "minUVarea: "+ (substring ((amin onlyUVarea) as string) 1 5) + "%"
								dNet_lbl_maxUVarea.text = "maxUVarea: "+ (substring ((amax onlyUVarea) as string) 1 5) + "%"
								--	load predefined presets 
								dNet_TextBoxUnimp.text = ((getIniSetting miauuIniFile "Smart" "UnimpPrstN") as string)
								dNet_TextBoxImp.text = ((getIniSetting miauuIniFile "Smart" "ImpPrstN") as string)
								
								UnimpPrst = dNet_TextBoxUnimp.text as string
								if UnimpPrst.count != 0 do
									LoadSmartPreset "UnimpPrst"

								smartState = 0
							)
							else
							(
								errMssg = 15
								ErrorMessage 15	--	no objects with Projection modifier
							)
						)
						else		--	show Smart settings withot making new calculation
						(
							--	open Smart rollout
							PlaceSmartControls()
							--	set the text for min and max UV area
							dNet_lbl_minUVarea.text = "minUVarea: "+ (substring ((amin onlyUVarea) as string) 1 5) + "%"
							dNet_lbl_maxUVarea.text = "maxUVarea: "+ (substring ((amax onlyUVarea) as string) 1 5) + "%"
							smartState = 0
						)
					)
					(smartState == 0):
					(
						for e = 250 to 179 by -5 do
						(
							miauuRTTassist.height = e
						)							
						smartState = 1					
					) 
				)
			)				
		)
		--	return original materials to objects and close dialog
 		on btn_smartRender rbuttonup do
		(
			btn_smartRender.bitmap = (openBitmap (url+"miauuITsmart.png"))
			dNet_smartSpinner.text = "0.0"
			smartIsRuning = false
			smartState = 1
			if dataSelMinorLP.count != 0 do
				for d in dataSelMinorLP where isValidNode d[1] do d[1].material = d[2]

			smartArrMinor = #()
			smartArrMajor = #()
			--	close Smart settings part of main UI
			for e = 250 to 179 by -5 do
			(
				miauuRTTassist.height = e
			)
			try(destroyDialog ObjByUVArea)catch()
		)
		--	show or hide original materials
 		on btn_smartRender mbuttonup do
		(
			case of
			(
				(smartStateMat == 1):
				(
					if smartIsRuning == true do
					(
						if smartArrMinor.count != 0 or smartArrMajor.count != 0 then
						(
							if dataSelMinorLP.count != 0 do
								for d in dataSelMinorLP do d[1].material = d[2]
									
							smartStateMat = 0
						)
						else
						(
							errMssg = 25
							ErrorMessage 25
						)
					)
				)
 				(smartStateMat == 0):
				(	
					--	put red material to Minor objects
					for o in smartArrMinor do
						o.material = standardMaterial diffuse:(color 146 0 0) ambient:(color 146 0 0) selfIllumAmount: 50.0 showInViewport:true		
					--	put Green material to Major objects
					for o in smartArrMajor do
						o.material = standardMaterial diffuse:(color 0 71 0) ambient:(color 0 71 0) selfIllumAmount: 50.0 showInViewport:true	
					smartStateMat = 1					
				) 
			)
		)
		on btn_smartRender mouseover do
		(
			btn_smartRender.bitmap = (openBitmap (url+"miauuITsmartHover.png"))
		)
		on btn_smartRender mouseout do
		(
			if smartIsRuning == true do
				btn_smartRender.bitmap = (openBitmap (url+"miauuITsmartHover.png"))
			if smartIsRuning == false do
				btn_smartRender.bitmap = (openBitmap (url+"miauuITsmart.png"))
		)
		--	
		function ApplyNewSmartMat =
		(
			currCmndPanelMode = getCommandPanelTaskMode()
			setCommandPanelTaskMode mode:#create
			-- find all object with UV space smaller than smartSpinner value
			smartArrMinor = #()
			smartArrMajor = #()
			maxMinorVal = dNet_smartSpinner.text as float
			for i = 1 to smartArr.count do
			(
				if smartArr[i][1] <= maxMinorVal then
				(
					local selMinorLP = smartArr[i][2]	
					--	collect minor LP objects
					append smartArrMinor selMinorLP
					--	applay new material	
					select selMinorLP					
					selMinorLP.material = standardMaterial diffuse:(color 146 0 0) ambient:(color 146 0 0) selfIllumAmount: 50.0 showInViewport:true							
				)
				else
				(
					append smartArrMajor smartArr[i][2]	
 					smartArr[i][2].material = standardMaterial diffuse:(color 0 71 0) ambient:(color 0 71 0) selfIllumAmount: 50.0 showInViewport:true	
				)	
			)
			setCommandPanelTaskMode mode:currCmndPanelMode
		)
		function ApplyNewSmartMat01 =
		(
			if dataSelMinorLP.count != 0 do
				for d in dataSelMinorLP do d[1].material = d[2]
					
			ApplyNewSmartMat()
			if ObjByUVArea.open == true do
				ObjByUVArea.ColorTheObjectsBackground()
		)
		on dNet_smartSpinner KeyUp s e do 
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				if dNet_smartSpinner.text != undefined do	ApplyNewSmartMat01()	
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				if dNet_smartSpinner.text != undefined do	ApplyNewSmartMat01()			
			)
		)
		on  dNet_smartSpinner LostFocus e do
		(
			if dNet_smartSpinner.text != undefined do	ApplyNewSmartMat01()			
		) 
		on btn_smartSpinnerUP lbuttondown do
		(			
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Using__Smart_.htm#smartspinner"
				shellLaunch "hh" goToHelp
			)
			else
			(
				dNet_smartSpinner.text = ((dNet_smartSpinner.text as float) + 0.1) as string	
		
				ApplyNewSmartMat()	
				--	refresh Smart list
				if ObjByUVArea.open == true do
					ObjByUVArea.ColorTheObjectsBackground()
			)	
		)
		on btn_smartSpinnerDown lbuttondown do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Using__Smart_.htm#smartspinner"
				shellLaunch "hh" goToHelp
			)
			else
			(
				dNet_smartSpinner.text = ((dNet_smartSpinner.text as float) - 0.1) as string
				
				--	return original materials to minor LP objects
				if dataSelMinorLP.count != 0 do
					for d in dataSelMinorLP do d[1].material = d[2]
				
				if (dNet_smartSpinner.text as float) < 0.0 then 
					dNet_smartSpinner.text = "0.0"
				else
					if (dNet_smartSpinner.text as float) != 0.0 do
					(
						ApplyNewSmartMat()
						--	refresh Smart list
						if ObjByUVArea.open == true do
							ObjByUVArea.ColorTheObjectsBackground()
					)
			)
		)
		--	set spinner value to zero
		on btn_smartSpinnerDown rbuttonup do
		(			
			DestroyPresetRollout()
			dNet_smartSpinner.text = "0.0"
			
			--	return original materials to minor LP objects
			if dataSelMinorLP.count != 0 do
				for d in dataSelMinorLP do d[1].material = d[2]
		)
		-- set unimportant object
		on btn_setUnimp lbuttonup do
		(
			-- move selected object from smartArrMajor to smartArrMinor array
			objArr = selection
			if objArr.count != 0 then
			(
				for obj in objArr do
				(
					n = findItem smartArrMajor obj
					if n != 0 then
					(
						deleteItem smartArrMajor n						
						append smartArrMinor obj						
						--	put RED material
						obj.material = standardMaterial diffuse:(color 146 0 0) ambient:(color 146 0 0) selfIllumAmount: 50.0 showInViewport:true
						--	refresh Smart list
						if ObjByUVArea.open == true do
							ObjByUVArea.ColorTheObjectsBackground()
					)
					else
					(
						errMssg = 26
						ErrorMessage 26	-- "This object is already set as Unimportant\nor this is not a Low-Poly object!"
					)
				)
			)
			else
			(
				errMssg = 21
				ErrorMessage 21	--	please select some low-poly objects first
			)
		)
		on btn_setUnimp mouseover do
		(
			btn_setUnimp.bitmap = (openBitmap (url+"miauuITsetUnimpHover.png"))
		)
		on btn_setUnimp mouseout do
		(
			btn_setUnimp.bitmap = (openBitmap (url+"miauuITsetUnimp.png"))
		)
		--	set important object
		on btn_setImp lbuttonup do
		(
			-- move selected object from smartArrMinor to smartArrMajor array 
			objArr = selection
			if objArr.count != o then
			(
				for obj in objArr do
				(
				--	remove obj from Unimportant
					n = findItem smartArrMinor obj
					if n != 0 then
					(
						deleteItem smartArrMinor n
						--	add obj to Important
						append smartArrMajor obj
						--	put GREEN material
						obj.material = standardMaterial diffuse:(color 0 71 0) ambient:(color 0 71 0) selfIllumAmount: 50.0 showInViewport:true	
						--	refresh Smart list
						if ObjByUVArea.open == true do
							ObjByUVArea.ColorTheObjectsBackground()
					)
					else
					(
						errMssg = 28
						ErrorMessage 28	-- "This object is already set as Important\nor this is not a Low-Poly object"
					)
				)
			)
			else
			(
				errMssg = 21
				ErrorMessage 21	--	please select some low-poly objects first
			)
		)
		on btn_setImp mouseover do
		(
			btn_setImp.bitmap = (openBitmap (url+"miauuITsetImpHover.png"))
		)
		on btn_setImp mouseout do
		(
			btn_setImp.bitmap = (openBitmap (url+"miauuITsetImp.png"))
		)
		--	load preset for Unimportant objects
		on dNet_TextBoxUnimp_Arrow lbuttonup do
		(
			case of
			(
				(presetSmartUnim ==1) : 
				(
					local presetROwidth = 120
					local presetROheight = 79
					rollout smartPresetUnimpRO "Smart Preset Unimportant" 
					(
						local tempMainUIheight = undefined
						local selColor = (dotNetClass "System.Drawing.Color").LightSteelBlue
						local selColor1 = (dotNetClass "System.Drawing.Color").DimGray	

						local SetupListView
						local pathToPresets = GetDir #userscripts + "\\RTTassist\\Presets\\"
						local pathToPresetsRPS = GetDir #userscripts + "\\RTTassist\\Presets\\"
						local theFiles = getFiles (GetDir #userscripts + "\\RTTassist\\Presets\\*.rpf")
						local lvItems=for f in theFiles collect getFilenameFile f 
						--	
						dotNetControl lv "System.Windows.Forms.ListView" width:118 height:96 pos:[1,1]
						
						function GetSelection =
						(
							for x=0 to lv.selectedIndices.count-1 collect lv.selectedIndices.item[x]
						)						
						function SetupListView = 
						(  						  
							local topItemNum=0
							if lv.items.count>0 do
								topItemNum=lv.TopItem.index
						  
							lv.clear()
							theFiles = getFiles (GetDir #userscripts + "\\RTTassist\\Presets\\*.rpf")
							lvItems=for f in theFiles collect getFilenameFile f
							
							lv.View = (dotNetClass "System.Windows.Forms.View").Details
							lv.fullRowSelect = true
							lv.gridLines = false
							lv.HideSelection=false
							lv.BorderStyle=lv.BorderStyle.none
							lv.backColor=lv.backColor.DimGray
							lv.foreColor=lv.foreColor.lightGray
							lv.headerStyle = lv.headerStyle.none
							
							dnFontStyle = dotNetClass "System.Drawing.FontStyle"
							myFontStyle = dotnet.combineenums dnFontStyle.bold
							lv.font = dotNetObject "System.Drawing.Font" "Arial" 9 myFontStyle
							
							lv.Columns.add "Presets Names" 150

							theRange = #() 
							for x=1 to lvItems.count do
							(
								li = dotNetObject "System.Windows.Forms.ListViewItem" lvItems[x]; append theRange li 
							)  						  
							lv.Items.AddRange theRange							
							if lv.items.count>0 do 
								lv.TopItem=lv.items.item[topItemNum]
						)

						on lv ItemSelectionChanged  arg do
						(
							arg.Item.BackColor = if arg.isSelected then selColor else lvBackColor
							arg.Item.ForeColor = if arg.isSelected then selColor1 else lvForeColor
							miauuRTTassist.dNet_TextBoxUnimp.text = arg.Item.text
							selectedPreset = undefined	
							selectedItem = GetSelection()
							if selectedItem.count != 0 do
							(
								selectedPreset = arg.item.text							
								pathToPresets += selectedPreset + ".rpf"
								pathToPresetsRPS += selectedPreset + ".rps"								
								setIniSetting miauuIniFile "Smart" "UnimpPrstN" (arg.Item.text as string)
								setIniSetting miauuIniFile "Smart" "UnimpPrst" (pathToPresets as string)
								setIniSetting miauuIniFile "Smart" "UnimpPrstR" (pathToPresetsRPS as string) 
								--	load preset to prevent error "select map type first" when press the Render button with RMB
								LoadSmartPreset "UnimpPrst"
							)							
							destroyDialog smartPresetUnimpRO
						)
						
						on smartPresetUnimpRO open do
						(
							SetupListView()
							tempMainUIheight = miauuRTTassist.height
						)			 
						on smartPresetUnimpRO close do
						(
							miauuRTTassist.presetSmartUnim = 1
							--	hide all controls in Selected Map Unique Settings
							miauuRTTassist.HideOthers()
							--	if Preset Manager or Map Settings  are opened hold its opened
							miauuRTTassist.height = tempMainUIheight
						)						
					)
					local mainROpos = GetDialogPos miauuRTTassist
					local posX = mainROpos.x+2
					local posY = mainROpos.y+240
					CreateDialog smartPresetUnimpRO presetROwidth presetROheight posX posY style:#() bgcolor:black --modal:true
					presetSmartUnim = 0
				)
				(presetSmartUnim ==0) : 
				(
					try(destroyDialog smartPresetUnimpRO)catch()
					presetSmartUnim = 1
				)
			)
		)
		--	load preset for Important objects
		on dNet_TextBoxImp_Arrow lbuttonup do
		(
			case of
			(
				(presetSmartIm ==1) : 
				(
					local presetROwidth = 120
					local presetROheight = 79
					rollout smartPresetImpRO "Smart Preset Unimportant" 
					(
						local tempMainUIheight = undefined
						local selColor = (dotNetClass "System.Drawing.Color").LightSteelBlue	
						local selColor1 = (dotNetClass "System.Drawing.Color").DimGray	

						local SetupListView
						local pathToPresets = GetDir #userscripts + "\\RTTassist\\Presets\\"
						local pathToPresetsRPS = GetDir #userscripts + "\\RTTassist\\Presets\\"
						local theFiles = getFiles (GetDir #userscripts + "\\RTTassist\\Presets\\*.rpf")
						local lvItems=for f in theFiles collect getFilenameFile f 
						--	
						dotNetControl lv "System.Windows.Forms.ListView" width:118 height:96 pos:[1,1]
						
						function GetSelection =
						(
							for x=0 to lv.selectedIndices.count-1 collect lv.selectedIndices.item[x]
						)						
						function SetupListView = 
						(  						  
							local topItemNum=0
							if lv.items.count>0 then
								topItemNum=lv.TopItem.index
						  
							lv.clear()
							theFiles = getFiles (GetDir #userscripts + "\\RTTassist\\Presets\\*.rpf")
							lvItems=for f in theFiles collect getFilenameFile f
							
							lv.View = (dotNetClass "System.Windows.Forms.View").Details 
							lv.fullRowSelect = true 
							lv.gridLines = false
							lv.HideSelection=false
							lv.BorderStyle=lv.BorderStyle.none
							lv.backColor=lv.backColor.DimGray
							lv.foreColor=lv.foreColor.lightGray
							lv.headerStyle = lv.headerStyle.none 
							
							dnFontStyle = dotNetClass "System.Drawing.FontStyle"
							myFontStyle = dotnet.combineenums dnFontStyle.bold
							lv.font = dotNetObject "System.Drawing.Font" "Arial" 9 myFontStyle
							
							lv.Columns.add "Presets Names" 150 						  
							
							theRange = #() 
							for x=1 to lvItems.count do
							(
								li = dotNetObject "System.Windows.Forms.ListViewItem" lvItems[x]; append theRange li 
							)  
						  
							lv.Items.AddRange theRange 
							
							if lv.items.count>0 then 
								lv.TopItem=lv.items.item[topItemNum] 
						)
						--	Load preset
						on lv ItemSelectionChanged  arg do
						(
							arg.Item.BackColor = if arg.isSelected then selColor else lvBackColor
							arg.Item.ForeColor = if arg.isSelected then selColor1 else lvForeColor
							miauuRTTassist.dNet_TextBoxImp.text = arg.Item.text
							--	the name of selected preset
							selectedPreset = undefined	
							--	get the index of selected item - zero based array
							selectedItem = GetSelection()
							--	get the name of selected preset
							if selectedItem.count != 0 do
							(
								selectedPreset = arg.item.text							
								pathToPresets += selectedPreset + ".rpf"
								pathToPresetsRPS += selectedPreset + ".rps"
								setIniSetting miauuIniFile "Smart" "ImpPrstN" (arg.Item.text as string)
								setIniSetting miauuIniFile "Smart" "ImpPrst" (pathToPresets as string)
								setIniSetting miauuIniFile "Smart" "ImpPrstR" (pathToPresetsRPS as string) 
							)							
							destroyDialog smartPresetImpRO
						)
						
						on smartPresetImpRO open do
						(
							SetupListView()
							tempMainUIheight = miauuRTTassist.height
						)			 
						on smartPresetImpRO close do
						(
							miauuRTTassist.presetSmartIm = 1
							miauuRTTassist.HideOthers()
							miauuRTTassist.height = tempMainUIheight
						) 						
					)
					local mainROpos = GetDialogPos miauuRTTassist
					local posX = mainROpos.x+123
					local posY = mainROpos.y+240
					CreateDialog smartPresetImpRO presetROwidth presetROheight posX posY style:#() bgcolor:black --modal:true
					presetSmartIm = 0
				)
				(presetSmartIm ==0) : 
				(
					try(destroyDialog smartPresetImpRO)catch()
					presetSmartIm = 1
				)
			)
		)		
--------------------------------
--	Explode spinner definition
--------------------------------
		on dNet_TxtBoxAsSpinner KeyUp s e do 
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				if dNet_TxtBoxAsSpinner.text != undefined do
					dNetTBasSpn = dNet_TxtBoxAsSpinner.text as float
				
				if explodeImplodeImgTagState == 0 and prefixNameLP != undefined and prefixNameHP != undefined then			
				(
					ExplodeObjPrep dNetTBasSpn (spn_animDistance.text as float) 1
				)
				else
				(
					if prefixNameLP == undefined and prefixNameHP == undefined then
					(
						errMssg = 1
						ErrorMessage 1
						dNet_TxtBoxAsSpinner.text = "1.0"
					)
					else
					(
						errMssg = 5
						ErrorMessage 5
						dNet_TxtBoxAsSpinner.text = "1.0"
					)
				)	
			)

			if e.KeyCode == e.KeyCode.Tab do
			(
				if dNet_TxtBoxAsSpinner.text != undefined then
					dNetTBasSpn = dNet_TxtBoxAsSpinner.text as float
				
				if explodeImplodeImgTagState == 0 and prefixNameLP != undefined and prefixNameHP != undefined then			
				(
					ExplodeObjPrep dNetTBasSpn (spn_animDistance.text as float) 1
				)
				else
				(
					if prefixNameLP == undefined and prefixNameHP == undefined then
					(
						errMssg = 1
						ErrorMessage 1
						dNet_TxtBoxAsSpinner.text = "1.0"
					)
					else
					(
						errMssg = 5
						ErrorMessage 5
						dNet_TxtBoxAsSpinner.text = "1.0"
					)
				)	
			)
		)

		on  dNet_TxtBoxAsSpinner LostFocus e do
		(
			if dNet_TxtBoxAsSpinner.text != undefined then
				dNetTBasSpn = dNet_TxtBoxAsSpinner.text as float

			if explodeImplodeImgTagState == 0 and prefixNameLP != undefined and prefixNameHP != undefined then			
			(
				ExplodeObjPrep dNetTBasSpn (spn_animDistance.text as float) 1
			)
			else
			(
				if prefixNameLP == undefined and prefixNameHP == undefined then
				(
					errMssg = 1
					ErrorMessage 1
					dNet_TxtBoxAsSpinner.text = "1.0"
				)
				else
				(
					errMssg = 5
					ErrorMessage 5
					dNet_TxtBoxAsSpinner.text = "1.0"
				)
			)	
			
		) 
		on btn_Explode lbuttondown do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Explode_function.htm"
				shellLaunch "hh" goToHelp
			)
			else
			(
				dNet_TxtBoxAsSpinner.text = ((dNet_TxtBoxAsSpinner.text as float) + 0.1) as string			
				dNetTBasSpn = dNet_TxtBoxAsSpinner.text as float

				if explodeImplodeImgTagState == 0 and prefixNameLP != undefined and prefixNameHP != undefined then			
				(
					ExplodeObjPrep dNetTBasSpn (spn_animDistance.text as float) 1
				)
				else
				(
					if prefixNameLP == undefined and prefixNameHP == undefined then
					(
						errMssg = 1
						ErrorMessage 1
						dNet_TxtBoxAsSpinner.text = "1.0"
					)
					else
					(
						errMssg = 5
						ErrorMessage 5
						dNet_TxtBoxAsSpinner.text = "1.0"
					)
				)	
			)	
		)
		on btn_Implode lbuttondown do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Explode_function.htm"
				shellLaunch "hh" goToHelp
			)
			else
			(
				dNet_TxtBoxAsSpinner.text = ((dNet_TxtBoxAsSpinner.text as float) - 0.1) as string
				if (dNet_TxtBoxAsSpinner.text as float) < 1.0 then 
					dNet_TxtBoxAsSpinner.text = "1.0"
				
				dNetTBasSpn = dNet_TxtBoxAsSpinner.text as float
				
				if explodeImplodeImgTagState == 0 and prefixNameLP != undefined and prefixNameHP != undefined then			
				(
					ImplodeObj()
				)
				else
				(
					if prefixNameLP == undefined and prefixNameHP == undefined then
					(
						errMssg = 1
						ErrorMessage 1
						dNet_TxtBoxAsSpinner.text = "1.0"
					)
					else
					(
						errMssg = 5
						ErrorMessage 5
						dNet_TxtBoxAsSpinner.text = "1.0"
					)
				)	
			)
		)
		--	set spinner value to zero
		on btn_Implode rbuttonup do
		(			
			DestroyPresetRollout()
			dNet_TxtBoxAsSpinner.text = "1.0"
			dNetTBasSpn = dNet_TxtBoxAsSpinner.text as float
			
		)
-----------------------------------------------		
--	Work with All/Selected/Visible object	
-----------------------------------------------		
		on chkbtn_IsSelect lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#selectedmode"
				shellLaunch "hh" goToHelp
			)
			else
			(
				selObj = #() as array
				case of
				(
					(isSelectObj == 0):
					(
						chkbtn_IsSelect.bitmap = (openBitmap (url+"miauuITisSelobjHover.png"))
						if (visibleObj == 1) or (allObjITState == 1)  do
						(
							chkbtn_IsVisible.bitmap = (openBitmap (url+"miauuITvisible.png"))
							chkbtn_All.bitmap = (openBitmap (url+"miauuITAllobj.png"))
							visibleObj = 0
							allObjITState = 0
						)
						GetSelectedObj()
						isSelectObj = 1
					)
					(isSelectObj == 1):
					(
						GetSelectedObj()
						isSelectObj = 0
					)
				)
			)
		)
		on chkbtn_IsSelect mouseover do
		(
			chkbtn_IsSelect.bitmap = (openBitmap (url+"miauuITisSelobjHover.png"))
		)
		on chkbtn_IsSelect mouseout do
		(
			if isSelectObj == 1 do
				chkbtn_IsSelect.bitmap = (openBitmap (url+"miauuITisSelobjHover.png"))
			if isSelectObj == 0 do
			(
				if allObjITState == 0 and visibleObj == 0 then
					chkbtn_IsSelect.bitmap = (openBitmap (url+"miauuITisSelobjHover.png"))
				else
					chkbtn_IsSelect.bitmap = (openBitmap (url+"miauuITisSelobj.png"))
			)
		)
		on chkbtn_IsVisible lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#visiblemode"
				shellLaunch "hh" goToHelp
			)
			else
			(
				selObj = #() as array
				case of
				(
					(visibleObj == 0):
					(
						chkbtn_IsVisible.bitmap = (openBitmap (url+"miauuITvisibleHover.png"))
						if (isSelectObj == 1) or (allObjITState == 1) do
						(
							chkbtn_All.bitmap = (openBitmap (url+"miauuITAllobj.png"))
							chkbtn_IsSelect.bitmap = (openBitmap (url+"miauuITisSelobj.png"))
							isSelectObj = 0
							allObjITState = 0
						)
						GetVisibleObj()
						visibleObj = 1
					)
					(visibleObj == 1):
					(
						GetVisibleObj()
						visibleObj = 0
					)
				)
			)
		)
		on chkbtn_IsVisible mouseover do
		(
			chkbtn_IsVisible.bitmap = (openBitmap (url+"miauuITvisibleHover.png"))
		)
		on chkbtn_IsVisible mouseout do
		(
			if visibleObj == 1 do
				chkbtn_IsVisible.bitmap = (openBitmap (url+"miauuITvisibleHover.png"))
			if visibleObj == 0 do
			(
				if isSelectObj == 0 and allObjITState == 0 then
					chkbtn_IsVisible.bitmap = (openBitmap (url+"miauuITvisibleHover.png"))
				else
					chkbtn_IsVisible.bitmap = (openBitmap (url+"miauuITvisible.png"))
			)
		)
		on chkbtn_All lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#allmode"
				shellLaunch "hh" goToHelp
			)
			else
			(
				selObj = #() as array
				case of
				(
					(allObjITState == 0):
					(
						chkbtn_All.bitmap = (openBitmap (url+"miauuITAllobjHover.png"))
						if (isSelectObj == 1) or (visibleObj == 1) do
						(
							chkbtn_IsSelect.bitmap = (openBitmap (url+"miauuITisSelobj.png"))
							chkbtn_IsVisible.bitmap = (openBitmap (url+"miauuITvisible.png"))
							isSelectObj = 0
							visibleObj = 0
						)
						GetAllObj()
						allObjITState = 1
					)
					(allObjITState == 1):
					(
						GetAllObj() 
						allObjITState = 0
					)
				)
			)
		)
		on chkbtn_All mouseover do
		(
			chkbtn_All.bitmap = (openBitmap (url+"miauuITAllobjHover.png"))
		)
		on chkbtn_All mouseout do
		(
			if allObjITState == 1 do
				chkbtn_All.bitmap = (openBitmap (url+"miauuITAllobjHover.png"))
			if allObjITState == 0 do
			(
				if isSelectObj == 0 and visibleObj == 0 then
					chkbtn_All.bitmap = (openBitmap (url+"miauuITAllobjHover.png"))
				else
					chkbtn_All.bitmap = (openBitmap (url+"miauuITAllobj.png"))
			)
		)
-----------------------------
--	define point to explode
-----------------------------
		on chkbox_explodeFromTop changed theState do
		(
			if theState then
			(
				if (chkbox_explodeFromCenter.state == on) or (chkbox_explodeFromBottom.state == on) do
				(
					chkbox_explodeFromCenter.state = off
					chkbox_explodeFromBottom.state = off
				)
			)
			else
				chkbox_explodeFromTop.state = on
		)
		on chkbox_explodeFromCenter changed theState do
		(
			if theState then
			(
				if (chkbox_explodeFromTop.state == on) or (chkbox_explodeFromBottom.state == on) do
				(
					chkbox_explodeFromTop.state = off
					chkbox_explodeFromBottom.state = off
				)
			)
			else
				chkbox_explodeFromCenter.state = on
		)
		on chkbox_explodeFromBottom changed theState do
		(
			if theState then
			(
				if (chkbox_explodeFromTop.state == on) or (chkbox_explodeFromCenter.state == on) do
				(
					chkbox_explodeFromTop.state = off
					chkbox_explodeFromCenter.state = off
				)
			)
			else
				chkbox_explodeFromBottom.state = on
		)
-----------------------------
	--	Open Settings, Render and Map rollouts
-----------------------------
		on btn_settings lbuttonup do
		(
			DestroyPresetRollout()
			case of
			(
				(settingsButtonState ==1) : 
				(
					btn_settings.bitmap = (openBitmap (url+"miauuITsettingsClose.png"))
					btn_renderDialog.bitmap = (openBitmap (url+"miauuITrendersettings.png"))
					btn_openMapSettings.bitmap = (openBitmap (url+"miauuITmapsettingsOpen.png"))
					--	remove render dialog controls and message labels
					placeSettingsControls()
					--	remove Smart settings
					removeOnlySmartSettings()
					if smartState == 0 do smartState = 1
					if batchState == 0 do batchState = 1
						
					settingsButtonState=0
					if renderButtonState == 0 do
						renderButtonState = 1
					if mapButtonState == 0 do
						mapButtonState = 1
				)
				(settingsButtonState ==0) : 
				(
					btn_settings.bitmap = (openBitmap (url+"miauuITsettings.png"))
-- 					for aControl in miauuRTTassist.controls do
-- 					(
-- 						case classof aControl of
-- 						(
-- 							SpinnerControl: setIniSetting miauuIniFile "Spinner" (aControl.name as string) (aControl.value as string)
-- 							CheckBoxControl: setIniSetting miauuIniFile "Checkbox" (aControl.name as string) (aControl.state as string)
-- 						)
-- 					)
					--	close settings part of rollout
					for f = 279 to 177 by -5 do
					(
						sleep 0.002
						miauuRTTassist.height = f
					)
					settingsButtonState=1
					if renderButtonState == 0 do
						renderButtonState = 1
					if mapButtonState == 0 do
						mapButtonState = 1
				)
			)
		)
	--	open Render dialog
		on btn_renderDialog lbuttonup do
		(
			DestroyPresetRollout()
			case of
			(
				(renderButtonState ==1) : 
				(
					btn_renderDialog.bitmap = (openBitmap (url+"miauuITrendersettingsClose.png"))
					btn_settings.bitmap = (openBitmap (url+"miauuITsettings.png"))
					PlaceRenderControls()
					--	remove Smart settings
					removeOnlySmartSettings()	
					--	remove Smart settings
					removeOnlySmartSettings()
					if smartState == 0 do smartState = 1
					if batchState == 0 do batchState = 1
					
					renderButtonState=0
					if settingsButtonState == 0 do
						settingsButtonState = 1
				)
				(renderButtonState ==0) : 
				(
					btn_renderDialog.bitmap = (openBitmap (url+"miauuITrendersettings.png"))
					btn_openMapSettings.bitmap = (openBitmap (url+"miauuITmapsettingsOpen.png"))
					for f = 279+25+20 to 177 by -5 do
					(
						sleep 0.002
						miauuRTTassist.height = f
					)
					renderButtonState=1
					if mapButtonState == 0 do
						mapButtonState = 1
					if settingsButtonState == 0 do
						settingsButtonState = 1
				)
			)
		)
	--	open map settings in Render dialog
		on btn_openMapSettings lbuttonup do
		(
			DestroyPresetRollout()
			case of
			(
				(mapButtonState ==1) : 
				(
					btn_openMapSettings.bitmap = (openBitmap (url+"miauuITmapsettingsClose.png"))
					PlaceProjectionContros()	
					for e = 279+25+20+13 to 585+19+20+20 by 5 do
					(
						miauuRTTassist.height = e
						sleep 0.002
					)
					mapButtonState=0
				)
				(mapButtonState ==0) : 
				(
					btn_openMapSettings.bitmap = (openBitmap (url+"miauuITmapsettingsOpen.png"))
					for f = 585+19+20+20 to 279+25+20+13 by -5 do
					(
						sleep 0.002
						miauuRTTassist.height = f
					)
					mapButtonState=1
				)
			)
		)
------------------------------------
	--	Explode animation spinners
------------------------------------
		on btn_sTimeUP lbuttonup do
		(
			if spn_sTime.text < "1.0" do
				spn_sTime.text = ((spn_sTime.text as float) + 0.01) as string
		)
		on btn_sTimeDown lbuttonup do
		(
			if spn_sTime.text != "0" do
				spn_sTime.text = ((spn_sTime.text as float) - 0.01) as string
		)
		on btn_sTimeDown rbuttonup do
		(
			spn_sTime.text = "0"
		)
		on btn_animDistanceUP lbuttonup do
		(
			spn_animDistance.text = ((spn_animDistance.text as float) + 0.01) as string
		)
		on btn_animDistanceDown lbuttonup do
		(
			if spn_animDistance.text != "1.01" do
				spn_animDistance.text = ((spn_animDistance.text as float) - 0.01) as string
		)
		on btn_animDistanceDown rbuttonup do
		(
			spn_animDistance.text = "1.01"
		)
-----------------------
	--	Rename Menager
-----------------------
		on btn_renameObj lbuttonup do
		(
			DestroyPresetRollout()
			try(destroydialog miauuRenameMenager)catch()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#renamebutton"
				shellLaunch "hh" goToHelp
			)
			else
			(
				rollout miauuRenameMenager "RTTAssist Rename Manager"
				(
					local rmFind = undefined
					local rmReplace = undefined
					local items = #() as array
					local itemsNames = #() as array
					local newItemsNames = #() as array
					edittext edttxt_Find "Find" fieldWidth:50 pos:[5,5] bold:true
					edittext edttxt_Replace "Replace" fieldWidth:50 pos:[90,5] bold:true
					button btn_FandR "Rename"

					function FindStringAndReplace str find repl = 
					(
						local result = undefined
						strF = findString str find
						if strF != undefined then
							result = (replace str strF find.count repl)
						else 
							result = str
						
						result
					)
					on edttxt_Find changed txt do
					(
						if txt != "" then
						(
							rmFind = txt
						)
						else
							rmFind = undefined
					)
					on edttxt_Replace changed txt do
					(
						if txt != "" then
						(
							rmReplace = txt
						)
						else
							rmReplace = undefined
					)
					on btn_FandR pressed do
					(
						selRen = #() as array
						if miauuRTTassist.allObjITState == 1 do
						(
							selRen = #() as array
							for o in objects where classof o != Biped_Object and superClassOf o != helper do
								append selRen o
						)
						if miauuRTTassist.isSelectObj == 1 do
						(
							selRen = #() as array
							for s in selection where classof s != Biped_Object and superClassOf s != helper do
								append selRen s
						)
						if miauuRTTassist.visibleObj == 1 do
						(
							selRen = #() as array
							for o in objects where classof o != Biped_Object and superClassOf o != helper do
							(
								if o.isHidden == false do
									append selRen o
							)
						)					
						--	collect all obj in scene
						for s in selRen do
							append items s
						--	collect the names of objects
						for j in items do append itemsNames j.name
						--	rename the objects and store the new names
						for i = 1 to itemsNames.count do
						(
							finalName = FindStringAndReplace itemsNames[i] rmFind rmReplace
							append newItemsNames finalName
						)
						--	put the new name to objects
						for i = 1 to newItemsNames.count do items[i].name = newItemsNames[i]
						--	empty the arrays
						items = #() as array
						itemsNames = #() as array
						newItemsNames = #() as array
					)
				)			
				createdialog miauuRenameMenager width:200
				setFocus miauuRenameMenager.edttxt_Find	
			)
		)
	--	autorename on right click
		on btn_renameObj rbuttonup do
		with undo "Rename Objects" on
		(
			DestroyPresetRollout()
			if prefixNameLP != undefined and prefixNameHP != undefined and prefixNameLPAdd != undefined and prefixNameHPAdd != undefined do
			(
				if CheckObjAndPrefixLP() == true and CheckObjAndPrefixHP() == true and CheckObjAndPrefixLPAdd() == true and CheckObjAndPrefixHPAdd() == true do
				(
					local rmFindL = prefixNameLPAdd
					local rmFindH = prefixNameHPAdd
					local rmReplaceL = prefixNameLP
					local rmReplaceH = prefixNameHP
					local items = #() as array
					local itemsNames = #() as array
					local newItemsNames = #() as array
					--	function that rename all objects in scene
					function FindStringAndReplace str find repl = 
					(
						local result = undefined
						strF = findString str find
						if strF != undefined then
							result = (replace str strF find.count repl)
						else 
							result = str
						
						result
					)
				--	rename LP objects
					selObj = GetProperObj()
					--	collect all obj in scene
					for s in selObj do
						append items s
					--	collect the names of objects
					for j in items do append itemsNames j.name
					--	rename the objects and store the new names
					for i = 1 to itemsNames.count do
					(
						finalName = FindStringAndReplace itemsNames[i] rmFindL rmReplaceL
						append newItemsNames finalName
					)
					--	put the new name to objects
					for i = 1 to newItemsNames.count do items[i].name = newItemsNames[i]
					--	empty the arrays
					items = #() as array
					itemsNames = #() as array
					newItemsNames = #() as array
				--	rename HP objects
					--	collect all obj in scene
					for s in selObj do
						append items s
					--	collect the names of objects
					for j in items do append itemsNames j.name
					--	rename the objects and store the new names
					for i = 1 to itemsNames.count do
					(
						finalName = FindStringAndReplace itemsNames[i] rmFindH rmReplaceH
						append newItemsNames finalName
					)
					--	put the new name to objects
					for i = 1 to newItemsNames.count do items[i].name = newItemsNames[i]
					--	empty the arrays
					items = #() as array
					itemsNames = #() as array
					newItemsNames = #() as array
					
					ErrorMessage 52
				)
			)
		)
		on btn_renameObj mouseover do
		(
			btn_renameObj.bitmap = (openBitmap (url+"miauuITrenameHover.png")) 
		)
		on btn_renameObj mouseout do
		(
			btn_renameObj.bitmap = (openBitmap (url+"miauuITrename.png")) 
		)
------------------
	--	Build Pairs
------------------
		function ClearDividerString objName =
		(
			--	clear divider string from LP_objects name
			local newDivStr = ""
			if dividerStr == "_" do
				newDivStr = "-"
			if dividerStr == "-" do
				newDivStr = "_"
			res = copy objName
			count = res.count
			for i = 1 to count do
			(
				if (findString dividerStr res[i]) != undefined do
					res[i] = newDivStr
			)
			
			res
		)
		function RenameSelObj _arrHP _objNames _mainHPname lmbRMB =
		(
			--	get the main HP
			HP = _arrHP[1]
			--	get the indes of the mainHP in array with all HP objects
			HPindex = findItem _objNames HP
			--	delete main HP from array of all HP objects
			deleteItem _objNames HPindex
			--	set the name of main HP
			HP.name = _mainHPname
			--	rename other HP objects
			for h=1 to _objNames.count do
			(
				if lmbRMB == 1 then
					_objNames[h].name = _mainHPname +  dividerStr + _objNames[h].name
				else
					_objNames[h].name = _mainHPname +  dividerStr + ("child0"+(h as string))
			)
		)
		function CheckForTSorMS _LP =
		(
			local result = false
			for m in _LP.modifiers do
			(
				if (classof m) == meshsmooth do result = true
				if (classof m) == TurboSmooth do result = true
			)
			
			result
		)
		--	build pairs
		function BuildPairsFN mode =
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/The_BuildPairs_Button.htm"
				shellLaunch "hh" goToHelp
			)
			else
			(
				local sel1 = selection
				local objNames = #() as array
				local objFace = #() as array
				
				if sel1.count > 1 then
				(
					--	get objects names and face count
					for o in sel1 where classof o != TargetObject  and superClassOf  o != helper do
					(
						theMesh = snapshotasmesh o
						theTest = theMesh.numfaces
						delete theMesh						
						append objNames o
						append objFace theTest
					)
					if objNames.count == 2 then
					(
						--		HP					LP
						if objFace[1] > objFace[2] then
						(	
							if mode == 1 then
							(
								clearedName = ClearDividerString objNames[2].name
							
								objNames[2].name = (GetHandleByAnim objNames[2] as string) + clearedName
								objNames[1].name = prefixNameHP + objNames[2].name
								objNames[2].name = prefixNameLP + objNames[2].name
							)
							else
							(
								objNames[1].name = prefixNameHP + et_buildParisName.text
								objNames[2].name = prefixNameLP + et_buildParisName.text
							)
						)
						else
						(
							if mode == 1 then
							(
								clearedName = ClearDividerString objNames[1].name
							
								objNames[1].name = (GetHandleByAnim objNames[1] as string) + clearedName
								objNames[2].name = prefixNameHP + objNames[1].name
								objNames[1].name = prefixNameLP + objNames[1].name
							)
							else
							(
								objNames[2].name = prefixNameHP + et_buildParisName.text
								objNames[1].name = prefixNameLP + et_buildParisName.text
							)
						)
					)
					else
					(
						tempobjNames = copy objNames #nomap
						--	remove objects with applied TS or MS modifiers
						for i = tempobjNames.count to 1 by -1 do
						(
							if (CheckForTSorMS tempobjNames[i]) == true do
								deleteItem tempobjNames i
						)
						local tempObjFace = #()
						for o in tempobjNames do
						(
							theMesh = snapshotasmesh o
							theTest = theMesh.numfaces
							delete theMesh
							append tempObjFace theTest
						)						
						--	find obj with low face count
						lowP = amin tempObjFace
						tempNumb = findItem tempObjFace lowP
						LP = tempobjNames[tempNumb]						
						--	delete LP opbj from array
						numb = findItem objNames LP
						deleteItem objNames numb						
						clearedName = ClearDividerString LP.name
						local mainHPname = undefined
						--	set the name of LP object
						if mode == 1 then
						(
							LP.name = prefixNameLP + (GetHandleByAnim LP as string) + clearedName
							--	get the name of main HP
							mainHPname = prefixNameHP + (GetHandleByAnim LP as string) + clearedName
						)
						else
						(	
							LP.name = prefixNameLP + et_buildParisName.text
							--	get the name of main HP
							mainHPname = prefixNameHP + et_buildParisName.text
						)
						--	try to find the right HP objedt with proper position compared to LP object position
							--	method one - by position
						local R = (distance LP.max LP.min) / 2	--	the raduis of BBox - define area to search for LP's BBox center
						local currLPpos = LP.center	--	the center of BBox of LP object
						local arrHP = #()	--	the main HP object - the closest match
						--	check if the center of LP is match to center of one of the HP objects
						for highBuddy in objNames do
						(
							if currLPpos == highBuddy.center do
								append arrHP highBuddy
						)
						if arrHP.count == 0 then
						(--	if there are no HP with center that match with LP cente
								--	try to find curr HP in radius of 10% of curr LP radius to BBox corner
								for highBuddy in objNames do
								(
									if (distance currLPpos highBuddy.center) <= (R*0.10) do
										append arrHP highBuddy
								)
								if arrHP.count == 0 then
								(--	if there are no HP with center in radius of 10% of LP BBox center
									--	try to find if curr HP is in radius of curr LP radius to BBox corner and two ogjects are intercest
									for highBuddy in objNames do
									(
										if ((distance currLPpos highBuddy.center) <= r) and ((intersects LP highBuddy) == true) do
											append arrHP highBuddy	
									)
									if arrHP.count == 0 then
									(
										errMssg = 23
										ErrorMessage 23	--messagebox "BuildPairs command failed.Please rename the selected objects manually!"
									)
									else
									(
										RenameSelObj arrHP objNames mainHPname 2
									)
								)
								else
								(
									RenameSelObj arrHP objNames mainHPname 2
								)								
						)
						else
						(
							RenameSelObj arrHP objNames mainHPname 2
						)
					)
					et_buildParisName.text = "   enter name"
				)
				else
				(
					errMssg = 22
					ErrorMessage 22		--	messagebox "Selecet more than one object!"
				)
			) 
			
		)
		on btn_buildPair lbuttonup do
		with undo "Build Pair" on
		(
			BuildPairsFN 1
		)
		--	user entered name for build pairs
		on et_buildParisName KeyUp s e do
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				if et_buildParisName.text != undefined and et_buildParisName.text != "" then
				(	
					BuildPairsFN 2
				)
				else
				(
					errMssg = 57
					ErrorMessage 57
				)
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				if et_buildParisName.text != undefined and et_buildParisName.text != "" then
				(
					BuildPairsFN 2
				)
				else
				(
					errMssg = 57
					ErrorMessage 57
				)
			)
		)
		on  et_buildParisName gotFocus e do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#buildpairstextfield"
				shellLaunch "hh" goToHelp
			)
			else
			(
				et_buildParisName.text = ""
			)
		)
		on  et_buildParisName LostFocus e do
		(
			if et_buildParisName.text == undefined or et_buildParisName.text == "" do
			(
				et_buildParisName.text = "   enter name"
			)		
		)
		on btn_buildPair rbuttonup do
		with undo "Build Pair" on
		(
			BuildPairsFN 2			
		)
		on btn_buildPair mouseover do
		(
			btn_buildPair.bitmap = (openBitmap (url+"miauuITbuildPairHover.png")) 
		)
		on btn_buildPair mouseout do
		(
			btn_buildPair.bitmap = (openBitmap (url+"miauuITbuildPair.png")) 
		)
------------------------------------
--	settings part of UI
------------------------------------
		on btn_faces_thresholdUP lbuttonup do
		(
			spn_faces_threshold.text = ((spn_faces_threshold.text as integer) + 1) as string
		)
		on btn_faces_thresholdDown lbuttonup do
		(
			if spn_faces_threshold.text != "0" do
				spn_faces_threshold.text = ((spn_faces_threshold.text as integer) - 1) as string
		)
		--	set spinner value to zero
		on btn_faces_thresholdDown rbuttonup do
		(
			spn_faces_threshold.text = "0"
		)
		--	cancel settings
		on btn_cancelSettings lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#resetsettings"
				shellLaunch "hh" goToHelp
			)
			else
			(
				btn_cancelSettings.bitmap = (openBitmap (url+"miauuITresetSettingsHover.png")) 
				spn_faces_threshold.text = ((getIniSetting miauuIniFile "Spinner" "spn_faces_threshold") as string)
				spn_sTime.text = ((getIniSetting miauuIniFile "Spinner" "spn_sTime") as string)
				spn_animDistance.text = ((getIniSetting miauuIniFile "Spinner" "spn_animDistance") as string)
				chkbox_AutoCheckOverlap.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_AutoCheckOverlap") as stringStream))
				chkbox_isNodeFrozen.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_isNodeFrozen") as stringStream))
				chkbox_noCageReset.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_noCageReset") as stringStream))
				chkbox_OnOffAnimation.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_OnOffAnimation") as stringStream))
				chkbox_errInViewport.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_errInViewport") as stringStream))
				chkbox_errInRollOut.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_errInRollOut") as stringStream))
				chkbox_errInMsgBox.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_errInMsgBox") as stringStream))
				chkbox_explodeFromTop.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_explodeFromTop") as stringStream))
				chkbox_explodeFromCenter.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_explodeFromCenter") as stringStream))
				chkbox_explodeFromBottom.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_explodeFromBottom") as stringStream))
				chkbox_ZeroPoint.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_ZeroPoint") as stringStream))
				chkbox_moveZeroPointObj.state = (readValue ((getIniSetting miauuIniFile "Checkbox" "chkbox_moveZeroPointObj") as stringStream))
			)
		) 
		on btn_cancelSettings mouseover do
		(
			btn_cancelSettings.bitmap = (openBitmap (url+"miauuITresetSettingsHover.png")) 
		)
		on btn_cancelSettings mouseout do
		(
			btn_cancelSettings.bitmap = (openBitmap (url+"miauuITresetSettings.png")) 
		)
		--	save settings
		on btn_saveSettings lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#savesettings"
				shellLaunch "hh" goToHelp
			)
			else
			(
				btn_saveSettings.bitmap = (openBitmap (url+"miauuITsavePresetHover.png")) 
				--	spinners
				setIniSetting miauuIniFile "Spinner" "spn_faces_threshold" (spn_faces_threshold.text as string)
				setIniSetting miauuIniFile "Spinner" "spn_sTime" (spn_sTime.text as string)
				setIniSetting miauuIniFile "Spinner" "spn_animDistance" (spn_animDistance.text as string)
				--	checkboxes
				setIniSetting miauuIniFile "Checkbox" "chkbox_AutoCheckOverlap" (chkbox_AutoCheckOverlap.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_isNodeFrozen" (chkbox_isNodeFrozen.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_noCageReset" (chkbox_noCageReset.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_OnOffAnimation" (chkbox_OnOffAnimation.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_errInViewport" (chkbox_errInViewport.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_errInRollOut" (chkbox_errInRollOut.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_errInMsgBox" (chkbox_errInMsgBox.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_explodeFromTop" (chkbox_explodeFromTop.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_explodeFromCenter" (chkbox_explodeFromCenter.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_explodeFromBottom" (chkbox_explodeFromBottom.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_ZeroPoint" (chkbox_ZeroPoint.state as string)
				setIniSetting miauuIniFile "Checkbox" "chkbox_moveZeroPointObj" (chkbox_moveZeroPointObj.state as string)	
				setIniSetting miauuIniFile "Checkbox" "chkbox_checkUpdateOnStatUp" (chkbox_checkUpdateOnStatUp.state as string)	
				
				setIniSetting miauuIniFile "Pin" "State" (pinRolloutErrMssg as string)
			)
		) 
		on btn_saveSettings mouseover do
		(
			btn_saveSettings.bitmap = (openBitmap (url+"miauuITsavePresetHover.png")) 
		)
		on btn_saveSettings mouseout do
		(
			btn_saveSettings.bitmap = (openBitmap (url+"miauuITsavePreset.png")) 
		)
		on btn_errInRollOutPin lbuttonup do
		(			
			DestroyPresetRollout()
			case of
			(
				(pinRolloutErrMssg ==1) : 
				(
					btn_errInRollOutPin.bitmap = (openBitmap (url+"miauuITpin.png")) 
					pinRolloutErrMssg = 0
				)
				(pinRolloutErrMssg ==0) : 
				(
					btn_errInRollOutPin.bitmap = (openBitmap (url+"miauuITunpin.png")) 					
					pinRolloutErrMssg = 1
				)
			) 
		)
-------------------------------------
--	render part of button events
-------------------------------------		
		on btn_BrowseFolder mouseDown senderArg arg do
		(	
			--	on LMB click - choose where to save maps
			if arg.button==arg.button.left do
			(		
				DestroyPresetRollout()
				if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
				(
					local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#output"
					shellLaunch "hh" goToHelp
				)
				else
				(
					local mapSavePath = getSavePath caption:"Select folder" initialDir:"$previews"
					if(mapSavePath != undefined)then
					(		
						btn_BrowseFolder.text = mapSavePath
						dNet_btn_BrowseFolder_Tooltip = dotnetobject "System.Windows.Forms.ToolTip"
						dNet_btn_BrowseFolder_Tooltip.ToolTipTitle = "Press to select output Path: RMB to open selected folder."
						dNet_btn_BrowseFolder_Tooltip.SetToolTip btn_BrowseFolder (mapSavePath as string)
					)	
				)	
			)	
			--	on RMB click open destinatioon folder
			if arg.button==arg.button.right do
			(				
				DestroyPresetRollout()
			
				folderToOpen = btn_BrowseFolder.text
				OpenFolders folderToOpen
			)
		)
------------------
	--	Combine Maps Rollout	
------------------
		on btn_CombineSing lbuttonup do
		(
			try(destroydialog CombineSingled)catch()
			rollout CombineSingled "Combine Maps"
			(
				local listFiles = #()
				local noA = #()
				local dir = undefined
				local mapFile = undefined
				local outputDir = undefined
				local lbBackColor = (dotNetClass "System.Drawing.Color").DimGray
				local lbForeColor = (dotNetClass "System.Drawing.Color").lightGray	
				local disableForeColor = (dotNetClass "System.Drawing.Color").Gray
				local allIndexes = #()
				local mapsToCombine = #()
				local bgColor = undefined
				local chkState = 1
				
				button btn_getDir "Select folder" pos:[5,5] width:93
				button btn_getFile "Select map" pos:[102,5] width:93
				--
				groupbox gbox_1 "Maps" pos:[2,30] width:196 height:200
					checkbox chkbox_showPreview "Show preview" pos:[93,30]
					dotNetControl lv "system.windows.forms.listView" height:150	width:190 pos:[5,45]				
					checkbutton bnt_useAll "Use All" pos:[5,205] height:20 checked:on
					checkbutton btn_useSelected "Use Selected" pos:[65,205] height:20 tooltip:"LMB - only selected maps will be combined.\nRMB - check/unckeck all maps."
					button btn_clearLV "Clear" pos:[155,205] height:20
				--
				groupbox gbox_2 "Output Path:" pos:[2,235] width:196 height:40
					button btn_SaveInFolder "Browse" pos:[5,250] width:85
					checkbox chkbox_SameAsSource "Same as source" pos:[93,253]
				--
				label lb_1 "Background color:" pos:[2,278]
				colorpicker clr_BG "" color:[0,255,0] pos:[165,280] fieldwidth:25 height:14
				checkbox chkbox_aotuBG "auto detect" pos:[93,279]
				edittext et_name "Name:" pos:[2,305] width:193
				button btn_CombineMaps "Combine Maps" pos:[40,330] width:120 height:30
				
				function CombineImages bitmapsToCombine combineMapName offOnPreview BGcolor cMapName outputDir =
				(
					if(bitmapsToCombine.count > 1)then
					(
						--	PART ONE - CREATE COMBINED MAP WITH PROPER ALPHA CHANNEL
						--	get the size of maps
						mapInfo = (getBitmapInfo bitmapsToCombine[1])
						sizeWidth = mapInfo[3]
						sizeHeight = mapInfo[4]						
						--	extension of saved file
						m_Extension = getFilenameType bitmapsToCombine[1]
						--	folder where to save rendered map
						m_RenderPath = outputDir
						m_RenderPath += "\\"
						
						texList = #() as array
						texListM = #() as array
						--create a composite map
						theComp = CompositeTextureMap()
						
						--Create all maps with proper texture loaded
							--	loop backwards to prevent combineMapBG to be on the top of all other maps
						for i = bitmapsToCombine.count to 1 by -1 do					
						(
							--	add layer
							theComp.add()
							--	add maps
							theMap1 = Bitmaptexture fileName:bitmapsToCombine[i]
							theMap1m = Bitmaptexture fileName:bitmapsToCombine[i]
							--	set mono output channel to alpha
							theMap1m.monoOutput = 1
							--	set RGB output channel to alpha
							theMap1m.RGBOutput = 1
							--	set source alpha to alpha
							theMap1m.alphasource = 0
							
							append texList theMap1
							append texListM theMap1m				
						)
						--	composite the two maps
						theComp.mapList = texList as array
						--	composite the mask of two maps
						theComp.mask = texListM as array		

						objForCombMap = Sphere segs:32 mapcoords:true pos:[-1000000,-1000000,-1000000]
						objForCombMap.material = standard diffusemap:theComp
						--	create new bitmap that will hold the combined maps of all objects with proper alpha chanel
						intoBitMap = bitmap sizeWidth sizeHeight
						--	render map
						comMap = renderMap objForCombMap.material.diffuseMap into:intoBitMap filter:false Display:offOnPreview
						
						comMap.filename = m_RenderPath+"Proper_Alpha_"+combineMapName+m_Extension						
						-- save combined maps with no BG color but with proper alpha channel
						save comMap
						try(delete objForCombMap)catch()
						
						--	PART TWO - CREATE COMBINED MAP WITH PROPER BACKGROUND COLOR
							--	make bitmap with background color
							bmBG = bitmap sizeWidth sizeHeight  color:BGcolor
							--	save map to output folder
							bmBG.filename = m_RenderPath+cMapName+m_Extension
							bmBGpath = bmBG.filename
							save bmBG
							--	get the combined map with proper alpha channel
							bmCombMapPropAlphaArr = getFiles (m_RenderPath+"/Proper_Alpha_*"+m_Extension)
							bmCombMapPropAlpha = bmCombMapPropAlphaArr[1]
							bitmapsToCombine2 = #(bmCombMapPropAlpha,bmBGpath)
							texList = #() as array
							texListM = #() as array
							theCompBG = CompositeTextureMap()							
							for i = bitmapsToCombine2.count to 1 by -1 do					
							(
								theCompBG.add()
								theMap1 = Bitmaptexture fileName:bitmapsToCombine2[i]
								theMap1m = Bitmaptexture fileName:bitmapsToCombine2[i]
								theMap1m.monoOutput = 1
								theMap1m.RGBOutput = 1
								theMap1m.alphasource = 0								
								append texList theMap1
								append texListM theMap1m				
							)
							theCompBG.mapList =	texList as array
							theCompBG.mask = texListM as array		
							objForCombMapBG = Sphere segs:32 mapcoords:true pos:[-1000000,-1000000,-1000000]
							objForCombMapBG.material = standard diffusemap:theCompBG
							intoBitMapBG = bitmap sizeWidth sizeHeight
							comMapBG = renderMap objForCombMapBG.material.diffuseMap into:intoBitMapBG filter:false Display:offOnPreview							
							comMapBG.filename = m_RenderPath+combineMapName+m_Extension
							save comMapBG							
							close comMap						
							freeSceneBitmaps()
							deleteFile bmBGpath	
							try(delete objForCombMapBG)catch()
						
						--	PART THREE - SWAP ALPHA CHANNELS OF TWO BITMAPS
						--	Writen by Dave Worty
							fileA = comMap.filename
							fileB = comMapBG.filename
							thebmpA = openbitmap fileA
							thebmpB = openbitmap fileB
							newBmpA = bitmap thebmpA.width thebmpA.height
							newBmpB = bitmap thebmpB.width thebmpB.height
							for i = 1 to thebmpA.height do
							(
								AR_thepixels_A = Getpixels thebmpA [0,i] thebmpA.width
								AR_thepixels_B = Getpixels thebmpB [0,i] thebmpB.width
								for j = 1 to AR_thepixels_A.count do
								(
									swap AR_thepixels_A[j].a AR_thepixels_B[j].a
								)
-- 								setpixels newbmpA [0,i] AR_thepixels_A 
								setpixels newbmpB [0,i] AR_thepixels_B 
							)
							close thebmpA
							close thebmpB
							newBmpA.filename = fileA
							newBmpB.filename = fileB
							Save newBmpA
							Save newBmpB
							Close NewBmpA
							Close NewBmpB
							try(deleteFile comMap.filename)catch()
							freeSceneBitmaps()
							gc()
					)			
				)	
				function AddColumns theLv columnsAr=
				(
					w=(theLv.width)-6
					for x in columnsAr do
					(
						theLv.columns.add x w
					)
				)
				function PopulateListView theLv=
				(
					rows=#()
					arr = listFiles
					for x=1 to arr.count do
					(
						mapName = (getFilenameFile arr[x])
						li=dotNetObject "System.Windows.Forms.ListViewItem" mapName
						append rows li
					)
					theLv.items.addRange rows 
				)
				function InitListView theLv=
				(					
					lv.clear()
					theLv.view=(dotNetClass "system.windows.forms.view").details
					theLv.FullRowSelect=true
					theLv.MultiSelect=true
					theLv.checkBoxes=true	
					theLv.backcolor = lbBackColor
					theLv.forecolor = lbForeColor
				)
				function ReInitListView =
				(
					InitListView lv
					AddColumns lv #("Maps")	
					PopulateListView lv
				)
				on CombineSingled open do
				(			
					ReInitListView()
					allIndexes = #()
				)		

				on btn_getDir pressed do
				(
					if chkbox_aotuBG.enabled == false do
					(
						chkbox_aotuBG.enabled = true
						chkbox_aotuBG.state = off
					)
					lv.enabled = false
					btn_useSelected.state = off
					InitListView lv
					AddColumns lv #("Maps")
					local lastSelDir = ((getIniSetting miauuIniFile "CombineMaps" "LastSelDir") as string)
					if (ValidateDirectory lastSelDir) == false do
						lastSelDir = "$previews"
					dir = getSavePath caption:"Select the directory" initialDir:lastSelDir
					if dir != undefined do
					(
						setIniSetting miauuIniFile "CombineMaps" "LastSelDir" (dir as string)						
						btn_getDir.tooltip = dir
						listFiles = #()
						listFilesTGA = getFiles (dir+"/*.tga")
						listFilesTIF = getFiles (dir+"/*.tif")
						listFilesPNG = getFiles (dir+"/*.png")
						
						if listFilesTGA.count != 0 do
							join listFiles listFilesTGA
						if listFilesTIF.count != 0 do
							join listFiles listFilesTIF
						if listFilesPNG.count != 0 do
							join listFiles listFilesPNG
						--	check if maps contain alpha channel	
						if listFiles.count != 0 then
						(
							noA = #()
							for f in listFiles do
							(
								bm = openBitmap f
								if bm.hasAlpha then
								(
									--	maps has alpha
								)
								else
								(
									append noA (getFilenameFile f)
								)
							) 
							--	show all maps that don't have alpha channel
							if noA.count != 0 then
							(						
								rollout noAlphaMaps "Maps without Alpha channel"
								(
									local exclude = false
									
									label lb1  "Maps that are listed below don't have an"
									label lb2 "alpha channel and can not be combined!"
									listbox lbox_mapsNoAlpha "" items:CombineSingled.noA readOnly:true
									button btn_exclude "Exclude" pos:[125,180] tooltip:"Exclude listed maps from final Combined Map"
									button btn_cancel "Cancel" pos:[185,180]
									
									on btn_exclude pressed do
									(
										exclude = true
										destroydialog noAlphaMaps
									)									
									on btn_cancel pressed do
									(
										exclude = false
										destroydialog noAlphaMaps
									)
								)
								createdialog noAlphaMaps modal:true width:250 fgcolor:red
								
								if noAlphaMaps.exclude == true then
								(
									--	remove maps without Alpha
									listFilesNameOnly = #()
									for f in listFiles do
									(
										append listFilesNameOnly (getFilenameFile f)
									)
									for j = 1 to noA.count do
									(
										for i = listFiles.count to 1 by -1 do
										(
											if (listFilesNameOnly[i] == noA[j]) do
											(
												deleteitem listFiles i
											)
										)
									)
									PopulateListView lv
									allIndexes = #()
									for i = 0 to lv.Items.count-1 do
										lv.Items.Item[i].checked = true
									Lv.forecolor = disableForeColor
								)
								else
								(
									listFiles = #()
								)
							)
							else
							(
								PopulateListView lv
								allIndexes = #()
								for i = 0 to lv.Items.count-1 do
									lv.Items.Item[i].checked = true
								Lv.forecolor = disableForeColor
							)
						)
					)
				)	
				--	select map one by one
				on btn_getFile pressed do
				(
					if chkbox_aotuBG.enabled == false do
					(
						chkbox_aotuBG.enabled = true
						chkbox_aotuBG.state = off
					)
					btn_useSelected.state = off
					lv.enabled = false
					mapFile = getOpenFileName types:"TGA(*.tga)|*.tga|TIF(*.tif)|*.tif|PNG(*.png)|*.png|All|*.*|"
					if mapFile != undefined then
					(
						bm = openBitmap mapFile
						if bm.hasAlpha then
						(
							append listFiles mapFile
						)
						else
						(
							messagebox "Selected map doesn't have Alpha channel!" title:"RTTAssist Live Log"
						) 
						--	reinitialize ListView to clear previous maps
						ReInitListView()
						allIndexes = #()

						for i = 0 to lv.Items.count-1 do
							lv.Items.Item[i].checked = true
						Lv.forecolor = disableForeColor
					)
				)

				on lv ItemChecked itemCheckedEventArgs do
				(				
					local listViewItem = itemCheckedEventArgs.item
					local index = listViewItem.index

					if (i = (findItem allIndexes index)) != 0 then
						deleteItem allIndexes i
					else
						appendIfUnique allIndexes index
				)
				--	rollout showing map preview
				rollout rol_MapPreview ""
				(
					local mousedd = false
					local roPos = [0,0]
					on rol_MapPreview lbuttonup pos do mousedd = false 
					on rol_MapPreview lbuttondown pos do
					(
						mousedd = true
						roPos = pos
					)
					on rol_MapPreview mousemove pos do
					(
						if mousedd do
							SetDialogPos rol_MapPreview  (mouse.screenpos - roPos)
					)					
					
					imgtag bm_Preview pos:[0,0] width:196 height:196 bitmap:(bitmap 1 1 color:black) enabled:off
						
					on rol_MapPreview resized Point2 do
					(
						local ro_size = GetDialogSize rol_MapPreview
						--	keep rollout square
						rol_MapPreview.width = ro_size[1]
						rol_MapPreview.height = ro_size[1]			
						
						bm_Preview.width = ro_size[1] - 2
						bm_Preview.height = ro_size[1] - 2						
						--	rollout can't be smaller than 196x196 px
						if rol_MapPreview.width < 196 do rol_MapPreview.width = 196
						if rol_MapPreview.height < 196 do rol_MapPreview.height = 196
					)
				)
				--	to show or not map preview window
				on chkbox_showPreview changed theState do
				(
					if theState then
					(
						try(destroyDialog rol_MapPreview)catch()
						local roWidth = 196
						local roHeight = 196
						
						local roPos = GetDialogPos CombineSingled
						if roPos.x <= (sysinfo.desktopSize.x - 400) then
							roPos.x = roPos.x+210
						else
							roPos.x = roPos.x-200
						
						createDialog rol_MapPreview roWidth roHeight roPos.x roPos.y style:#(#style_resizing)							
					)
					else
					(
						destroyDialog rol_MapPreview
					)
				)
				on lv MouseDown arg do
				(
					--	show preview
					if arg.button==arg.button.left do
					(
						if chkbox_showPreview.state == true do
						(
							if (hitNode = lv.GetItemAt arg.x arg.y) != undefined do
							(
								rol_MapPreview.bm_Preview.bitmap =  (openBitmap (listFiles[(hitNode.index+1)]))
								rol_MapPreview.bm_Preview.width = rol_MapPreview.width
								rol_MapPreview.bm_Preview.height = rol_MapPreview.height
							)	
						)
					)
					--	delete map from listview
					if arg.button==arg.button.middle do
					(						
						if (hitNode = lv.GetItemAt arg.x arg.y) != undefined do
						(
							deleteItem listFiles (hitNode.index+1)
							ReInitListView()
						)				
					)
				)
				--	get all maps
				on bnt_useAll changed theState do
				(
					if theState then
					(
						mapsToCombine = listFiles
						btn_useSelected.state = off				
						lv.enabled = false
						for i = 0 to lv.Items.count-1 do
							lv.Items.Item[i].checked = true
						Lv.forecolor = disableForeColor
					)
					else
					(
						lv.enabled = true
						btn_useSelected.state = on
						Lv.forecolor = lbForeColor
					)
				)
				--	get selected by user maps	
				on btn_useSelected changed theState do
				(
					if theState then
					(
						bnt_useAll.state = off
						lv.enabled = true
						for i = 0 to lv.Items.count-1 do
							lv.Items.Item[i].checked = false
						Lv.forecolor = lbForeColor
					)
					else
						bnt_useAll.state = on
				)
				--	check or uncheck all maps in listview
				on btn_useSelected rightclick do
				(
					if chkState == 1 then
					(
						--	uncheck all
						for i = 0 to lv.Items.count-1 do
							lv.Items.Item[i].checked = true
						chkState = 0
					)
					else
					(
						--	check all
						for i = 0 to lv.Items.count-1 do
							lv.Items.Item[i].checked = false
						chkState = 1
					)
				)

				on btn_clearLV pressed do
				(
					listFiles = #()
					noA = #()
					dir = undefined
					mapFile = undefined
					outputDir = undefined
					mapsToCombine = #()
					ReInitListView()
					allIndexes = #()
					bnt_useAll.state = on
					btn_useSelected.state = off
				)
				--	set where to save combined map
				on btn_SaveInFolder pressed do
				(
					if (outputPath = getSavePath caption:"Select output directory") != undefined do
					(
						outputDir = outputPath
						chkbox_SameAsSource.state = off
						btn_SaveInFolder.tooltip = outputPath
					)
				)
				--	autodetct background color of combined map
				on chkbox_aotuBG changed theState do
				(
					if theState then
					(
						if listFiles.count != 0 then
						(
							bm = openBitmap listFiles[2]
							if (getFilenameType listFiles[2]) != ".png" then
							(
								bmW = bm.width
								bmH = bm.height
								--	detect color of the first and the last pixels
								zeroPixelColor = getPixels bm [0,0] 1
								lastPixelColor = getPixels bm [(bmW-1),(bmH-1)] 1
								--	if color is match use it as background color
								if zeroPixelColor[1] == lastPixelColor[1] then
								(
									a = zeroPixelColor[1] as string
									c = (substring a 1 (a.count-2))+")"
									d = execute c
									clr_BG.color = d
									bgColor = d
								)
								else
								(
									chkbox_aotuBG.enabled = false
									msg = "Auto-detecting the background color failed!\n"
									msg += "Use the colorpicker to set it manually"
									messagebox msg title:"RTTAssist Combine Map"
								)
							)
							else
							(
								msg = "Auto-detecting the background color\n"
								msg += "doesn't work with .PNG files!\n"
								msg += "Set the background color manually."
								messagebox msg title:"RTTAssist Combine Map"
								
							)
						)
						else
						(
							messagebox "First select maps to combine!" title:"RTTAssist Combine Map"
							chkbox_aotuBG.state = off
						)
					)
					else()					
				)
				on clr_BG changed theColor do
				(
					bgColor = clr_BG.color
				)
				--	start combining maps
				on btn_CombineMaps pressed do
				(
					bgColor = clr_BG.color
					local combMapName = ""
					--	check for valid autput path
					if chkbox_SameAsSource.state == on then
					(
						if dir != undefined then
							outputDir = dir
						else
							messagebox "Please set the output path using the browse button!" title:"RTTAssist Combine Map"
					)
					else
					(
						if outputDir == undefined do
							messagebox "Please set the output path using the browse button!" title:"RTTAssist Combine Map"
					)
					--	set the name of combined map
					if et_name.text != "" then
						combMapName = et_name.text
					else
						combMapName = "Combined_Map"
					--	if Use All is pressed get all listed map and combine them
					if bnt_useAll.state == on do
						mapsToCombine = listFiles
					--	if Use selected is pressed get the list of checked maps and combine them
					if btn_useSelected.state == on do
					(
						--	turn 0-based array to 1-based
						if allIndexes.count != 0 then
						(
							for i=1 to allIndexes.count do
							(
								allIndexes[i] = allIndexes[i]+1
							)
							--	sort indexes to match to proper map
							sort allIndexes
							--	get selectd by user maps
							mapsToCombine = #()
							for i = 1 to allIndexes.count do
							(
								append mapsToCombine listFiles[allIndexes[i]]
							)
							--	mapsToCombine contains all maps that user has checkd and wants to combine
						)
						else
							messagebox "Select some maps!" title:"RTTAssist Combine Maps"
					)	
					--	if there is a valid output path start combining the maps
					if outputDir != undefined do				
					(
						CombineImages mapsToCombine combMapName true bgColor "CombMapBG" outputDir
					)
				)
				
				on CombineSingled resized Point2 do
				(
					local ro_size = GetDialogSize CombineSingled
					lv.width = ro_size[1] - 10
					lv.height = ro_size[2] - 210
					bnt_useAll.pos = [5,(ro_size[2] - 160)]
					btn_useSelected.pos = [65,(ro_size[2] - 160)]
					btn_clearLV.pos = [155,(ro_size[2] - 160)]
					gbox_2.pos = [2,(ro_size[2] - 130)]
					btn_SaveInFolder.pos = [5,(ro_size[2] - 110)]
					chkbox_SameAsSource.pos = [93,(ro_size[2] - 107)]
					lb_1.pos = [2,(ro_size[2] - 82)]
					clr_BG.pos = [165,(ro_size[2] - 80)]
					chkbox_aotuBG.pos = [93,(ro_size[2] - 81)]
					et_name.pos = [38,(ro_size[2] - 55)]
					btn_CombineMaps.pos = [40,(ro_size[2] - 30)]
					if CombineSingled.width < 200 do CombineSingled.width = 200
					if CombineSingled.height < 365 do CombineSingled.height = 365
				)				
				on CombineSingled close do
				(
					try(destroyDialog rol_MapPreview)catch()
				)
			)
			createdialog CombineSingled width:200 height:365 \
				style:#(#style_titlebar, #style_sysmenu, #style_resizing)
		)
		on btn_CombineSing mouseover do
		(
			btn_CombineSing.bitmap = (openBitmap (url+"miauuITcombineSingHover.png")) 
		)
		on btn_CombineSing mouseout do
		(
			btn_CombineSing.bitmap = (openBitmap (url+"miauuITcombineSing.png")) 
		)
-------------------------
	--	preset system
-------------------------
		--	save preset
		on dNet_TextBoxSP KeyUp s e do
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				if dNet_TextBoxSP.text != undefined and dNet_TextBoxSP.text != "Enter name" do
					presetName = dNet_TextBoxSP.text
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				if dNet_TextBoxSP.text != undefined and dNet_TextBoxSP.text != "Enter name" do
					presetName = dNet_TextBoxSP.text
			)
		)
		on  dNet_TextBoxSP LostFocus e do
		(
			if dNet_TextBoxSP.text != undefined and dNet_TextBoxSP.text != "Enter name" do
				presetName = dNet_TextBoxSP.text
		) 	
		on  dNet_TextBoxSP gotFocus e do
		(			
			DestroyPresetRollout()
		) 
		--	save preset in separate file
		on btn_SavePrst lbuttonup do
		(
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#savepreset"
				shellLaunch "hh" goToHelp
			)
			else
			(
				if CheckForSelectedMaps() then
				(
					presetName = dNet_TextBoxSP.text
					if dNet_TextBoxSP.text != undefined and dNet_TextBoxSP.text != "Enter name" and dNet_TextBoxSP.text != "Open presets folder" and dNet_TextBoxSP.text != "----------------------------" then
					(
						miauuIniPresetFile = GetDir #userscripts + "\\RTTassist\\Presets\\" + (presetName as string)+".rpf"
						--	save checkbox settings
						--	Maps
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_AlphaMap" (chkbox_AlphaMap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_AmbientOcclusion" (chkbox_AmbientOcclusion.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMap" (chkbox_BlendMap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_CompleteMap" (chkbox_CompleteMap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_DiffuseMap" (chkbox_DiffuseMap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_HeightMap" (chkbox_HeightMap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightingMap" (chkbox_LightingMap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_normalsMap" (chkbox_normalsMap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_ShadowsMap" (chkbox_ShadowsMap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_SpecularMap" (chkbox_SpecularMap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_UVMap" (chkbox_UVMap.state as string)
						--	Projection setting
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_renderIsolate" (chkbox_renderIsolate.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_redrawViews" (chkbox_redrawViews.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_useCage" (chkbox_useCage.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_combMaps" (chkbox_combMaps.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_UseProjection" (chkbox_UseProjection.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_Raytrace" (chkbox_Raytrace.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_UVmatch" (chkbox_UVmatch.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_Closest" (chkbox_Closest.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_Furthest" (chkbox_Furthest.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_HitMatchMtlID" (chkbox_HitMatchMtlID.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_RayMissCheck" (chkbox_RayMissCheck.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_CropAlpha" (chkbox_CropAlpha.state as string)
						--	Blend Map
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMLight" (chkbox_BlendMLight.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMShadows" (chkbox_BlendMShadows.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMDiffuse" (chkbox_BlendMDiffuse.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMAmbient" (chkbox_BlendMAmbient.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMSpecular" (chkbox_BlendMSpecular.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMSelf_Illum" (chkbox_BlendMSelf_Illum.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMReflection" (chkbox_BlendMReflection.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMRefraction" (chkbox_BlendMRefraction.state as string)
						--	Complete map
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_ComplMShadows" (chkbox_ComplMShadows.state as string)
						--	Diffuse Map
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_DiffMLight" (chkbox_DiffMLight.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_DiffMShadows" (chkbox_DiffMShadows.state as string)
						--	Lighting Map
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightMShadows" (chkbox_LightMShadows.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightMDirectLight" (chkbox_LightMDirectLight.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightMIndirectLight" (chkbox_LightMIndirectLight.state as string)
						--	Normals Map
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_NormalsMOutToBump" (chkbox_NormalsMOutToBump.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_NormalsMRenderIntoAlphaChannel" (chkbox_NormalsMRenderIntoAlphaChannel.state as string)
						--	Specular Map
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_SpecMLight" (chkbox_SpecMLight.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_SpecMShadows" (chkbox_SpecMShadows.state as string)
						--	Uv map
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_showOverlap" (chkbox_showOverlap.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeNone" (chkbox_modeNone.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeSolid" (chkbox_modeSolid.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeNormal" (chkbox_modeNormal.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeShaded" (chkbox_modeShaded.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_force2sided" (chkbox_force2sided.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_visibleEdges" (chkbox_visibleEdges.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_invisibleEdges" (chkbox_invisibleEdges.state as string)
						setIniSetting miauuIniPresetFile "Checkbox" "chkbox_seemEdges" (chkbox_seemEdges.state as string)
						
						--	save output path
						if btn_BrowseFolder.text != undefined do
							setIniSetting miauuIniPresetFile "Render" "OutpuPath" (btn_BrowseFolder.text as string)
						--	save extension of files to save as
						if btn_saveAsType.text != undefined do
							setIniSetting miauuIniPresetFile "Render" "FileExtension" (btn_saveAsType.text as string)						
						--	save map size
						if spn_mapHeight.text != undefined do
							setIniSetting miauuIniPresetFile "Render" "Height" (spn_mapHeight.text as string)
						if spn_mapWidth.text != undefined do
							setIniSetting miauuIniPresetFile "Render" "Width" (spn_mapWidth.text as string)						
						--	save ray-miss color
						setIniSetting miauuIniPresetFile "Color" "Ray-miss color" (colorPick_RayMissColor.color as string)						
						--	save colors for UV map
						setIniSetting miauuIniPresetFile "Color" "clrPick_seemEdgesColor" (clrPick_seemEdgesColor.color as string)
						setIniSetting miauuIniPresetFile "Color" "clrPick_edgesColor" (clrPick_edgesColor.color as string)
						setIniSetting miauuIniPresetFile "Color" "clrPick_overlapColor" (clrPick_overlapColor.color as string)
						setIniSetting miauuIniPresetFile "Color" "clrPick_fillColor" (clrPick_fillColor.color as string)						
						--	save background colors of maps
							--	alpha
							setIniSetting miauuIniPresetFile "Color" "Alpha BG color" (colorPick_EleBGColorAlpha.color as string)
							--AO
							setIniSetting miauuIniPresetFile "Color" "AO BG color" (colorPick_EleBGColorAO.color as string)
							--	Blend
							setIniSetting miauuIniPresetFile "Color" "Blend BG color" (colorPick_EleBGColorBlend.color as string)
							--	Complete
							setIniSetting miauuIniPresetFile "Color" "Complete BG color" (colorPick_EleBGColorCompl.color as string)
							--	Diffuse
							setIniSetting miauuIniPresetFile "Color" "DIffuse BG color" (colorPick_EleBGColorDiff.color as string)
							--	Height
							setIniSetting miauuIniPresetFile "Color" "Height BG color" (colorPick_EleBGColorHeight.color as string)
							--	Ligthing
							setIniSetting miauuIniPresetFile "Color" "Lighting BG color" (colorPick_EleBGColorLight.color as string)
							--	Normals
							setIniSetting miauuIniPresetFile "Color" "Normals BG color" (colorPick_EleBGColorNormals.color as string)
							--	Shadows
							setIniSetting miauuIniPresetFile "Color" "Shadows BG color" (colorPick_EleBGColorShadows.color as string)
							--	Specular
							setIniSetting miauuIniPresetFile "Color" "Specular BG color" (colorPick_EleBGColorSpec.color as string)
							--	AO btight
							setIniSetting miauuIniPresetFile "Color" "AO Bright color" (colorPick_AObright.color as string)
							--	AO dark
							setIniSetting miauuIniPresetFile "Color" "AO Dark color" (colorPick_AOdark.color as string)							
						--	save  Filtering Options
							--	have to save render preset only if fitering is added
							if lb_filteringOptions.text != "No filtering:"  or lb_filteringOptions.text != "G.Supersampler: None" do
							(
								miauuIniPresetFileRPS = GetDir #userscripts + "\\RTTassist\\Presets\\" + (presetName as string)+".rps"
								renderpresets.SaveAll 0 miauuIniPresetFileRPS
							)							
						--	save spinners values
							--	padding
							setIniSetting miauuIniPresetFile "Spinner" "Padding" (spn_Padding.text as string)
							--	channel
							setIniSetting miauuIniPresetFile "Spinner" "UVChannel" (spn_UVChannel.text as string)
							--	offset dotnet spinnet
							setIniSetting miauuIniPresetFile "Spinner" "Offset" (spn_Offset.text as string)
							--	offset 3ds max spinnet
							setIniSetting miauuIniPresetFile "Spinner" "OffsetStd" (sOffset.value as string)
							--	AO Samples
							setIniSetting miauuIniPresetFile "Spinner" "AOSamples" (spn_AOSamples.text as string)
							--	AO SpreadS
							setIniSetting miauuIniPresetFile "Spinner" "AOSpread" (spn_AOSpread.text as string)
							--	AO Max Dist
							setIniSetting miauuIniPresetFile "Spinner" "AOMaxDist" (spn_AOMaxDist.text as string)
							--	AO Falloff
							setIniSetting miauuIniPresetFile "Spinner" "AOFalloff" (spn_AOFalloff.text as string)

							presetName = undefined
							dNet_TextBoxSP.text = "Enter name"
					)
					else
					(
						errMssg = 17
						ErrorMessage 17
					)
				)
				else
				(
					errMssg = 16
					ErrorMessage 16
				)
			)
		)	
		on btn_SavePrst mouseover do
		(
			btn_SavePrst.bitmap = (openBitmap (url+"miauuITsavePresetHover.png")) 
		)
		on btn_SavePrst mouseout do
		(
			btn_SavePrst.bitmap = (openBitmap (url+"miauuITsavePreset.png")) 
		)
		--	cancel saving preset and hide all controls
		on btn_delete lbuttonup do
		(			
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#deletepreset"
				shellLaunch "hh" goToHelp
			)
			else
			(
				selPreset = dNet_TextBoxSP.text
				iniPreset = selPreset + ".rpf"
				rpsPreset = selPreset + ".rps"
				theDir = GetDir #userscripts + "\\RTTassist\\Presets\\"
				theDir += iniPreset
				deleteFile theDir
				--	delete RPS file if it exist
				if rpsPreset != undefined do
				(
					theDir = GetDir #userscripts + "\\RTTassist\\Presets\\"
					theDir += rpsPreset
					deleteFile theDir
				)
				dNet_TextBoxSP.text = "Enter name"
			)
		)
		on btn_delete mouseover do
		(
			btn_delete.bitmap = (openBitmap (url+"miauuITdeletePresetHover.png")) 
		)
		on btn_delete mouseout do
		(
			btn_delete.bitmap = (openBitmap (url+"miauuITdeletePreset.png")) 
		)
		--	rollout of all presets - works as RCmenu
		rollout MainPresetRO "Presets" 
		(			
			local tempMainUIheight = undefined
			local SetupListView
			local pathToPresets = GetDir #userscripts + "\\RTTassist\\Presets\\"
			local pathToPresetsRPS = GetDir #userscripts + "\\RTTassist\\Presets\\"
			local theFiles = getFiles (GetDir #userscripts + "\\RTTassist\\Presets\\*.rpf")

			local lvItems=for f in theFiles collect getFilenameFile f
			
			dotNetControl lv "System.Windows.Forms.ListView" width:120 height:96 pos:[1,1]
			
			function GetSelection =
			(
				for x=0 to lv.selectedIndices.count-1 collect lv.selectedIndices.item[x]
			)			
			function SetupListView = 
			( 			  
				local topItemNum=0
				if lv.items.count>0 do
					topItemNum=lv.TopItem.index
			  
				lv.clear()			  
				lv.View = (dotNetClass "System.Windows.Forms.View").Details
				lv.fullRowSelect = true
				lv.gridLines = false
				lv.HideSelection=false
				lv.BorderStyle=lv.BorderStyle.none
				lv.backColor=lv.backColor.DimGray
				lv.foreColor=lv.foreColor.lightGray
				lv.headerStyle = lv.headerStyle.none				
				dnFontStyle = dotNetClass "System.Drawing.FontStyle"
				myFontStyle = dotnet.combineenums dnFontStyle.bold
				lv.font = dotNetObject "System.Drawing.Font" "Arial" 9 myFontStyle				
				lv.Columns.add "Presets Names" 150
				append lvItems "----------------------------"
				append lvItems "Open presets folder"
				theRange = #() 
				for x=1 to lvItems.count do
				(
					li = dotNetObject "System.Windows.Forms.ListViewItem" lvItems[x]; append theRange li 
				) 			  
				lv.Items.AddRange theRange				
				if lv.items.count>0 do 
					lv.TopItem=lv.items.item[topItemNum]
			)
			--	Load preset
			on lv ItemSelectionChanged  a do
			(
				if a.Item.text != "Open presets folder" and a.Item.text != "----------------------------" then
				(
					miauuRTTassist.dNet_TextBoxSP.text = a.Item.text
					--	the name of selected preset
					selectedPreset = undefined	
					--	get the number of selected item - zero based array
					selectedItem = GetSelection()
					--	get the name of selected preset
					if selectedItem.count != 0 do
						selectedPreset = a.item.text
					
					pathToPresets += selectedPreset + ".rpf"
					--	load maps
					miauuRTTassist.chkbox_AlphaMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_AlphaMap") as stringStream))
					miauuRTTassist.chkbox_AmbientOcclusion.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_AmbientOcclusion") as stringStream))
					miauuRTTassist.chkbox_BlendMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMap") as stringStream))
					miauuRTTassist.chkbox_CompleteMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_CompleteMap") as stringStream))
					miauuRTTassist.chkbox_DiffuseMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffuseMap") as stringStream))
					miauuRTTassist.chkbox_HeightMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_HeightMap") as stringStream))
					miauuRTTassist.chkbox_LightingMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightingMap") as stringStream))
					miauuRTTassist.chkbox_normalsMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_normalsMap") as stringStream))
					miauuRTTassist.chkbox_ShadowsMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_ShadowsMap") as stringStream))
					miauuRTTassist.chkbox_SpecularMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecularMap") as stringStream))
					miauuRTTassist.chkbox_UVMap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UVMap") as stringStream))
					--	load projection controls
					miauuRTTassist.chkbox_renderIsolate.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_renderIsolate") as stringStream))
					miauuRTTassist.chkbox_redrawViews.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_redrawViews") as stringStream))
					miauuRTTassist.chkbox_useCage.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_useCage") as stringStream))
					miauuRTTassist.chkbox_combMaps.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_combMaps") as stringStream))
					miauuRTTassist.chkbox_UseProjection.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UseProjection") as stringStream))
					miauuRTTassist.chkbox_Raytrace.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Raytrace") as stringStream))
					miauuRTTassist.chkbox_UVmatch.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_UVmatch") as stringStream))
					miauuRTTassist.chkbox_Closest.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Closest") as stringStream))
					miauuRTTassist.chkbox_Furthest.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_Furthest") as stringStream))
					miauuRTTassist.chkbox_HitMatchMtlID.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_HitMatchMtlID") as stringStream))
					miauuRTTassist.chkbox_RayMissCheck.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_RayMissCheck") as stringStream))
					miauuRTTassist.chkbox_CropAlpha.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_CropAlpha") as stringStream))
					--	blend map selected map unique settings
					miauuRTTassist.chkbox_BlendMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMLight") as stringStream))
					miauuRTTassist.chkbox_BlendMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMShadows") as stringStream))
					miauuRTTassist.chkbox_BlendMDiffuse.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMDiffuse") as stringStream))
					miauuRTTassist.chkbox_BlendMAmbient.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMAmbient") as stringStream))
					miauuRTTassist.chkbox_BlendMSpecular.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMSpecular") as stringStream))
					miauuRTTassist.chkbox_BlendMSelf_Illum.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMSelf_Illum") as stringStream))
					miauuRTTassist.chkbox_BlendMReflection.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMReflection") as stringStream))
					miauuRTTassist.chkbox_BlendMRefraction.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_BlendMRefraction") as stringStream))
					--	Complete map selected map unique settings 
					miauuRTTassist.chkbox_ComplMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_ComplMShadows") as stringStream))
					--	Diffuse Map selected map unique settings
					miauuRTTassist.chkbox_DiffMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffMLight") as stringStream))
					miauuRTTassist.chkbox_DiffMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_DiffMShadows") as stringStream))
					--	Lighting Map selected map unique settings
					miauuRTTassist.chkbox_LightMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMShadows") as stringStream))
					miauuRTTassist.chkbox_LightMDirectLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMDirectLight") as stringStream))
					miauuRTTassist.chkbox_LightMIndirectLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_LightMIndirectLight") as stringStream))
					--	Normals Map selected map unique settings					
					miauuRTTassist.chkbox_NormalsMOutToBump.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_NormalsMOutToBump") as stringStream))
					miauuRTTassist.chkbox_NormalsMRenderIntoAlphaChannel.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_NormalsMRenderIntoAlphaChannel") as stringStream))
					--	Specular Map selected map unique settings
					miauuRTTassist.chkbox_SpecMLight.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecMLight") as stringStream))
					miauuRTTassist.chkbox_SpecMShadows.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_SpecMShadows") as stringStream))
					--	UV Map selected map unique settings
					miauuRTTassist.chkbox_showOverlap.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_showOverlap") as stringStream))
					miauuRTTassist.chkbox_modeNone.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeNone") as stringStream))
					miauuRTTassist.chkbox_modeSolid.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeSolid") as stringStream))
					miauuRTTassist.chkbox_modeNormal.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeNormal") as stringStream))
					miauuRTTassist.chkbox_modeShaded.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_modeShaded") as stringStream))
					miauuRTTassist.chkbox_force2sided.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_force2sided") as stringStream))
					miauuRTTassist.chkbox_visibleEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_visibleEdges") as stringStream))
					miauuRTTassist.chkbox_invisibleEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_invisibleEdges") as stringStream))
					miauuRTTassist.chkbox_seemEdges.state = (readValue ((getIniSetting pathToPresets "Checkbox" "chkbox_seemEdges") as stringStream))
					--	load output path
					miauuRTTassist.btn_BrowseFolder.text  = ((getIniSetting pathToPresets "Render" "OutpuPath") as string)
					--	load map file extension
					miauuRTTassist.btn_saveAsType.text= ((getIniSetting pathToPresets "Render" "FileExtension") as string)
					--	load map size
					miauuRTTassist.spn_mapHeight.text = ((getIniSetting pathToPresets "Render" "Height") as string)
					miauuRTTassist.spn_mapWidth.text = ((getIniSetting pathToPresets "Render" "Width") as string)
					--	load ray-miss check color
					miauuRTTassist.colorPick_RayMissColor.color  = (readValue(( getIniSetting pathToPresets "Color" "Ray-miss color") as stringStream))
					--	load UV Map colors
					miauuRTTassist.clrPick_seemEdgesColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_seemEdgesColor") as stringStream))
					miauuRTTassist.clrPick_edgesColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_edgesColor") as stringStream))
					miauuRTTassist.clrPick_overlapColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_overlapColor") as stringStream))
					miauuRTTassist.clrPick_fillColor.color  = (readValue(( getIniSetting pathToPresets "Color" "clrPick_fillColor") as stringStream))
					--	load background colors of all maps
					miauuRTTassist.colorPick_EleBGColorAlpha.color = (readValue(( getIniSetting pathToPresets "Color" "Alpha BG color") as stringStream))
					miauuRTTassist.colorPick_EleBGColorAO.color = (readValue(( getIniSetting pathToPresets "Color" "AO BG color") as stringStream))
					miauuRTTassist.colorPick_EleBGColorBlend.color = (readValue(( getIniSetting pathToPresets "Color" "Blend BG color") as stringStream))
					miauuRTTassist.colorPick_EleBGColorCompl.color = (readValue(( getIniSetting pathToPresets "Color" "Complete BG color") as stringStream))
					miauuRTTassist.colorPick_EleBGColorDiff.color = (readValue(( getIniSetting pathToPresets "Color" "DIffuse BG color") as stringStream))
					miauuRTTassist.colorPick_EleBGColorHeight.color = (readValue(( getIniSetting pathToPresets "Color" "Height BG color") as stringStream))
					miauuRTTassist.colorPick_EleBGColorLight.color = (readValue(( getIniSetting pathToPresets "Color" "Lighting BG color") as stringStream))
					miauuRTTassist.colorPick_EleBGColorNormals.color = (readValue(( getIniSetting pathToPresets "Color" "Normals BG color") as stringStream))
					miauuRTTassist.colorPick_EleBGColorShadows.color = (readValue(( getIniSetting pathToPresets "Color" "Shadows BG color") as stringStream))
					miauuRTTassist.colorPick_EleBGColorSpec.color = (readValue(( getIniSetting pathToPresets "Color" "Specular BG color") as stringStream))
					miauuRTTassist.colorPick_AObright.color = (readValue(( getIniSetting pathToPresets "Color" "AO Bright color") as stringStream))
					miauuRTTassist.colorPick_AOdark.color = (readValue(( getIniSetting pathToPresets "Color" "AO Dark color") as stringStream))
					--	spinners
					miauuRTTassist.spn_Padding.text = ((getIniSetting pathToPresets "Spinner" "Padding") as string)
					miauuRTTassist.spn_UVChannel.text = ((getIniSetting pathToPresets "Spinner" "UVChannel") as string)
					miauuRTTassist.spn_Offset.text = ((getIniSetting pathToPresets "Spinner" "Offset") as string)							
					miauuRTTassist.sOffset.value = (readValue((getIniSetting pathToPresets "Spinner" "Offset") as stringStream))
					miauuRTTassist.spn_AOSamples.text = ((getIniSetting pathToPresets "Spinner" "AOSamples") as string)
					miauuRTTassist.spn_AOSpread.text = ((getIniSetting pathToPresets "Spinner" "AOSpread") as string)
					miauuRTTassist.spn_AOMaxDist.text = ((getIniSetting pathToPresets "Spinner" "AOMaxDist") as string)
					miauuRTTassist.spn_AOFalloff.text = ((getIniSetting pathToPresets "Spinner" "AOFalloff") as string)
					--	load filtering settings if they exist
					pathToPresetsRPS += selectedPreset + ".rps"
					if (doesfileexist pathToPresetsRPS) then
					(
						renderpresets.LoadAll 0 pathToPresetsRPS
					)
					--	destroy dialog
					destroydialog MainPresetRO
				)
				else
				(	--	open Presets folder
					if a.Item.text == "Open presets folder" do
					(
						folderToOpen = GetDir #userscripts + "\\RTTassist\\Presets\\"
						OpenFolders folderToOpen 
						destroyDialog MainPresetRO
					)
				)
			)
			
			on MainPresetRO open do
			(
				SetupListView()
				tempMainUIheight = miauuRTTassist.height
			)			 
			on MainPresetRO close do
			(
				miauuRTTassist.HideOthers()
				miauuRTTassist.height = tempMainUIheight
				miauuRTTassist.LoadPresetState = 1
				miauuRTTassist.PresetDLLstate = 1
			)
		)
		--	show rollout with presets
		on dNet_TextBoxSP_Arrow lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#presetname"
				shellLaunch "hh" goToHelp
			)
			else
			(
				case of
				(
					(PresetDLLstate == 1) : 
					(
						local presetROwidth = 120
						local presetROheight = 79
						local mainROpos = GetDialogPos miauuRTTassist
						local posX = mainROpos.x+5
						local posY = mainROpos.y+275+20+16
						CreateDialog MainPresetRO presetROwidth presetROheight posX posY style:#() bgcolor:black --	modal:true
						PresetDLLstate = 0
					)
					(PresetDLLstate ==0) : 
					(
						destroyDialog MainPresetRO
						PresetDLLstate = 1
					)
				)
			)
		)
		--	open preset rollout
		on btn_loadPreset lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#presetsbutton"
				shellLaunch "hh" goToHelp
			)
			else
			(
				case of
				(
					(LoadPresetState ==1) : 
					(
						local presetROwidth = 122
						local presetROheight = 79
						local mainROpos = GetDialogPos miauuRTTassist
						local posX = mainROpos.x+112
						local posY = mainROpos.y+153
						CreateDialog MainPresetRO presetROwidth presetROheight posX posY style:#() bgcolor:black
						LoadPresetState = 0
					)
					(LoadPresetState ==0) : 
					(
						destroyDialog MainPresetRO
						LoadPresetState = 1
					)
				)
			)
		)
		on btn_loadPreset mouseover do
		(
			btn_loadPreset.bitmap = (openBitmap (url+"miauuITloadPresetHover.png")) 
		)
		on btn_loadPreset mouseout do
		(
			btn_loadPreset.bitmap = (openBitmap (url+"miauuITloadPreset.png")) 
		)
------------------
	--	Render controls	
------------------
		--	show message when turn On the CombineMap checkbox, but file type is not PNG, TGA or TIF
		on chkbox_combMaps changed theState do
		(
			if theState do
			(
				if btn_saveAsType.text != ".PNG"  and btn_saveAsType.text != ".TGA" and btn_saveAsType.text != ".TIF"  do
				(
					errMssg = 10
					ErrorMessage 10
				)
			)
		)
		on lb_combMaps lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed do
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Combine_maps_feature.htm"
				shellLaunch "hh" goToHelp
			)
		)
		on chkbox_redrawViews changed theState do
		(
			if theState do
				chkbox_renderIsolate.state = on
		)
		--	lock the height to width of texture map size
		on ImgTag_LockSize lbuttondown do
		(			
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#locksize"
				shellLaunch "hh" goToHelp
			)
			else
			(
				case of
				(
					(lockSizeState ==1) : 
					(
						sizeLockState = 1
						ImgTag_LockSize.bitmap = (openBitmap (url+"miauuLockTexSizePressed.png"))
						ImgTag_LockSize.tooltip = "Unlock!"
						lockSizeState = 0
					)
					(lockSizeState ==0) : 
					(
						sizeLockState = 0
						ImgTag_LockSize.bitmap = (openBitmap (url+"miauuLockTexSizeBMP.png"))						
						lockSizeState = 1
					)
				)
			)
		)
		on spn_mapWidth KeyUp s e do
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				GetMapSize spn_mapWidth.text 2
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				GetMapSize spn_mapWidth.text 2
			)
		)
		on  spn_mapWidth LostFocus e do
		(
			if spn_mapWidth.text != undefined do
				GetMapSize spn_mapWidth.text 2
		) 
		on  spn_mapWidth gotFocus e do
		(			
			DestroyPresetRollout()
		) 
		on spn_mapHeight KeyUp s e do
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				GetMapSize spn_mapHeight.text 1
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				GetMapSize spn_mapHeight.text 1
			)
		)
		on  spn_mapHeight LostFocus e do
		(
			if spn_mapHeight.text != undefined do
				GetMapSize spn_mapHeight.text 1
		) 
		on  spn_mapHeight gotFocus e do
		(			
			DestroyPresetRollout()
		) 
		--	open help for isolate pair, show isolation, hide faces(MR) checkbox
		on lb_chkbox_renderIsolate lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed do
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#isolate"
				shellLaunch "hh" goToHelp
			)
		)
		on lb_chkbox_redrawViews lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed do
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#show_isolation"
				shellLaunch "hh" goToHelp
			)
		)
		on lb_chkbox_hideFacesMR lbuttonup do
		(
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed do
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#hidefaces"
				shellLaunch "hh" goToHelp
			)
		)
		on chkbox_useCage changed theState do 
		(			
			DestroyPresetRollout()
			spn_Offset.text = "0.0"
			sOffset.value = 0.0
			spn_Offset.enabled = not theState
			sOffset.enabled = not theState
		)
		
		--	get Padding from textbox
		on btn_PaddingUP lbuttonup do
		(			
			DestroyPresetRollout()
			spn_Padding.text = ((spn_Padding.text as integer) + 1) as string
		)
		on btn_PaddingDown lbuttonup do
		(			
			DestroyPresetRollout()
			if spn_Padding.text != "0" do
				spn_Padding.text = ((spn_Padding.text as integer) - 1) as string
		)
		on btn_PaddingDown rbuttonup do
		(			
			DestroyPresetRollout()
			spn_Padding.text = "0"
		)
		on  spn_Padding gotFocus e do
		(			
			DestroyPresetRollout()
		) 
		-- get UV Channel
		on btn_UVChannelUP lbuttonup do
		(			
			DestroyPresetRollout()
			spn_UVChannel.text = ((spn_UVChannel.text as integer) + 1) as string
		)
		on btn_UVChannelDown lbuttonup do
		(			
			DestroyPresetRollout()
			if spn_UVChannel.text != "0" do
				spn_UVChannel.text = ((spn_UVChannel.text as integer) - 1) as string
		)
		on btn_UVChannelDown rbuttonup do
		(			
			DestroyPresetRollout()
			spn_UVChannel.text = "0"
		)
		on  spn_UVChannel gotFocus e do
		(			
			DestroyPresetRollout()
		) 
		--	get offset
		on spn_Offset KeyUp s e do
		(
			if e.KeyCode == e.KeyCode.Enter do
			(
				if spn_Offset.text != undefined do
					sOffset.value = (spn_Offset.text as float)
			)
			if e.KeyCode == e.KeyCode.Tab do
			(
				if spn_Offset.text != undefined do
					sOffset.value = (spn_Offset.text as float)
			)
		)
		on  spn_Offset LostFocus e do
		(
			if spn_Offset.text != undefined do
				sOffset.value = (spn_Offset.text as float)
		) 
		on  spn_Offset gotFocus e do
		(			
			DestroyPresetRollout()
		) 
		on btn_OffsetUP lbuttonup do
		(			
			DestroyPresetRollout()
			spn_Offset.text = ((spn_Offset.text as float) + 0.1) as string
			sOffset.value = (spn_Offset.text as float)
		)
		on btn_OffsetUP rbuttonup do
		(			
			DestroyPresetRollout()
			spn_Offset.text = ((spn_Offset.text as float) + 1.0) as string
			sOffset.value = (spn_Offset.text as float)
		)
		on btn_OffsetDown lbuttonup do
		(			
			DestroyPresetRollout()
			if spn_Offset.text != "0.0" do
				spn_Offset.text = ((spn_Offset.text as float) - 0.1) as string
				
			sOffset.value = (spn_Offset.text as float)
		)
		on btn_OffsetDown rbuttonup do
		(
			DestroyPresetRollout()
			spn_Offset.text = "0.0"
			sOffset.value = (spn_Offset.text as float)
		)
		--	change render
		on  lb_scanline lbuttonup do
		(			
			DestroyPresetRollout()
			if (renderers.current.classID[1] != 1) do
				renderers.current = default_scanline_renderer()
			lb_scanline.bitmap = (openBitmap (url+"miauuITscanlineActive.png"))
			lb_mRay.bitmap = (openBitmap (url+"miauuITmentalRay.png"))
		)
		on lb_mRay lbuttonup do
		(			
			DestroyPresetRollout()
			if (renderers.current.classID[1] != 1492548972) do
				renderers.current = mental_ray_renderer()
			lb_mRay.bitmap = (openBitmap (url+"miauuITmentalRayActive.png"))
			lb_scanline.bitmap = (openBitmap (url+"miauuITscanline.png"))
		)
		--	set the current preset as mentalRay default preset and save it
		on lb_mRay rbuttonup do
		(			
			DestroyPresetRollout()
			if (renderers.current.classID[1] != 1492548972) do
				renderers.current = mental_ray_renderer()
			--	save the current settings of mentalRay as default
			defaultMRPreset = GetDir #userscripts + "\\RTTassist\\Presets\\defaultMRpreset.rps"			
			renderpresets.SaveAll 0 defaultMRPreset
			--	save the settings of RTTAssist
				miauuIniPresetFile = GetDir #userscripts + "\\RTTassist\\Presets\\" + "defaultMRpreset.rpf"
				--	save checkbox settings
				--	Maps
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_AlphaMap" "false"
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_AmbientOcclusion" (chkbox_AmbientOcclusion.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMap" "false"
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_CompleteMap" "false"
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_DiffuseMap" "false"
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_HeightMap" "false"
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightingMap""false"
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_normalsMap" "false"
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_ShadowsMap" "false"
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_SpecularMap" "false"
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_UVMap" "false"
				--	Projection setting
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_renderIsolate" (chkbox_renderIsolate.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_redrawViews" (chkbox_redrawViews.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_useCage" (chkbox_useCage.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_combMaps" (chkbox_combMaps.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_UseProjection" (chkbox_UseProjection.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_Raytrace" (chkbox_Raytrace.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_UVmatch" (chkbox_UVmatch.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_Closest" (chkbox_Closest.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_Furthest" (chkbox_Furthest.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_HitMatchMtlID" (chkbox_HitMatchMtlID.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_RayMissCheck" (chkbox_RayMissCheck.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_CropAlpha" (chkbox_CropAlpha.state as string)
				--	Blend Map
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMLight" (chkbox_BlendMLight.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMShadows" (chkbox_BlendMShadows.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMDiffuse" (chkbox_BlendMDiffuse.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMAmbient" (chkbox_BlendMAmbient.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMSpecular" (chkbox_BlendMSpecular.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMSelf_Illum" (chkbox_BlendMSelf_Illum.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMReflection" (chkbox_BlendMReflection.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_BlendMRefraction" (chkbox_BlendMRefraction.state as string)
				--	Complete map
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_ComplMShadows" (chkbox_ComplMShadows.state as string)
				--	Diffuse Map
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_DiffMLight" (chkbox_DiffMLight.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_DiffMShadows" (chkbox_DiffMShadows.state as string)
				--	Lighting Map
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightMShadows" (chkbox_LightMShadows.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightMDirectLight" (chkbox_LightMDirectLight.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_LightMIndirectLight" (chkbox_LightMIndirectLight.state as string)
				--	Normals Map
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_NormalsMOutToBump" (chkbox_NormalsMOutToBump.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_NormalsMRenderIntoAlphaChannel" (chkbox_NormalsMRenderIntoAlphaChannel.state as string)
				--	Specular Map
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_SpecMLight" (chkbox_SpecMLight.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_SpecMShadows" (chkbox_SpecMShadows.state as string)
				--	Uv map
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_showOverlap" (chkbox_showOverlap.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeNone" (chkbox_modeNone.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeSolid" (chkbox_modeSolid.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeNormal" (chkbox_modeNormal.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_modeShaded" (chkbox_modeShaded.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_force2sided" (chkbox_force2sided.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_visibleEdges" (chkbox_visibleEdges.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_invisibleEdges" (chkbox_invisibleEdges.state as string)
				setIniSetting miauuIniPresetFile "Checkbox" "chkbox_seemEdges" (chkbox_seemEdges.state as string)
				
				--	save output path
				if btn_BrowseFolder.text != undefined do
					setIniSetting miauuIniPresetFile "Render" "OutpuPath" (btn_BrowseFolder.text as string)
				--	save extension of files to save as
				if btn_saveAsType.text != undefined do
					setIniSetting miauuIniPresetFile "Render" "FileExtension" (btn_saveAsType.text as string)						
				--	save map size
				if spn_mapHeight.text != undefined do
					setIniSetting miauuIniPresetFile "Render" "Height" (spn_mapHeight.text as string)
				if spn_mapWidth.text != undefined do
					setIniSetting miauuIniPresetFile "Render" "Width" (spn_mapWidth.text as string)						
				--	save ray-miss color
				setIniSetting miauuIniPresetFile "Color" "Ray-miss color" (colorPick_RayMissColor.color as string)						
				--	save colors for UV map
				setIniSetting miauuIniPresetFile "Color" "clrPick_seemEdgesColor" (clrPick_seemEdgesColor.color as string)
				setIniSetting miauuIniPresetFile "Color" "clrPick_edgesColor" (clrPick_edgesColor.color as string)
				setIniSetting miauuIniPresetFile "Color" "clrPick_overlapColor" (clrPick_overlapColor.color as string)
				setIniSetting miauuIniPresetFile "Color" "clrPick_fillColor" (clrPick_fillColor.color as string)						
				--	save background colors of maps
				--	alpha
				setIniSetting miauuIniPresetFile "Color" "Alpha BG color" (colorPick_EleBGColorAlpha.color as string)
				--AO
				setIniSetting miauuIniPresetFile "Color" "AO BG color" (colorPick_EleBGColorAO.color as string)
				--	Blend
				setIniSetting miauuIniPresetFile "Color" "Blend BG color" (colorPick_EleBGColorBlend.color as string)
				--	Complete
				setIniSetting miauuIniPresetFile "Color" "Complete BG color" (colorPick_EleBGColorCompl.color as string)
				--	Diffuse
				setIniSetting miauuIniPresetFile "Color" "DIffuse BG color" (colorPick_EleBGColorDiff.color as string)
				--	Height
				setIniSetting miauuIniPresetFile "Color" "Height BG color" (colorPick_EleBGColorHeight.color as string)
				--	Ligthing
				setIniSetting miauuIniPresetFile "Color" "Lighting BG color" (colorPick_EleBGColorLight.color as string)
				--	Normals
				setIniSetting miauuIniPresetFile "Color" "Normals BG color" (colorPick_EleBGColorNormals.color as string)
				--	Shadows
				setIniSetting miauuIniPresetFile "Color" "Shadows BG color" (colorPick_EleBGColorShadows.color as string)
				--	Specular
				setIniSetting miauuIniPresetFile "Color" "Specular BG color" (colorPick_EleBGColorSpec.color as string)
				--	AO btight
				setIniSetting miauuIniPresetFile "Color" "AO Bright color" (colorPick_AObright.color as string)
				--	AO dark
				setIniSetting miauuIniPresetFile "Color" "AO Dark color" (colorPick_AOdark.color as string)														
			--	save spinners values
				--	padding
				setIniSetting miauuIniPresetFile "Spinner" "Padding" (spn_Padding.text as string)
				--	channel
				setIniSetting miauuIniPresetFile "Spinner" "UVChannel" (spn_UVChannel.text as string)
				--	offset dotnet spinnet
				setIniSetting miauuIniPresetFile "Spinner" "Offset" (spn_Offset.text as string)
				--	offset 3ds max spinnet
				setIniSetting miauuIniPresetFile "Spinner" "OffsetStd" (sOffset.value as string)
				--	AO Samples
				setIniSetting miauuIniPresetFile "Spinner" "AOSamples" (spn_AOSamples.text as string)
				--	AO SpreadS
				setIniSetting miauuIniPresetFile "Spinner" "AOSpread" (spn_AOSpread.text as string)
				--	AO Max Dist
				setIniSetting miauuIniPresetFile "Spinner" "AOMaxDist" (spn_AOMaxDist.text as string)
				--	AO Falloff
				setIniSetting miauuIniPresetFile "Spinner" "AOFalloff" (spn_AOFalloff.text as string)
			--			
			errMssg = 58
			ErrorMessage 58
			
			lb_mRay.bitmap = (openBitmap (url+"miauuITmentalRayActive.png"))
			lb_scanline.bitmap = (openBitmap (url+"miauuITscanline.png"))
		)
		--	show RC menu with standart Map size
		on ImgTag_getMapSize lbuttondown do
		(			
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#mapsize"
				shellLaunch "hh" goToHelp
			)
			else
				popUpMenu rcMapSize pos:(ImgTag_getMapSize.pos + [0,15]) rollout:miauuRTTassist align:#align_topleft
		)
		--	show RC menu with file type fo Save As
		on btn_saveAsType mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(
				if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
				(
					local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#Image_format"
					shellLaunch "hh" goToHelp
				)
				else
					popUpMenu rcSaveAs pos:(btn_saveAsType.pos+[0,15]) rollout:miauuRTTassist align:#align_topleft
			)
		)
		on lb_saveAsTypeArrow lbuttondown do
		(			
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Overview_of_The_Interface.htm#Image_format"
				shellLaunch "hh" goToHelp
			)
			else
				popUpMenu rcSaveAs pos:(btn_saveAsType.pos+[0,15]) rollout:miauuRTTassist align:#align_topleft
		)
	--	switch raytrace - UVMatch checkbox
		on chkbox_Raytrace changed theState do
		(			
			DestroyPresetRollout()
			if theState then
				chkbox_UVmatch.state = off
			else
				chkbox_UVmatch.state = on
		)
		on chkbox_UVmatch changed theState do
		(			
			DestroyPresetRollout()
			if theState then
				chkbox_Raytrace.state = off
			else
				chkbox_Raytrace.state = on
		)
	--	switch resolveHit checkbox
		on chkbox_Closest changed theState do
		(			
			DestroyPresetRollout()
			if theState then
				chkbox_Furthest.state = off
			else
				chkbox_Furthest.state = on
		)
		on chkbox_Furthest changed theState do
		(			
			DestroyPresetRollout()
			if theState then
				chkbox_Closest.state = off
			else
				chkbox_Closest.state = on
		)
		--	open filtering settings for current renderer
		on btn_SamplerSetup lbuttonup do 
		(			
			DestroyPresetRollout()
			local renderTab = undefined
			local rendererClass = classof renderers.current
			if (rendererClass == mental_ray_renderer) then
				renderTab = #(188154248, 1489465121)
			else if (rendererClass == Default_Scanline_Renderer) then
				renderTab = #(1126448576, 479530250)
			if not renderSceneDialog.isOpen() do
				renderSceneDialog.open()
			if renderTab != undefined do
				tabbeddialogs.setCurrentPage #render renderTab -- set to Renderer tab
		)
 		--	try to swich mRay per pixels minimum settings
		on lb_filteringOptions mouseDown senderArg arg do 
		(
			--	on RMB click try to swich mRay per pixels minimum settings
			if arg.button==arg.button.right then
			(					
				DestroyPresetRollout()			
				local renderer = renderers.current
				local rendererClass = classof renderer
				local txt
				if (rendererClass == mental_ray_renderer) then
				(
					txt = "Samples per pixel: "
					local n = amax renderer.MinimumSamples 
					local m = amax renderer.MaximumSamples 0
					case n of
					(
						(-3):
						(
							append txt "1/16"
							renderer.MinimumSamples = -2
						)
						(-2):
						(
							append txt "1/4"
							renderer.MinimumSamples = -1
						)
						(-1):
						(
							append txt ((4^(n+1)) as string)
							renderer.MinimumSamples = 0
						)
						0:
						(
							append txt ((4^(n+1)) as string)
							renderer.MinimumSamples = 1
						)
						1:
						(
							append txt ((4^(n+1)) as string)
							renderer.MinimumSamples = 2
						)
						2:
						(
							append txt ((4^(n+1)) as string)
							renderer.MinimumSamples = 3
						)
						3:
						(
							append txt ((4^(n+1)) as string)
							renderer.MinimumSamples = 4
						)
						4:
						(
							append txt ((4^(n+1)) as string)
							renderer.MinimumSamples = 5
						)
						5:
						(
							append txt "1/64"
							renderer.MinimumSamples = -3
						)
					)
					txt += " - " +(((4^m) as string))
					lb_filteringOptions.text = txt
				)
			)
			--	on MMB try to swich mRay per pixels maximum settings
			if arg.button==arg.button.middle then
			(				
				DestroyPresetRollout()
				local renderer = renderers.current
				local rendererClass = classof renderer
				local txt11= "Samples per pixel: "
				local txt = ""
				if (rendererClass == mental_ray_renderer) then
				(
					local n = amax renderer.MinimumSamples 0
					local m = amax renderer.MaximumSamples
					case m of
					(
						(-3):
						(
							append txt "1/16"
							renderer.MaximumSamples = -2
						)
						(-2):
						(
							append txt "1/4"
							renderer.MaximumSamples = -1
						)
						(-1):
						(
							append txt ((4^(m+1)) as string)
							renderer.MaximumSamples = -0
						)
						0:
						(
							append txt ((4^(m+1)) as string)
							renderer.MaximumSamples = 1
						)
						1:
						(
							append txt ((4^(m+1)) as string)
							renderer.MaximumSamples = 2
						)
						2:
						(
							append txt ((4^(m+1)) as string)
							renderer.MaximumSamples = 3
						)
						3:
						(
							append txt ((4^(m+1)) as string)
							renderer.MaximumSamples = 4
						)
						4:
						(
							append txt ((4^(m+1)) as string)
							renderer.MaximumSamples = 5
						)
						5:
						(
							append txt "1/64"
							renderer.MaximumSamples = -3
						)						
					)
					txt11 += (((4^n) as string))+" - " + txt
					lb_filteringOptions.text = txt11
				)	
			)
		)
		on btn_SamplerSetup mouseover do
		(
			btn_SamplerSetup.bitmap = (openBitmap (url+"miauuITfilteringSetupHover.png"))
		)
		on btn_SamplerSetup mouseout do 
		(
			btn_SamplerSetup.bitmap = (openBitmap (url+"miauuITfilteringSetup.png"))
		)
		--	change controls shown in selected Map Unique settings
			--	for Alpha
		on chkbox_AlphaMap changed theState do
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowAlpha()
			)
			else
				HideAlpha()
		)
		on dNet_lbl_addAlpha   mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_AlphaMap.checked do
				(
					HideOthers()			
					ShowAlpha()
				)
			)
		)
			--	for AO
		on chkbox_AmbientOcclusion changed theState do
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowAO()
			)
			else
				HideAO()
		)
		on dNet_lbl_addAO mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_AmbientOcclusion.checked do
				(
					HideOthers()			
					ShowAO()
				)
			)
		)
			--	for Blend
		on chkbox_BlendMap changed theState do 
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowBlend()
			)
			else
				HideBlend()
		)
		on dNet_lbl_addBlend mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_BlendMap.checked do
				(
					HideOthers()			
					ShowBlend()
				)
			)
		)
			--	for Complete
		on chkbox_CompleteMap changed theState do
		(
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowComplete()
			)
			else
				HideComplete()
		)
		on dNet_lbl_addComplete mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_CompleteMap.checked do
				(
					HideOthers()			
					ShowComplete()
				)
			)
		)
			--	for Diffuse
		on chkbox_DiffuseMap changed theState do 
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowDiffuse()
			)
			else
				HideDiffuse()
		)
		on dNet_lbl_addDiffuse mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_DiffuseMap.checked do
				(
					HideOthers()			
					ShowDiffuse()
				)
			)
		)
			--	for Height
		on chkbox_HeightMap changed theState do
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowHeight()
			)
			else
				HideHeight()
		)
		on dNet_lbl_addHeigh mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_HeightMap.checked do
				(
					HideOthers()			
					ShowHeight()
				)
			)
		)
			--	for Lighting
		on chkbox_LightingMap changed theState do 
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowLight()
			)
			else
				HideLight()
		)
		on dNet_lbl_addLight mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_LightingMap.checked do
				(
					HideOthers()			
					ShowLight()
				)
			)
		)
			--	for Normals
		on chkbox_normalsMap changed theState do
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowNormals()
			)
			else
				HideNormals()
		)
		on dNet_lbl_addNormals mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_normalsMap.checked do
				(
					HideOthers()			
					ShowNormals()
				)
			)
		)
			--	for Shadows
		on chkbox_ShadowsMap changed theState do
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowShadows()
			)
			else
				HideShadows()
		)
		on dNet_lbl_addShadows mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_ShadowsMap.checked do
				(
					HideOthers()			
					ShowShadows()
				)
			)
		)
			--	for Specular
		on chkbox_SpecularMap changed theState do 
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowSpecular()
			)
			else
				HideSpecular()
		)
		on dNet_lbl_addSpecular mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_SpecularMap.checked do
				(
					HideOthers()			
					ShowSpecular()
				)
			)
		)
			--	for UV map
		on chkbox_UVMap changed theState do 
		(			
			DestroyPresetRollout()
			if theState then
			(
				HideOthers()
				ShowUVmap()
			)
			else
				HideUVmap()
		)
		on dNet_lbl_addUVmap mouseDown senderArg arg do
		(			
			DestroyPresetRollout()
			if arg.button==arg.button.left do
			(	
				if chkbox_UVMap.checked do
				(
					HideOthers()			
					ShowUVmap()
				)
			)
		)
		--	selected map unique settings
			--	for AO(MR)
		on btn_AOSamplesUP lbuttonup do
		(			
			DestroyPresetRollout()
			spn_AOSamples.text = ((spn_AOSamples.text as integer) + 1) as string
		)
		on btn_AOSamplesDown lbuttonup do
		(			
			DestroyPresetRollout()
			if btn_AOSpreadUP.text != "0" do
				spn_AOSamples.text = ((spn_AOSamples.text as integer) - 1) as string
		) 
		on btn_AOSamplesDown rbuttonup do
		(			
			DestroyPresetRollout()
			spn_AOSamples.text = "0"
		) 
		on btn_AOSpreadUP lbuttonup do
		(			
			DestroyPresetRollout()
			spn_AOSpread.text = ((spn_AOSpread.text as float) + 0.1) as string
		)
		on btn_AOSpreadDown lbuttonup do
		(			
			DestroyPresetRollout()
			if spn_AOSpread.text != "0.0" do
				spn_AOSpread.text = ((spn_AOSpread.text as float) - 0.1) as string
		)
		on btn_AOSpreadDown rbuttonup do
		(			
			DestroyPresetRollout()
			spn_AOSpread.text = "0.0"
		)
		on btn_AOMaxDistUP lbuttonup do
		(			
			DestroyPresetRollout()
			spn_AOMaxDist.text = ((spn_AOMaxDist.text as float) + 0.1) as string
		)
		on btn_AOMaxDistDown lbuttonup do
		(			
			DestroyPresetRollout()
			if btn_AOSpreadUP.text != "0.0" do
				spn_AOMaxDist.text = ((spn_AOMaxDist.text as float) - 0.1) as string
		)
		on btn_AOMaxDistDown rbuttonup do
		(			
			DestroyPresetRollout()
			spn_AOMaxDist.text = "0.0"
		)
		on btn_AOFalloffUP lbuttonup do
		(
			
			DestroyPresetRollout()
			spn_AOFalloff.text = ((spn_AOFalloff.text as float) + 0.1) as string
		)
		on btn_AOFalloffDown lbuttonup do
		(
			DestroyPresetRollout()
			if btn_AOSpreadUP.text != "0.0" do
				spn_AOFalloff.text = ((spn_AOFalloff.text as float) - 0.1) as string
		)
		on btn_AOFalloffDown rbuttonup do
		(
			DestroyPresetRollout()
			spn_AOFalloff.text = "0.0"
		)
			--	for UV map
		on chkbox_modeNone changed theState do
		(
			if theState then
			(
				chkbox_modeSolid.state = off
				chkbox_modeNormal.state = off
				chkbox_modeShaded.state = off
			)
			else
				chkbox_modeNone.state = on			
		)
		on chkbox_modeSolid changed theState do
		(
			if theState then
			(
				chkbox_modeNone.state = off
				chkbox_modeNormal.state = off
				chkbox_modeShaded.state = off
			)
			else
				chkbox_modeSolid.state = on			
		)
		on chkbox_modeNormal changed theState do
		(
			if theState then
			(
				chkbox_modeNone.state = off
				chkbox_modeSolid.state = off
				chkbox_modeShaded.state = off
			)
			else
				chkbox_modeNormal.state = on			
		)
		on chkbox_modeShaded changed theState do
		(
			if theState then
			(
				chkbox_modeNone.state = off
				chkbox_modeSolid.state = off
				chkbox_modeNormal.state = off
			)
			else
				chkbox_modeShaded.state = on			
		)
------------------
	-- help
		on btn_help lbuttonup do
		(
			DestroyPresetRollout()
			popUpMenu rcRTTassistHelp pos:(btn_help.pos + [0,14]) rollout:miauuRTTassist align:#align_topleft
		)
		on btn_help mouseover do
		(
			btn_help.bitmap = (openBitmap (url+"miauuIThelpHover.png"))
		)
		on btn_help mouseout do
		(
			btn_help.bitmap = (bitmap 2 2 color:white)
		)
	--	about
		on btn_about lbuttonup do
		(
			global RTTAssistAbout
			try(destroyDialog RTTAssistAbout)catch()
			rollout RTTAssistAbout "RTTAssist About"
			(
				local url= ((pathConfig.GetDir #userscripts)+"\\RTTAssistUI\\RTTAssistIcons\\")
				
				ImgTag aboutBG bitmap:(openBitmap (url+"miauuITabout.png")) pos:[0,0]  \
					width:247 height:327 opacity:1 transparent:(color 0 255 255) enabled:off
					
				local licFilePath = "file:///"+(pathConfig.GetDir #userscripts)+"\\RTTAssistUI\\license.html"
				local bmM = bitmap 82 12 color:white
				local bmK = bitmap 79 12 color:white
				local bmS = bitmap 152 11 color:white
				local bmSF = bitmap 59 10 color:white
				local bmDW = bitmap 67 10 color:white
				local bmFC = bitmap 67 10 color:white
				ImgTag btn_martin bitmap:bmM pos:[11, 131]  width:82 height:12  opacity:0.0 transparent:(color 255 255 255)
				ImgTag btn_kostadin bitmap:bmK pos:[11, 147]  width:79 height:12  opacity:0.0 transparent:(color 255 255 255)
				ImgTag btn_sergey bitmap:bmS pos:[11, 189]  width:152 height:11  opacity:0.0 transparent:(color 255 255 255)
				ImgTag btn_sven bitmap:bmSF pos:[11, 204]  width:59 height:10  opacity:0.0 transparent:(color 255 255 255)
				ImgTag btn_dave bitmap:bmDW pos:[10, 218]  width:67 height:10  opacity:0.0 transparent:(color 255 255 255)	
				ImgTag btn_FullCredits bitmap:bmFC pos:[10, 231]  width:99 height:10  opacity:0.0 transparent:(color 255 255 255)	

				hyperLink httpOficialSite "Oficial Site" pos:[14,265] color:(color 176 208 231) hoverColor:(color 71 159 218) \
					visitedColor:(color 71 159 218) address:"http://vertexbee.com/rttassist.htm"
				hyperLink httpVideos "Youtube Videos" pos:[78,265] color:(color 176 208 231) hoverColor:(color 71 159 218) \
					visitedColor:(color 71 159 218) address:"http://www.youtube.com/user/RTTassist?feature=mexp"
				hyperLink httpVertexBee "vertexbee.com" pos:[165,265] color:(color 176 208 231) hoverColor:(color 71 159 218) \
					visitedColor:(color 71 159 218) address:"http://www.vertexbee.com"
				hyperLink httpGetMyUi "getmyui.com" pos:[14,278] color:(color 176 208 231) hoverColor:(color 71 159 218) \
					visitedColor:(color 71 159 218) address:"http://www.getmyui.com"
				hyperLink httpToTex "sven.fraeys.be" pos:[78,278] color:(color 176 208 231) hoverColor:(color 71 159 218) \
					visitedColor:(color 71 159 218) address:"http://www.sven.fraeys.be/portfolio/"
				hyperLink httpLicense "License" pos:[165,278] color:(color 176 208 231) hoverColor:(color 71 159 218) \
					visitedColor:(color 71 159 218) address:licFilePath
-- 				ImgTag it_License bitmap:(bitmap 2 2 color:white) pos:[165,250]  \
-- 					width:36 height:9 opacity:1 transparent:(color 0 255 255)

				ImgTag btn_donate bitmap:(openBitmap (url+"miauuITdonate.png")) pos:[185, 299]  width:54 height:17  opacity:1 transparent:(color 0 255 255)

				
				on btn_martin lbuttonup do
				(
					--	open website
					ShellLaunch @"http://www.vertexbee.com/"  ""
				)
				on btn_martin mouseover do
				(
					btn_martin.bitmap = (openBitmap (url+"miauuITaboutMlink.png"))
					global aboutMartin
					try(destroyDialog aboutMartin)catch()
					local roWidth = 287
					local roHeight = 116
					rollout aboutMartin ""
					(
						local url= ((pathConfig.GetDir #userscripts)+"\\RTTAssistUI\\RTTAssistIcons\\")
				
						ImgTag aboutBG bitmap:(openBitmap (url+"miauuITaboutMartin.png")) pos:[0,0]  \
							width:287 height:116 opacity:1 transparent:(color 0 255 255) enabled:off
						
						on aboutMartin rbuttondown do
						(
							destroyDialog aboutMartin
						)
					)
					local roPos = GetDialogPos RTTAssistAbout
					roPos.x += 247
					roPos.y += 136
					createdialog aboutMartin roWidth roHeight roPos.x roPos.y style:#()  
				)
				on btn_martin mouseout do
				(
					btn_martin.bitmap = bmM
					try(destroyDialog aboutMartin)catch()
				)
				
				on btn_kostadin lbuttonup do
				(
					--	open website
					ShellLaunch @"http://www.scriptspot.com/users/miauu"  ""
				)
				on btn_kostadin mouseover do
				(
					btn_kostadin.bitmap = (openBitmap (url+"miauuITaboutKlink.png"))
				)
				on btn_kostadin mouseout do
				(
					btn_kostadin.bitmap = bmK
				)
				--	about Sergey
				on btn_sergey lbuttonup do
				(
					ShellLaunch @"http://www.getmyui.com/"  ""
				)
				on btn_sergey mouseover do
				(
					btn_sergey.bitmap = (openBitmap (url+"miauuITaboutSlink.png"))
					global aboutSergey
					try(destroyDialog aboutSergey)catch()
					local roWidth = 287
					local roHeight = 116
					rollout aboutSergey ""
					(
						local url= ((pathConfig.GetDir #userscripts)+"\\RTTAssistUI\\RTTAssistIcons\\")
				
						ImgTag aboutBG bitmap:(openBitmap (url+"miauuITaboutSergey.png")) pos:[0,0]  \
							width:287 height:116 opacity:1 transparent:(color 0 255 255) enabled:off
						
						on aboutSergey rbuttondown do
						(
							destroyDialog aboutSergey
						)
					)
					local roPos = GetDialogPos RTTAssistAbout
					roPos.x += 247
					roPos.y += 207
					createdialog aboutSergey roWidth roHeight roPos.x roPos.y style:#()  
				)
				on btn_sergey mouseout do
				(
					btn_sergey.bitmap = bmS
					try(destroyDialog aboutSergey)catch()
				)
				--	about Sven
				on btn_sven lbuttonup do
				(
					ShellLaunch @"http://www.sven.fraeys.be/portfolio/"  ""
				)
				on btn_sven mouseover do
				(
					btn_sven.bitmap = (openBitmap (url+"miauuITaboutSven.png"))
				)
				on btn_sven mouseout do
				(
					btn_sven.bitmap = bmS
				)
				--	about Dave
				on btn_dave lbuttonup do
				(
					ShellLaunch @"http://davewortley.cgsociety.org/about/"  ""
				)
				on btn_dave mouseover do
				(
					btn_dave.bitmap = (openBitmap (url+"miauuITaboutDave.png"))
				)
				on btn_dave mouseout do
				(
					btn_dave.bitmap = bmDW
				)
				--	view full cretids list
				on btn_FullCredits lbuttonup do
				(
					try(destroyDialog RTTAssistFullCredits)catch()
					rollout RTTAssistFullCredits "RTTAssist full credits list"
					(
						label lbl_1 "Authors:" pos:[10,5]
						hyperLink httpMartin "* Martin Punchev - idea and development" pos:[10,20] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://www.vertexbee.com"
						hyperLink httpKostadin "* Kostadin Kotev - code and development." pos:[10,35] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://www.scriptspot.com/users/miauu"
						
						label lbl_2 "Special thanks to:" pos:[10,65]
						hyperLink httpSergei "* Sergey Punchev" pos:[20,80] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://getmyui.com/"
						label lbl_3 "- UI design" pos:[30,93]
						
						hyperLink httpSven "* Sven Fraeys" pos:[20,110] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://www.sven.fraeys.be/portfolio/"
						label lbl_4 "- Baking System(ToTex)" pos:[30,123]
						
						hyperLink httpDave "*David Wortley - Swap Alpha channel." pos:[20,140] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://davewortley.cgsociety.org/about/"
						label lbl_5 "- Swap Alpha channel" pos:[30,153]
						
						hyperLink httpHristo "* Hristo Rusanov" pos:[20,170] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://hristo-rusanov.cghub.com/"
						label lbl_6 "- for the gun model used in the presentation materials" pos:[30,183]
						
						hyperLink httpJean "* Jean-Baptiste \"Noors\" Sarrazin" pos:[20,200] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://www.polycount.com/forum/member.php?u=25782"
						label lbl_7 "- for the ideas about composite alpha map in v1.3" pos:[30,213]
						label lbl_7_1 "  and the batch selection sets in v1.4." pos:[30,225]
						
						hyperLink httpNick "* Nick  Quackenbush" pos:[20,240] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://www.linkedin.com/in/nickquackenbush"
						label lbl_8 "- for the idea about the global control of the cage" pos:[30,253]
						label lbl_8_1 "  push amount in v1.3" pos:[30,265]
						
						hyperLink httpJoshua "* Joshua Stubbles" pos:[20,280] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://www.ivassago.com/index.html"
						label lbl_9 "- for the idea about projection cage export/import!" pos:[30,293]
						
						hyperLink httpDenisT "* Denis Trofimov" pos:[20,310] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://denist.cgsociety.org/about/"
						label lbl_10 "- for the stop flickering of the command panel code!" pos:[30,323]

						
						hyperLink httpPolycount "* Polycount community" pos:[20,348] color:(color 176 208 231) hoverColor:(color 71 159 218) \
							visitedColor:(color 71 159 218) address:"http://www.polycount.com/forum/showthread.php?t=81405"
						label lbl_11 "- for the great feedback!" pos:[30,363]

					)
					createdialog RTTAssistFullCredits 	width:300 bgcolor:(color 71 71 71)
				)
				on btn_FullCredits mouseover do
				(
					btn_FullCredits.bitmap = (openBitmap (url+"miauuITfullCredits.png"))
				)
				on btn_FullCredits mouseout do
				(
					btn_FullCredits.bitmap = bmDW
				)
				--	donate button
				on btn_donate lbuttonup do
				(
					ShellLaunch @"https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=JULVY7LTCC8RS"  ""
				)
				on btn_donate mouseover do
				(
					btn_donate.bitmap = (openBitmap (url+"miauuITdonateHover.png"))
				)
				on btn_donate mouseout do
				(
					btn_donate.bitmap = (openBitmap (url+"miauuITdonate.png"))
				)
				--	license button
-- 				on it_License lbuttondown do
-- 				(
-- 					licFile = (pathConfig.GetDir #userscripts)+"\\RTTAssistUI"+"\license.html"
-- 					shelllaunch licFile ""
-- 				)
-- 				on it_License mouseover do
-- 				(
-- 					it_License.bitmap = (openBitmap (url+"miauuITlicenseHover.png"))
-- 				)
-- 				on it_License mouseout do
-- 				(
-- 					it_License.bitmap = (openBitmap (url+"miauuITlicense.png"))
-- 				)
				
				on RTTAssistAbout open do
				(
-- 					it_License.bitmap = (openBitmap (url+"miauuITlicense.png"))
				)
				on RTTAssistAbout close do
				(
					try(destroyDialog aboutMartin)catch()
					try(destroyDialog aboutSergey)catch()
				)
			)
			createdialog RTTAssistAbout width:247 height:327 bgcolor:(color 71 71 71)
		)
		on btn_about mouseover do
		(
			btn_about.bitmap = (openBitmap (url+"miauuITaboutHover.png"))
		)
		on btn_about mouseout do
		(
			btn_about.bitmap = (bitmap 2 2 color:white)
		)
---------------------
	--	Batch Render
---------------------
		on btn_BatchRender lbuttonup do
		(			
			DestroyPresetRollout()
			if keyboard.AltPressed and keyboard.controlPressed and keyboard.ShiftPressed then
			(
				local goToHelp = "mk:@MSITStore:"+helpFile+"::/Batch_Rendering.htm#batch_rendering"
				shellLaunch "hh" goToHelp
			)
			else
			(
				case of
				(
					(batchState == 1):
					(
						btn_BatchRender.bitmap = (openBitmap (url+"miauuITBatchHOver.png"))
						if startBatchRender == false then
						(
							startBatchRender = true
							--	place batch controls
							RemoveProjectionSettings()
							PlaceBatchControls()							
							BatchListViewReIinit()
							allIndexes = #()							
							batchState = 0
						)
						else
						(
							RemoveProjectionSettings()
							PlaceBatchControls()							
							batchState = 0
						)
					)
					(batchState == 0):
					(
						btn_BatchRender.bitmap = (openBitmap (url+"miauuITBatch.png"))
						for h = 453 to 177 by -5 do
						(
							miauuRTTassist.height = h
						)							
						batchState = 1		
					)
				)
			)
		)
		on btn_BatchRender mouseover do
		(
			btn_BatchRender.bitmap = (openBitmap (url+"miauuITBatchHOver.png"))
		)
		on btn_BatchRender mouseout do
		(
			if startBatchRender == true do
				btn_BatchRender.bitmap = (openBitmap (url+"miauuITBatchHOver.png"))
			if startBatchRender == false do
				btn_BatchRender.bitmap = (openBitmap (url+"miauuITBatch.png"))
		)

		on btn_BatchRender rbuttonup do
		(
			startBatchRender = false
			btn_BatchRender.bitmap = (openBitmap (url+"miauuITBatch.png"))
			batchState = 1
			for e = 453 to 177 by -5 do
			(
				miauuRTTassist.height = e
				sleep 0.002
			)
			maxFiles = #()
			maxFilesToBatch = #()
			InitListView lv_Batch
		)

		function GetFilesRecursive root pattern =
		(		
			dir_array = GetDirectories (root+"\*")
			for d in dir_array do
				join dir_array (GetDirectories (d+"*"))	
			
			my_files = #()				
			for f in dir_array do
				join my_files (getFiles (f + pattern))
					
			my_files 
		)
		on btn_Batch_getDir lbuttonup do
		(
			lv_Batch.enabled = false
			btn_Batch_useSelected.state = off
			
			local lastSelDir = ((getIniSetting miauuIniFile "BatchRender" "LastSelDir") as string)
			if (ValidateDirectory lastSelDir) == false do
				lastSelDir = "$scenes"

			dir = getSavePath caption:"Select the directory" initialDir:lastSelDir	--	"$scenes"
			if dir != undefined do
			(
				--	set last opened folder to ini file
				setInisetting miauuIniFile "BatchRender" "LastSelDir" (dir as string)
				maxFiles = #()
				--	get all max files
				maxFiles = getFiles (dir+"\*.max")
				--	check for subfolders
				subFiles = GetFilesRecursive dir "*.max"
				if subFiles.count != 0 then
				(
					msg = "The selected folder have subfolders!\n"
					msg += "Do you want to include the files from the subfolders too?"
					if queryBox  msg title:"RTTAssist: Sub-folders found" do
						join maxFiles subFiles
				)
				PopulateListView lv_Batch
				allIndexes = #()
				TurnBatchLVchkBoxOn()
			)
		)	
		on btn_Batch_getDir mouseover do
		(
			btn_Batch_getDir.bitmap = (openBitmap (url+"miauuITbatchSelDIrHover.png"))
		)
		on btn_Batch_getDir mouseout do
		(
			btn_Batch_getDir.bitmap = (openBitmap (url+"miauuITbatchSelDIr.png"))
		)
		--	select files one by one
		on btn_Batch_getFile lbuttondown do
		(
			lv_Batch.enabled = false
			maxFile = getMAXOpenFileName dir:"$scenes"
			if maxFile != undefined then
			(
				append maxFiles maxFile
				BatchListViewReIinit()
				allIndexes = #()
				TurnBatchLVchkBoxOn()
			)
		)
		on btn_Batch_getFile mouseover do
		(
			btn_Batch_getFile.bitmap = (openBitmap (url+"miauuITbatchSelFileHover.png"))
		)
		on btn_Batch_getFile mouseout do
		(
			btn_Batch_getFile.bitmap = (openBitmap (url+"miauuITbatchSelFile.png"))
		)
		
		on btn_Batch_useAll changed theState do
		(
			if theState then
			(
				maxFilesToBatch = maxFiles
				btn_Batch_useSelected.state = off				
				lv_Batch.enabled = false
				TurnBatchLVchkBoxOn()
			)
			else
				btn_Batch_useAll.state = on
		)

		on btn_Batch_useSelected changed theState do
		(
			if theState then
			(
				btn_Batch_useAll.state = off
				lv_Batch.enabled = true
				for i = 0 to lv_Batch.Items.count-1 do
					lv_Batch.Items.Item[i].checked = false
				lv_Batch.forecolor = (dotNetClass "System.Drawing.Color").lightGray
			)
			else
				btn_Batch_useSelected.state = on
		)

		--	check or uncheck all maps in the listview
		on lb_btn_Batch_useSelected rbuttonup do
		(
			if chkBatchState == 1 then
			(	--	uncheck all
				for i = 0 to lv_Batch.Items.count-1 do
					lv_Batch.Items.Item[i].checked = true
				chkBatchState = 0
			)
			else
			(	--	check all
				for i = 0 to lv_Batch.Items.count-1 do
					lv_Batch.Items.Item[i].checked = false
				chkBatchState = 1
			)
		)
		--	celar the listview
		on btn_Batch_clear lbuttonup do
		(
			maxFilesToBatch = #()
			maxFiles = #()
			BatchListViewReIinit()
			allIndexes = #()
			btn_Batch_useAll.state = on
			btn_Batch_useSelected.state = off
		)
		on btn_Batch_clear mouseover do
		(
			btn_Batch_clear.bitmap = (openBitmap (url+"miauuITbatchClearHover.png"))
		)
		on btn_Batch_clear mouseout do
		(
			btn_Batch_clear.bitmap = (openBitmap (url+"miauuITbatchClear.png"))
		)
		--	turn On checkboxes and add selected maps to array of combined maps
		on lv_Batch ItemChecked itemCheckedEventArgs do
		(		
			local listViewItem = itemCheckedEventArgs.item
			local index = listViewItem.index
			if (i = (findItem allIndexes index)) != 0 then
				deleteItem allIndexes i
			else
				appendIfUnique allIndexes index
		)

		on lv_Batch MouseDown arg do
		(
			--	delete selected max file from the listview
			if arg.button==arg.button.middle then
			(				
				if (hitNode = lv_Batch.GetItemAt arg.x arg.y) != undefined do
				(
					deleteItem maxFiles (hitNode.index+1)
					BatchListViewReIinit()
				)				
			)
			--	open folder of selected max file
			if arg.button==arg.button.right then
			(
				
				if (hitNode = lv_Batch.GetItemAt arg.x arg.y) != undefined do
				(
					f = (hitNode.index+1)
					folderToOpen = (getFilenamePath maxFiles[f])
					OpenFolders folderToOpen
				)				
			)
		)
		-- set output path
		on chkbox_Batch_SameAsSource changed theState do
		(
			if theState then
				chkbox_Batch_usePresetOP.state = false
			else
				chkbox_Batch_SameAsSource.state = true	
		)
		on chkbox_Batch_usePresetOP changed theState do
		(
			if theState then
				chkbox_Batch_SameAsSource.state = false
			else
				chkbox_Batch_usePresetOP.state = true	
		)
		--	to show or not full path name of selected files
		on btn_Batch_fullPath changed theState do
		(
			BatchListViewReIinit()
			for i = 0 to lv_Batch.Items.count-1 do
				lv_Batch.Items.Item[i].checked = true
			if btn_Batch_useSelected.state == false do
				lv_Batch.forecolor = disableForeColor
		)		
		
		--	open all .max files directories
		on lb_chkbox_Batch_SameAsSource rbuttonup do
		(
			for f in maxFiles do
			(
				folderToOpen = (getFilenamePath f)
				OpenFolders folderToOpen
			)
		)
		--	open preset output folder
		on lb_chkbox_Batch_usePresetOP rbuttonup do
		(
			folderToOpen = btn_BrowseFolder.text
			OpenFolders folderToOpen
		)
		
		on btn_vray changed theState do
		(
			if theState then
			(
				--	change the text of maps labels to indicate the VRay maps				
				vrayIsActiveRenderer = true
				--	hide defoult maps
				RemoveStandartMaps()
				--	show vray maps
				PlaceVRayMaps()
			)
			else
			(
				--	change the text of maps labels to indicate the Standart maps				
				--	remove Vray maps
				RemoveVRayMaps()
				--	show Standart maps
				PlaceStandartMaps()
			)
		)		
		
		on btn_CloseX lbuttonup do
		(
			deleteChangeHandler rendererChange 
			callbacks.removeScripts id:#miauuRTTassist_rendererChange
			callbacks.removeScripts id:#miauuRTTAssist_ImplodeOnSave
			callbacks.removeScripts id:#miauuRTTAssist_ExplodeAfterSave

			if btn_BrowseFolder.text != undefined do
				setIniSetting miauuIniFile "Render" "OutpuPath" (btn_BrowseFolder.text as string)

			if btn_saveAsType.text != undefined do
				setIniSetting miauuIniFile "Render" "FileExtension" (btn_saveAsType.text as string)

			if prefixNameLP != undefined and prefixNameHP != undefined do
			(
				setIniSetting miauuIniFile "Prefix" "LP" prefixNameLP
				setIniSetting miauuIniFile "Prefix" "HP" prefixNameHP
			)
			if dividerStr != undefined then
				setIniSetting miauuIniFile "Prefix" "divideSymb" dividerStr
			else
				setIniSetting miauuIniFile "Prefix" "divideSymb" "---"

			if dataSelMinorLP.count != 0 do
				for d in dataSelMinorLP where isValidNode d[1] do d[1].material = d[2]

			for i = 1 to allObjInScene.count where isValidNode allObjInScene[i] do
			(
				allObjInScene[i].center = startingObjPos[i]
				isThereModifier = allObjInScene[i].modifiers
				if isThereModifier.count != 0 do
					EnableSkin isThereModifier isThereModifier.count
			)
				
			selObj = #()
			pairsNamesNoPrefixLP = undefined
			pairsNamesNoPrefixHP = undefined
			pairsNamesNoPrefixLPAdd = undefined
			pairsNamesNoPrefixHPAdd = undefined
			
			try(destroydialog miauuCompairNames)catch()
			try(destroydialog miauuRenameMenager)catch()
			try(delete miauuZeroPoint)catch()
			try(delete objForCombMap)catch()
			try(destroydialog editTextSaveP)catch()			
			try(destroyDialog smartPresetUnimpRO)catch()
			try(destroyDialog smartPresetImpRO)catch()
			try(destroydialog miauuTGAimageControl)catch()
			try(destroydialog roBMP)catch()
			try(destroydialog roJPG)catch()
			try(destroyDialog roPNG)catch()
			try(destroyDialog roTIF)catch()
			try(destroyDialog ObjByUVArea)catch()
			try(destroyDialog showLPandHPgroupsWithProj)catch()
			try(destroydialog CombineSingled)catch()
			try(destroydialog rol_MapPreview)catch()
			try(destroyDialog rol_SelectionSets)catch()
			try(destroyDialog rol_showUVcalculProgres)catch()
			
			destroydialog miauuRTTassist
			freeSceneBitmaps()
			gc light:true
		)
		on btn_CloseX mouseover do
		(
			btn_CloseX.bitmap = (openBitmap (url+"miauuITcloseHover.png"))
		)
		on btn_CloseX mouseout do
		(
			btn_CloseX.bitmap = (openBitmap (url+"miauuITclose.png"))
		)
	)
 	thePos = (readValue ((getIniSetting miauuIniFile "Dialog" "Position") as stringStream))
 	if thePos == OK do thePos = [100,100]
 	if thePos.x > sysinfo.desktopSize.x - dialogWidth do thePos.x =
 	sysinfo.desktopSize.x - dialogWidth
 	if thePos.y > sysinfo.desktopSize.y - dialogHeight do thePos.y =
 	sysinfo.desktopSize.y - dialogHeight - 25
 	if thePos.x < 0 do thePos.x = 0
 	if thePos.y < 0 do thePos.y = 0
 	createDialog miauuRTTassist dialogWidth dialogHeight thePos.x thePos.y \
 		style:#() 	 bgcolor:(color 128 128 128)
)